(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1334430,      25411]*)
(*NotebookOutlinePosition[   1338666,      25528]*)
(*  CellTagsIndexPosition[   1337863,      25504]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000480000>R000`400?l00000o`00003oooooool9
ooooo`00ooooool9ooooo`001ooooolE0?ooo`0?0>[/m@2a]mX0Phg305m//`11D:@0;CjJ01l`U00K
;I807BnC02/kV@0nCJ80FFJ`07j8`@2`]]T0k>gf0=@0oooo2Oooool000Oooooo4P3oool0103Gfn`0
Qi76041?X`0A8hd=00lRS004010SS@0nCZ<0RI;60=gPkm40oooo2Oooool000Oooooo3`3oool00`3Y
jo@0SIK803Y9X00D00lRS004010RS012DJD0YjkE0?_koAL0oooo00D0g=o_0;VogP2i_mh0k^og0=gP
k`020:F/e0060>o`m`3oool0oooo0?ooo`39cND0h>?`0`3oool00`37bn@0YJcD0:Z`eP020?ooo`04
0>?UlP2i_mh0^KoN0>GWl`<0oooo00<0g=o^0;VogP2i_mh0102i_mh01@37c>D0oooo0<G:i02i_mh0
a<WS00@0oooo00@0`<GQ0;VogP2i_mh0bLgU0`3oool00`3onOT0onc/0?ooo`0>0?ooo`030?oOg`3o
f=P0ooOg00H0oooo00<0on3P0?ooo`3oool00P3oool01P3oknl0oooo0?ooo`3oool0ooWi0?ogm`@0
oooo00<0on3P0?ooo`3oool00`3oool01P3oh>00oooo0?ooo`3oool0onSX0?ogm`@0oooo00<0on3P
0?ogm`3oool00P3oool00`3omoL0on3P0?ooo`020?ooo`030?oXj03omoL0oooo00<0oooo00<0ooWi
0?oPh03oool0103oool00`3oj>P0ooOg0?ooo`040?ooo`030?oPh03of=P0ono_00D0oooo0P3omoL3
0?ooo`030?ogm`3oj>P0oooo01d0oooo2Oooool000Oooooo3@3oool00`3cm?T0Q8k401T[T@0I00lR
S00302hnV`3;cnH0oooo01D0oooo00D0Qi7600lRS00?8X`0`lSR0<76h@0200lRS0060;Nmg@3oool0
oooo0?gmoP0W>9P0KgZj0`3oool00`1EHjh03b:<02loV`020?ooo`0409nWd@0?8X`03b:<0:F/e0<0
oooo00<0Qi7600lRS00?8X`0100?8X`01@0oCZ<0oooo03M7W`0?8X`0<d>M00<0oooo00D0];[K00lR
S00?8X`04BB=0;c2g`020?ooo`040?ogm`3nEU80oSPd0?oWiP`0oooo00@0oY2=0?hY9@3n;RX0oWAa
0P3nJfL0203of]T0oooo0?ooo`3oool0okFc0?hG4P3nCd/0om[I0P3oool01`3n:RD0oS<^0?ooo`3o
ool0olW80?hG4P3nQX@00P3oool0103odM00oQLB0?i5@@3odM020?ooo`080?nIU`3n5a80oUEA0?of
mP3oool0oRXU0?hY9@3o]K<30?ooo`030?hP6`3n:BD0okFc0080oooo00P0oVYW0?hG4P3nF5@0on?S
0?ooo`3nAD40oRTU0?ne/`<0oooo00@0oWAa0?hG4P3nAD40olO60`3oool00`3n:RD0oRTU0?nRX002
0?ooo`070?ogm`3nF5@0oQLB0?hY9@3n?3P0oVYW0?oPh0030?ooo`030?o7aP3n5a80oX>10080oooo
00@0oWej0?hG4P3nHEh0ong/703oool9ooooo`001oooool<0?ooo`030:fcf00V=iL03b:<01/03b:<
00<072jB0<?8hP3oool0503oool01@27TLH03b:<00lRS033b>80jnce00803b:<00L0U9c<0?ooo`3o
ool0a<SS00lRS00V=iL0oOgn0080oooo00<0>dZQ00lRS01;FJT00P3oool0102OYm403b:<00lRS02U
[=@30?ooo`0308NAaP0?8X`03b:<00@03b:<00D0?djS0?ooo`0gAil03b:<03=3W@020?ooo`050?Gf
nP0^?i/03b:<00lRS01oRL800P3oool01P3onOT0oUIB0?hG4P3n5a80oSPd0?oWiP/0oooo00<0oUQD
0?n6Q03oool00P3oool00`3om_H0oTE10?o7aP020?ooo`090?nn_@3n5a80oTE10?idL@3o/[00oooo
0?iQGP3n5a80om[I0080oooo01<0oRXU0?hc;P3oool0oooo0?o/k03n5a80oRhZ0?imNP3nVIL0oooo
0?nIU`3n5a80oeeI0?imNP3om_H0oTE10?hG4P3nQX@0ojZX0080oooo0P3n5a801@3nOGX0oi>@0?oo
o`3nAD40oQLB0080oV5N00D0onSW0?i5@@3n5a80ohJ40?j6Q0020?ooo`050?iTH@3n5a80ogej0?iZ
I`3nOGX00P3oool03@3n<bh0oQLB0?j6Q03nJVL0ooKf0?nb/03n5a80oS<^0?ofmP3oool0oiVG0?h^
:P3oalH00`3oool02@3n:RD0oTe90?ooo`3oool0oi2=0?hG4P3nCd/0oWAa0?oHf00K0?ooo`Wooooo
0007ooooo`X0oooo00<0k^og05aY/@0?8X`07P0?8X`00`0H:Y00`<GQ0?ooo`0C0?ooo`0808NAaP0?
8X`03b:<0<?8hP3oool08cBF00lRS01^N[X20?ooo`04075l^`0?8X`03b:<0<76h@80oooo00<07S2C
00lRS01VL[H00P3oool0102OYm403b:<00lRS02U[=@30?ooo`0408NAaP0?8X`03b:<0:2WdP<0fmk^
00D0h^Ga0?ooo`0gAil03b:<03=3W@020?ooo`05071k^P0?8X`03b:<04MEY`3knod00P3oool00`3n
K6T0oQLB0?hG4P020?hG4P030?hh=03ojnX0oooo00T0oooo00<0oXJ40?oAd03oool00`3oool03@3o
VIL0oRXU0?o`k`3oool0onc/0?hG4P3nAD40oooo0?ogm`3oool0oiVG0?hG4P3oVIL00P3oool00`3n
JfL0oQLB0?oAd0020?ooo`090?i?B`3n9b80oooo0?ofmP3oool0olO60?hG4P3oO7T0ooKf0080oWej
00<0oQLB0?oAd03omoL00P3oool03P3nAD40oQLB0?ooo`3omoL0oooo0?iHE03n5a80oj:P0?ofmP3o
O7T0oWej0?hG4P3ok>`0ooKf0P3oool01@3oRhT0oQLB0?nn_@3oool0ong/0080oooo00P0oV5N0?hG
4P3odM00ooKf0?ooo`3oRhT0oQLB0?idL@<0oooo00<0oRhZ0?hl>03oool00P3oool02@3nF5@0oQlJ
0?ooo`3oool0olO60?hG4P3nF5@0oooo0?ogm`0K0?ooo`Wooooo0007ooooo`T0oooo00<0f=_/02`l
VP0?8X`0800?8X`00`0H:Y00a<SS0?ooo`0B0?ooo`0;08NAaP0?8X`03b:<0<?8hP3oool0C5ZY00lR
S01:FJT0oooo0?cloP0T=IH00P0?8X`00`1WLkH0oooo0??dn@0200lRS004086;``3oool0oooo09nW
d@803b:<00D0YJcD0?ooo`3oool0oooo08NAaP0200lRS0030;VogP3oool0oooo00<0oooo00T0=dNO
00lRS00c@id0oooo0;Fkf`0@8h`03b:<020aU03SiO800P3oool00`3nOGX0oQLB0?hG4P040?hG4P03
0?i;A`3omoL0oooo00P0oooo00<0om[I0?o/k03oool00`3oool00`3oVIL0oQLB0?nZZ0020?ooo`03
0?hl>03n5a80onc/0080oooo00<0om7@0?hG4P3nAD400P3oool00`3oZjX0oQLB0?j6Q0020?ooo`03
0?j6Q03n5a80on?S00<0oooo00L0oR0K0?i=B@3oool0om[I0?i?B`3n5a80oj^Z00<0oooo00<0oV]W
0?hG4P3odM000P3oool0203nQX@0oQLB0?imNP3oool0olW80?i[I`3n5a80okjm0`3oool00`3o^KP0
oQLB0?n@S@040?ooo`030?nIU`3n5a80oi2=0080oooo00<0oi>@0?hG4P3nM7400`3oool00`3nK6T0
oQLB0?ne/`020?ooo`030?n@S@3n5a80okFc0080oooo00<0oR0K0?hZ9@3oool0703oool9ooooo`00
1oooool80?ooo`030=KIj`0V=iL03b:<02803b:<00<072jB0=CGjP3oool04@3oool02P27TLH03b:<
00lRS033b>80oooo07Ao_00?8X`09CNG0?ooo`31a^4200lRS004010SS00I:i40m?Gj0=SKk0803b:<
00@0W:C@0?ooo`3oool0WjOA0P0?8X`01@2U[=@0oooo0?ooo`3oool0Qi7600803b:<00<0^KoN0?oo
o`3oool00`3oool0200gAil03b:<03=3W@3WjO@08S>E00lRS00@8h`0^;gM0P3oool00`3nOGX0oQLB
0?hG4P060?hG4P030?iFDP3omoL0oooo00`0oooo00@0om7@0?hc;P3n5a80oh^90P3oool00`3nOGX0
oQLB0?ne/`030?ooo`0<0?hP6`3n<bh0okjm0?ooo`3ohn<0oQLB0?hc;P3ok>`0oooo0?nn_@3n5a80
oj:P0`3oool01`3nHEh0oQlJ0?ooo`3oool0oWej0?hG4P3nJfL00`3oool00`3oVIL0oQLB0?nRX002
0?ooo`030?nn_@3n5a80oS`h0080oooo00<0oVYW0?hG4P3nQX@00`3oool00`3oh=l0oQLB0?iQGP04
0?ooo`030?oJf@3n5a80oUQD0080oooo00<0okVh0?hG4P3nCd/00`3oool00`3oTi00oQLB0?i[I`02
0?ooo`030?o7aP3n5a80oUQD0080oooo00<0oUQD0?hG4P3of]T0703oool9ooooo`001oooool70?oo
o`030;_0g`0M;i<03b:<02@03b:<00<09cRH0=CGjP3oool0403oool01P27TLH03b:<00lRS033b>80
oooo0:2XdP803b:<00P0k^og06Ue]`0?8X`0:cbJ05m//`0?8X`0WJC@0;Vng@803b:<00@0^l3N0?oo
o`3oool0WjOA0P0?8X`01@2U[=@0oooo0?ooo`3oool0Qi7600803b:<00X0UYk=0<gAi`3=dNL0cM7W
0>7Sl@3oool0=dNO00lRS00]?IX0AUFV0P0?8X`0101fPKd0oooo0?oin@3nK6T:0?hG4P030?i;B03o
jnX0oooo00P0oooo00<0olG40?idL@3n;RX00`3n5a801P3oZjX0oooo0?ooo`3o^KP0oQLB0?idL@<0
oooo00P0oTe90?h^:P3nRhT0onGU0?ooo`3n;RX0oUEA0?n3P@80ooOg00<0oQhI0?iMF@3oool00P3o
ool01`3oXZ00oQLB0?o1`03oool0onSW0?hG4P3n;RX00`3oool00`3of=P0oQLB0?iTH@030?ooo`07
0?hf<P3n5a80onSW0?ooo`3oh>00oQLB0?iED@040?ooo`030?hV8P3n;RX0oooo00@0oooo00D0oRhZ
0?hO6P3omoL0oooo0?oblP020?hO6P060?ogm`3oool0oooo0?nb/03n5a80oTE10`3oool01`3n91l0
ofaY0?nRX03oool0oiZH0?hG4P3oTi00703oool9ooooo`001oooool60?ooo`030;g2g`0E:8l03b:<
02H03b:<00<072jB0<_?iP3oool03`3oool01P27TLH03b:<00lRS033b>80oooo0<gAi`803b:<00P0
_<;O01X/T@0?8X`0RiC70;2ff@0?8X`0>TZQ09bTc`803b:<00@0fMc]0?ooo`3oool0WjOA0P0?8X`0
1@2U[=@0oooo0?ooo`3oool0Qi7600H03b:<00<0KgZj0?ooo`0gAil0100?8X`0100iBJ00n?Sl0?oo
o`3nIF8<0?hG4P030?hl=`3oool0oooo00H0oooo00<0okFc0?hG4P3n5a800P3n5a805`3n81/0oWej
0?ooo`3ok>`0oi2=0?ofmP3n5a80oRXU0?ooo`3o]K<0om[I0?idL@3n5a80on?S0?ilN@3okN`0oV5N
0?hP6`3ohn<0oVYW0?ofmP3n?SX0oR0K0080oooo00@0oi2=0?oSh`3n5a80oXJ40P3oool00`3nF5@0
oQLB0?oPg`030?ooo`030?hZ9@3n<bh0oooo0080oooo00<0olO60?hP6`3oT8d00P3oool00`3nCd/0
oQLB0?ofmP030?ooo`030?iQGP3n5a80on?S0080oooo00D0ojZX0?oSh`3nJfL0oQLB0?ne/`020?oo
o`030?n@S@3n5a80ojbZ0080oooo00d0ojZX0?hG4P3nCd/0oooo0?ne/`3of]T0oUEA0?iHE03oalH0
ojbZ0?oAd03n5a80oTm;01`0oooo2Oooool000Oooooo1@3oool00`3Ig>d07BnC00lRS00X00lRS003
01h`T`3@e>T0oooo00h0oooo0100Qi7600lRS00?8X`0`lSR0?ooo`3dmOX042>=00lRS01CHJ`03b:<
010SS@3Ri?40l_?i01DXS`0?8X`0DUn/0P0?8X`0103emOX0oooo0?ooo`2OYm4200lRS0050:F/e03o
ool0oooo0?ooo`27TLH01P0?8X`01@1_N[X0oooo03M7W`0?8X`04bF>00803b:<00D0JGFg0?ooo`3o
ool0om;A0?hW8`0:0?hG4P030?hJ5P3o/:h0oooo00L0oooo00H0oUQD0?hG4P3n:BD0oXJ40?nn_@3o
m_H30?ooo`0I0?oAd03nF5@0oQLB0?hG4P3oh=l0oooo0?j@S@3n:BD0oQLB0?ne/`3oj>L0oUQD0?hP
6`3n5a80om[I0?oSh`3nCT/0oQlJ0?hG4P3odM00oooo0?oJf@3nCd/0oQLB0?i?B`020?ooo`030?n@
S@3n5a80oj:P00<0oooo00<0oUQD0?hG4P3ol>l00`3oool03@3odM00oS`h0?nb/03o_[d0oTE10?hG
4P3o_[d0oooo0?oSh`3oXZ00oUQD0?hG4P3oM7400P3oXZ001@3omoL0oWej0?hY9@3n5a80oWej00<0
oooo0140oiVG0?hl>03of]T0ooKf0?iMF@3n5a80oiVG0?ooo`3om_H0oXJ40?hV8P3n:RD0oooo0?o7
aP3n?3P0oQLB0?hP6`0L0?ooo`Wooooo0007ooooo`@0oooo00<0m_Ok03Q8X00?8X`0:P0?8X`00`0P
<Y@0d=CY0?ooo`0=0?ooo`0408NAaP0?8X`03b:<0<?8hP80oooo00D0:3VH00lRS00@8h`03b:<04eK
ZP020?ooo`0505]X/00?8X`03b:<00lRS00S=9H00`3oool0102OYm403b:<00lRS02U[=@30?ooo`04
08NAaP0?8X`03b:<08nHb@<0`lSR00H0fmk^0?ooo`0gAil03b:<03=3W@1VL[H200lRS0050:bbe`3o
ool0oooo0?oBd@3n9b<0203n5a800`3n6QH0ok2^0?ooo`080?ooo`030?i5@@3n9b80ooKf00L0oooo
00@0ooKf0?nIU`3nCT/0onSW0P3oool03@3oalH0oUQD0?nn_@3oool0ooKf0?nIU`3nCT/0onc/0?oo
o`3om_H0oi>A0?i>B`3ok>`00P3oool00`3om_H0oX>10?idL@020?ooo`030?oJf@3nOGX0oiZH00<0
oooo00<0oi2=0?hG4P3o`L00103oool0303om_H0oWai0?i5@@3nHEh0oiVG0?ne/`3oool0ooKf0?o1
`03nM740oQLB0?hl>080oWAa00D0oo3_0?ooo`3oalH0oV5N0?jIU`040?ooo`050?oJf@3nOGX0oTE1
0?iED@3oVIL0103oool01`3o/[00oTi;0?ooo`3oool0on?S0?iZI`3nHEh0703oool9ooooo`001ooo
ool40?ooo`0307N2_P0?8X`03b:<02/03b:<00<083:D0=OJk03oool0303oool01027TLH03b:<00lR
S033b>820?ooo`0504YHZ00?8X`03b:<00lRS02U[=@00P3oool01@2`]mT03b:<00lRS00?8X`0A5>U
00<0oooo00@0WjOA00lRS00?8X`0YJcD0`3oool01027TLH03b:<00lRS02i_mh50?ooo`0803M7W`0?
8X`0<d>M0?CenP0b@Yd03b:<01laU03Ri?420?ooo`030?oBd@3n9b<0oQLB00D0oQLB00<0oQXE0?n`
[P3oool02@3oool00`3nM740oShj0?ooo`040?ooo`030?nj^03oool0oooo0200oooo00<0okjm0?hG
4P3oViP03@3oool00`3ok>`0oQLB0?i?B`0g0?ooo`Wooooo0007ooooo`<0oooo00<0bloV014TS@0?
8X`0;@0?8X`00`0Q<iD0dMGY0?ooo`0;0?ooo`0408NAaP0?8X`03b:<0<?8hP80oooo00D0L7^j00lR
S00?8X`08S>E0?Kgn`020?ooo`050?Wjo00T=IH03b:<00lRS01YM;L00`3oool0102OYm403b:<00lR
S02U[=@30?ooo`0408NAaP0?8X`03b:<0;VogPD0oooo00T0=dNO00lRS00c@id0oooo0=SKk00O<9<0
3b:<03A4WP3Xj_@00P3oool00`3ofMP0oS8]0?hG4P030?hG4P030?hJ5@3oZjT0oooo00X0oooo00<0
on3P0?ha;@3oj>L00`3oool00`3omoL0oW5^0?ooo`020?ooo`030?oPh03nK6T0ok:`01`0oooo00<0
ooOg0?hG4P3nI6403P3oool00`3nAD40oQLB0?o`k`040?ooo`030?n;R@3nM740oo3_02l0oooo2Ooo
ool000Oooooo0`3oool00`1AGj`03b:<00lRS00^00lRS00305]X/03oool0oooo00X0oooo00@0Qi76
00lRS00?8X`0`lSR0P3oool0102EWL`03b:<00lRS01jQ;l40?ooo`0507b7`00?8X`03b:<08bFb03<
d>L00P0c@id0100U=YH03b:<00lRS00V=iL203=3W@050>3Sl027TLH03b:<00lRS00Y>IP00`0c@id0
1@1LJK40oooo03M7W`0?8X`0<d>M0080oooo00D0^KkN010SS00?8X`0?DfR0?GfnP020?ooo`060?oI
f@3n9b<0oQLB0?hG4P3n6QH0ok2^3@3oool01`3odM00oTE10?ne/`3odM00okFc0?i5@@3nEE400`3o
ool00`3oZjX0oQLB0?hn>P0K0?ooo`040?o]k03odM00oQLB0?hf<Ph0oooo00<0on?S0?j6Q03oalH0
103oool00`3n81/0oQLB0?nRX00_0?ooo`Wooooo0007ooooo`80oooo00<0e=OZ010SS@0?8X`0;`0?
8X`00`0F:8l0k_3g0?ooo`0:0?ooo`0408NAaP0?8X`03b:<0<?8hP80oooo00@0][_L00lRS00?8X`0
dmOZ103oool01@3AeNT03b:<00lRS02]/mP0`lSR00P03b:<00<0fmk^08NAaP0?8X`01@0?8X`01@0o
CZ<0oooo03M7W`0?8X`0<d>M00<0oooo00@0Ig>f00lRS00?8X`0GV^b0`3oool0103od]40oRLS0?hJ
5P3o/:h?0?ooo`060?ofmP3oZjX0oWAa0?idL@3oVIL0oo3_0`3oool00`3om_H0oXJ40?nb/00K0?oo
o`050?oJf@3nOGX0oUQD0?hO6P3ok>`0503oool00`3o]K<0oWej0?o/k00_0?ooo`Wooooo0007oooo
o`80oooo00<0Ig>f00lRS00?8X`0<00?8X`00`2KXll0oooo0?ooo`090?ooo`040;6gfP1SKk@0Hfnd
0=WLk@80oooo00<0hnGb06mj^P20R/801P3oool0101lQ/00KgZj0=kQk`3Hfn`806=_]0030>SYm02a
]mX0Hfnd00D0Hfnd00D0PXc30?ooo`1mQl40Hfnd07^5`0030?ooo`050>[/m@1TL;D0Hfnd06=_]03:
c^H00`3oool00`3od]40ok:a0?ooo`0i0?ooo`030?o`k`3oool0oooo04D0oooo2Oooool000Oooooo
00<0oooo0>g^mP0F:8l0<P0?8X`00`15E:H0oooo0?ooo`300?ooo`Wooooo0007ooooo`030?ooo`2J
X/l03b:<03803b:<00<042>=0>W[m03oool0`03oool9ooooo`001oooool00`3oool0AE>V00lRS00K
00lRS00301`^TP0?8X`03b:<00/03b:<00<052J>00lRS00?8X`01`0?8X`00`2NYM00oooo0?ooo`2o
0?ooo`Wooooo0007ooooo`030>W[m@0@8hd03b:<01X03b:<00<0D5j[0?7bn01GI:l02`0?8X`00`16
E:H0h^Ca03i=XP0800lRS00305]X/03oool0oooo0;l0oooo2Oooool000Oooooo00<0/KOJ00lRS00?
8X`06@0?8X`01@1@GZ/0moSk0?ooo`3inO`0EfB_00T03b:<00D0AUBV0?;cn@3oool0k_3g03I6W`07
00lRS00302HgU`3oool0oooo0;l0oooo2Oooool000Oooooo00<0P8[200lRS00?8X`0600?8X`00`15
E:H0moSk0?ooo`020?ooo`030?Wio01GI:l03b:<00H03b:<00<0AUBV0?;cn@3oool00P3oool00`3N
hNl09CJF00lRS00600lRS0030>c]mP3oool0oooo0;h0oooo2Oooool000Oooooo00<0F6F_00lRS00?
8X`05`0?8X`00`0a@Y`0j^ce0?ooo`040?ooo`030?Wio01;FJT03b:<00@03b:<00<0?DbR0?;cn@3o
ool0103oool00`3Gfn`09CJF00lRS00400lRS003051NZ`3hn?`0oooo0;l0oooo2Oooool000Oooooo
00<0>DRP00lRS00?8X`05P0?8X`00`15E:H0j^ce0?ooo`060?ooo`030?3an01;FJT03b:<00803b:<
00<0?DbR0>SZm03oool01P3oool00`3NhNl0=TJO00lRS00200lRS00306Mc]P3inO`0oooo0<00oooo
2Oooool000Oooooo00<083:D00lRS00?8X`05@0?8X`00`1@GZ/0moSk0?ooo`080?ooo`050?Wio01G
I:l03b:<04IDYP3bloT02@3oool0103^l?L0?TfR00lRS01WLkK30?ooo`Wooooo0007ooooo`0301@W
S`0?8X`03b:<01@03b:<00<0@e:U0?Ohn`3oool02P3oool00`3inO`0PWfd0?;cn@0;0?ooo`030>k`
m`1[MkP0nOWl00`0oooo00<0no_m0?ooo`3oool0]03oool9ooooo`001ooooolG00lRS00301PZT030
aN40oooo00X0oooo00<0ol;10?hV8@3o^KP02`3oool00`2]]=P08cFF0=SKk@0;0?ooo`030:fdf018
EjL0moSk0;D0oooo2Oooool000Oooooo00<05bV@00lRS00?8X`05@0?8X`00`0H:Y00`<GQ0?ooo`08
0?ooo`050?o2`@3n81/0oQLB0?hM603o^KP02@3oool01@2]]=P04bF>00lRS00`@I`0jN_e00T0oooo
00D0[KCH01<USP0?8X`0D5j[0?Ohn`2d0?ooo`Wooooo0007ooooo`0302<dUP0?8X`03b:<01H03b:<
00<062Z@0<35h@3oool01P3oool00`3oc</0oR0K0?hG4P020?hG4P030?hM603oaL@0oooo00H0oooo
00<0[KCH01<USP0?8X`00P0?8X`00`0gAil0jN_e0?ooo`060?ooo`030:fdf00C9Hh03b:<00803b:<
00<0D5j[0?Ohn`3oool0/P3oool9ooooo`001oooool00`0mC:803b:<00lRS00G00lRS00301LYT02h
_]d0oooo00@0oooo00<0olc;0?hY9@3n5a80103n5a800`3n9R40olG40?ooo`040?ooo`0309JNc@0B
9Hd03b:<00@03b:<00<0<46L0=SKk03oool0103oool00`2FW/d04RF=00lRS00400lRS00304EDYP3Z
k?D0oooo0;40oooo2Oooool000Oooooo00<0Gfbc00lRS00?8X`0600?8X`00`0G:I00`<GQ0?ooo`02
0?ooo`030?o2`@3n81/0oQLB00H0oQLB00<0oQdH0?ni^03oool00P3oool00`2FW/d03b:<00lRS006
00lRS003020bU03@e>T0oooo0080oooo00<0PH_300lRS00?8X`01P0?8X`00`0a@Y`0i^Sc0?ooo`2`
0?ooo`Wooooo0007ooooo`0308VCa`0?8X`03b:<01T03b:<00D062Z@0<35h@3oool0ol;10?hP6`09
0?hG4P050?hM603o^KP0oooo0:fdf00B9Hh02@0?8X`0100P<Y@0d=CY0?ooo`21Rl<:00lRS0030352
W03Zk?D0oooo0:l0oooo2Oooool000Oooooo00<0^KoN00lRS00?8X`06P0?8X`00`0H:Y00bIfc0?hP
6`0;0?hG4P030?hM602gQJ@04bF>00/03b:<00<083:D07^6`00?8X`02`0?8X`00`15E:H0nOWl0?oo
o`2^0?ooo`Wooooo0007ooooo`030?7bn00C9Hh03b:<01X03b:<00<0AUBV0?;/l@3nEU802`3n5a80
0`3nA400jM_T03M7W`0;00lRS00305MT[`2n`n005BR?00/03b:<00<0Ig>f0?ooo`3oool0[P3oool9
ooooo`001oooool00`3oool0D5j[00lRS00I00lRS00505aX/@3emOX0oooo0?oin@3nK6T02@3n5a80
1@3nFED0oo;a0?ooo`3]k_H0@E2T00T03b:<00D0KWZj0?[jo@3oool0`lSR024cU@0900lRS00306Mc
]P3jn_d0oooo0:l0oooo2Oooool000Oooooo00<0oooo0:J]e@0?8X`0600?8X`00`1LJK40oOgn0?oo
o`030?ooo`030?imNP3n5a80oQLB00D0oQLB00<0oVIS0?oln`3oool00P3oool00`3]k_L0=dNO00lR
S00600lRS003086;``3oool0oooo0080oooo00<0em_/02DfUP0?8X`01P0?8X`00`1hPkh0oooo0?oo
o`2`0?ooo`Wooooo0007ooooo`030?ooo`3dmOX06bfB01L03b:<00<0AUBV0?GenP3oool01@3oool0
0`3nK6T0oQLB0?hG4P030?hG4P030?iIE@3oo?/0oooo00@0oooo00<0jN_e03M7W`0?8X`0100?8X`0
0`21Rl<0oooo0?ooo`040?ooo`030=OKk00U=YH03b:<00@03b:<00<0N8>n0?ooo`3oool0/@3oool9
ooooo`001oooool20?ooo`0307Ao_@0?8X`03b:<01@03b:<00<0AUBV0?;cn@3oool01P3oool00`3o
nOT0oUIB0?hG4P020?hG4P030?i4@03ol_40oooo00H0oooo00<0jN_e03M7W`0?8X`00P0?8X`00`21
Rl<0oooo0?ooo`060?ooo`030=OKk00U=YH03b:<00803b:<00<0N8>n0?ooo`3oool0/P3oool9oooo
o`001oooool20?ooo`030=oQl00B9Hh03b:<01<03b:<00<0AUBV0?;cn@3oool0203oool01@3omoL0
oUIB0?hG4P3nA400ono^00T0oooo00@0jN_e03M7W`0?8X`0KWZj2P3oool0103Gfn`09CJF00lRS01h
Pkje0?ooo`Wooooo0007ooooo`<0oooo00<0Gf^b00lRS00?8X`04@0?8X`00`0`@9`0l_?i0?ooo`0:
0?ooo`030?ogm`3gMGD0ono^00/0oooo00<0jN_e07M]Z03jn_d02`3oool00`3Gfn`0N8:n0?ooo`0;
0?ooo`030?gmoP3hn?`0oooo0:L0oooo2Oooool000Oooooo0`3oool00`3Gf^`052N>00lRS00A00lR
S003010RS022S<<0o_kn00X0oooo00<0^l3O02DfUP2Z/=H02`3oool00`3oTY00oQdI0?nc/@0H0?oo
o`040?Kgn`1LJ;40AEBV0>[/mJL0oooo2Oooool000Oooooo103oool00`28TLH03b:<00lRS00B00lR
S00306]g^03moOh0oooo00L0oooo00D0[KCH01<USP0?8X`042><09RQcP090?ooo`050?imNP3n5a80
oQLB0?hL5`3o^KP05P3oool01P3moOh0G6Va00lRS00?8X`0<D:L0>KXljH0oooo2Oooool000Oooooo
103oool00`3jnod0@U6T00lRS00C00lRS00306]g^03no_h0oooo00D0oooo00<0^l3O01<USP0?8X`0
0P0?8X`00`0@8h`0Z[3F0?ooo`060?ooo`030?imNP3n5a80oQLB0080oQLB00<0oQdH0?ni^03oool0
4`3oool00`3moOh0JgNh00lRS00300lRS0030352W03Vj?<0oooo0:@0oooo2Oooool000Oooooo1@3o
ool00`3Qho408S>E00lRS00C00lRS00308:<``3oool0oooo00<0oooo00<0d=CY01d_T`0?8X`0100?
8X`00`0G:I00`<GQ0?ooo`040?ooo`030?imNP3n5a80oQLB00@0oQLB00<0oQdH0?ni^03oool04@3o
ool00`3moOh0JgNh00lRS00500lRS0030352W03Zk?D0oooo0:<0oooo2Oooool000Oooooo1P3oool0
0`34bN<05BR?00lRS00B00lRS003010SS02HXLh0oooo0080oooo00<0d=CY020bU00?8X`01P0?8X`0
0`0H:Y00`<GQ0?ooo`020?ooo`030?nBT03n5a80oQLB00H0oQLB00<0oQdH0?ni^03oool03`3oool0
0`3moOh0JgNh00lRS00700lRS00304EDYP3gn?/0oooo0:80oooo2Oooool000Oooooo1`3oool00`2n
`n007BnC00lRS00B00lRS005010RS022S<<0o_kn0;_0g`0M;i<02@0?8X`01@0G:I00Z[3F0?ooo`3o
TY00oQPC00T0oQLB00<0oQ`G0?nSX@3oool03@3oool00`3emOX0G6Ra00lRS00900lRS00304EDYP3Z
k?D0oooo0:40oooo2Oooool000Oooooo203oool00`3BeNX08S>E00lRS00C00lRS00304eLZP0C9Hh0
3b:<00X03b:<00<042><09QFPP3n5a80303n5a800`3oclh0oooo0?ooo`0;0?ooo`0305]X/00?8X`0
3b:<00X03b:<00<0=dNO0?cloP3oool0X03oool9ooooo`001oooool90?ooo`030=7Dj@0S=IH03b:<
02003b:<00<072jB0>ETK03n5a802P3n5a800`3oQH<0oooo0?ooo`0<0?ooo`030=OKk00U=YH03b:<
00T03b:<00<05BR?0;Nmg03oool0X@3oool9ooooo`001oooool:0?ooo`030>GWlP19EjP03b:<01h0
3b:<00@0=DFN0=OJk03oool0oVaY2@3n5a800`3oQH<0oooo0?ooo`0>0?ooo`030=OKk00U=YH03b:<
00L03b:<00<052N>0;Nmg03oool0XP3oool9ooooo`001oooool;0?ooo`030?gmoP2BVl/06B^A01/0
3b:<00<042>=07=n_03em_X00P3oool00`3onOT0oUIB0?hG4P060?hG4P030?n5P`3oool0oooo0100
oooo00<0em_/02DfUP0?8X`01P0?8X`00`2PZ=40oooo0?ooo`2R0?ooo`Wooooo0007ooooo`d0oooo
00<0hnKb06Ea]@0A8hd0600?8X`00`0hB:00b<gU0?ooo`040?ooo`030?ogm`3nEU80oQLB00@0oQLB
00<0ohF30?ooo`3oool04P3oool00`3Gfn`09CJF00lRS00400lRS00308fFb03oool0oooo0:<0oooo
2Oooool000Oooooo3`3oool00`3CenX0Kg^j020bU00C00lRS004018TS@1>G:X0Z[7F0?[ko@L0oooo
00H0ooWi0?i/J@3n5a80oQLB0?hJ5@3oVYLF0?ooo`060=kQk`0`@9`03b:<00lRS00G:I00YJcDYP3o
ool9ooooo`001ooooolA0?ooo`040?Wjo02b^=X0HVjd01l`U0d03b:<00@042>=041?X`2?V<T0i>Kb
303oool00`3nOGX0oQLB0?nJU`0H0?ooo`040=kQk`0U=YH062Z@0<35hJL0oooo2Oooool000Oooooo
503oool03`3lo?h0b<gU08nHbP1ULKD0A5>U02`lVP0L;Y804RB=01LZT00R<iD0=dJO05=Q[@1iQ;l0
Z:oE0>KXl`0@0?ooo`030?nk^@3oool0oooo01P0oooo00<0em_/0<;7hP3oool0Y`3oool9ooooo`00
ooooool9ooooo`00\
\>"], "Text",
  ShowCellBracket->False,
  CellMargins->{{0, 0}, {Inherited, 0}},
  Evaluatable->False,
  GeneratedCell->False,
  CellAutoOverwrite->False,
  ImageSize->{285.188, 63.375},
  ImageMargins->{{0, 0}, {3, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006^00007b000`400?l00000o`00003oo`3el^:_
0?GbhP00o`3el^:_0?GbhP00o`3el^:_0?GbhP00o`3el^:_0?GbhP004@3el^800`3LhZH0ing40>O]
a00E0>O]a0030=SQW`3el^80mO;R0?l0mO;RP`3el^800140mO;R00<0h^Ne0<oKR@2R^AT0502N]a80
0`2fbDd0i>Zm0?GbhP3o0?GbhX@0mO;R000A0?GbhP040>;W]@3?fhT0c]=c0::i6A<0W[LB00<0]/U=
0>CZ_@3el^80o`3el^:40?GbhP004@3el^801@3RikD0cm^90=WIR@3>dg<0X[TI0180W[LB00<0]/U=
0>CZ_@3el^80o`3el^:40?GbhP004@3el^801P3RikD0cm^90=WIR@3IfHT0/[EK09fe4Q40W[LB00<0
]/U=0>CZ_@3el^80o`3el^:40?GbhP004@3el^801`3RikD0cm^90=WIR@3IfHT0NgTd092>@P2P]a`0
402N]a800`2fbDd0i>Zm0?GbhP3o0?GbhX@0mO;R000A0?GbhP080>;W]@3?fhT0fMV90=[JR01gLSD0
KF@R07Eg5@2Q^1/?09jg4P030;K9C@3Tj[d0mO;R00L0mO;R00<0_i^[0:eoV@38Z[@00P3el^802P38
Z[@0dKRn0?GbhP3el^80_i^[0:eoV@3A^;h0]XfR0:eoV@38Z[@30?GbhP050>cTf@2]OiT0[GnI0=[7
a`3el^800P2]OiT01P3A^;h0mO;R0?GbhP2oVj/0[GnI0;nKZ`<0mO;R0P2]OiT00`3A^;h0mO;R0;nK
Z`040:eoV@080=6h_P3SeM00[GnI0:eoV@3/i=T0mO;R0>cTf@2]OiT20?GbhP040>?Ed02]OiT0[GnI
0=[7a`80[GnI00T0k>CI0?GbhP3el^80mO;R0<RZ]02]OiT0]XfR0?GbhP3A^;h00P2]OiT20?GbhP04
0>?Ed02]OiT0[GnI0>?Ed0<0mO;R00@0_i^[09YRQ`28AGD0Xg2@0P3JalL20:eoV@070>cTf@3el^80
mO;R0?GbhP38Z[@0[GnI0;J=XP050?GbhP060=6h_P2]OiT0[GnI0:eoV@2fSJ80f/O70`3el^800`3S
eM00[GnI0:eoV@020:eoV@030;nKZ`3el^80mO;R0080mO;R00<0dKRn0:eoV@3A^;h0103el^850:eo
V@80mO;R1@2]OiT30?GbhP060=6h_P2SL900R4Ee095COP2fSJ80k>CI0`3el^800`2oVj/0[GnI0=6h
_P050?GbhP030=6h_P2]OiT0[GnI0080[GnI00L0dKRn0?GbhP2oVj/0[GnI0=6h_P3el^80hmG@0080
[GnI00<0b:Zd0?GbhP3el^801@3el^801@3A^;h0Xg2@08Q5M@2JHXL0b:Zd00<0mO;R00H0hmG@0:eo
V@28AGD0R4Ee0:eoV@3SeM030?GbhP030=6h_P2]OiT0_i^[00@0mO;R00L0]XfR0:eoV@3A^;h0mO;R
0;nKZ`2]OiT0dKRn00@0mO;R00<0_i^[0:eoV@2]OiT00P2]OiT01`3SeM00mO;R0:eoV@2]OiT0hmG@
0?GbhP3A^;h00P2]OiT00`3JalL0dKRn0:eoV@030:eoV@050=6h_P3el^80dKRn0:eoV@2oVj/0103e
l^800`2fSJ80[GnI0=6h_P030?GbhP070=6h_P2SL900R4Ee09YRQ`38Z[@0mO;R0=6h_P040:eoV@03
0=6h_P3el^80mO;R0100mO;R00<0]XfR0:eoV@38Z[@00`3el^801`3/i=T0[GnI0:eoV@3JalL0dKRn
0:eoV@2oVj/01@3el^800`3SeM00[GnI0:eoV@020?GbhP090;nKZ`2]OiT0[GnI0>cTf@2oVj/0[GnI
0=6h_P3el^80dKRn00@0[GnI00<0dKRn0?GbhP3el^800P3el^800`3/i=T0]XfR0:eoV@050:eoV@09
0;nKZ`3el^80mO;R0?GbhP2]OiT0KAUI06@;D028AGD0f/O700@0mO;R00D0b:Zd07HXHP1T2e00MRQR
0<RZ]0040?GbhP060=[7a`2ADgh0I0]@06dIF@2JHXL0hmG@603el^800140mO;R00T0h^Ne0<oKR@1n
IT<0PVM207YT>01UGQ00RHPd0:bSJ@2N/QP03P2N]a800`2fbDd0i>Zm0?GbhP070?GbhP030;J=XP1T
2e00MRQR0080mO;R00H0OcI[07HXHP3/i=T0mO;R08Q5M@1T2e020:eoV@0306@;D01]6ET0k>CI0080
mO;R00P0b:Zd06@;D01T2e00f/O70?GbhP1o=V/0I0]@0:eoV@80mO;R00<0Xg2@06@;D028AGD00`3e
l^801@1o=V/0I0]@0:eoV@3el^80Xg2@00@0I0]@00/0Xg2@0?GbhP1]6ET0I0]@0;nKZ`3el^80b:Zd
06@;D02fSJ80mO;R0=6h_P0206@;D0040>cTf@1]6ET0I0]@0:eoV@<0mO;R00D0OcI[06@;D02ADgh0
mO;R0<RZ]00206@;D080mO;R00@0k>CI06@;D01T2e00dKRn0P3el^800`2JHXL0I0]@06@;D00206@;
D005095COP3/i=T0KAUI06@;D02]OiT00`3el^800`1o=V/0I0]@095COP050?GbhP030:eoV@1T2e00
I0]@00<0I0]@00@0Xg2@0>cTf@3el^80dKRn101T2e000`28AGD0mO;R0?GbhP020?GbhP0307HXHP1T
2e00OcI[00@0mO;R1@1T2e020?GbhPD0I0]@0P3el^800`2JHXL0I0]@06@;D00306@;D00706dIF@3J
alL0mO;R0?GbhP28AGD0I0]@0:eoV@050?GbhP030:eoV@1T2e00I0]@0080I0]@00X0[GnI0?GbhP28
AGD0I0]@0:eoV@3el^80R4Ee06@;D01]6ET0hmG@1P3el^800`2JHXL0I0]@06@;D00206@;D00408Q5
M@3el^80mO;R0;nKZ`H0I0]@00H0_i^[0?GbhP3el^80[GnI06@;D028AGD30?GbhP080:=`T01T2e00
I0]@0:eoV@3el^80R4Ee06@;D02]OiT40?GbhP0308Q5M@1T2e00I0]@0080I0]@00/0dKRn0?GbhP1T
2e00I0]@0=6h_P3/i=T0KAUI06@;D01o=V/0mO;R0:eoV@0406@;D0050:eoV@3el^80[GnI06@;D028
AGD00`3el^80102SL900I0]@06@;D02]OiT20?GbhP0309YRQ`1T2e00I0]@0080I0]@00<0R4Ee0?Gb
hP2]OiT0101T2e000`2]OiT0mO;R0?GbhP0@0?GbhP0309YRQ`1T2e00KAUI00<0mO;R00L0_i^[06@;
D01T2e00hmG@0:eoV@1T2e00R4Ee00D0mO;R00D0dKRn06@;D01T2e00mO;R0=6h_P0206@;D0070:=`
T03el^80R4Ee06@;D02]OiT0mO;R0:eoV@0406@;D0030:eoV@3el^80mO;R00<0mO;R00<0b:Zd06@;
D01T2e00101T2e001028AGD0mO;R0?GbhP2JHXL406@;D00506dIF@3JalL0mO;R0?GbhP2oVj/01@1T
2e00102oVj/0mO;R0?GbhP3A^;h506@;D00306dIF@3/i=T0mO;R01H0mO;R000A0?GbhP0:0>;W]@3?
fhT0KD0b05m7;01MBA`0LE`T0:RVCP32`FT0P5Dm09^_5Pd0W[LB00<0]/U=0>CZ_@3el^801`3el^80
1@3SeM00I0]@06@;D03JalL0k>CI0080I0]@00L0[GnI0?GbhP28AGD0I0]@0:eoV@3/i=T0KAUI00L0
I0]@0P3el^800`2ADgh0I0]@08Q5M@020?GbhP030;J=XP1T2e00I0]@00<0mO;R00D0TE=n06@;D028
AGD0mO;R0;J=XP0206@;D080[GnI00/0_i^[0?GbhP2JHXL0I0]@095COP3el^80Xg2@06@;D01]6ET0
k>CI0=6h_P0206@;D0030?GbhP2]OiT0I0]@00H0I0]@00<0[GnI0?GbhP3JalL00P1T2e00203A^;h0
mO;R0?GbhP1]6ET0I0]@0:eoV@3el^80]XfR0P1T2e001P1f:680[GnI09YRQ`2ADgh0mO;R0:eoV@L0
I0]@00<0[GnI0?GbhP3el^800`3el^801@2]OiT0I0]@07HXHP2]OiT0R4Ee0080I0]@00<0VV:70?Gb
hP3A^;h00P1T2e020:eoV@050;nKZ`3el^80mO;R0?GbhP3A^;h00`1T2e00103A^;h0mO;R0?GbhP3e
l^8206@;D00309YRQ`2]OiT0[GnI0080mO;R0P1T2e001@2JHXL0[GnI0:eoV@3el^80[GnI0080I0]@
00<0MRQR0:eoV@2JHXL00P1T2e001P1]6ET0k>CI0?GbhP28AGD0I0]@0:eoV@D0mO;R00<0[GnI06@;
D01f:6800P2]OiT0103A^;h0mO;R08Q5M@1T2e020:eoV@80I0]@00<0b:Zd0?GbhP3el^80103el^80
2@2]OiT0I0]@06@;D028AGD0[GnI09YRQ`28AGD0mO;R0=6h_P0206@;D00406dIF@2SL900Xg2@06dI
F@80I0]@00D0dKRn0?GbhP2]OiT0I0]@08Q5M@020?GbhP090;nKZ`1T2e00I0]@06@;D02]OiT0mO;R
08Q5M@1T2e00[GnI00@0mO;R00<0R4Ee06@;D028AGD00P2]OiT03@3SeM00mO;R06@;D01T2e00dKRn
08Q5M@1T2e00KAUI0>?Ed03el^80[GnI06@;D01f:6800P2]OiT01@3A^;h0mO;R0:eoV@1T2e00R4Ee
0080mO;R00L0_i^[06@;D01T2e00I0]@0:eoV@3el^80[GnI0080I0]@00P0R4Ee0:eoV@2JHXL0R4Ee
0?GbhP2]OiT0I0]@07HXHP80[GnI00<0dKRn0?GbhP3el^801P3el^800`3/i=T0f/O70?GbhP070?Gb
hP030=[7a`1T2e00I0]@00D0I0]@00D0TE=n0?GbhP2]OiT0I0]@08Q5M@050?GbhP070=6h_P1T2e00
I0]@0>cTf@1]6ET0I0]@07lfJ`020?GbhP0708Q5M@1T2e00[GnI0?GbhP2]OiT0I0]@07HXHP020:eo
V@030=6h_P3el^80mO;R00@0mO;R00@0_i^[06@;D01T2e00KAUI0P28AGD00`2SL900mO;R0=[7a`02
06@;D0050:=`T038Z[@0MRQR06@;D02ADgh00P3el^801`1]6ET0I0]@08Q5M@3A^;h0R4Ee06@;D01]
6ET00P3el^801@1o=V/0I0]@06dIF@38Z[@0_i^[0080I0]@00<0_i^[0?GbhP3el^805@3el^800140
mO;R00/0h^Ne0<oKR@2LNeD0GCTV04i05P18>QD0THI40:Z>IP1j=d`0]jeP0::i6@0<09jg4P030;K9
C@3Tj[d0mO;R00P0mO;R00@0OcI[06@;D02fSJ80b:Zd0P1T2e001`1]6ET0hmG@08Q5M@1T2e00[GnI
0?GbhP2oVj/00P1T2e001@1o=V/0R4Ee06dIF@1T2e00R4Ee0080mO;R00<0[GnI06@;D01o=V/00P3e
l^80103A^;h0I0]@06@;D03/i=T20?GbhP050:eoV@1T2e00OcI[0?GbhP3A^;h00P1T2e002@3/i=T0
mO;R0?GbhP3el^80b:Zd06@;D01]6ET0mO;R07lfJ`0206@;D0040:=`T03A^;h0I0]@06@;D080mO;R
00D0MRQR06@;D01]6ET0R4Ee07lfJ`0206@;D0030=6h_P3el^80mO;R0080I0]@00/0b:Zd0?GbhP3e
l^80R4Ee06@;D02SL900mO;R08Q5M@1T2e00MRQR0>cTf@020?GbhP080=[7a`3el^80mO;R07HXHP1T
2e00KAUI08Q5M@1o=V/206@;D0030=6h_P3el^80mO;R00<0mO;R00<0[GnI06@;D028AGD00P3el^80
1@2]OiT0I0]@06@;D03JalL0dKRn0080I0]@1P3el^801@2ADgh0I0]@06@;D01T2e00VV:700<0mO;R
0P1T2e000`3A^;h0mO;R0?GbhP020?GbhP80I0]@00L0dKRn0?GbhP3el^80mO;R06dIF@1T2e00R4Ee
00<0mO;R00/0dKRn06@;D01T2e00]XfR0?GbhP28AGD0I0]@08Q5M@2]OiT0_i^[0=[7a`020?GbhP03
0:eoV@1T2e00R4Ee00@0mO;R00<0R4Ee06@;D02ADgh00P1T2e000`2SL900mO;R0?GbhP050?GbhP80
I0]@00X0TE=n0?GbhP3el^80mO;R0=[7a`3el^80TE=n06@;D01]6ET0k>CI0P3el^802`3/i=T0KAUI
06@;D02ADgh0mO;R0:eoV@1T2e00R4Ee0?GbhP3JalL0KAUI00<0I0]@00D0[GnI0?GbhP28AGD0I0]@
0:eoV@040?GbhP0308Q5M@1T2e00[GnI00@0mO;R0P1T2e00102ADgh0I0]@06@;D038Z[@20?GbhP03
0:eoV@1T2e00R4Ee00@0mO;R00H0[GnI06@;D028AGD0mO;R0=[7a`1]6ET306@;D0050:eoV@3el^80
I0]@06@;D02ADgh00`3el^801@3JalL0mO;R0:eoV@1T2e00R4Ee00X0mO;R00D0_i^[06@;D01T2e00
OcI[0>cTf@070?GbhP0507lfJ`1T2e00KAUI08Q5M@1o=V/00P1T2e00202oVj/0mO;R0:eoV@1T2e00
MRQR0:eoV@2fSJ80dKRn0P3el^801`3A^;h0I0]@06@;D02ADgh0I0]@06dIF@3SeM000P3el^801`28
AGD0I0]@0:eoV@3el^80[GnI06@;D028AGD02P3el^80102oVj/0I0]@06@;D02oVj/30?GbhP030:eo
V@1T2e00OcI[0080mO;R00D0b:Zd06@;D01T2e00mO;R0=6h_P0206@;D0030>cTf@3el^80k>CI0080
I0]@00D0dKRn0?GbhP28AGD0R4Ee0;J=XP020?GbhP0308Q5M@1T2e00[GnI01L0mO;R000A0?GbhP0<
0>;W]@3?fhT0UG5L06m0>01cFCT0I4/h05hh9020FdX0Of]D0::HL@2QVU80X;HG2`2N]a800`2fbDd0
i>Zm0?GbhP080?GbhP0;0;J=XP1T2e00OcI[0:=`T01T2e00KAUI06@;D02ADgh0R4Ee06@;D02]OiT0
0P3el^80101f:680I0]@09YRQ`3el^8206@;D0040:eoV@3el^80mO;R0<RZ]080I0]@0P3el^80103/
i=T0I0]@06@;D01o=V/208Q5M@0507HXHP1T2e00I0]@0?GbhP3/i=T0101T2e001P1]6ET0mO;R0?Gb
hP1]6ET0I0]@0;nKZ`80I0]@00<0KAUI06@;D02fSJ800P1T2e020?GbhP050;nKZ`1T2e00I0]@0>?E
d02]OiT00P1T2e030?GbhP0307lfJ`1T2e00[GnI0080mO;R00L0Xg2@06@;D028AGD0mO;R08Q5M@1T
2e00R4Ee00H0mO;R00D0_i^[06@;D01T2e00hmG@0:eoV@0206@;D0H0mO;R00<0[GnI06@;D028AGD0
0P3el^801@3/i=T0I0]@06@;D02]OiT0dKRn00@0I0]@00@0[GnI0?GbhP3el^80hmG@0P1T2e00102J
HXL0I0]@06@;D03SeM020?GbhP@0I0]@00<0R4Ee0?GbhP3el^800P1T2e00103A^;h0mO;R0?GbhP3A
^;h206@;D0030<RZ]03el^80mO;R0080mO;R00D0OcI[06@;D028AGD0mO;R08Q5M@0506@;D0030;J=
XP3el^80[GnI00@0I0]@00<0dKRn0?GbhP28AGD0101T2e000`2JHXL0k>CI0?GbhP040?GbhP040=6h
_P1T2e00I0]@0=6h_PD0mO;R0P1T2e000`2SL900mO;R0?GbhP020?GbhP0:0:=`T01T2e00I0]@0?Gb
hP2]OiT0I0]@08Q5M@3/i=T0KAUI06@;D080OcI[00@0I0]@0:eoV@3el^80R4Ee101T2e020?GbhP03
08Q5M@1T2e00I0]@0080I0]@0P3el^8406@;D00506dIF@2]OiT0mO;R0?GbhP2]OiT0101T2e00203A
^;h0mO;R0:eoV@1T2e00R4Ee0>cTf@1]6ET0I0]@0P1o=V/00`1T2e00[GnI0=6h_P0206@;D0030=6h
_P3el^80mO;R00<0mO;R00<0[GnI06@;D01T2e000P1T2e000`3A^;h0mO;R0?GbhP050?GbhP0507HX
HP1T2e00I0]@06@;D02oVj/01`3el^801`2fSJ80I0]@06@;D03/i=T0Xg2@06@;D01]6ET00P3el^80
0`2]OiT0I0]@06@;D00306@;D003095COP3el^80dKRn00@0I0]@00/0MRQR0<RZ]03el^80mO;R08Q5
M@1T2e00[GnI0?GbhP2]OiT0I0]@08Q5M@0;0?GbhP040:eoV@1T2e00I0]@0;nKZ`80mO;R00<0R4Ee
06@;D02SL9000P3el^801`3/i=T0I0]@06@;D03A^;h0[GnI06@;D01o=V/00`3el^800`1o=V/0I0]@
0:eoV@050?GbhP040=[7a`1]6ET0I0]@0<RZ]1L0mO;R000A0?GbhP0=0>;W]@3?ei@0PUU8081`=`2<
IUX0F0`T06Hi:P1[>bl0FALa06HV>P21B4l0LVXT0::i6@0:09jg4P030;K9C@3Tj[d0mO;R00P0mO;R
00/0hmG@06@;D01T2e00MRQR06@;D02fSJ80KAUI06@;D01f:680I0]@0:eoV@020?GbhP040<RZ]01T
2e00I0]@0=6h_P80I0]@00@0b:Zd0?GbhP3el^80dKRn0P1T2e000`3JalL0mO;R0?GbhP0806@;D003
0=[7a`3el^80I0]@00@0I0]@00X0k>CI0?GbhP2JHXL0I0]@07HXHP1T2e00MRQR0:eoV@1T2e00MRQR
0P1T2e030?GbhP0607lfJ`1T2e00VV:709YRQ`1T2e00OcI[0`3el^800`28AGD0I0]@095COP020?Gb
hP070:eoV@1T2e00KAUI0?GbhP2JHXL0I0]@07HXHP070?GbhP0607lfJ`1T2e00VV:709YRQ`1T2e00
OcI[1P3el^800`2]OiT0I0]@08Q5M@020?GbhP050>cTf@1T2e00I0]@0:eoV@3A^;h0101T2e002P2]
OiT0mO;R0?GbhP2SL900I0]@07HXHP3el^80MRQR06@;D02]OiT20?GbhP@0I0]@00<0R4Ee0?GbhP3e
l^800P1T2e00103A^;h0mO;R0?GbhP3A^;h206@;D0030<RZ]03el^80mO;R0080mO;R00T0OcI[06@;
D028AGD0mO;R08Q5M@1T2e00R4Ee0:eoV@1o=V/00P1T2e000`3el^80[GnI06@;D00306@;D0090=6h
_P3el^80R4Ee06@;D028AGD0Xg2@06dIF@1T2e00VV:700D0mO;R00@0dKRn06@;D01T2e00b:Zd1@3e
l^8206@;D0030:=`T03el^80mO;R0080mO;R00H0Xg2@06@;D01T2e00mO;R0:eoV@1T2e0207lfJ`08
06@;D01]6ET0k>CI08Q5M@1T2e00[GnI0?GbhP28AGD406@;D080mO;R00<0R4Ee06@;D01T2e000P1T
2e020?GbhP80I0]@0P2JHXL206@;D0030;nKZ`3el^80[GnI00@0I0]@00@0dKRn0?GbhP2]OiT0I0]@
0P1o=V/01`1T2e00KAUI0>cTf@28AGD0I0]@0:eoV@3A^;h00P1T2e000`38Z[@0mO;R0?GbhP030?Gb
hP030:eoV@1T2e00I0]@0080I0]@00<0dKRn0?GbhP3el^801@3el^801@1f:680I0]@06@;D01T2e00
_i^[00L0mO;R00L0k>CI06@;D01T2e00_i^[07HXHP1T2e00VV:70080mO;R00D0[GnI06@;D01f:680
[GnI095COP0206@;D080dKRn0P1T2e003@2]OiT0R4Ee06@;D01T2e00hmG@0?GbhP28AGD0I0]@0:eo
V@3el^80[GnI06@;D028AGD0303el^80202ADgh0I0]@06@;D03A^;h0mO;R08Q5M@1T2e00[GnI0`3e
l^8206@;D0040=6h_P2]OiT0I0]@08Q5M@<0mO;R00<0R4Ee06@;D02]OiT0103el^80102]OiT0I0]@
06@;D02SL90H0?GbhP004@3el^803P3RikD0/:5n07iWA`1eKb/0OUe807eAB`1WH200L5<k06HG>@1Y
:d40UFaJ089PA028JSl0VjdE2@2N]a800`2fbDd0i>Zm0?GbhP090?GbhP0607lfJ`1T2e00I0]@06@;
D03JalL0_i^[0`1T2e001`2]OiT0mO;R0?GbhP3el^80R4Ee06@;D01f:6800P1T2e00103/i=T0mO;R
0?GbhP3el^8206@;D0060<RZ]03el^80mO;R08Q5M@1T2e00Xg2@0`3el^8206@;D0050<RZ]03el^80
R4Ee06@;D02SL900103el^801`38Z[@0I0]@06@;D01T2e00TE=n0?GbhP1f:6800`1T2e030?GbhP06
0=6h_P1T2e00I0]@07HXHP1T2e00Xg2@0`3el^800`2]OiT0I0]@07lfJ`020?GbhP050=6h_P1T2e00
I0]@0>cTf@3A^;h00P1T2e001@2fSJ80mO;R0?GbhP3el^80hmG@0080mO;R00H0dKRn06@;D01T2e00
MRQR06@;D02SL9060?GbhP030:eoV@1T2e00R4Ee0080mO;R00D0[GnI06@;D01T2e00f/O70=6h_P02
06@;D0@0mO;R00P0k>CI06dIF@1T2e00[GnI0?GbhP2]OiT0I0]@06dIF@80mO;R0P1T2e000`3A^;h0
mO;R0?GbhP020?GbhP80I0]@00L0dKRn0?GbhP3el^80mO;R06dIF@1T2e00R4Ee00<0mO;R00X0dKRn
06@;D01T2e00]XfR0?GbhP28AGD0I0]@0:eoV@3el^80dKRn0P1T2e00103A^;h0[GnI06@;D028AGD4
0?GbhP0508Q5M@1T2e00[GnI0?GbhP2]OiT00P1T2e060?GbhP0306dIF@1T2e00R4Ee00<0mO;R00H0
f/O70?GbhP2ADgh0I0]@06dIF@3/i=T20?GbhP060>cTf@1]6ET0I0]@095COP3el^80[GnI101T2e00
2@3JalL0mO;R08Q5M@1T2e00[GnI0?GbhP28AGD0I0]@0:eoV@040?GbhP0308Q5M@1T2e00[GnI00@0
mO;R0P1T2e002@3A^;h0mO;R08Q5M@1T2e00R4Ee0?GbhP2]OiT0I0]@08Q5M@040?GbhP030:eoV@1T
2e00I0]@0080I0]@00T0f/O70?GbhP28AGD0I0]@0:eoV@3el^80KAUI06@;D028AGD00`3el^801@3J
alL0mO;R0:eoV@1T2e00R4Ee00X0mO;R00D0_i^[06@;D01T2e00OcI[0>cTf@080?GbhP0309YRQ`1T
2e00OcI[0080I0]@00H0f/O70?GbhP3el^80[GnI06@;D028AGD20?GbhP80I0]@00@0[GnI0=6h_P1T
2e00I0]@0P3el^8206@;D0090:eoV@3el^80R4Ee06@;D02]OiT0mO;R0:eoV@1T2e00R4Ee00`0mO;R
00P0hmG@06@;D01T2e00VV:70?GbhP2ADgh0I0]@09YRQ`80mO;R00L0hmG@06@;D01T2e00f/O70;J=
XP1T2e00MRQR00<0mO;R00<0MRQR06@;D02fSJ80103el^80103A^;h0OcI[06@;D02JHXLH0?GbhP00
4@3el^803`3RikD0T7MK05hk=P2NQfd0UY9?07im;@25Q300^:Mi085M@`1lBS/0L3Di08eMC`2YUFT0
MV``09V_4P0809jg4P030;K9C@3Tj[d0mO;R00T0mO;R00@0]XfR06@;D01T2e00KAUI0P3el^80101o
=V/0I0]@06@;D02]OiT30?GbhP050=6h_P1T2e00I0]@06@;D01f:6800P3el^802P2oVj/0[GnI06@;
D01T2e00R4Ee0:eoV@3A^;h0VV:706@;D028AGD30?GbhP0707HXHP1T2e00[GnI0?GbhP2JHXL0I0]@
07HXHP020:eoV@040=6h_P3el^80mO;R06dIF@80I0]@00<0]XfR0?GbhP38Z[@00`1T2e040?GbhP09
08Q5M@1T2e00I0]@06@;D02oVj/0mO;R0>?Ed02]OiT0R4Ee0080I0]@0P2]OiT01P3SeM00I0]@06@;
D03A^;h0mO;R09YRQ`80I0]@00@0TE=n0:eoV@28AGD0Xg2@0`3el^801@28AGD0I0]@06@;D01T2e00
_i^[00H0mO;R00D0[GnI06@;D01f:680[GnI08Q5M@0206@;D003095COP3el^80dKRn0080I0]@0P2]
OiT00`2oVj/0mO;R0;nKZ`0206@;D0030>?Ed03el^80hmG@0080I0]@00D0_i^[0?GbhP1T2e00I0]@
09YRQ`020:eoV@80mO;R0P1T2e001@3A^;h0mO;R0?GbhP3el^80[GnI0080I0]@00<0MRQR0:eoV@2J
HXL00P1T2e00201]6ET0k>CI0?GbhP28AGD0I0]@08Q5M@2]OiT0OcI[0P1T2e00103/i=T0[GnI06@;
D01f:6820:eoV@090=6h_P3el^80R4Ee06@;D02JHXL0b:Zd07lfJ`1T2e00MRQR00H0mO;R00T0[GnI
06@;D01T2e00R4Ee0:eoV@2JHXL0R4Ee0?GbhP3A^;h00P1T2e00101]6ET0Xg2@0:=`T01]6ET206@;
D0030=6h_P3el^80[GnI00<0I0]@00X0_i^[0?GbhP3el^80R4Ee06@;D02]OiT0mO;R08Q5M@1T2e00
R4Ee0P2]OiT01@3SeM00mO;R08Q5M@1T2e00R4Ee0080[GnI00d0hmG@0?GbhP1T2e00I0]@0;J=XP2o
Vj/0KAUI06@;D02JHXL0mO;R0:eoV@1T2e00MRQR0080[GnI00<0dKRn0?GbhP2]OiT00`1T2e00202o
Vj/0mO;R0?GbhP28AGD0I0]@0:eoV@3el^80[GnI0P1T2e002028AGD0[GnI09YRQ`28AGD0mO;R0:eo
V@1T2e00MRQR0P2]OiT00`3A^;h0mO;R0?GbhP060?GbhP030>cTf@3JalL0mO;R00T0mO;R00D0dKRn
06@;D01T2e00I0]@07lfJ`030?GbhP050:eoV@1T2e00MRQR0:eoV@2ADgh00P1T2e001P38Z[@0dKRn
06@;D01T2e00dKRn0:eoV@80I0]@00T0_i^[0?GbhP28AGD0I0]@0:eoV@3el^80[GnI06@;D028AGD0
203el^801@1]6ET0I0]@08Q5M@3el^80k>CI0080I0]@00`0R4Ee0?GbhP2fSJ80I0]@07HXHP3/i=T0
mO;R0;J=XP1T2e00KAUI0?GbhP3JalL206@;D0030=[7a`3el^80f/O70080I0]@00L0f/O70?GbhP38
Z[@0[GnI0;nKZ`3el^80dKRn0080I0]@603el^800140mO;R0100h^Ne081AD@1lC5<0E4dG07an6`1_
HR/0UIDm08Mm@`1^HB@0OG8N071e6@1=:b@0[I]U064g;`1eE2l0VjdE1`2N]a800`2fbDd0i>Zm0?Gb
hP090?GbhP040>?Ed01T2e00I0]@08Q5M@80mO;R00@0dKRn06@;D01T2e00[GnI103el^80102ADgh0
I0]@06@;D02JHXL20?GbhP03095COP1T2e00I0]@00<0I0]@00@0Xg2@0:eoV@1T2e00MRQR0`3el^80
1@28AGD0I0]@09YRQ`3el^80[GnI00@0I0]@00@0TE=n0?GbhP3el^80VV:70P1T2e00103A^;h0mO;R
0?GbhP28AGD206@;D0@0mO;R00L0f/O706@;D01T2e00I0]@0>?Ed03el^80f/O700H0I0]@00@0k>CI
06@;D01T2e00_i^[0P3el^800`2SL900I0]@06@;D00206@;D00508Q5M@3el^80mO;R0?GbhP3JalL0
0`1T2e000`3SeM00mO;R0?GbhP040?GbhP030:eoV@1T2e00I0]@00<0I0]@00@0Xg2@0>cTf@3el^80
dKRn101T2e001@28AGD0mO;R07lfJ`1T2e00TE=n00<0mO;R00@0TE=n06@;D01o=V/0mO;R1@1T2e02
0?GbhP80I0]@00<0dKRn0?GbhP3el^800P3el^800`2SL900I0]@06@;D00306@;D00507HXHP3JalL0
mO;R0?GbhP28AGD01@1T2e000`2fSJ80mO;R0:eoV@0406@;D0030:eoV@3el^80R4Ee00D0I0]@00<0
_i^[0?GbhP3el^801@3el^800`2JHXL0I0]@06@;D00206@;D00508Q5M@3el^80mO;R0;nKZ`1]6ET0
101T2e001@1]6ET0_i^[0?GbhP3el^80[GnI0080I0]@00T0Xg2@0?GbhP3el^80mO;R08Q5M@1T2e00
[GnI0?GbhP28AGD0101T2e000`3A^;h0mO;R08Q5M@0406@;D0030=6h_P3el^80I0]@00@0I0]@00@0
KAUI0=[7a`3el^80[GnI101T2e000`2]OiT0mO;R0:eoV@0206@;D0070:=`T03el^80mO;R0?GbhP28
AGD0I0]@0:eoV@020?GbhP0309YRQ`1T2e00I0]@0080I0]@00<0R4Ee0?GbhP2]OiT0101T2e000`2]
OiT0mO;R0?GbhP0C0?GbhP0407HXHP1T2e00I0]@0;J=XP<0mO;R00<0[GnI06@;D01T2e000`1T2e00
0`2ADgh0mO;R0=6h_P0506@;D00:07lfJ`3/i=T0mO;R08Q5M@1T2e00[GnI0?GbhP2]OiT0I0]@08Q5
M@P0mO;R00D0VV:706@;D01T2e00Xg2@095COP0206@;D0030;J=XP3el^80hmG@0080I0]@00D0R4Ee
0:=`T01]6ET0I0]@09YRQ`020?GbhP0707HXHP1T2e00MRQR0:eoV@1f:680I0]@07HXHP020?GbhP07
0;J=XP1T2e00I0]@0<RZ]02JHXL0I0]@06dIF@0H0?GbhP004@3el^804@3RikD0a:jG09MfJP1nIS<0
Og/^07QR>@1/BC@0L5LU05PO:`2@NU40AQhR09UhH@2BNe00S8ID03lh3@1]JQ40WK4G00H0W[LB00<0
]/U=0>CZ_@3el^802P3el^800`2fSJ80[GnI0=6h_P030?GbhP030;J=XP2]OiT0dKRn00@0mO;R00@0
hmG@0:eoV@2]OiT0dKRn0P3el^800`3A^;h0[GnI0:eoV@030:eoV@040;nKZ`3SeM00[GnI0:eoV@<0
mO;R00D0dKRn0:eoV@2oVj/0mO;R0>?Ed0040:eoV@040;nKZ`3el^80mO;R0=[7a`80[GnI0`3el^80
0`3JalL0[GnI0:eoV@050?GbhP030;nKZ`2]OiT0[GnI00<0mO;R1P2]OiT0103SeM00_i^[0:eoV@3A
^;h30?GbhP050>?Ed02]OiT0R4Ee095COP2oVj/0103el^800`2oVj/0[GnI0:eoV@070?GbhP060=6h
_P2]OiT0[GnI0:eoV@2fSJ80f/O70`3el^800`3SeM00[GnI0:eoV@020:eoV@050;nKZ`3/i=T0[GnI
0:eoV@3JalL00`3el^80103JalL0[GnI0:eoV@3/i=T50:eoV@80mO;R0P2]OiT00`3SeM00mO;R0?Gb
hP030?GbhP060=6h_P2SL900R4Ee095COP2fSJ80k>CI0`3el^801P2oVj/0[GnI0:eoV@2]OiT0_i^[
0>?Ed080mO;R00<0dKRn0:eoV@2]OiT00P2]OiT00`3A^;h0mO;R0;nKZ`030:eoV@030;J=XP3SeM00
mO;R00P0mO;R00D0dKRn0:=`T028AGD0VV:70<RZ]0030?GbhP060>?Ed02]OiT0R4Ee08Q5M@2]OiT0
hmG@0`3el^800`3A^;h0[GnI0;J=XP040?GbhP050;nKZ`2]OiT0dKRn0?GbhP2oVj/0102]OiT00`3S
eM00mO;R0;nKZ`040:eoV@030>?Ed03el^80[GnI00<0[GnI00D0_i^[0>cTf@3el^80mO;R0=6h_P04
0:eoV@050=6h_P3el^80dKRn0:eoV@2fSJ80103el^800`2oVj/0[GnI0=6h_P030?GbhP070=6h_P2S
L900R4Ee09YRQ`38Z[@0mO;R0=6h_P040:eoV@030=6h_P3el^80mO;R01<0mO;R00@0b:Zd0:eoV@2]
OiT0k>CI0`3el^801P3A^;h0[GnI0:eoV@2]OiT0]XfR0=[7a`80mO;R00<0hmG@0:eoV@2]OiT00P2]
OiT02`38Z[@0mO;R0?GbhP3el^80_i^[0:eoV@3A^;h0mO;R0=6h_P2]OiT0_i^[00P0mO;R00<0hmG@
06dIF@1T2e000`1T2e001@1o=V/0k>CI0?GbhP3el^80_i^[00@0I0]@00H0OcI[0>cTf@3el^80mO;R
0=[7a`1]6ET306@;D00606dIF@3JalL0mO;R0?GbhP3/i=T0OcI[101T2e000`2]OiT0mO;R0?GbhP0F
0?GbhP004@3el^804P3RikD0cm^90=[IR@1]AC@0U8/h05<?701@4A/0GRXQ0:J:J02HU5h0J2hm05Q?
:`22RaH0JUlg08R0@025KE40NU`f09jf4`D0W[LB00<0]/U=0>CZ_@3el^80o`3el^9:0?GbhP050>cT
f@2fSJ80R4Ee095COP2oVj/01@3el^801@3A^;h0TE=n08Q5M@2]OiT0k>CI00@0mO;R00D0hmG@09YR
Q`28AGD0VV:70>?Ed0040?GbhP050>cTf@2fSJ80R4Ee08Q5M@2oVj/06@3el^800140mO;R01<0h^Ne
0<oKR@2SUEh0VWe@09AjB`2UYT@0UY4g05hN9P1L:B80WII]074m?`1kNCT0RI0V07A?>`2AOdd0IT4i
07=R;P2CTBh0W;8H00@0W[LB00<0]/U=0>CZ_@3el^80o`3el^:40?GbhP004@3el^80503RikD0cm^9
0:^GI02CMU00X8MK0;^aN`2XTWL0NVY704XR5P1ZCR@0UhUH0:^WK`1UIQ40A1lM089O?P1S?S00G5T>
06QX401mPa40WKDB0`2N]a800`2fbDd0i>Zm0?GbhP3o0?GbhX@0mO;R000A0?GbhP0E0>;W]@3?fhT0
fMV90:F:H`2^W6d0LcXd08=M@P1N:Rl0KDlj0;FSPP2XWGP0L4l]0756?P1J;B`0FcDY09R1F@1^KA80
NghB08F>4`2BXB40X[TI0080W[LB00<0]/U=0>CZ_@3el^80o`3el^:40?GbhP004@3el^800`3RikD0
cm^90=WIR@020=WIR@0D0<:fM@1kC3/0EQ@[04/;601B41d0CS<P07aT;02PTf00MF]105a<4`2>IUT0
RG]@07n54P1cNA40b<Y[0<kCL`2R^AT0W[LB0;K9C@3Tj[go0?GbhXD0mO;R000A0?GbhP030>;W]@3?
fhT0fMV900<0fMV901<0dLn305XE<@1Q6SX0I1Lk06dPA`1S7S`0IB@l05Dg801`Gah0UgmC0;>aF`3=
bgX0^;UM0=?BP@3IfHT0c]=c0::i6@2fbDd0i>Zm0?l0mO;RQ@3el^800140mO;R00<0h^Ne0<oKR@3:
dF/0103:dF/02@2<GT/0D1DY07iL?@2CSSh0QG<X08MTD@2[Vf@0P6540;BYI@060<[AJ`030;o:E@2f
bDd0i>Zm0?l0mO;RQ@3el^800140mO;R00<0h^Ne0??fh@3WkL@0103WkL@02@3[kl/0moKQ0>O]a03R
hl<0fm^_0;6GQ@2POg00aK:E0>__b`070>O]a0030>gbd`3Tj[d0mO;R0?l0mO;RQ03el^800140mO;R
00<0j^_80=oS[P3Ohjh05@3Ohjh00`3Uik/0mO;R0?GbhP3o0?GbhX<0mO;R003o0?GbhZl0mO;R003o
0?GbhZl0mO;R0000\
\>"], "Text",
  Evaluatable->False,
  ImageSize->{430, 31},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  Background->RGBColor[0.960006, 0.940017, 0.890013]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["MathLink",
    FontFamily->"Times",
    FontSlant->"Italic"],
  StyleBox[" + Netlib = MathLib",
    FontFamily->"Times"]
}], "Title",
  ShowCellBracket->False,
  FontColor->RGBColor[0.440009, 0, 0.290013],
  Background->RGBColor[0.850004, 0.910002, 0.570001]],

Cell[TextData[{
  "Fast Numerics for ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Subtitle",
  ShowCellBracket->False,
  FontColor->RGBColor[0.440009, 0, 0.290013],
  Background->RGBColor[0.850004, 0.910002, 0.570001]],

Cell[TextData[{
  "O. R\[UDoubleDot]benk\[ODoubleDot]nig, E. B. Rudnyi and J. G. Korvink\n\
IMTEK\[Dash]Institute for Microsystem Technology\nAlbert Ludwig University \
Freiburg\nGermany, Europe\n",
  StyleBox[ButtonBox["http://www.imtek.de/simulation",
    ButtonData:>{
      URL[ "http://www.imtek.de/simulation/"], None},
    Active->True,
    ButtonStyle->"Hyperlink"], "Text"]
}], "Author",
  ShowCellBracket->False,
  FontColor->GrayLevel[1],
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[CellGroupData[{

Cell["Abstract", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " is an advanced environment perfectly suited to rapid prototyping in \
scientific computing. One can easily combine symbolic and numerical \
computations and, in the latter case, check the influence of rounding errors \
merely by increasing precision to arbitrary levels. The range of available \
linear algebra functions is large and convenient, so that a developer can \
focus on the problem at hand, for example, the development of sophisticated \
discretization schemes for partial differential equations.\n\tHowever, when \
one extends the developed prototype application to large numerical \
computations, important for practice, ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " happens to be restrictively slow. A danger exists in that the development \
effort is lost, since translation of a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " package to a compiled language cannot, in general be automated, so that \
one may have to start from scratch. Also from this point of view it is most \
desirable to remain within the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " environment.\n\tConsider a simple example based on an algorithm found at \
the heart of many scientific computational engines. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s LUDecomposition function, which is a basic linear algebra block, is \
much more flexible but unfortunately much slower than for example analogous \
functions available in ",
  ButtonBox["Lapack",
    ButtonData:>"Lapack",
    ButtonStyle->"Hyperlink"],
  ". The reason is straightforward and will be explained below.\n\tIn the \
present work, we discuss how we use ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " to directly call precompiled ",
  ButtonBox["Netlib",
    ButtonData:>"Netlib",
    ButtonStyle->"Hyperlink"],
  "  numerical libraries in order to combine ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s flexibility and the efficiency of mature numerical algorithms. We \
package the libraries in notebooks that renders their use completely \
transparent to the typical user. Two cases described below are considered in \
this paper."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Introduction", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  "This paper is divided into several parts. First, in the setup section, we \
describe on how to obtain the necessary software and install it on your \
system. At the end you should have a working interface to the LU routines \
from ",
  ButtonBox["ATLAS",
    ButtonData:>"ATLAS",
    ButtonStyle->"Hyperlink"],
  " and ",
  ButtonBox["Quadpack",
    ButtonData:>"Quadpack",
    ButtonStyle->"Hyperlink"],
  ".\nIn the next part we investigate linear algebra with lapack as a first \
example. We will find a deficiency of speed for solving large \
LUDecompositions where arbitrary precise solutions are not needed. In this \
section we will explain how we created a user transparent solution to solve \
large scale linear algebra problems considerably faster than the native ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " methods. \nThis will be followed by an example using numerical \
integration with Quadpack."
}], "Text"],

Cell[TextData[{
  "All timings indicated below are for a 1.7 GHz, 256M machine running a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 4.2 kernel under the SuSE Linux operating system."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Lapack Interface", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[CellGroupData[{

Cell["Outline", "Subsection"],

Cell[TextData[{
  "We are concerned with pointing out different needs of the Computer Algebra \
System ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " in different domains of science. The needs apparent can be expressed as a \
level of abstraction needed to solve a problem at hand. It is argued that a \
high level of abstraction, i.e. functions able to handle symbolic algebra, is \
not always needed. In deed the performance with respect to computational time \
and memory is an important factor. This will be discussed in the section ",
  ButtonBox["Level of abstraction versus performance",
    ButtonData:>"Level of abstraction versus. performance",
    ButtonStyle->"Hyperlink"],
  ".\nConsequently we will develop our own solution for the discussed \
problem. The critical discussion can be found in the section on ",
  ButtonBox["Performance comparison between Mathematica and MathLib",
    ButtonData:>"Performance comparison between Mathematica and MathLib",
    ButtonStyle->"Hyperlink"],
  " and ",
  ButtonBox["Accuracy of the result",
    ButtonData:>"Accuracy of the result",
    ButtonStyle->"Hyperlink"],
  ". Rounding these main topics off we present ",
  ButtonBox["The transparent user interface",
    ButtonData:>"The transparent user interface",
    ButtonStyle->"Hyperlink"],
  "\nand some thoughts on ",
  ButtonBox["Portability",
    ButtonData:>"Portability",
    ButtonStyle->"Hyperlink"],
  ". The ",
  ButtonBox["Conclusion",
    ButtonData:>"Conclusion",
    ButtonStyle->"Hyperlink"],
  " presents our results."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Level of abstraction versus performance", "Subsection",
  CellTags->"Level of abstraction versus. performance"],

Cell[CellGroupData[{

Cell["The starting point", "Subsubsection"],

Cell[TextData[{
  "The traditional way in scientific computing, regarding application \
development, is to write a piece of code to perform a task at the need of a \
scientist. If some parts of the task is also to be preformed by other \
applications, mostly it pays to develop a library providing the common \
routines needed by the applications. This has the advantage that a certain \
abstraction, a decoupleing is achieved. The concept of linear algebra is one \
such application needed over and over in science.\nThe linear algebra \
abstraction itself is based on a more fundamental library which can also be \
decoupled: the ",
  StyleBox["B",
    FontWeight->"Bold"],
  "asic ",
  StyleBox["L",
    FontWeight->"Bold"],
  "inear ",
  StyleBox["A",
    FontWeight->"Bold"],
  "lgebra ",
  StyleBox["S",
    FontWeight->"Bold"],
  "ubprograms (BLAS). BLAS provides so called vector-vector (so called level \
1 BLAS), matrix-vector (level 2) and matrix-matrix (level 3) operations.\nOn \
the other hand the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " application is well suited for scientific computation since it relives \
the scientist of the burden to develop fundamental routines; an extreme level \
of abstraction has been reached at the point where numerical and symbolic \
data can be combined. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " provides a wealth of functions a scientist can choose from. Thus a \
scientist can concentrate on the problem at hand. This is further underlined \
by the interpreted development cycle, which is, with respect to the total \
time spent solving a problem, usually faster then the write-compile-debug \
cycle common to a C developing environment.\nThe ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " internal routines provide arbitrary precision. The computational cost for \
arbitrary precision becomes predominant for large scale scientific \
applications and in this aspect ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " tends to be restrictive.  The central question is whether a scientific \
application does always need arbitrary precision. Do you always have the time \
for arbitrary precision? In the deadline driven engineering domain clearly \
not always. This is underlined by the success of for example Matlab in the \
engineering branch. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " should offer the flexibility to the user to choose when there is a need \
for speed and when there is a need for precision or a high level of \
abstraction. The purpose of this paper is to investigate weather and if so, \
at what cost we can overcome the performance restriction of high abstraction. \
We are interested in an investigation on  how it is possible access the speed \
common to in C written applications in ",
  StyleBox["Mathematica ",
    FontSlant->"Italic"],
  "on the specific case of LU decomposition. However the message conveyed is \
more general. The user has a need to access the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " kernel memory  in a faster way than that provided by ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  ".\nReturning to our specific goal in mind, one implementation of the BLAS \
library is provided by the ",
  StyleBox["A",
    FontWeight->"Bold"],
  "utomatically ",
  StyleBox["T",
    FontWeight->"Bold"],
  "uned ",
  StyleBox["L",
    FontWeight->"Bold"],
  "inear ",
  StyleBox["A",
    FontWeight->"Bold"],
  "lgebra ",
  StyleBox["S",
    FontWeight->"Bold"],
  "oftware (ATLAS). Much effort was spend in providing a high performance \
BLAS library that is automatically tuned for each underlying hardware system. \
ATLAS is now also moving beyond the basic linear algebra frontiers and \
provides some linear algebra routines. Figure ",
  
  CounterBox["NumberedFigure", "MathLibIdea"],
  " shows the hierarchical layers of ideas build on top of the hardware. The \
BLAS is closest to the hardware followed by the linear algebra abstraction \
followed by the application layer. Implementations of the abstract layers are \
ATLAS providing the BLAS and some parts linear algebra layer. The jump in \
abstraction layer is indicated with the red line. The rest of the linear \
algebra is provided by the ",
  StyleBox["L",
    FontWeight->"Bold"],
  "inear ",
  StyleBox["A",
    FontWeight->"Bold"],
  "lgebra ",
  StyleBox["P",
    FontWeight->"Bold"],
  "ackage (LAPACK). To gain access to a full fledged linear algebra package \
both the ATLAS and the LAPACK provided libraries  have to be merged.\n",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " for now does all its computations internally and is directly on top of \
the hardware layer - at least from a user point of view.\nThe idea is to \
export the large linear algebra problem via ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " through an interface to an external linear algebra package.\nThe marriage \
between ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " and NetLib, the provider of LAPACK, is called ",
  StyleBox["MathLib",
    FontSlant->"Italic"],
  "."
}], "Text"],

Cell[TextData[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .54326 
%%ImageSize: 498 271 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-4.2067e-17 0.00201207 -0.00201207 0.00201207 [
[ 0 0 0 0 ]
[ 1 .54326 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .54326 L
0 .54326 L
closepath
clip
newpath
% Start of colorimage (RGB)
p
0 -0.00201 translate
1.00201 .54527 scale
1494 string
498 271 8 [498 0 0 271 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  false 3 Mcolorimage
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF0000000000000D0D0D000000FFFFFF
F5F5F5FFFFFF0000000000000000001616160E0E0EF3F3F3FFFFFF0505050F0F0F000000
000000FBFBFB0000000F0F0F0000000000000707070E0E0E000000FFFFFFF9F9F9FFFFFF
000000121212000000F5F5F5101010000000010101FFFFFFFFFFFFF3F3F3FFFFFFFFFFFF
000000F7F7F7FFFFFFF5F5F5FAFAFA0C0C0CFFFFFFEEEEEEFFFFFFFFFFFF0000000E0E0E
020202000000FFFFFF020202050505FDFDFD0B0B0B0000000000000C0C0C000000FFFFFF
F4F4F4F5F5F5111111000000000000000000FBFBFBFFFFFFFCFCFCF5F5F5FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF8F8F8F6F6F6080808000000FFFFFFFCFCFC
FFFFFFFDFDFDFFFFFFF9F9F9020202000000E2E2E2FFFFFF000000000000000000FFFFFF
FFFFFF040404040404F9F9F9FBFBFB0B0B0B000000F5F5F5FEFEFEFBFBFBFFFFFF000000
000000FFFFFFEEEEEEFFFFFF000000000000FFFFFFFFFFFFFDFDFDFFFFFFF3F3F3000000
000000000000FEFEFEFCFCFC040404000000FFFFFFFFFFFFF9F9F9000000090909010101
FFFFFFF7F7F7000000000000FFFFFFFDFDFDF8F8F80F0F0F000000FFFFFFFBFBFBF8F8F8
FFFFFF000000020202000000FEFEFEFFFFFF0E0E0EECECECF4F4F4FFFFFFF6F6F6FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFFFFFF000000000000FCFCFCFFFFFF
F8F8F8FEFEFEFFFFFFFFFFFF0909090B0B0BFFFFFFFCFCFCFFFFFF030303000000FFFFFF
FFFFFF0000000B0B0BFAFAFAFFFFFF000000000000FEFEFEFFFFFFE9E9E91212120E0E0E
050505FFFFFFFBFBFBFFFFFF0000000C0C0CF4F4F4FFFFFFFEFEFEFFFFFFFFFFFF000000
070707050505FFFFFFFDFDFD060606000000000000F9F9F9F7F7F7FFFFFF080808000000
FFFFFFFFFFFF0F0F0F070707FFFFFFFCFCFCFCFCFC020202000000FCFCFCFFFFFFFFFFFF
FFFFFF121212000000FFFFFFFFFFFFECECECF9F9F9151515FFFFFFFFFFFFF7F7F7FCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF8F8F8F6F6F6FFFFFF000000020202FFFFFFF9F9F9
FFFFFFFEFEFEFFFFFFFFFFFF000000000000FFFFFFFBFBFBFFFFFF0000000F0F0FFFFFFF
EBEBEB020202000000FAFAFAF5F5F50A0A0A010101FFFFFFFDFDFDFFFFFF000000000000
FEFEFEEEEEEEFFFFFFF8F8F8020202000000FFFFFFFAFAFAFFFFFFE5E5E5FCFCFC000000
050505000000FFFFFF030303000000ECECEC111111FEFEFEFFFFFFFBFBFB0505050A0A0A
EDEDEDFFFFFF000000000000FFFFFFF9F9F9FFFFFF000000090909FFFFFFF1F1F1FAFAFA
000000000000FFFFFFF3F3F3FFFFFFFFFFFFEDEDEDFFFFFFF8F8F8FAFAFAFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000050505F7F7F7FFFFFF
F5F5F5F6F6F6FFFFFFFFFFFF0D0D0D000000FFFFFFFCFCFCF6F6F6FFFFFF000000000000
FFFFFF0303030B0B0BFFFFFFFFFFFF000000080808E0E0E0FFFFFFFFFFFF0000000D0D0D
F9F9F9FFFFFFEEEEEEFCFCFC000000060606FFFFFFF8F8F8FFFFFFFFFFFF0A0A0A000000
F0F0F0FFFFFF000000000000080808F6F6F6030303F6F6F6FAFAFAFEFEFEE5E5E5060606
070707F3F3F3020202000000FFFFFFFDFDFDFFFFFF000000000000DFDFDFFFFFFFFFFFFF
020202000000FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9FCFCFCFFFFFFF1F1F1FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF0F0F0FCFCFCF5F5F5FAFAFA010101161616E6E6E6FFFFFF
FFFFFFFFFFFFF4F4F4F1F1F10202020A0A0AECECECFFFFFFFDFDFDF5F5F5FFFFFFF9F9F9
FFFFFF000000060606F8F8F8FDFDFD000000000000FFFFFFF9F9F9EEEEEE0C0C0C000000
FFFFFFF3F3F3FFFFFFFFFFFF0A0A0A000000E7E7E7FFFFFFF7F7F7DEDEDE0F0F0F050505
FFFFFFF9F9F9000000030303F6F6F6FFFFFFFFFFFF000000FFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFEFEFE090909030303EEEEEEFFFFFFFAFAFA060606000000FFFFFFFFFFFFF0F0F0
040404000000131313000000090909000000000000000000FFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFE0707070000000D0D0D000000
0606060000000E0E0E000000000000000000FFFFFFFFFFFFFFFFFF000000000000FFFFFF
EDEDED101010000000FEFEFEFCFCFC0202020C0C0CF4F4F4FEFEFEFFFFFFF6F6F6040404
050505FAFAFAF7F7F7FFFFFF000000060606FFFFFFFDFDFDFFFFFF0F0F0F000000F8F8F8
F9F9F9FFFFFF070707000000FFFFFFF9F9F9F0F0F0101010F0F0F0F6F6F6060606000000
F6F6F6FFFFFF000000000000FFFFFFFEFEFEF3F3F3040404020202F7F7F7FEFEFEFFFFFF
FFFFFF000000EEEEEEFFFFFFFAFAFA0505050C0C0C010101FCFCFCFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF4F4F4FFFFFF010101000000FFFFFFFBFBFB
FFFFFFFAFAFAF9F9F9FFFFFF000000000000FFFFFFF8F8F8FDFDFD060606000000FFFFFF
FFFFFF000000060606FDFDFDFFFFFF0000000808080A0A0A020202000000FFFFFF000000
0E0E0EFCFCFCFFFFFF000000000000020202F8F8F8FFFFFFFFFFFF0000000B0B0BFDFDFD
FFFFFFF8F8F8000000010101FDFDFDFDFDFDFFFFFF010101000000FFFFFF000000020202
FBFBFBFFFFFF090909000000FFFFFFFFFFFFF1F1F1060606000000060606000000040404
FFFFFF050505070707FCFCFCFFFFFF070707000000FFFFFFFFFFFFFFFFFFFAFAFAFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFF
F0F0F0FFFFFFFFFFFFF2F2F20D0D0D000000FFFFFFFFFFFFFFFFFFFCFCFC000000010101
010101000000FCFCFCFFFFFFF8F8F8FAFAFA020202EAEAEA080808000000FAFAFAFFFFFF
EEEEEE0000000000000000000101010C0C0CFCFCFCF6F6F60000000B0B0B000000000000
FFFFFF0000000C0C0C000000000000FFFFFFECECEC020202000000FFFFFFF2F2F2000000
000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF131313EBEBEB171717030303
F3F3F3F7F7F7F2F2F2040404000000000000FFFFFFFBFBFBFFFFFFF1F1F1FCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5F1F1F1FFFFFFFDFDFD000000000000FAFAFAFFFFFF
FFFFFFFEFEFEFEFEFEFFFFFF000000000000FFFFFFF1F1F1FFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFAFAFAFFFFFFFFFFFFFEFEFEFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF000000000000FFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFF
FFFFFFF7F7F7FFFFFFFFFFFFFBFBFBEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFCFCFCFFFFFFECECECF4F4F4FFFFFFF4F4F4EBEBEBFFFFFFFDFDFDEFEFEF
FFFFFFFFFFFFF3F3F3FFFFFFFFFFFFFFFFFFF2F2F2FDFDFDFFFFFFFFFFFFFFFFFFF7F7F7
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFEFEFE000000010101FFFFFFFDFDFD
FEFEFEFFFFFFE9E9E9FFFFFF0000000C0C0CF7F7F7FFFFFFFBFBFBFFFFFFFEFEFEFAFAFA
FAFAFAFEFEFEFFFFFFFBFBFBF6F6F6FFFFFFFFFFFFF3F3F3FAFAFAFEFEFEFEFEFEFEFEFE
FFFFFFE2E2E2F5F5F5FFFFFF0000000E0E0EFFFFFFF2F2F2FAFAFAFFFFFFFEFEFEFAFAFA
FDFDFDFFFFFFF0F0F0FAFAFAFFFFFFF3F3F3FAFAFAFFFFFFFEFEFEF5F5F5FCFCFCF4F4F4
FEFEFEFEFEFEFFFFFFECECECFFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
F6F6F6F7F7F7FFFFFFFEFEFEFDFDFDFFFFFFF9F9F9FFFFFFFBFBFBFFFFFFF0F0F0FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFFF1F1F1FFFFFF0000000A0A0AFDFDFDFFFFFF
FCFCFCFCFCFCFFFFFFFDFDFD000000010101FAFAFAFBFBFBFFFFFFF1F1F1FCFCFCFFFFFF
FFFFFFFCFCFCF1F1F1FFFFFFFFFFFFE5E5E5FFFFFFFEFEFEFFFFFFFFFFFFF8F8F8FCFCFC
F8F8F8FFFFFFFFFFFFF8F8F8000000000000FFFFFFFDFDFDFCFCFCF9F9F9F3F3F3FFFFFF
FFFFFFF5F5F5FFFFFFFBFBFBEEEEEEFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F2F2F2FDFDFDFFFFFFFEFEFEF1F1F1FFFFFFF7F7F7FFFFFFFFFFFFE7E7E7FFFFFFFFFFFF
FBFBFBFBFBFBFBFBFBFBFBFBFFFFFFEBEBEBFFFFFFF4F4F4FAFAFAFFFFFFF2F2F2FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE010101000000000000000000000000000000
FFFFFFFFFFFF000000000000040404040404000000FFFFFFF7F7F7FFFFFFFEFEFEFDFDFD
FDFDFDFEFEFEFFFFFFF7F7F7F2F2F2FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFF9F9F9FFFFFF
F4F4F4FFFFFFE7E7E7FFFFFF070707000000FFFFFFFFFFFFFFFFFFF1F1F1FFFFFFEAEAEA
FFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFE0E0E0FFFFFF
FFFFFFF4F4F4FFFFFFFCFCFCFFFFFFF7F7F7FFFFFFFCFCFCFFFFFFFFFFFFF2F2F2FFFFFF
F7F7F7FEFEFEFFFFFFFFFFFFFFFFFFFDFDFDE4E4E4FFFFFFFBFBFBFCFCFCFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFEDEDEDFFFFFFF7F7F7FFFFFFF1F1F1F1F1F1FFFFFFFFFFFF
F0F0F0FFFFFFFFFFFFF8F8F8FFFFFFF7F7F7F6F6F6F8F8F8FCFCFCFFFFFFFDFDFDFFFFFF
FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFCFCFCFFFFFFF2F2F2FFFFFFF8F8F8F9F9F9FFFFFF
FFFFFFF4F4F4FFFFFFF0F0F0FFFFFFF6F6F6FFFFFFF7F7F7F3F3F3FCFCFCFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFF3F3F3FBFBFBFFFFFFF7F7F7F2F2F2F3F3F3FFFFFFFFFFFFF2F2F2
F4F4F4FFFFFFFFFFFFFBFBFBF5F5F5FFFFFFFAFAFAFFFFFFF5F5F5FFFFFFF6F6F6FFFFFF
FAFAFAFFFFFFF9F9F9F0F0F0FDFDFDFFFFFFFFFFFFF7F7F7F7F7F7FCFCFCFFFFFFF0F0F0
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFF4F4F4FCFCFC
FFFFFFFAFAFAFBFBFBFBFBFBF3F3F3FFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFBFBFB
FBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFEFEFEFAFAFAF7F7F7FFFFFFFCFCFCFAFAFA
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFF9F9F9FFFFFFF1F1F1
FFFFFFFDFDFDFFFFFFFFFFFFFAFAFAF6F6F6F9F9F9FFFFFFFFFFFFF4F4F4FFFFFFFBFBFB
FFFFFFF5F5F5FFFFFFFFFFFFFDFDFDFDFDFDF7F7F7FFFFFFFFFFFFFBFBFBFFFFFFFAFAFA
FFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F4F4F4FFFFFFFFFFFFF6F6F6FFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFAFAFAFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFAFAFAFDFDFDFFFFFFFFFFFFF9F9F9FDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFF4F4F4FFFFFFFFFFFFF4F4F4FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF6F6F6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFCFCFCF7F7F7FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFBFBFBFFFFFFFFFFFFF3F3F3FDFDFDFFFFFFFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF8F8F8FAFAFAFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF8F8F8FFFFFFFEFEFEFDFDFDFCFCFCFFFFFFFFFFFF
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFF7F7F7F4F4F4
F8F8F8FFFFFFFFFFFFFBFBFBFBFBFBFFFFFFFFFFFFF8F8F8F4F4F4F7F7F7FFFFFFFFFFFF
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
F9F9F9FFFFFFFDFDFDF3F3F3FEFEFEFFFFFFFFFFFFF8F8F8FEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFFFFFFEBEBEBF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F5F5F5FDFDFDFFFFFFFFFFFFF1F1F1FFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF6F6F6EDEDEDFEFEFEF8F8F8FAFAFAFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE5E5E5FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF7F7F7
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFAFAFAFFFFFF
FFFFFFF2F2F2FFFFFFF0F0F0F0F0F0FFFFFFF2F2F2FFFFFFFFFFFFFAFAFAFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF5F5F5FAFAFAFFFFFFF0F0F0F3F3F3F8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF3F3F3FFFFFFFFFFFFECECECFEFEFEFCFCFCFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF3F3F3FFFFFFFFFFFFFAFAFAFDFDFDEBEBEBFFFFFFFCFCFCFCFCFCFCFCFCFCFCFC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FFFFFFFFFFFFF4F4F4020202000000121212070707060606000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000080808000000070707000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000060606000000030303040404000000000000070707
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000080808090909000000
000000111111000000000000000000000000111111000000000000090909080808000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000D0D0D000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFAFAFAFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
EFEFEFF7F7F7FFFFFF000000101010000000000000000000020202020202020202020202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FFFFFFFFFFFFF5F5F50303030606060000000D0D0D010101000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000A0A0A0000000303030707070000000D0D0D000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000050505000000181818000000000000000000090909050505
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000030303000000000000050505
000000000000161616000000000000161616000000000000050505000000000000030303
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
010101000000080808000000080808000000050505000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000010101EAEAEAFFFFFFFCFCFCFDFDFDFFFFFFF7F7F7FBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFF8F8F8FCFCFCFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2F2F2FDFDFD
FFFFFF010101070707F5F5F5FFFFFFF9F9F9FFFFFF0000000B0B0BFFFFFFF3F3F3EAEAEA
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFBFBFBF8F8F8FFFFFFF6F6F6
FFFFFFFEFEFE000000020202FFFFFFFFFFFFF2F2F2040404000000FDFDFDFFFFFFFFFFFF
F8F8F8FFFFFFFFFFFFFFFFFFECECECFFFFFF000000060606000000E1E1E1FFFFFFFFFFFF
F3F3F3F9F9F9FDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFF3F3F3FFFFFF000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF020202
060606000000F0F0F0FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF000000000000FFFFFF
FFFFFFF8F8F8FFFFFFFAFAFAFFFFFF000000030303FFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
F4F4F4000000FFFFFFFFFFFFF7F7F7000000FFFFFFFBFBFBFFFFFFFFFFFFE1E1E1FFFFFF
000000000000000000FFFFFFFFFFFFFFFFFF010101FFFFFFFBFBFBF2F2F2FFFFFFF3F3F3
000000000000F3F3F3FFFFFFFFFFFFE6E6E6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFF8F8F8F3F3F3FFFFFFFFFFFFFFFFFFFFFFFFE6E6E6F7F7F7FAFAFAFFFFFFF3F3F3
F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFAFAFA
FBFBFBEBEBEBFEFEFEFFFFFFFDFDFDFFFFFFFCFCFCF9F9F9F2F2F2FFFFFFFFFFFFFDFDFD
FFFFFFFBFBFBFFFFFFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFEFEFEFDFDFDECECECFFFFFFFFFFFFF0F0F0FEFEFE
FFFFFFFEFEFEF1F1F1FFFFFFF2F2F2FFFFFFFDFDFDF5F5F5F3F3F3FFFFFFFFFFFFF8F8F8
F1F1F1FFFFFFF4F4F4FFFFFFFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFF9F9F9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE8E8E8E6E6E6FFFFFF
ECECECF5F5F5FFFFFFFEFEFEFFFFFFE9E9E9FFFFFFFFFFFFE8E8E8FCFCFCFFFFFFEFEFEF
FFFFFFFFFFFFF7F7F7FFFFFFFDFDFDF5F5F5FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFFFFFEFFFCFFFFF8FFFFF5FFFFF5FFFFF7FFFF
FBFFFFFFFEFFFFFBFFFFFBFFFFFBFFFFFCFFFFFDFFFFFEFFFFFCFBFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFA
FFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFAFFFCFB
FFFDFFFFFCFFFEFBFFFFFDFFFEFDFF000005000005FEFFFFFEFFFFFCFFFFFCFFFFFCFFFF
FCFFFFFCFFFFFBFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFDFFFCFCFFFEFFFBFFFFF7FFFFFEFFFDFFF3EEFFE2E1A72525
A72525FFE2E1FFF3EEFCFFFDF8FFFFF9FFFFFFFEFFFFFDFAFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFDFFFCFCFFFEFFFBFFFFF7FFFFFEFFFDFFF3EEFFE2E1A72525
A72525FFE2E1FFF3EEFCFFFDF8FFFFF9FFFFFFFEFFFFFDFAFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFF8F8F8F4F4F4FFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFF6F6F6F4F4F4FFFFFFFFFFFFFFFFFFFFFFFFF1F1F1FFFFFF
FAFAFAFDFDFDFFFFFFEAEAEAFFFFFFF8F8F8FFFFFFFFFFFFF8F8F8F4F4F4FFFFFFFDFDFD
FFFFFFF2F2F2F5F5F5F8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF2F2F2
FEFEFEF8F8F8FFFFFFF5F5F5FFFFFFF2F2F2FCFCFCF3F3F3FDFDFDF7F7F7FFFFFFFFFFFF
FEFEFEFAFAFAFFFFFFFCFCFCFFFFFFF4F4F4FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFDFFFCFCFFFEFFFBFFFFF7FFFFFEFFFDFFF3EEFFE2E1A72525
A72525FFE2E1FFF3EEFCFFFDF8FFFFF9FFFFFFFEFFFFFDFAFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFEBEBEBFBFBFBFFFFFFF5F5F5F9F9F9
0C0C0CFFFFFFFBFBFBFDFDFD000000040404000000010101FFFFFFF9F9F9FFFFFF000000
000000FDFDFDFBFBFBFFFFFF0A0A0A080808FCFCFCFFFFFF0000000B0B0BFFFFFFFDFDFD
F1F1F1151515000000EFEFEFFFFFFFFFFFFF000000000000FFFFFFF8F8F8FFFFFF050505
070707EBEBEBFFFFFFE7E7E7000000000000FAFAFAFFFFFFF4F4F4FFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFF0000000E0E0EFFFFFFF4F4F40000000E0E0EF6F6F6FBFBFB
FFFFFFF8F8F8030303070707FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF0000000A0A0A000000040404000000000000030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF9FFFFF7FFFFF8FFFFFBFFFF
FEFCFDFFFAFBFFF1F5270000380000972F3A9E1E2DB52234B61429CA1F32BC0B1FD21C2B
CF1218D21112D21112D21112D21112D21112D21112D21112D21112D21112D21112D21112
D21112D21112D21112D21112D9161ACB0E15CA192BC1182FBD152EBF182CCA1E2AC6252B
B73132460000260000130000060105000100030000030100040300030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
030303030303030303030303030303030303030303030303030303030303030303030303
020202060606020202050505030303000000030303F1F1F1FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFF000000000000FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE7E7E7FFFFFFFFFFFF
FDFDFDE1E1E1FFFFFFFAFAFAFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFAFAFAF6F6F6FFFFFF
FFFFFFFFFFFFEAEAEAFFFFFFFBFBFBEEEEEEFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCF9F9F9
FFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFEBEBEBFDFDFDF8F8F8FFFFFFF5F5F5F3F3F3
FAFAFAFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFEFEFEFFEFEFEFFFFFFE9E9E9F7F7F7FFFFFF
EFEFEFFFFFFFFFFFFFF9F9F9FBFBFBFFFFFFEEEEEEFFFFFFFFFFFFFBFBFBFFFFFFFDFDFD
FFFFFFFBFBFBF5F5F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFF3F3F3FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFEEEEEEFFFFFFFFFFFFFFFFFF
F7F7F7FDFDFDFFFFFFF9F9F9FFFFFFFBFBFBF8F8F8FFFFFFFDFDFDFFFFFFFDFDFDFAFAFA
FFFFFFFBFBFBFDFDFDFFFFFFF1F1F1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4FDFDFD
FFFFFFFDFDFDF9F9F9FCFCFCFFFFFFFBFBFBFFFFFFF8F8F8FFFFFFFDFDFDFFFFFFFFFFFF
F6F6F6FAFAFAFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFCFCFCF8F8F8FDFDFDFFFFFFFFFFFF
F7F7F7FFFFFFFAFAFAFAFAFAFFFFFFFFFFFFF4F4F4FFFFFFF2F2F2FFFFFFF9F9F9FEFEFE
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFF
F9F9F9F5F5F5FFFFFFFFFFFFF6F6F6FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFEFEFEE8E8E8
FFFFFFF0F0F0FFFFFFF9F9F9EAEAEAFFFFFFFFFFFFF4F4F4FFFFFFF4F4F4FFFFFFFFFFFF
FEFEFEF8F8F8FFFFFFF5F5F5FFFFFFFBFBFBECECECFCFCFCFDFDFDFBFBFBFFFFFFFFFFFF
FFFFFFF7F7F7FFFFFFFFFFFFF5F5F5F9F9F9FFFFFFFFFFFFF6F6F6FFFFFFF7F7F7FFFFFF
FFFFFFFFFFFFFFFFFFF8F8F8FFFFFFEDEDEDFFFFFFFFFFFFFFFFFFF7F7F7FEFEFEF8F8F8
FFFFFFFEFEFEFEFEFEFFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFF5F5F5F9F9F9FFFFFF
FFFFFFFFFFFFEBEBEBFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1F1F1FFFFFFFFFFFF
F3F3F3FFFFFFF2F2F2F4F4F4FFFFFFF8F8F8FFFFFFF4F4F4FCFCFCFDFDFDF2F2F2FFFFFF
F3F3F3FFFFFFF6F6F6FFFFFFFFFFFFF6F6F6FFFFFFFCFCFCFFFFFFFFFFFFF0F0F0F3F3F3
FAFAFAFFFFFFF2F2F2FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECECEC
F7F7F7FAFAFAFAFAFAFFFFFFFEFEFEFFFFFFF1F1F1FFFFFFFFFFFFFFFFFFFAFAFAF6F6F6
FFFFFFFDFDFDFAFAFAFFFFFFFDFDFDFFFFFFFEFEFEFCFCFCE9E9E9FFFFFFF6F6F6FFFFFF
FFFFFFF6F6F6FFFFFFFBFBFBF6F6F6FCFCFCFFFFFFF5F5F5F3F3F3FFFFFFFFFFFFFBFBFB
F9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFDECECEC
FFFFFFF7F7F7FFFFFFFEFEFEFFFFFFFFFFFFEEEEEEFFFFFFF9F9F9FFFFFFFFFFFFF6F6F6
FFFFFFFFFFFFFFFFFFF6F6F6F5F5F5FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFF0F0F0FFFFFFFDFDFDFEFEFEFFFFFFF7F7F7FFFFFFFFFFFFEEEEEEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF5F5F5EFEFEFFBFBFBFCFCFCFFFFFFFDFDFDEDEDEDFFFFFFFAFAFA
FFFFFFF3F3F3FBFBFBFAFAFAFEFEFEFFFFFFF5F5F5FFFFFFFFFFFFFDFDFDF9F9F9FFFFFF
FFFFFFF8F8F8FBFBFBFFFFFFF7F7F7FFFFFFF2F2F2FFFFFFFFFFFFFAFAFAF7F7F7FCFCFC
FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8
FDFDFDFFFFFFEFEFEFFCFCFCFFFFFFF8F8F8FFFFFFFCFCFCFBFBFBF9F9F9EEEEEEFEFEFE
FFFFFFFDFDFDEBEBEBFFFFFFFFFFFFF1F1F1FFFFFFFFFFFFFFFFFFF4F4F4F5F5F5FFFFFF
FAFAFAF7F7F7F8F8F8FFFFFFFFFFFFFFFFFFFFFFFFF2F2F2FBFBFBFFFFFFF4F4F4FCFCFC
FFFFFFF3F3F3F5F5F5FFFFFFFFFFFFFAFAFAFFFFFFF9F9F9FFFFFFFCFCFCFFFFFFFDFDFD
F9F9F9FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF7F7F7FBFBFBEBEBEBFFFFFFFEFEFEF8F8F8
F1F1F1FFFFFFFAFAFAFDFDFDFFFFFFF7F7F7FFFFFFF8F8F8FFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEEEEEFEFEFEFFFFFF
FEFEFEF4F4F4FFFFFFFFFFFFFFFFFFF8F8F8FAFAFAFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFEFEFEFFFFFFFCFCFCFEFEFEF8F8F8FFFFFFFFFFFFF6F6F6FFFFFFFFFFFFEFEFEF
FFFFFFFAFAFAFFFFFFFFFFFFF8F8F8F8F8F8FDFDFDFFFFFFF0F0F0FDFDFDFFFFFFFFFFFF
EDEDEDFFFFFFFFFFFFF1F1F1FFFFFFF6F6F6E9E9E9FFFFFFF0F0F0FFFFFFFEFEFEFFFFFF
ECECECFFFFFFE5E5E5FFFFFFFFFFFFF9F9F9FDFDFDFFFFFFFCFCFCFCFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFF3F3F3FFFFFFFFFFFFF7F7F7F3F3F3FFFFFFFBFBFBF1F1F1
FFFFFFF1F1F1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF0F0F0
FFFFFF141414000000000000000000FFFFFFF8F8F8000000FFFFFFFFFFFFECECEC010101
000000000000020202000000FFFFFFFFFFFF0000000000000C0C0C000000FFFFFF000000
020202FBFBFBF5F5F5000000090909000000FFFFFFF8F8F80C0C0C000000050505EEEEEE
FFFFFF000000020202000000FFFFFF0C0C0C0000000C0C0C050505060606000000010101
101010000000161616ECECECFEFEFE000000161616000000FFFFFFF7F7F7000000000000
060606EFEFEFFFFFFF070707000000000000FFFFFF0C0C0C0D0D0D000000FFFFFF0A0A0A
0000000C0C0C000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FFFFFFEDEDED050505FFFFFFFFFFFFFEFEFEFFFFFF000000090909FFFFFFFFFFFFFFFFFF
FCFCFC0D0D0D050505F8F8F8FFFFFF000000060606000000FFFFFFFCFCFC0D0D0D000000
F8F8F8FFFFFF040404000000FFFFFFFFFFFFFFFFFFFDFDFD000000131313E2E2E2FFFFFF
FFFFFF000000000000FFFFFFFAFAFAF5F5F50E0E0E000000FFFFFFFAFAFAFFFFFFFFFFFF
F9F9F9080808000000FFFFFFFFFFFFFAFAFA0000000B0B0BF5F5F5FFFFFF000000090909
FDFDFDFFFFFFF8F8F8080808000000FFFFFFFFFFFF000000000000FFFFFFFEFEFE000000
0B0B0B000000FFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FAFAFAFFFFFFFCFCFC
FFFFFFFCFCFC000000FFFFFFFFFFFFF7F7F7060606040404030303F5F5F5F7F7F7FBFBFB
FFFFFF000000000000FFFFFFF9F9F9F8F8F8060606000000FFFFFFFFFFFF0000000B0B0B
F5F5F5FFFFFF080808000000F8F8F8FFFFFFFEFEFEFFFFFF040404000000FFFFFFFFFFFF
FFFFFF000000000000FAFAFAFFFFFFFFFFFF070707000000FFFFFFF9F9F9FFFFFFF5F5F5
FBFBFBFFFFFF000000FDFDFDFFFFFFF0F0F00000000A0A0AF0F0F0FFFFFF010101000000
FFFFFFFFFFFFFFFFFF000000000000FFFFFFFDFDFD000000000000FFFFFFFFFFFF000000
000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF7F7F7
FCFCFCFFFFFF151515FCFCFCFFFFFFECECEC000000010101000000040404FFFFFFFFFFFF
FBFBFB0F0F0F000000FFFFFFFFFFFFFEFEFE0A0A0A000000FFFFFFF0F0F0040404080808
FAFAFAFCFCFC0000000A0A0AFFFFFFFFFFFFF6F6F6FCFCFC000000131313FFFFFFEBEBEB
FBFBFB060606000000FFFFFFFFFFFFF4F4F4000000070707F7F7F7FDFDFDFFFFFFFFFFFF
FDFDFDFFFFFFF8F8F8FFFFFFF0F0F0FFFFFF0A0A0A000000FFFFFFFFFFFF000000000000
FAFAFAF9F9F9FFFFFF090909080808FBFBFBF2F2F2070707080808FFFFFF000000010101
FFFFFFEFEFEFFFFFFFEEEEEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FCFCFCFFFFFF
FFFFFFEEEEEE040404EFEFEFEBEBEBFFFFFF020202000000FFFFFF000000EEEEEEFFFFFF
FFFFFF050505000000FFFFFFF4F4F4FEFEFEFFFFFF0707070F0F0FFFFFFF000000000000
FFFFFFF9F9F9080808000000FFFFFFEEEEEEFFFFFFF9F9F9000000000000F5F5F5FFFFFF
F4F4F41A1A1A000000FFFFFFFEFEFEFFFFFF010101000000FFFFFFFCFCFCFFFFFFF9F9F9
FCFCFCF3F3F3FFFFFFF7F7F7FFFFFFFBFBFB000000030303FCFCFCF0F0F00000000A0A0A
FFFFFFE2E2E2FFFFFF050505000000FCFCFCFFFFFF000000000000010101080808FFFFFF
F4F4F4F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FEFEFEFFFFFF
FEFEFEF8F8F8070707FFFFFFFFFFFF000000050505FFFFFFF3F3F30C0C0C000000FEFEFE
FFFFFF0000000E0E0EFDFDFDFFFFFFFDFDFDF6F6F6F1F1F1E9E9E9FFFFFF050505000000
FFFFFFF5F5F5020202000000FFFFFFFFFFFFFFFFFFFBFBFB0A0A0A0A0A0AEAEAEAFBFBFB
FFFFFF000000181818F1F1F1FFFFFFFBFBFB000000030303FFFFFFFAFAFAFAFAFAF7F7F7
FFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEDEDED000000060606F8F8F8FFFFFF000000000000
F9F9F9FFFFFFF5F5F5000000000000FFFFFFF3F3F3000000040404F8F8F8070707FEFEFE
FFFFFFFFFFFFF2F2F2F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFECECEC
FDFDFDFFFFFF000000F8F8F8FEFEFE000000000000FFFFFFFFFFFFFFFFFF020202FBFBFB
F1F1F1101010000000FFFFFFFFFFFFFDFDFD0505050D0D0DFFFFFFFFFFFF020202060606
F3F3F3FFFFFF000000070707FCFCFCFDFDFDF6F6F6FFFFFF000000000000FFFFFFFEFEFE
FAFAFA000000050505FFFFFFF6F6F6FFFFFF141414010101F3F3F3FFFFFFF4F4F4FFFFFF
F8F8F8FFFFFFFFFFFFFFFFFFFBFBFBFFFFFF050505000000FFFFFFE7E7E7111111000000
FFFFFFFFFFFFF9F9F90A0A0A030303F1F1F1FFFFFF010101000000FFFFFFF4F4F4000000
FFFFFFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF8F8F8FFFFFFFFFFFF
FFFFFFFCFCFC000000FFFFFF010101181818000000F6F6F6F0F0F0FFFFFF070707000000
FCFCFC080808000000FCFCFCFFFFFFFFFFFF060606000000E9E9E9FFFFFF020202000000
FFFFFFF3F3F30A0A0A000000FFFFFFFFFFFFFFFFFFFFFFFF000000000000000000FBFBFB
FFFFFF070707000000FFFFFFFFFFFFEEEEEE000000000000FFFFFFFFFFFFFFFFFFFFFFFF
F4F4F4F2F2F2FFFFFFF0F0F0FFFFFF000000000000050505F9F9F9FFFFFF040404000000
000000F7F7F7FFFFFF000000000000FFFFFFFFFFFF000000070707EAEAEAFFFFFFFFFFFF
000000F9F9F9FFFFFFF3F3F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF2F2F2FFFFFF
FFFFFFF8F8F81B1B1BF0F0F0000000020202F8F8F8FFFFFFFFFFFFFEFEFEEDEDED0E0E0E
FFFFFF000000000000FFFFFFF0F0F0FFFFFFFFFFFF0707070D0D0D080808020202F7F7F7
EFEFEFFFFFFF0404040000000000000D0D0DF7F7F7FFFFFF000000000000FFFFFF000000
000000040404FFFFFFF8F8F8FFFFFFFFFFFF080808000000FFFFFFF6F6F6FFFFFFFAFAFA
FFFFFFFFFFFFF1F1F1FFFFFFFAFAFAFFFFFF000000050505FFFFFFFFFFFFF4F4F4040404
FFFFFF050505000000060606FFFFFFEBEBEBFFFFFF0B0B0B000000FFFFFFF5F5F5000000
020202020202000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFF3F3F3FFFFFF
FBFBFBFEFEFE0000000C0C0C070707000000FFFFFFF8F8F8F9F9F9FFFFFFFFFFFF000000
FCFCFC000000080808F9F9F9FFFFFFFFFFFFF5F5F5FFFFFFFDFDFDF8F8F8FFFFFFFFFFFF
FFFFFFFFFFFFF2F2F2050505FFFFFFF8F8F8F7F7F7FFFFFF000000000000FFFFFFF8F8F8
FFFFFFFDFDFDFAFAFAFFFFFFFCFCFCF9F9F9040404000000FCFCFCFAFAFAFAFAFAFFFFFF
F9F9F9FFFFFFF6F6F6FEFEFEFEFEFEF7F7F7FBFBFBFFFFFFF3F3F3FFFFFFFFFFFFFEFEFE
FFFFFFF8F8F8FDFDFDFEFEFEFFFFFFFFFFFFECECEC010101000000FFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF3F3F3FFFFFFFEFEFE
FFFFFFFBFBFB000000020202000000FFFFFFFFFFFFFEFEFEFBFBFBFFFFFFFFFFFF000000
020202040404000000FFFFFFFFFFFFFFFFFFECECECFFFFFFF6F6F6FFFFFFF0F0F0FFFFFF
FAFAFAFFFFFFF1F1F10D0D0DF2F2F2FFFFFFF5F5F5FFFFFF070707000000FEFEFEFFFFFF
FAFAFAF3F3F3FFFFFFFEFEFEFFFFFFFBFBFB000000020202FFFFFFF4F4F4FFFFFFFFFFFF
FDFDFDFFFFFFF5F5F5FFFFFFFAFAFAFEFEFEFFFFFFFFFFFFF9F9F9FAFAFAFFFFFFFFFFFF
FFFFFFFAFAFAF4F4F4FFFFFFFFFFFFF7F7F7FFFFFF000000000000FFFFFFF7F7F7FFFFFF
FFFFFFF4F4F4FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFE7E7E7FFFFFF
FFFFFFFFFFFF000000000000010101FCFCFCFFFFFFF6F6F6FFFFFFF1F1F1FFFFFFFFFFFF
0000000000001C1C1CF5F5F5F0F0F0FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFEFEFEFFFFFFF
FFFFFFFBFBFBFFFFFFF1F1F1FDFDFDFFFFFFF9F9F9FEFEFE000000000000FBFBFBF8F8F8
F8F8F8FFFFFFE7E7E7FFFFFFFFFFFFFFFFFF000000000000FEFEFEF1F1F1F9F9F9FFFFFF
FEFEFEF1F1F1FFFFFFF5F5F5FFFFFF000000000000FFFFFFFFFFFFFDFDFDF7F7F7FFFFFF
FFFFFFFFFFFFFFFFFFF6F6F6F3F3F3FFFFFFFFFFFF0E0E0E0E0E0EFFFFFFFFFFFFF3F3F3
F6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4
040404050505000000010101FFFFFFF6F6F6FDFDFDFFFFFFFCFCFCFEFEFEFFFFFFEBEBEB
000000000000000000010101FFFFFFEDEDEDFFFFFFFEFEFEF8F8F8FEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFF3F3F3FFFFFFFFFFFFF2F2F2FFFFFFFDFDFD0000000E0E0EFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF4F4F40404040505050000000101010101010D0D0DFFFFFFFFFFFF
F3F3F3FFFFFFE9E9E9FFFFFFEDEDED0B0B0B000000FBFBFBFCFCFCFFFFFFF6F6F6FFFFFF
F7F7F7FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFDADADA000000000000DADADAFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFCF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F0F0FFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFF8F8F8FFFFFFFFFFFFF3F3F3FFFFFFFDFDFDFAFAFAFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFE9E9E9FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFEBEBEB
FBFBFBFFFFFFF5F5F5F9F9F9FCFCFCFFFFFFF1F1F1FFFFFFFEFEFEFCFCFCFFFFFFEFEFEF
F0F0F0FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFEFEFEFFEFEFEFFFFFF
FFFFFFF7F7F7FFFFFFEAEAEAFFFFFFFFFFFFFCFCFCFFFFFFFDFDFDFFFFFFFCFCFCFCFCFC
FFFFFFFBFBFBFFFFFFFCFCFCF8F8F8FFFFFFFFFFFFFBFBFBFBFBFBFFFFFFFFFFFFF8F8F8
FCFCFCFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECECECFFFFFFF8F8F8
FBFBFBFDFDFDFFFFFFFFFFFFF2F2F2FFFFFFFFFFFFEBEBEBFFFFFFFFFFFFE6E6E6FEFEFE
F3F3F3FCFCFCFFFFFFF5F5F5FFFFFFFFFFFFF6F6F6FCFCFCFFFFFFFCFCFCFCFCFCFFFFFF
FDFDFDFBFBFBFFFFFFFFFFFFF8F8F8FFFFFFFAFAFAFFFFFFF8F8F8FFFFFFFFFFFFFFFFFF
FFFFFFECECECFFFFFFF8F8F8FBFBFBFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4
F9F9F9FCFCFCF9F9F9FFFFFFF4F4F4F2F2F2FFFFFFFAFAFAF9F9F9F7F7F7FFFFFFFFFFFF
FFFFFFF3F3F3FAFAFAFDFDFDFFFFFFFBFBFBF9F9F9F5F5F5F5F5F5F9F9F9FBFBFBFFFFFF
FDFDFDFAFAFAF3F3F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8F7F7F7FFFFFFFFFFFF
FCFCFCFFFFFFF1F1F1FEFEFEFEFEFEF9F9F9FFFFFFFFFFFFF5F5F5F9F9F9FFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFBFBFBFFFFFFFFFFFFFFFFFFFBFBFBFAFAFAFFFFFF
FFFFFFF2F2F2FFFFFFF0F0F0FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFE9E9E9FEFEFE
F8F8F8F7F7F7FFFFFFFFFFFFFCFCFCFFFFFFF1F1F1FEFEFEF7F7F7FFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFF6F6F6FBFBFBFFFFFFF8F8F8FAFAFAFFFFFFFFFFFFFDFDFDFEFEFEF8F8F8
F9F9F9FEFEFEFFFFFFFFFFFFF9F9F9F3F3F3FBFBFBFFFFFFFFFFFFFBFBFBF3F3F3F9F9F9
FFFFFFFFFFFFFEFEFEF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF3F3F3F8F8F8
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FEFEFEF5F5F5FDFDFDFFFFFFF6F6F6FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFF9F9F9F6F6F6
FAFAFAFFFFFFFFFFFFFDFDFDFFFFFFE6E6E6FBFBFBFFFFFFF9F9F9FFFFFFFFFFFFF9F9F9
FEFEFEFFFFFFF3F3F3F8F8F8FFFFFFFFFFFFF2F2F2FFFFFFFAFAFAFFFFFFF7F7F7FAFAFA
FFFFFFF3F3F3FFFFFFFDFDFDF4F4F4FFFFFFFEFEFEFEFEFEF8F8F8FFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFF9F9F9F8F8F8FFFFFFFFFFFFFFFFFFF5F5F5F5F5F5FFFFFFFFFFFFFFFFFF
F8F8F8F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFAFFFFFF
FAFAFAF8F8F8FFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFF8F8F8EFEFEFFDFDFDFFFFFF
FEFEFEFFFFFFF4F4F4FEFEFEFFFFFFFFFFFFFBFBFBFAFAFAF4F4F4FFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFF3F3F3FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBF7F7F7FDFDFDFFFFFF
FBFBFBFFFFFFFAFAFAFFFFFFFAFAFAF8F8F8FFFFFFFCFCFCFFFFFFEAEAEAFFFFFFF4F4F4
FEFEFEF7F7F7FFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
F9F9F9FFFFFFFFFFFFFFFFFFFDFDFDFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFDFDFD
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFCFCFC010101010101FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1F1F1FFFFFFFFFFFF
F5F5F5FBFBFBFFFFFF0000000C0C0CF0F0F0FFFFFFF9F9F9FFFFFFEFEFEFFFFFFFF5F5F5
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFEFEFE000000000000FFFFFFFAFAFAFFFFFFF7F7F7FDFDFD
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF3F3F3FFFFFFFFFFFFFBFBFBFFFFFFFCFCFCFAFAFA
FFFFFFFFFFFFF1F1F1FFFFFFF4F4F4FFFFFFFFFFFFFCFCFCFFFFFFF3F3F3FFFFFFF4F4F4
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFF4F4F4FFFFFFF3F3F3FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F0F0F8F8F8F9F9F9
FFFFFFFFFFFFE9E9E9151515000000191919000000000000080808000000000000050505
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000A0A0A000000000000000000090909000000000000000000030303000000000000
000000000000F6F6F6FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFEFEFE080808000000
000000070707000000000000090909000000000000FFFFFFFFFFFFF4F4F4FFFFFFFFFFFF
F3F3F3FFFFFFFFFFFF000000000000000000000000000000000000000000000000000000
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000
000000000000000000000000000000FFFFFFFFFFFFF3F3F3FFFFFFFFFFFFF4F4F4FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFF7F7F7
FFFFFFF6F6F6FFFFFFE7E7E7090909000000000000040404000000050505000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000
0000000B0B0B000000010101050505040404000000121212000000000000000000050505
040404030303FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFF9F9F9FAFAFAFBFBFB000000050505
0202020101010B0B0B000000080808060606000000F5F5F5FFFFFFFFFFFFF7F7F7FFFFFF
FAFAFAFCFCFCFFFFFF0D0D0D000000000000000000000000000000000000000000000000
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000000
0000000000000000000000000D0D0DFFFFFFFCFCFCFAFAFAFFFFFFF7F7F7FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFCFCFC
FFFFFFFDFDFDFCFCFCFFFFFFFCFCFCF7F7F7FFFFFFFEFEFEEEEEEEFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFF9F9F9060606000000F8F8F8FFFFFFFFFFFFFDFDFDFDFDFD
F9F9F9EBEBEBFFFFFFFFFFFFF7F7F7F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFF2F2F2FFFFFF
FBFBFBFDFDFDFAFAFAFFFFFFF1F1F1FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8
FFFFFFF8F8F8FFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF2F2F2FFFFFFF8F8F8FFFFFFF8F8F8FFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4F9F9F9FFFFFF
FFFFFFFFFFFFF0F0F0F3F3F3FFFFFFFFFFFFF9F9F9FBFBFBFEFEFEF9F9F9FAFAFAFFFFFF
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FCFCFCF1F1F1FFFFFFFFFFFFFFFFFF000000060606FFFFFFF4F4F4FFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFEAEAEAFFFFFFFFFFFFFCFCFCFEFEFEFDFDFDF6F6F6E6E6E6FFFFFFF8F8F8
FFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4FFFFFFEEEEEEFFFFFFFFFFFF
FDFDFDFFFFFFFAFAFAFFFFFFFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFDFDFDFDFDFD
FDFDFDFDFDFDFDFDFDFDFDFDFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFFEEEEEEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
EEEEEEFBFBFBFFFFFFFFFFFFF0F0F0FFFFFFF2F2F2FFFFFFFFFFFFFAFAFAFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDF4F4F4060606020202ECECECFFFFFFFFFFFFFFFFFFFDFDFD
F8F8F8F7F7F7FFFFFFFEFEFEFBFBFBFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F6F6F6FDFDFDF8F8F8FBFBFBFBFBFBF9F9F9FAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFEDEDEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFEDEDEDFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFEEEEEEFDFDFDFFFFFFFFFFFFFAFAFAF6F6F6F9F9F9FFFFFFFFFFFF
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FBFBFBFFFFFFF6F6F6FFFFFFFFFFFF010101000000FFFFFFFFFFFFF5F5F5FFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFF6F6F6FBFBFBFFFFFFFFFFFFFBFBFBFBFBFBFFFFFFEEEEEEFFFFFF
FFFFFFF8F8F8FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6FFFFFFFFFFFFF1F1F1F8F8F8
FFFFFFFCFCFCFFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFCFCFCFFFFFFF8F8F8F1F1F1FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFF6F6F6FFFFFFFDFDFDFFFFFFF4F4F4FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF6F6F6
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFFAFAFAFEFEFEFFFFFFFFFFFF010101050505FDFDFDFFFFFFFDFDFDFFFFFFFEFEFE
FCFCFCFFFFFFF7F7F7FFFFFFFBFBFBFFFFFFFBFBFBFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
FDFDFDFFFFFFF8F8F8F7F7F7FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
F9F9F9FEFEFEF9F9F9FCFCFCFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFCFCFCF9F9F9FEFEFEF9F9F9FFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F6F6F6FFFFFFF4F4F4FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFF1F1F1FFFFFFFFFFFFFEFEFE
FEFEFEFFFFFFFEFEFEFEFEFEFFFFFFF5F5F5FFFFFFFFFFFFF9F9F9FBFBFBFCFCFCFFFFFF
FAFAFAFFFFFFF6F6F6F9F9F9FFFFFFF0F0F0FFFFFFFAFAFAFFFFFFF4F4F4FFFFFFFFFFFF
ECECECFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFF2F2F2FFFFFFF3F3F3
FFFFFFFBFBFBFFFFFFF7F7F7FFFFFFFCFCFCF9F9F9FFFFFFFFFFFFFDFDFDFFFFFFF9F9F9
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFCFCFCF8F8F8FFFFFFF8F8F8FFFFFF
FDFDFDFFFFFFF9F9F9FCFCFCFFFFFFF7F7F7FFFFFFF7F7F7FFFFFFFFFFFFFEFEFEFFFFFF
F6F6F6F9F9F9FFFFFFFAFAFAFBFBFBFFFFFFFFFFFFFEFEFEFDFDFDFDFDFDFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFF9F9F9FDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFE3E3E3FFFFFFFFFFFFF3F3F3FFFFFFFCFCFCFFFFFFFFFFFFE3E3E3FEFEFEFFFFFF
F6F6F6FFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFCFCFCEFEFEFFFFFFFFFFFFFFFFFFFF5F5F5
FEFEFEF8F8F8FFFFFFFFFFFFF5F5F5FAFAFAFFFFFFFFFFFFEAEAEAFFFFFFF5F5F5FFFFFF
FFFFFFF7F7F7FFFFFFF1F1F1FFFFFFEAEAEAFFFFFFFDFDFDF9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFE4E4E4FFFFFFFFFFFFF3F3F3F9F9F9FFFFFFEFEFEFFFFFFF
FFFFFFFFFFFFF1F1F1F9F9F9ECECECFFFFFFE5E5E5FFFFFFFFFFFFFFFFFFEEEEEEFEFEFE
FFFFFFFFFFFFF1F1F1FFFFFFEBEBEBFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFAFAFAEDEDED
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFECECECFFFFFFFFFFFFF0F0F0FFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F3F3F3FFFFFFF9F9F9F3F3F3FFFFFFFFFFFFFFFFFFFFFFFFE7E7E7FFFFFFF6F6F6FEFEFE
FFFFFFFFFFFFF7F7F7FDFDFDFEFEFEFFFFFFF2F2F2FFFFFFF0F0F0FAFAFAFFFFFFFFFFFF
FFFFFFF2F2F2FFFFFFFFFFFFFDFDFDFDFDFDF4F4F4FFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFF0F0F0FFFFFFFBFBFBFDFDFDFFFFFFF4F4F4FFFFFFF4F4F4
FFFFFFF9F9F9FDFDFDFFFFFFFFFFFFF3F3F3FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFF5F5F5
FFFFFFF0F0F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDEDEDFFFFFFFDFDFDFFFFFFFFFFFF
F8F8F8E8E8E8FFFFFFF4F4F4FCFCFCF3F3F3FFFFFFF4F4F4F5F5F5FEFEFEFFFFFFF7F7F7
FFFFFFFAFAFAEFEFEFFFFFFFFFFFFFF0F0F0FFFFFFF0F0F0F5F5F5FFFFFFFFFFFFFAFAFA
F5F5F5FFFFFFFFFFFFFFFFFFFBFBFBF3F3F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
040404000000000000020202FCFCFCFBFBFB000000F9F9F9FFFFFFEDEDED090909080808
000000020202020202FFFFFF000000050505000000000000FFFFFF040404000000FFFFFF
FFFFFFFCFCFC000000000000010101FFFFFF030303000000000000E8E8E8FFFFFF060606
000000070707FAFAFAFCFCFC040404000000000000050505F9F9F9FFFFFFF6F6F6FFFFFF
000000070707000000000000FFFFFF000000000000080808000000FFFFFF000000090909
000000FDFDFDFFFFFF000000090909000000000000FFFFFF030303000000F8F8F8F3F3F3
0606060D0D0D010101F5F5F50808080000000A0A0AFCFCFCF5F5F5FDFDFD000000030303
000000161616FFFFFFFBFBFBFFFFFFFFFFFF121212000000050505000000FFFFFF000000
0F0F0FEFEFEFFFFFFFEBEBEBFFFFFFFFFFFFFEFEFEF5F5F5FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF000000FFFFFFFFFFFFFBFBFBECECEC090909060606FFFFFFE5E5E5FFFFFFFAFAFA
0C0C0C020202FFFFFF000000080808000000FFFFFFFFFFFF000000030303FEFEFEFFFFFF
FFFFFF070707010101FFFFFFFFFFFFF7F7F7000000030303FFFFFFFFFFFFFDFDFD000000
090909FAFAFAFAFAFA000000010101000000FFFFFFFFFFFF000000FBFBFBFFFFFFF9F9F9
000000010101FFFFFFFFFFFFEEEEEE121212000000F7F7F7FFFFFFFAFAFA000000161616
FFFFFFF9F9F9000000060606000000FFFFFFFFFFFF000000000000F2F2F2FFFFFF0E0E0E
000000E7E7E7FFFFFFFFFFFFFFFFFF000000020202FFFFFFFFFFFF000000000000000000
FAFAFAF2F2F2000000FFFFFFFAFAFA000000000000000000FFFFFFFFFFFF000000070707
FEFEFEF5F5F5EEEEEEFFFFFFFCFCFCEDEDEDFFFFFFF5F5F5FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF000000E6E6E6FFFFFFF0F0F00C0C0C020202000000FCFCFCFFFFFFF4F4F4FFFFFF
000000000000FFFFFFFBFBFB020202000000FBFBFBFBFBFB0000000B0B0BFFFFFFF8F8F8
EDEDED000000080808F8F8F8FBFBFBFFFFFF070707000000F3F3F3FBFBFBFFFFFF000000
000000FFFFFFFFFFFF030303000000FFFFFFFAFAFAEEEEEEFFFFFF161616FFFFFFFFFFFF
0505050D0D0DF1F1F1F2F2F2FFFFFF000000090909FFFFFFFEFEFEFFFFFF000000000000
FFFFFFFBFBFBF5F5F5030303151515F5F5F5FFFFFF000000010101FEFEFEFFFFFF000000
0C0C0CFFFFFFF4F4F4FFFFFFF9F9F9020202090909F1F1F10000000E0E0E030303FFFFFF
FEFEFEFFFFFFFFFFFF000000FFFFFFFEFEFE000000000000FFFFFFF5F5F5191919000000
F9F9F9FFFFFFFFFFFFF5F5F5FFFFFFF5F5F5FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF000000FEFEFEFFFFFFF9F9F90000000101010E0E0E000000FFFFFFF2F2F2FBFBFB
0E0E0E000000FFFFFFFEFEFE0000000D0D0DF2F2F2FFFFFF000000000000FFFFFFF8F8F8
FFFFFF000000000000FFFFFFF8F8F8FBFBFB000000080808FFFFFFFFFFFFEDEDED070707
0D0D0DFBFBFB000000000000FFFFFFFFFFFFF8F8F8FFFFFFF3F3F3EDEDEDFEFEFEFCFCFC
000000010101FFFFFFFFFFFFFCFCFC000000000000F8F8F8FFFFFFE3E3E3181818000000
FBFBFBFFFFFFFCFCFC030303000000F9F9F9FFFFFF000000000000FFFFFFFFFFFF000000
000000FCFCFCFBFBFBFFFFFFFFFFFF000000000000FFFFFF000000090909FDFDFDF6F6F6
FFFFFFE8E8E8FFFFFFFFFFFFF7F7F7FFFFFF0000000F0F0FFFFFFFF7F7F7000000000000
F7F7F7FAFAFAF3F3F3FFFFFFFFFFFFFFFFFFF6F6F6FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF010101000000FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFD000000FFFFFFFEFEFEF8F8F80F0F0F000000FBFBFB090909F9F9F9FFFFFFFBFBFB
000000030303FEFEFEFFFFFFFFFFFF000000000000FFFFFF0000000B0B0BFBFBFBFFFFFF
F0F0F0010101080808E8E8E8FFFFFFF9F9F9040404000000FBFBFBF5F5F5FFFFFF000000
000000FFFFFF030303000000F5F5F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
080808000000FFFFFFFBFBFBF8F8F8070707000000FFFFFFFFFFFFFDFDFD000000000000
FFFFFFF6F6F6FFFFFFF8F8F80202020B0B0BF6F6F6040404070707F3F3F3FFFFFF000000
070707FFFFFFFFFFFFF6F6F6FFFFFF050505000000FFFFFF060606000000FBFBFBFFFFFF
F9F9F9FFFFFFFFFFFFF6F6F6FFFFFFF0F0F0FFFFFF000000070707FCFCFC030303010101
FFFFFFF9F9F9FFFFFFFFFFFFEEEEEEFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFFFEFEFE000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF040404000000FEFEFEFFFFFFFDFDFDFFFFFFF8F8F8FAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF4F4F4FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFF3F3F3FFFFFF
F8F8F8010101FCFCFCFFFFFF000000000000FFFFFFFFFFFF000000000000FFFFFFFFFFFF
000000000000FCFCFCFFFFFFF7F7F7FFFFFFF7F7F7FFFFFF030303000000FBFBFBFEFEFE
FFFFFF0000000D0D0DFFFFFFECECECFFFFFF060606000000FBFBFBFDFDFDFFFFFF0A0A0A
030303FFFFFF0000000C0C0C010101050505000000070707000000010101FFFFFFFCFCFC
030303000000FFFFFFFFFFFFF8F8F8040404000000F9F9F9FAFAFAFFFFFF000000000000
FFFFFFFFFFFFEEEEEEFFFFFFF8F8F8FFFFFFFFFFFF0000000E0E0EFCFCFCF3F3F3050505
0A0A0AF6F6F6FFFFFFFBFBFBFFFFFF000000040404FAFAFA090909000000FFFFFFFFFFFF
FBFBFBFCFCFCFFFFFFFCFCFCF8F8F8FFFFFFFEFEFEFCFCFCFFFFFFF8F8F8010101050505
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFEFEFEF7F7F7FFFFFF010101000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF000000131313F0F0F0FFFFFFFDFDFDF9F9F9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F6F6F6FAFAFAFFFFFFFFFFFFFDFDFD
FFFFFF000000FFFFFFF5F5F50000000E0E0EF1F1F1FEFEFEFFFFFF000000FEFEFEEDEDED
1B1B1B000000FCFCFCFFFFFF090909000000FFFFFFF7F7F7060606101010FFFFFFFFFFFF
FFFFFF000000000000FFFFFFFFFFFFF7F7F7000000000000FFFFFFF5F5F5FBFBFB000000
020202FBFBFBFFFFFF000000FFFFFFF8F8F8FFFFFF0F0F0F000000020202FFFFFFFCFCFC
000000000000FFFFFFFDFDFDFBFBFB0C0C0C000000FFFFFFFEFEFEFFFFFF101010000000
F0F0F0F6F6F6FFFFFF000000161616FAFAFAFAFAFA060606000000FDFDFDFFFFFF010101
010101F4F4F4FAFAFAFFFFFFFFFFFF030303000000FFFFFFFFFFFF020202FFFFFFF3F3F3
FFFFFFFFFFFF000000060606FFFFFFF4F4F4030303000000FFFFFFFEFEFE121212000000
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEEEEEEFDFDFDFFFFFFF2F2F2000000070707FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDEDEDFFFFFFFEFEFEFAFAFAFEFEFEFFFFFFF6F6F6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFAFAFAFFFFFFFFFFFFF2F2F2FFFFFFF0F0F0
E6E6E6181818F6F6F6000000101010000000FFFFFFFFFFFFF3F3F3060606030303EEEEEE
0A0A0A0D0D0DEDEDEDFFFFFF000000101010F3F3F3FFFFFF000000000000FFFFFFFEFEFE
FEFEFE070707000000FBFBFBFEFEFEFDFDFD0000000E0E0E050505EFEFEFFFFFFF060606
050505FFFFFFF9F9F9000000000000FFFFFFFAFAFA000000070707FAFAFAF5F5F5FFFFFF
090909000000080808FFFFFFFFFFFF020202000000000000FFFFFFFEFEFE000000000000
FFFFFFFFFFFFF9F9F9000000000000FFFFFFFFFFFF000000000000FFFFFFFEFEFE000000
000000FFFFFFFFFFFFFFFFFF000000000000111111EDEDEDF8F8F8FFFFFF000000FFFFFF
FDFDFD060606000000FBFBFBF0F0F0FFFFFF000000000000FFFFFFFBFBFB000000050505
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFECECECFFFFFFFFFFFFFBFBFBFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFDFDFDFBFBFBFFFFFFFFFFFF
FFFFFF000000F4F4F40000000D0D0DF6F6F6FFFFFFF3F3F3FFFFFFFFFFFF000000FFFFFF
000000000000FFFFFFFFFFFFF5F5F50000000000000404040C0C0CFEFEFEFFFFFFFAFAFA
FFFFFF0000000B0B0B000000000000FFFFFF000000000000F5F5F5010101000000000000
FFFFFFFFFFFFFEFEFEFBFBFBFFFFFF000000010101080808F7F7F7FFFFFFFFFFFFEBEBEB
ECECEC1D1D1DFBFBFB000000060606000000FFFFFFFFFFFF000000000000090909FFFFFF
FAFAFAF8F8F8FFFFFFF8F8F80B0B0B050505000000040404FFFFFFF9F9F9F1F1F10A0A0A
121212000000040404EAEAEAFEFEFE0F0F0F000000FEFEFEFFFFFFF5F5F5FBFBFB000000
000000000000FFFFFFFFFFFFFEFEFEFFFFFFF3F3F3000000000000020202000000FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFEFEFEF1F1F1F8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF2F2F2F9F9F9F9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFEBEBEBFBFBFBFFFFFFF5F5F5F9F9F9
FFFFFF0000000B0B0B060606000000F5F5F5FFFFFFFFFFFFFFFFFFFFFFFF000000FBFBFB
020202000000FFFFFFF3F3F3FFFFFFF6F6F6FFFFFFFFFFFFF7F7F7F8F8F8FEFEFEFDFDFD
FFFFFFFFFFFF0C0C0CFAFAFAFFFFFFFBFBFB0000000B0B0BFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFEFEFEFFAFAFAFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFEFEFEFFFFFFFE8E8E8FFFFFF
FFFFFFF8F8F8F3F3F3FFFFFFFFFFFFEEEEEEFFFFFFF2F2F2FEFEFEFFFFFFFFFFFFEBEBEB
FFFFFFEFEFEFFFFFFFFFFFFFF6F6F6F7F7F7FFFFFFFFFFFFF6F6F6FFFFFFFCFCFCFFFFFF
000000F0F0F0FFFFFFFFFFFFF4F4F4FFFFFFF6F6F6FFFFFFE2E2E2FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEEEEEEFFFFFFEFEFEFFFFFFFF5F5F5FFFFFFFCFCFCFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFF9F9F9F8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFFFFFFFF3F3F3FBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3FFFFFF
FDFDFD000000040404000000FFFFFFFFFFFFECECECFFFFFFFDFDFDF6F6F60606060B0B0B
000000000000ECECECFFFFFFFFFFFFFDFDFDFFFFFFF2F2F2FFFFFFF2F2F2FFFFFFFEFEFE
F6F6F6F5F5F5000000FFFFFFF9F9F9FFFFFF111111000000F0F0F0FFFFFFF6F6F6F1F1F1
FBFBFBFFFFFFFCFCFCFBFBFBF0F0F0FFFFFFFFFFFFEBEBEBFFFFFFFDFDFDFFFFFFEFEFEF
FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9FFFFFFF7F7F7FFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAE9E9E9FFFFFFF7F7F7
0C0C0CF2F2F2FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF9F9F9FFFFFFECECECFDFDFDFFFFFF
FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFE6E6E6FFFFFFF5F5F5FDFDFDF9F9F9FFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFAFAFAF0F0F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFEFEFEFAFAFAFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFBFBFBFFFFFFF1F1F1
FFFFFF000000000000070707F6F6F6FFFFFFF1F1F1FFFFFFFCFCFCFFFFFFFFFFFF000000
0000000A0A0AFFFFFFF9F9F9FFFFFFF8F8F8FAFAFAFFFFFFFFFFFFFFFFFFFDFDFDFBFBFB
FFFFFFFFFFFFFFFFFFFAFAFAF7F7F7F5F5F50101010C0C0CFFFFFFE9E9E9FFFFFFFFFFFF
F8F8F8FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFF9F9F9FCFCFCF5F5F5F9F9F9FFFFFFFFFFFF
EFEFEFFFFFFFF7F7F7FCFCFCF7F7F7F7F7F7FDFDFDFAFAFAFFFFFFFCFCFCFBFBFBF7F7F7
F8F8F8F5F5F5FFFFFFF1F1F1FFFFFFF2F2F2F7F7F7FFFFFFFFFFFFFFFFFFFCFCFCFEFEFE
F9F9F9FFFFFFFFFFFFE4E4E4050505020202FBFBFBFFFFFFF4F4F4FFFFFFEFEFEFFFFFFF
FFFFFFF1F1F1FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEEEEEFEFEFEF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F8F8F8FEFEFEFCFCFCF3F3F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFAFAFAFFFFFFF8F8F8FFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFF0F0F0FFFFFFFAFAFAFFFFFFF1F1F10D0D0D
000000000000090909FFFFFFFAFAFAFEFEFEFFFFFFFFFFFFFEFEFEFEFEFEFEFEFE000000
000000030303000000FFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFDFDFDF4F4F4FDFDFDFFFFFF
F8F8F8FCFCFCF8F8F8FFFFFFFDFDFDFFFFFF000000000000FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF7F7F7FFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFF
FFFFFFF2F2F2FFFFFFFCFCFCFFFFFFFAFAFAFFFFFFFCFCFCFCFCFCF5F5F5FFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8FFFFFFF8F8F8FFFFFFF4F4F4FFFFFFFCFCFCF6F6F6FEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFF0B0B0B000000FEFEFEF8F8F8FBFBFBFFFFFFFFFFFFF7F7F7
FAFAFAFFFFFFFDFDFDFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFCFCFCFFFFFFF7F7F7FEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFF7F7F7FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  GeneratedCell->False,
  CellAutoOverwrite->False,
  ImageSize->{498, 271},
  ImageMargins->{{126, 0}, {0, 20}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007b00013a000`40n007h00O^Ooo00Wogooo0000
00QQ003oooNnool00`0000H@XPQQmikoo`0P264200000ooO0008H@0200002`0P26400?ooomooo`00
48800?Nn48800P000_oo00_gW_ooool00?Nnooog__oO267oonmm00;oo`090008H@00003oo`00023o
o`Q10080000326400?oo00;g_P0548800000003og`02ool00oNnooooo`3Zool00;[oo`04omog_PQ1
0005ool01OoO00000>LLool00`000_oo0P0P0_oO00H8@@00mkkooooOool200000oookggoo`020004
ool01?NN000000000_oo00X08000oooooooO0008@@00ooog_P8000;oo`04oml8H@00ool2oml01?oo
000000000_oo00D8HNmmmkkoooNn0>_oo`00^?oo00Cg__ooooooo`8000;oo`04omooooooool22443
ool20002ool01000247ogooo0P000_oo00[_GA2226408?ooomooo`00267g_PCoo`030000800P00;o
o`0802000000omog__oo244000;oo`0326408?oo00;oo`8000Coo`0748800?ooooo_OOoO4:800_oo
00?g__ooool0jOoo002iool00ooOmkkoo`0200000oooomooo`03ool200001oooomooo`00267oonmM
00800004omog_PQ10003ool200001?ookggooooO0P0000WooooOoooW??oo00008000ool00P0000W_
OA22oooooooO0208@Nmmool00P0000SooooOool000Q1ooogW_oO0P0000KoooNNooooonmmool2oml0
0oooomooo`3Yool00;coo`0400008?Nnool2mkh2ool01PQQ003ooooomkkoo`800003ool000Q100;o
o`030008@NLL00;oo`0:0008HOoOooo_OOoo00008?oooml2ool010Q1003gW_oo0P0000L8@ONn003g
__oOoooW?00202000oNN00000003ool200000mkkooooo`020005ool01?oOooooooNNjooo002hool0
1oNNooog__oO000@X^Ll00?oo`05mkkgWP00247_O@02ool02?Nnoooogooo00008?oOool200001ooo
omo_O@QQ003oooNN00;oo`0:24400>Llooog_]kk26408?oooml200001?Nnooooo`000ooo00[ogooo
ool8@@00kggooooO020000;oo`06mih08000488000Q10`00k_oo002lool01`0P0008H@00020000QQ
00<000?oo`800004ooo_OA220002ool00`00267g_P02ool02?Nn02008?oOmkkoo`000203ool04@QQ
003ogooOool08000oooogoNN48;gW_Nn02000?Nnool00P000_oo00CgWP0P003g_P?oo`07003_OOoo
oml080QQ00000ooo00?ogoooool0j?oo002jool01oNnool00000oooogooo00;og`08ool00000oooo
gooo020000;oo`0500008?ooool00002244200000ooo0008H@02ool300001OoOooooo`0024400_oo
00?og`0000000ooo0P0000Ooo`00003ogooo24400002ool01oNN0200000P00008?oo008080;oo`03
02000?oo00;oo`03omoooooo0>Woo`00_?oo0P000_oo00KgW_ooooogWPQQ0004ool40002ool2oml0
1`00ked8@@00omooonmm00@00005267oooNn0008@@0200000ooo0008H@0200001_ookgd00000ooog
WP@000Goo`0848;_GA2R003gW_Nnmih080800004oooogooomik/ool00;Soo`04mkkgW_ooool20000
0ooOooooo`03ool200000ooomikoo`07ool00ooOoooog`03ool00ooOooooo`03ool20002ool00ooO
ooooo`02ool01ONnoooooooOkgd01ooo00Sogoooooo_OONnooog_^mM0_oo00C_OOooooogWP?oo`03
mikooooo00;oo`03mkkooooo0>Soo`00^_oo00Cogooo000000Coo`07kegoo`00267g__oooml00_oo
0_oO0_oo00KogoNnooooooNNoml4ool02>LLmkkoo`00267oooNNoml2ool02?oOooooooNNomooooNN
oml2ool00oNnooog_P03ool01>mmooooooNN1Ooo0_Nn1?oo00GogoooomooooNN0>_oo`00^?oo00Kg
__oomikoo`002446ool20002oml00ooomikoo`03ool01?NNooooonLl1?oo00?ogooooml00_oo00?o
g`0000000ooo00SogoNNooooooNnoooognmm1ooo00OgW_ooooooooNNooog_P02ool00nLlooooo`04
oml01oookegoooNnomooooNN0>_oo`00^_oo1P000_oo0P000P0P00<00?oomkh01_oo00?g__NNool0
0_oo00[g__ooomooooNnoooW??oo020000?oo`05mikoonmMooo_O@08ool01>LLooooooNn0ooo00?g
__ooool00_oo00?gW_oomkh01Ooo00?W??oooml0kOoo002hool01>mmooog__oo0_NN0_oo00GgW_oo
oooogooo00;g_P03omoooooo00Woo`04mikooooOoml2ool02_NnooogW_oomkkoooNnmikooooO1?oo
00CgW_oOooog_P;gWP;oo`0Amikg__oooooogoNnoooogooomkkoooNnoooogoooomogWP03ool2mkh2
ool00oNNooooo`3Xool00;_oo`04mkkooooomkh2ool3oml00oNNooooo`04ool2oml6ool01OoOmkko
oooooml02Ooo00?ogooomih01?oo00?ogoNnoml00_oo00Gg__ooomooooNn00Coo`06mkkoooooomoo
oooO2Ooo00?ogoooool0j_oo003oooocool00?oooo?oo`00oooolooo003oooocool00?oooo?oo`00
oooolooo003oooocool00?oooo?oo`0000Cg__ooooog_P;oo`03mkkooooo013oo`03omoooooo09ko
o`05omoooooooooog`0Qool00oNnooooo`03ool01?NnooooooNn1Ooo00?g__ooool0Tooo00?g__oO
ool0>?oo00Gg__oooooooooO02goo`000_oo00CogoooooogWQOoo`?ogiWoo`03omoooooo02Koo`;g
_P03omoooooo00;og`;oo`03omog__Nn09;oo`04omoooooomih3ool00ooOooooo`0gool00nmMomoo
o`03ool00oNnooooo`0Xool00005mkkoooooooogWP02ool00oNnooooo`0?ool00oNnkggoo`02oml0
0oooomooo`2Hool00nLloooog`03ool00oNnooooo`0Oool2oml2ool01_NNooogW_NNooogWP;oo`;o
gi;oo`03mkkogooo00;gWP03omoooooo03Ooo`04mikoooookgd^ool00007ooogW_oooooogoooked0
4Ooo00?g__ooool00_oo00?g__ooool0Vooo0_oO9?oo0_oO00?ooooOoml01?oo0_oO00?ooooOoml0
Tooo00?ogooomkh0?Ooo00C_OOooooog_Rcoo`000_oo00Cg_P00000@PP8081D000032440000P09T0
000402000000020200000`0P0000000O0002244200000a220000000200000a2200000002246B0000
0`QQ0000000m0002ool01?oOoooooooO:ooo00001Nmmmkkoo`0048804`0000D8@@00020080000088
@IT00005020@PP000008@@0U00000`0P000080020002244200000`0P0000802E0000100P00000122
>@0000D@P_ooomooonmm02goo`000_oo00Gg_P00020000QQ0180000624400000020000QQV@0000<0
80006<<00`0000<8@@0P00008P0000@08000000@XP8000044:800000022E00001@Q10008@@000200
>P0000?_GOooool00_oo00?g__oOool0:Ooo0002ool01OoOoooooooooml04_oo00Kog`00247_OOoo
mkjIool00`00023og`02ool00oNnoooog`0Pool00ooOooogWP03ool01?NN2648HONN0ooo00?gW_oo
oml0T?oo00Og__oomkkogooo0200000iool00ooOoooog`03ool00oNNooooo`0Yool001[oo`800003
oooogooo09Woo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`006_oo0P0000?ooooOool0VOoo
0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooO
ooooo`0Xool2002Lool2001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`80
09coo`8006_oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo
000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2002Lool2001[ool001[oo`800003
oooogooo09Woo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`006_oo0P0000?ooooOool0VOoo
0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooO
ooooo`0Xool2002Lool2001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`80
09coo`8006_oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo
000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2002Lool2001[ool001[oo`800003
oooogooo09Woo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`006_oo0P0000?ooooOool0VOoo
0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooO
ooooo`0Xool2002Lool2001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`80
09coo`8006_oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo
000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2002Lool2001[ool001[oo`800003
oooogooo09Woo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`006_oo0P0000?ooooOool0VOoo
0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooO
ooooo`0Xool2002Lool2001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`80
09coo`8006_oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo
000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2002Lool2001[ool001[oo`800003
oooogooo03;oo`05omooooooooog_P03ool00oNNooooo`05ool01_NNooooooNnoooog`?oo`04mkko
ooookgd4ool01_Nnoooooooomkkoo`;og`07oooogoNnmkkooooOmkh01?oo00?ogoooool0<?oo0P00
0_oo00?ogoooool0:?oo0P00W?oo0P00Jooo000Jool200000oooomooo`0dool01?Nnoooooooo0_Nn
0_oo00K_GOoOoooogooooml4ool01ONnooooooNnoml00_oo00?_GOooool00_Nn0_oo00?gW_oOmih0
2?oo00Cg__ooooo_G@;oo`04mkkooooooml`ool20002ool00ooOooooo`0Xool2002Lool2001[ool0
01[oo`800003oooogooo037oo`04omooooNnmkh2ool01NmmooooooNNoml00_oo00Oogooomikogooo
omo_G@02ool01ONNoooooooomkh00ooo00GgW_oooooooooO00Coo`;og`04mkkoonmmmih3ool02?oO
mkkogooOooog__oooml`ool20002ool00ooOooooo`0Xool2002Lool2001[ool001[oo`800003oooo
gooo037oo`03mkkooooo00Goo`03mikooooo00;gWP05ooog__ooooogWP04ool00nmmooooo`03ool0
1?NNoooooooO0_oo00Cogooooooog`?oo`04mkkooooomkh3ool01_NnoooogooOooogWS;oo`8000;o
o`03omoooooo02Soo`8009coo`8006_oo`006_oo0P0000?ooooOool0<_oo00WW??ooooooonLLoooo
gooooml01?oo00Kg__ooooogW_oomkh2oml01_ooomooooNnoooog`Goo`03mkkoooNn00?oo`;og`03
ooo_OONN00Goo`03mikogooo00;oo`03omoooooo02ooo`8000;oo`03omoooooo02Soo`8009coo`80
06_oo`006_oo0P0000?ooooOool0<ooo00GgW_oo000@PP0P00<0000;4:800?oomikoooNnool0000P
4888@@0600001?oo000000000_oo00?ogooo00000P0000LHh`00omooo`Q10008@@0200001a22003o
ooookegg_^mm03;oo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`006_oo0P0000?ooooOool0
=_oo0P0000GooooOooooo`QQ008000;oo`06mkkoo`00003ooooO0ooo0P000_oo00D00?oOooog__oO
00;oo`042648@@00mkh2ool03PQ1003g__oomih000Q1003ogoooomoooooOmkh`ool20002ool00ooO
ooooo`0Xool2002Lool2001[ool001[oo`800003oooogooo03;oo`04omog__oomkh202001ooOoooo
oooomih000QQ00?oo`04mkh0000Poml2ool02ONNomooo`Q1mikoo`00oooog`03ool01?Nn00008000
0_oo00Gg_P00oooogoNn00;oo`8000?oo`03omoooooo033oo`8000;oo`03omoooooo02Soo`8009co
o`8006_oo`006_oo0P0000?ooooOool0=Ooo00Gog`0P003ooooO00;oo`05mih0000Poooog`02ool2
00000oooomooo`02ool02ONNoooooooomkh@X_Nnooo_O@02ool20003ool00ooOooooo`02ool01ONn
ool00000oml00_oo0_Nn<Ooo0P000_oo00?ogoooool0:?oo0P009ooo00Sg__oomikooooOooogWPQQ
0P0000GoooNnoooog`Q100@000?oo`0<oml080QQ0008@@00247g__oomkh000QQ0P000P0P00@0000P
000000;oo`0400008000mkh3ool020000208@@00023oooNn244300001@0P00008?oomkh00_oo00?_
OOooool0;Ooo0P00Jooo000Jool200000oooomooo`0cool00ooOooooo`0200001Ooomkkoonmmool0
0P0000Cogoooooooo`800005oooogoooooog_P02ool03OoOmkkoo`00020000Q1020000Q1267_GONn
00;oo`;gWP08oooW??oo000@PP0PomogWP?oo`03omoooooo02koo`8000;oo`03omoooooo02Soo`80
02Woo`09kggoooooomooooNN003oonmm00;oo`0?mkkoo`0002000?oomkkoooNNooog__oO000@P_Nn
00;oo`0Aiccooooo00008?NNooog__oooml8@@00ooogW_oo003og`02ool02ONnooog_P0024408?NN
mkkoo`020002ool01_NN02000000ooog_P?oo`03mikooooo02_oo`8006_oo`006_oo0P0000?ooooO
ool0<ooo00kgW_ooool0000PmkkooooOool000Q1ooogW^mM0_oo0P0000CooooOooooo`;og`04ooog
__ooool20002ool00oNN02000003ool02_oOooooooookggoo`0002000>LL0_oo00?gW_oOool0<Ooo
0P000_oo00?ogoooool0:?oo0P009ooo00?ogoooool00ooo00?gW_oo00001_oo00@0000P003gWPKo
o`8000;oo`04omoooooOool20005ool02?Nn003ooooomkh00?oooml2ool00nLLool000020003ool0
1P00oooogoNNooogWP800004mikoooooic`_ool2001[ool001[oo`800003oooogooo037oo`09mkko
ooooooo_GA220008H@0000808003003ooooo00Coo`800003oooogooo00?oo`09omooooooomog_PQ1
mkkogooo00800008oooogoNNooog__oomih8@@<00004mkkooooOomldool20002ool00ooOooooo`0X
ool2000Wool04OoOooooonmMomooooNnomooo`00ooog__ookegog`0P00000ooo00GogoooooooooNn
00808009ooog__oooooogoNn48800?Nn00;oo`03kegooooo00;oo`07omog__oo023ogoNnmih00_oo
0P0000SoooNNmikoooNNomooooNN0_oo00H00122oooNnooomkh_ool2001[ool001[oo`800003oooo
gooo037oo`03mkkoonmm00;oo`8000;oo`07omogWP00003_OOooked00_oo0P0000GooooOooooonmm
00Coo`03kggoo`0000;oo`800003ooog__oo00Coo`<00005023oooNNooog_P02ool00oNnomooo`0`
ool20002ool00ooOooooo`0Xool2000/ool01OoOooooooNN24400P0000<8H@0002000P000_oo00Cg
__ooomogWP;oo`8000;oo`04omogW_oOool20005ool00nmmooogWP02ool01ONn0008@@0002001000
1?oo00?ogoooool00_oo0`0000?ogoooool00_oo00?ogoooool0:ooo0P00Jooo000Jool200000ooo
omooo`0bool01_oOmkkoooNN020Q10;og`06mkkooooO000@P^mM0ooo0P0000?ooooOool01?oo00_g
W_oooooogooo023_GAS3003oooNn00?oo`07mih000QQ023gW_oomih00_oo00?g__oomkh0<ooo0P00
0_oo00?ogoooool0:?oo0P00:?oo0_oO0_oo00kgW_oomikoo`006<?oooNNool8@@00ooog__oO1_oo
00<0000Pkgd00_oo00Oogooomkh000Q1oooW?002ool00oNnooooo`02ool01?oOool8@@000ooo00L0
8000ooooooNnomo_G@02ool2mih00`004:808002ool01?NNmkkooooO;_oo0P00Jooo000Jool20000
0oooomooo`0bool01?Nnoooooooo0P0000Gg__ooooooooNN008000Coo`800003oooogooo00?oo`08
kggoooooomooooNN000@PP80000>mikooooooooogooo02000?oomkkogooomkh000Goo`03omoooooo
02koo`8000;oo`03omoooooo02Soo`8002Woo`03omog__oO00Coo`03oml00?oo00;oo`800004miko
ooooool2oml01ONnoooog`0024400_oo00CogoNNooooo`8000?oo`0;mikoonmmoooogoooomooooNn
267og`02ool200002Oookggoonmmooog__oo0208H@020005ool00nmMooooo`0]ool2001[ool001[o
o`800003oooogooo03?oo`05omogW_oo02000002ool2oml00ooo24400004ool200001Oooomoooooo
oml00_oo00_g__oooooogooo244000QQmkkooooO00?oo`03mkh000Q100Goo`04003oooooomlcool2
0002ool00ooOooooo`0Xool2000Wool01?NnoooooooO0_oo00GgW_ooomooo`0000;oo`0400008?oO
ool2oml00ooomkkoo`03ool200001?ooomoooooo0_oO00<080Q1ool00_oO0ooo00?ogoookgd00_oo
00CgWP00ooog_P800004oooogooooml2ool01OoO0000000P00000_oo00Cogoooomoogc3oo`8006_o
o`006_oo0P0000?ooooOool0<_oo00[_OOoomkkog`0P003ogooomkh080800005ooogW_oooooog`02
00001?oomkkooooO2Ooo0P000ooo00O_OOooooo_GOoo02000002ool30002ool00oNnooooo`0aool2
0002ool00ooOooooo`0Xool2000`ool01?Nnool00?oo0P000ooo00_ogoooomoooooOooooga22003o
gooo00;og`04ooog_PQ10004ool00oNNooooo`06ool01P00ool0000Poooog`Coo`800003023ooooo
00;og`;oo`05mkkooooooooog`0]ool2001[ool001[oo`800003oooogooo037oo`05kggoonLL2648
@@0200000`Q1000080020002ool01?Nnool000000PQ100<0000Pkgd02_oo00D00?ooooog__oo00;o
g`0;mkkooooooml0000P000@PP00ooo_O@0eool20002ool00ooOooooo`0Xool2000_ool01NmMoooo
g`0026400P0000?ooooOool00_oo00D08?oooooogooo00800004mkkogooomkh2ool01@00247ooooo
ked02_oo0`0000<08?oOool00_oo00KgW_oo48808?Nnmih3ool01@00omooooookgd0;ooo0P00Jooo
000Jool200000oooomooo`0bool01?NnooogW_oo0_oO00?g__oooml00ooo00?ogoooool00ooo00?g
__ooool02_oo00GW??ooomogW_oo00;g_P?oo`03mikooooo00?oo`05mkkoonmMooo_O@0cool20002
ool00ooOooooo`0Xool2000bool00`0024400004ool00nmMool00003ool00ooO2648@@03ool20000
1?oo000@P_Nn0ooo00?_GOooool01_oo00D@XP00023oonmm00;oo`0;mikoooNN02000?ooomog__oo
mih@PP05ool00oNNooooo`0[ool2001[ool001[oo`800003oooogooo03;oo`04kggooooomih3ool0
2_NNoooooooOoooogooomkkoooNN0_oo00C_OOoOoooog`[oo`03omooooNN00;oo`;g_P;oo`05miko
oooOooogWP03ool01OoOooooooNnoml0<?oo0P000_oo00?ogoooool0:?oo0P00<_oo00Kg_P00023o
ooNnoml3ool00`0P003oo`02ool01P00247g__oooml000;oo`8000?oo`03iccooooo00Ooo`03kgd0
800000;oo`0BmkkoooooomogW_oo0208@Ooomih8H@0P003oooNnooog__oO;_oo0P00Jooo000Jool2
00000oooomooo`0bool00oNnomooo`02ool01_NNooooooooiccog`;oo`05kegooooOoooog`04ool0
0ooOooooo`07ool02_NnomoooooomkkoooNNooog__oO0ooo00?ogoookgd00ooo00C_OONNooogWS3o
o`8000;oo`03omoooooo02Soo`8002ooo`;og`03mikoo`0000Koo`03kgd8@@0000D0000424400000
488200001`0P000000Q1mikoooNN00Woo`0;003ooooomikoooNNoooogooomkkoo`0200001a220000
0?oomkkooooO00;oo`03omoooooo02_oo`8006_oo`006_oo0P0000?ooooOool0<Ooo00Gg__ooooog
__NN00Coo`05iccoooooooog_P04ool01_oOoooogoNnoooog`Woo`06omooooookegooooO0_oo00?g
W_ookgd00ooo00Sogooomkkg__oOmkkooooO<Ooo0P000_oo00?ogoooool0:?oo0P00;ooo00?ogooo
mih00_oo00C_GOookggNn`Goo`04mkkooooomih3ool01ONnmikooooomkh00_oo00?g__oomih02Ooo
00CgW_ooooo_O@?oo`03omooooNn00Ooo`07mikg__ooooogW_oooml0;Ooo0P00Jooo000Jool20000
0oooomooo`0aool00oNnooooo`02ool00ooOmikoo`03ool01^Llmkkogooomikg_PCoo`03omoooooo
00_oo`04omooooooool2oml00nmMooooo`03ool00ooOmikoo`03ool00ooOooog_P0`ool20002ool0
0ooOooooo`0Xool2000_ool01?oOooooonmm0_oo00OgW_ooooooooNNooogWP02ool02?Nnmikooooo
omogW_oomkh6ool00ooOooooo`09ool01NmMiccoonmmmkh00ooo00C_GOooooo_G@;oo`04kggooooo
mkh2ool00oNnoooog`0]ool2001[ool001[oo`800003oooogooo03?oo`03mkkooooo00?oo`03mkko
oooo00Soo`04mikooooomkh;ool3oml6ool00oNnoooog`03ool00ooOooog_P02ool00oNnooooo`0_
ool20002ool00ooOooooo`0Xool2000`ool01OOOoooooooomkh00_oo00?ogoooool01_oo00CWGONo
oooog`;oo`06mkkoooOOmkooooNo0_oo00?ggoooool01_oo00C_O_ooooogg`;oo`03mikooooo00;o
o`04kikooooomih2ool00oOOooo_WP02ool00oNNooooo`0/ool2001[ool001[oo`800003oooogooo
09Woo`8000;oo`03omoooooo02Soo`8001Ooo`03omooo_on00Coo`?oggSoo`03omoooooO008006_o
o`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P005ooo00CogooNookooP?oo`?o
gg_oo`8006_oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P005ooo0_oO0_oo
0_Oo1_oo0oOoLOoo1OOo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2
000Gool2oml2ool3mol6ool2mombool4mol2001[ool001[oo`800003oooogooo09Woo`8000;oo`03
omoooooo02Soo`8001coo`?go`;oo`?oggGoo`03omoooooo008006_oo`006_oo0P0000?ooooOool0
VOoo0P000_oo00?ogoooool0:?oo0P007?oo0oOo0_oo1OoOLOoo1OoO0P00Jooo000Jool200000ooo
omooo`2Iool20002ool00ooOooooo`0Xool2000Mool2mol2ool4ommcool2oml2ool2001[ool001[o
o`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`80027oo`Cog`?oofkgo`;oo`;ooP;oo`80
06_oo`006_oo00<000Q1oml0Vooo0P000_oo00?ogoooool0:?oo0P005ooo00Oo_oooomoog_ooookg
g@02ooh00onMoico_@02ooh00oOmookoo`1_ool01Oonoogoo_omooh00P0P00?gooooool0J?oo000H
ool01OoOool00000ool00_oOVOoo0P000_oo00?ogoooool0:?oo0P006ooo00Coo_nmomgog@Co_@;o
g@03okgoW?nn06ko_P;o_@07omgoW?oMomd880Q0ooh0J_oo000Jool00`00267g_P2Kool20002ool0
0ooOooooo`0Xool2000Gool00ooOokkgoP02ooh01OnmoignVOjJo_`00_lL00?o??mMocd0L_lL00Sn
^_lloegoOB00603og_oO1?oo0_onHooo000Hool01OoOool000002440W@000_oo00?ogoooool0:?oo
0P006Ooo00cgooonomgo_OkK/TVaZ;67T>BAIY55VFH2XBI`XBD02ZTUZDJQAX3TTLQiYbP0oiko_ooO
1?oo00?oo_ooool0HOoo000Hool01OoOool000002440W@000_oo00?ogoooool0:?oo0P006Ooo00og
ooOnookoWOjKV8BH0/U7X@FQIYTUXBJXaK3UZ@D0KZ4U00^Y1K3U/@JY1Y2TVHR1R2P0oioo_ooO06So
o`006_oo00<000QQmkh0Vooo0P000_oo00?ogoooool0:?oo0P005ooo00kogoNNkok_o_onokgnoL5X
dFSmn_kLoacnnolL0_kL00?no?lLoa`0K?lL00[no?kLoW[no?lMocdX01P0okoogfWoo`006?oo00Go
gooo00000?oo00;ogiWoo`8000;oo`03omoooooo02Soo`8001Ooo`0?okoogoOokoogo_mLo[bY9iR4
o[_oO?oLom_oo?mk00;oWFko_P04okgoW?nlog/2omd00`PP267go`03momWool001[oo`030008@OoO
09_oo`8000;oo`03omoooooo02Soo`8001Ooo`0<oekogoOoiokooooNoafQ1JU6oaco_?om0_Om00?o
_?onooh0K_oo00Koo_omoocooOOmooh202001>oomoogooOoIooo000Jool200000oooomooo`2Iool2
0002ool00ooOooooo`0Xool2000Gool01ooOooooooOoooooWOlL00:Q9@04oacoWOonmol2ool00oon
ooooo`1_ool01?onoooooooo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooOooooo`0X
ool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool200000oooomooo`2Iool2
0002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool2
00000oooomooo`2Iool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0
NOoo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2000Jool01?Oooooo
WOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooOooooo`0X
ool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool200000oooomooo`2Iool2
0002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool2
00000oooomooo`2Iool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0
NOoo0P00Jooo000Jool200000oooomooo`1Pool00ooOoooog`03ool00oNNooooo`0`ool20002ool0
0ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool200000ooo
omooo`1Nool00oNNooooo`04ool2oml00ooomikoo`0_ool20002ool00ooOooooo`0Xool2000Jool0
1?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool200000oooomooo`1Jool00oNNooogWP05
ool2mkh01?NNooooonLl<Ooo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oaco
WOoo07Woo`8006_oo`006_oo0P0000?ooooOool0GOoo00Cg__oOoooog`?oo`05mkkoooNnooogWP0`
ool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000J
ool200000oooomooo`1Iool01?oOkggoooNn1?oo00Og__oooooooooOoooW?00aool20002ool00ooO
ooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P00Jooo000Jool200000oooomoo
o`1Kool01NmMoooogooomih02?oo00?ogoooool0;_oo0P000_oo00?ogoooool0:?oo0P006_oo00Cg
oooooigo70:Q9003oacoWOoo07Woo`8006_oo`006_oo0P0000?ooooOool0FOoo00W_OOooooooonmM
000YA@0002000P000_oo00?_GOoooml0<?oo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo
70:Q9003oacoWOoo07Woo`8006_oo`006_oo0P0000?ooooOool0F_oo00Cg__oooml8@@8000;oo`04
mkkoo`00oml2ool00ooOooooo`0^ool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T
00?o7?nMool0NOoo0P00Jooo000Jool200000oooomooo`0Bool01?NnomoooooO1?oo00GgW_ooooog
__oo00;og`?oo`;og`Coo`03mkkoooNn00;oo`09mkkooooomikooooOmkkooooO00Coo`06mkkooooo
mikooooO0_oo00Kg__oooooogooomih2ool02?NnooooonmMoooogooomkh2ool01oNnooogW_oomiko
gooo00800003omoooooo00;oo`05oml00?oOoooog`02ool00oNnoooW?002ool00ooOooog_P02ool0
0ooOmkkoo`03ool01?NNomoooooO1Ooo00Gg__oooooooooO013oo`8000;oo`03omoooooo02Soo`80
01[oo`04mooooonMoa`2XB@00olLoigoo`0Dool01_oOoooooooOoooog`Coo`;og`Coo`04mkkooooo
mkh2ool00oNNoooog`02ool01_oOooooooNnooog_PGoo`03mikoooNn00;oo`04mkkooooomih2ool0
1?NnoooogooO0_oo00?g__oooml00_oo00W_OOooooooooNnoooogooooml01_oo00Gg__ooomoooooO
01Goo`8006_oo`006_oo0P0000?ooooOool04_oo0ooO1?oo0_oO00?oooNnmkh01?oo00?ogoooool0
0_oo00?ogoooool00ooo00G_OOoooooooooO00;oo`04mikooooomih4ool02_Nnoooooooomikogooo
mikoooNn1Ooo00GogoNnooog__oo00;og`0?mikoooooomooonmmoooogoooomogW_oo000@X^mm00@0
0006247ooooomkkognmm0ooo00Og_^mmoooogoNNooo_G@02ool00nmMooooo`03ool00oNNooooo`04
ool01?Nnooog__oO4Ooo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oacoWOoo
01Goo`07keggW_ooooog__oooml00_oo00cg__oomkkogoooomoooooOmikoooNNkgd3ool01?oOoooo
ooNn0_oo00OgW_ooomoogoooomog_P03ool01OoOmikoooNNkgd00ooo0_oO0ooo00?ogoooool00_oo
00GogoooomoooooO00Coo`06mikoooooomooooNN1?oo00?ogoooool05?oo0P00Jooo000Jool20000
0oooomooo`0Aool01_oOoooooooo00008080000;0200000P000H``00mkkog`0024400002ool01@00
24400?oomkh00P0000<8@Ooooml010001?oo100000Woo`00000000QQ2440000Pkgd00ooo0_oO00Co
o`004:8000Coo`070200000002000?oooml00`000_oo0P0000D080004:80800000;og`07ool8@@00
6<<00?oomkh00_oo00<8@@QQ00000P0000<08?ooool00`0000D08000ooooonLl00<00004247oo`Q1
000Bool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool05?oo00?W??oo
ool01_oo00?_OOoomkh01?oo00?gW_ooool00_oo00?ogooooml00_oo00?_GOoOool00_oo00?ogooo
mih00_oo00GgW_oomikg__NN00Coo`04omoooooOmkh3ool00ooOooooo`03ool01?NnoooooooO0ooo
00?gW_oOool01?oo00?gW_oomkh00_oo00?ogoookgd05Ooo0P00Jooo000Jool200000oooomooo`0B
ool01>mmomoooooo0P0000?oooNnoml00_oo0P0000GooooOoml000QQ00;og`0726400?oOomooo`QQ
02000_oo00d000Q1003ogoNn003g__NN6<<001S3kggoo`020002ool0100P003ooooO0ooo00Og__oo
ooooomkk003og`02ool01?NNooooo`000P0P00WoonLLoooog`00023_OOoo24400`0000?_OOoOool0
0_oo00H8H@00023g__oo0003ool200000oNnomooo`0200001?oomih8@@000_oo0_Nn0PQ100<8HNmm
oml00P0000?oonLlool04?oo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oaco
WOoo01Koo`09mikg__ooooo_OOooomooooNn00;og`Goo`03mikoonmm00;oo`03mkk_OOoo00?oo`04
omog__oooml2ool00nmmooog_P04ool00oNNooo_O@02ool01?Nnooog_^mm0_oo00?ogoookgd00_Nn
00KooooOooogW_oomih5ool01?NNomoooooo0_oO0ooo00?ogoooool05?oo0P00Jooo000Jool20000
0oooomooo`0Cool02?Nnooog_PQQ023g__oooml3ool01000omoooooo0P000_oo0P000ooo0P0000Cg
W_oo000000Coo`05003oonmm02000002ool01000267ooooo0P0000GoooNnomoogoNn00Goo`04003o
oooomkh3ool00`0024400004ool01P0P003oooNnool8@@Goo`0=mikoo`00247oooNnooog_P00oooo
g`QQ00000_oo00Gogooo00000?oo008000;oo`03omoooooO008000;oo`050008HOoOooog_P0@ool2
0002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool05?oo00?_OOoomih01?oo
00?gW_oomkh00_oo00?gW_oomkh00ooO0ooo00SognmMooooooNnooog__NN0_oo00GogooooooooooO
00;oo`04kggooooOoml3ool01?oOkegoooNn2_oo00Cg__ooooo_O@;oo`03omogW_oO00Koo`04mkko
gooomihGool2001[ool001[oo`800003oooogooo017oo`05omooooooooo_O@020002ool01?NNomoo
ooNn0ooo00?og`Q100000_oo00<000Q1oml00_oO00D000Q1ool000QQ00;oo`04kggogooOmkh2ool0
2P0048;oooNN00008>mMmih8@@000_oo00?ogoooool00_oo0_Nn0_oo00<00?oooml00ooo0P0000?o
ooNnmkh00_oo0P000_oo00?gWP0000000P0000D8@Oooool0800000?oo`09mkkoooooomog_P00023g
__oO00;oo`030008HNmm008000?oo`0;kggoo`00003g__oO02000?NNooogWP0@ool20002ool00ooO
ooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool06?oo00?ogoooked00_oo0_Nn0_oo00?o
goooool01?oo00Kogoooomoogoookgd2ool00ooOooooo`02ool01Nmmoooooooomkh01_oo00Cogooo
omoog`Coo`03kegoooNN00;oo`04kegooooooml3ool01OoOooooooooked01?oo0_oO1?oo00?ogooo
ool04ooo0P00Jooo000Jool200000oooomooo`0Bool01?oOmikooooo0P0000OoooNNooooooNnoooo
g`03ool20002oml20003ool00`Q1003oo`020006ool00oNnooooo`0200000ooo00008002ool00`Q1
48;_O@02ool01_NNmkkoooNnoooog`;oo`800006020000000008@@000_oo00Gogooomkh0800000;o
o`80000:247ooooo0008@ONn0008HONnkgd2ool02?NnomooooNn48800?oooml2ool01a22003oo`0P
003oonmM00?oo`06oml8@@0Pmkh080004ooo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo
70:Q9003oacoWOoo01Coo`07omo_O@0P0000800026400P0000LH``00003oo`0048800002ool01ONn
ool000004:800P0000?oonmM48800P0000<08000ool00_oo00?gW_oo4:800P000_oo00Gg__oo0000
012R008000;oo`03mikooooo00@000080208@OooiccoooNn00008080000448;oonmm020200000aSS
0000800Hool2001[ool001[oo`800003oooogooo01Koo`8000?oo`04mkkooooooml3ool01P00247o
oooo244000;oo`04mkh08000ool20000100P000000Q10P001?oo00Kg__oo00000?oooml20002ool0
1ONnoooooooOool00_oO00GooooO02000?oO00;oo`8000Koo`0>0008HNmmool8@@00ooog__oo0200
0?oo02000080800800008000247ogooo000080;oo`07mkkoo`00003oo`0024400ooo0_oO00KooooO
ooooo`000202ool00ooOooooo`0>ool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T
00?o7?nMool05?oo00Oogooooml8H@00ooogWP02ool01_Nn0208@OoOool000Koo`0<0008@@00oooo
goookgd8H@00omoooooO1?oo00?_O@0Pool01Ooo00P000Q1003ogooomkkoo`0P0P000_oo00?ogooo
kgd00P0P00Og__ooool0000Pooog_P03ool00`0P00000002ool00ooOooooo`0Eool2001[ool001[o
o`800003oooogooo01?oo`;og`03ool0000000Koo`;g_P06ooog_P0P48;gW_oo0P000ooo00D0000P
mkkoo`0000?oo`050200000Pooo_O@020002ool01000247g__oo0P000ooo00?gW_ooool00_oO00Go
oooOooooo`0P00;oo`04mkh0000Pmkh3ool01?oOkgd@XP000_oo00<08000ool00_oO00D08000oooo
o`0P00;og`04ool000000202ool20002ool01OoO24400000ool00P000_oo00?_OOooool00P0000Co
oooO000080;oo`03omoooooo00koo`8000;oo`03omoooooo02Soo`8001[oo`04mooooonMoa`2XB@0
0olLoigoo`0Gool20003ool01ooOooog_P00mkkoo`0000;oo`;og`;oo`800003023oooNn00;oo`80
0006oooogooomkkoooNN0_oo00<00?ooool00_oO0_oo0P0000<08?oooml00_oo00<0000Pool00ooo
00Cogoooool000?oo`8000Coo`<000;oo`03mkkooooo01Koo`8006_oo`006_oo0P0000?ooooOool0
4Ooo00?g__ooool00_oo00<0000Pmkh00ooo00GgW_NnoooooooO00808006003gW_oo000@PP000_oo
00H0000Pkggoo`Q10002ool20003ool01P0P247g__oo244000;oo`@00003023ooooo00?oo`0:omoo
oooomkh08?NNoml0000Pmih2ool02?oOoooooooo0008@OoOool200001oNNool0000002000?oo0080
00;oo`0324400?oo00;oo`800003247gW_oo00800007ooog_P00020000Q126400_oO00@08000ooog
WP88@@03mkkooooo013oo`8000;oo`03omoooooo02Soo`8001[oo`04mooooonMoa`2XB@00olLoigo
o`0Gool20005ool01_NnoooooooOool000Goo`800003ooogW_oo00;oo`0648800?ooooog__oO1?oo
00?og`0Pool01?oo0P000ooo00Sg_P0048800?oomikoooNn0_oo00oW??ooooooooNn8@@00?oOoooo
g`0024400?ookgd06_oo0P00Jooo000Jool200000oooomooo`0Bool01?Nnomooonmm0P000_oo00K_
OOoooooogoNnool2oml200001Oooomog_P00ool00P0000@@X_oOooog_P;oo`060200000Poooognmm
0_oo0P0000@8H@00ooog_P;oo`08023gWP00247gW_oomkkog`;oo`06mikogooooml08?oo0P0000Go
oooOooo_OOoo00;g_P8000;oo`05mkkoo`Q10008H@03ool2mkh01Ooo00000000ool00_oO00G_OA2R
023oo`Q100800006ooo_OOoooml00?oo0P000_oo00Wog`Q1000@PP00kegogooomkh04?oo0P000_oo
00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oacoWOoo01Ooo`8000Coo`04kggooooomkh2
ool600000`0P267oo`02ool01_Nnool00000ooogWP;oo`03mkk_GOoo00;oo`030200000000<00003
0208HOoo00?oo`800005oooogooooooog`07ool200000ooooml8@@0200001ONnooo_GOookgd06?oo
0P00Jooo000Jool200000oooomooo`0Aool02OoOoooooooooml@XP00oooog`02ool01>LlooooooNn
1?oo00WgW_ooooo_GOoomkkoooNNmkh00_oo00?_GOooool00_oo00GgW_ooooogW_oO00;oo`09kggo
ooNNooogW_ooomooonmm00?oo`03mikooooO00;oo`03mikooooo00<000034:;g__oo00;oo`09kggo
oooo24400?NnomooooNN00;oo`03mikg__oO00;oo`03mkkooooO00?oo`03omoooooo00800005ooog
W_ooooog_P02ool01?oOooogW_oO1?oo00?g__ookgd00ooo00?gW_ooool03ooo0P000_oo00?ogooo
ool0:?oo0P006_oo00Cgoooooigo70:Q9003oacoWOoo01Ooo`8000Goo`07omoooooOomooo`002440
0_oo00Cg_P00003g_P;oo`0@kggooooO488001S30208H@00omooonmMoooog`002442ool01?Nn0000
0?Nn0_oo00K_GOoo4:800?oooml3ool2oml5ool00`0P003og`0200000a2Rooooo`02ool01OoOoooo
ooNnoml05Ooo0P00Jooo000Jool200000oooomooo`0Cool3oml01P0P003oooNnomog_P;oo`06mkko
oooomkkooooO0_oo00GgW_ooomooonmm00Koo`03omooooNn00;oo`;og`Coo`06mkkoooooomoooooO
0_oo00OogooomikoooNNooogWP02ool01_oOool00000023_O@Ooo`030008@Ooo00?oo`03omooooNN
00;oo`04mikogooomkh2ool01ONnmikoooNnool00P000ooo00KognmMoooogoookgd4ool01NLloooo
oooomkh00_oo00?_GONnool04?oo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003
oacoWOoo01Ooo`8000?oo`03mkkogooO00;oo`05kggg__oo003gWP02ool00`006<?g_P02mkh00ooo
mikoo`0200001_oomkkoo`00023gWPCoo`06003gW_ooool001S30_Nn0ooo0P000_oo00?ogoooool0
0_oO1Ooo00D000QQ020000Q100;oo`08kggoooooooo_OONNooogWQGoo`8006_oo`006_oo0P0000?o
oooOool04_oo00OW??oomkkoo`00023g_P02ool02OoOoooooooOooogWP0P003oo`02mkh2ool00oNn
ooooo`02ool01?NnooooooNn1Ooo00GW7?ooomooooNN00?oo`05mikooooooooog`02ool01OoOoooo
oooooml00_oo00CgW_Nnooooo`800005kegooooomkkog`02ool01ONn26400?Nnked00_oo00OogoNn
ooogW_oOoooog`02ool00ooOooog_P02ool02?oO02008000ooogW_oooml2ool01_NnooogW_ooomog
_P;oo`03omogW_Nn00Goo`03omoooooo00koo`8000;oo`03omoooooo02Soo`8001[oo`04mooooonM
oa`2XB@00olLoigoo`0Gool20006ool02oNNmkkooooOmkh8@OoOmkh8@@0Pkgd00_oo01Kogoooooog
WPQ16<?W7?oomkkooa22003ooooOiccoo`Q1omog_PQ1023_O@;oo`05mkkoooNn26400004ool00ooO
ooooo`05ool200001?oO0008HOoO0_oo0_Nn00CogoNnoooogaKoo`8006_oo`006_oo0P0000?ooooO
ool04Ooo00C_GOooool8H@80000<0200000PkegoonmMoooogoNnool8H@001ooo00GogoNNoooooooO
00?oo`03kggooooo00Goo`0;mikooooomikogoooomooonmMooogWP03ool00oNNooooo`03ool01^LL
ool08?oOooo_G@;oo`04mikoooNN26420002ool01ONnooooooookgd00_oO0_oo00?gW_Nnool00ooo
00_ogooomkh000Q1mkkoooNnoooognmm00Koo`03kegooooO00Coo`;g_P03omoooooo00ooo`8000;o
o`03omoooooo02Soo`8001[oo`04mooooonMoa`2XB@00olLoigoo`0Gool20004ool04ONNooooooNN
oooogoookgdH`oNn0008@OoomkkgW_oomih00_oo0P001?oo0P00013ogoooooooonmm6<?g_P00247o
ooNnmikoonmmmkh080800004omoooooomkh2ool00nLlooooo`02ool020Q1003ooooo00008?oomih4
ool00ooOooog_P0Eool2001[ool001[oo`800003oooogooo01;oo`04kegooooOoml3ool00ooOoooo
g`02ool01?oOooog__Nn2ooo00Cg__oomkkog`;oo`05omooooNnooogWP04ool01?Nnoooooooo0_oO
00CoooNnooooo`;og`08ooog__oomikooooOooo_O@;oo`03omoooooO00;oo`04kggoooookgd2ool0
0ooOooo_O@05ool2oml3ool00oNnoooog`02ool01ooOoooooooomikoooNn00?oo`04omoooooooml2
ool00oNNooooo`03ool00oNnooooo`0Aool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL
0Z4T00?o7?nMool05ooo0P000ooo00GogoooomoooooO00;oo`03mikoo`0000800003023g__oo00?o
o`05mkkoo`Q1003oo`02mkh01Ooo00000?ookgd00ooo0`0000<08?Nnool00_oo00Kogooo000000Q1
mkh3ool01?oOooooo`000ooo00D000Q1ooog__oo00800004oooogooomkh2ool00oNnooooo`0Dool2
001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`8001[oo`04mooooonMoa`2
XB@00olLoigoo`0Gool2000<ool01P0026400?oOoooog`Goo`0402000?oooml2ool00`0P003oo`04
ool03`0026400?oOoooogoooomoooooOool08000mkkoo`02oml2ool200001Ooomikoo`0002000_oo
00S_OOoo00008?ookggoooNn0_oo00?g__ooool04ooo0P00Jooo000Jool200000oooomooo`2Iool2
0002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool05Ooo00Kogooo00000?oo
oml9ool01ooOool00000ooog__oo00;og`03mikogooo008000?oo`800007ooo_OOoomkkooooOool0
0P0000CoooNnoooog`;oo`06mkkooooo0008@@000ooo00@0000P003gWP;oo`0348800?oo00Coo`80
0005ooogW_oooooog`0Fool2001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02So
o`8001[oo`04mooooonMoa`2XB@00olLoigoo`0Eool200022642000;ool01A22ooo_OOoooml00_oo
00?ogaS300000`0000<0800026400ooo00?ogoooool00_oo00D@P_ookggooooO00;oo`06mkkooooo
omooo`000P0P0P0000D08000003oonmM00<0000624400?ooool0000P0`006Ooo0P00Jooo000Jool2
00000oooomooo`2Iool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0
5Ooo00Kogooomkkg__oooml9ool01>mmomoognmm0_oo00Gg__oomikoonLL00Coo`04mkkogooOoml3
ool00nLlooo_O@02oml01^mmooooooNnooogWPCoo`07kegoonmMooog__oooml00_oo00?_GOooool0
1Ooo00?gW_oooml00_oo00Gg__ooomooonmm01Goo`8006_oo`006_oo0P0000?ooooOool0VOoo0P00
0_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oacoWOoo01Koo`04omoooooooml;ool0
1OoOoooooooOmkh01_oo0_Nn1?oo00?gW_oooml00_oo00?_GOoooml00_oo00?ogoNnool00_oo00?g
W_Nnoml01ooo00_gW_ooomooooNnooogW_oomikoooNn00?oo`05omooooooooog_P0Gool2001[ool0
01[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`8001[oo`04mooooonMoa`2XB@00olL
oigoo`0Eool00oNNooooo`02ool00oNNooooo`07ool00oNnooogWP04ool00ooOooo_O@03ool01?oO
ooog__NN0ooo00OogoNnooooooNnooogWP04ool3oml2ool01^mmomogW_NnooogWPKoo`03omoooooo
00Coo`04mikoooookgd2ool00ooOooogWP0Eool2001[ool001[oo`800003oooogooo09Woo`8000;o
o`03omoooooo02Soo`8001[oo`04mooooonMoa`2XB@00olLoigoo`0Gool2oml=ool01OoOoooooooO
mih02_oo00Gg__ooomoooooO00Coo`05omooooooomogWP02ool01?NnkegoooNn1?oo00O_OOookggg
__oOooo_O@02ool00nmmooooo`03ool01ooOooooooNnkegoooNN01Koo`8006_oo`006_oo0P0000?o
oooOool0VOoo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oacoWOoo01Koo`04
kggoooookgd:ool01?oOoooogoNn1_oo0_oO0_oo00?gW_oooml01Ooo00KogoooomoooooOmkh4ool0
0oNNooooo`02ool00oNNoooog`02ool01Nmmoooooooooml00_oo00W_OOoooooooooOooog__oomkh0
6ooo0P00Jooo000Jool200000oooomooo`2Iool20002ool00ooOooooo`0Xool2000Jool01?Oooooo
WOlL0Z4T00?o7?nMool0NOoo0P008Ooo00Sg__oomikooooOooogWPQQ0`000_oo00@00?ooomooo`80
000524400000oooog`0400000ooo24400002ool01ONN244000Q1ool00`0000?ogooo24400P0000Co
o`000008H@<00004020000000002ool300001?NNool0000P100000?g__ooool00Ooo000Jool20000
0oooomooo`2Iool20002ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo
0P008ooo00O_OOoooooogooomih08002ool01^mmool00000ooog_P;oo`8000;oo`030000800P00;o
o`800005oooogooO02000003ool00`00023og`02ool01`00023oonmMool0800000;oo`0<mkkogooo
0008HOoOoooog`0P247ooooO0P000ooo00<000Q1ool00_oo000Jool200000oooomooo`2Iool20002
ool00ooOooooo`0Xool2000Jool01?OoooooWOlL0Z4T00?o7?nMool0NOoo0P008Ooo00?ogoooool0
0ooo00CgW_oo003og`;oo`800007023g__oOoooog`0002000_oo00?og`0000000_oo00<0000Pool0
0_oo0P000_oo00?gWPQ100000_oo00?g_P0000000ooo00X080Q1ooo_OOookggooooO003gWP;oo`80
00;oo`034888HNmm00;oo`03oml0000000;oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogooo
ool0:?oo0P006_oo00Cgoooooigo70:Q9003oacoWOoo07Woo`80027oo`0>omooooookegogooomkko
g`QQoooogooo000080800003oooogooo00800003oooogooo0088@@;oo`080008@OooooogWQ2R003_
O@;oo`800003oooogooo00808003kegoonLl00800003omooooNn00Goo`0>omooo`00267oooNn0008
HONnomoooooO000080;oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P006_oo
00Cgoooooigo70:Q9003oacoWOoo07Woo`8002Koo`04omoooooo0002mkh02_oo00000?oo003oonmm
ool@XP000_oo00SgW_oO00000?oO48800?oO0_oo0P0000KooooOool08122oml2ool00`00247oo`02
ool01000247ognmM0_oo00KogoNNomo_GONnool200001?oOool080000_oo00C_GOoo000000;oo`00
6_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P006_oo00Cgoooooigo70:Q9003oaco
WOoo07Woo`8002;oo`;og`;oo`04mikoooNN0002ool200001_oomkh00000ooo_O@800003kggooooo
00?oo`04oml0000Poml2ool01@00247ooooomkh00P000ooo0P0000?gW_oomkh00P000ooo00?gW_oo
ool00_oo0_Nn00L08000ooooo`00267og`03ool00`00267oo`01ool001[oo`800003oooogooo09Wo
o`8000;oo`03omoooooo02Soo`8001[oo`04mooooonMoa`2XB@00olLoigoo`1iool2000Sool00ooO
mkkog`03ool01P00mkkoo`00247gWP;oo`08003ooooo0008@ONnoooog`8000;oo`80000Booog__oo
24400?NNooog_P0048;oooNnool00122oooogooo0P0000?gW_oOked00_oo00?g__NNmih00_oo00@0
8000mkkog`800006ooo_OOoo0008@@000_oo000Jool200000oooomooo`2Iool20002ool00ooOoooo
o`0Xool2000Lool01_nMoa^Y9:TToa_o_G[oo`80027oo`04mkkooooooml2ool01ONNool00?oO2440
0P0000?oooNNoml00P0000coo`00003oooNNool0000Pmikoo`0P0002ool00oNn00000003ool30002
ool200001Ooomkkoo`0P00001?oo00?g__ooool00_oo0P0000X08?oOool08000023ooooO244000?o
o`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P0000?ogoooool00_oo00?oo_oo
ool03ooo0_on0_oO00Soo_nLoaZa0jTSoa_o_Ooo0ooOM_oo0P008ooo01?g__oooooogooomkh8@ONN
00008?oomikoooNNool00?oo00008003oml02_oo000080Q1003g__oomkkog`0P0P0000T8@Ooo0000
0?oo0008H@00oml00ooo0P000ooo00?g__oooml00ooo00?gWP0P02000_oo0P0000Kog`QQ00000?oo
oml2ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Goo`03mooooooo00800003omoo
oooo01Coo`0>mooooooOokoooonMo_^Y1:TToa_o_Oooomoo_gOoo`8002;oo`04mkkoooookgd3ool0
10004888H@000_oo00Gg__ooool00?oo008000Koo`04omo_GOoomkh2ool00oNN003g_P02ool00`00
023oo`03ool01?oOmkkooooo0P001?oo00Cg__oomikog`;oo`04mikooooOool200000oooomooo`05
ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Goo`03mooooooo00800003omoooooo
00;oo`03mooooooo00ooo`;go`?oo`07okoo7J4UXBGo?OoNmol00ooo00?gooooool0Looo0P008Ooo
00Cogoooooog_P;oo`03g]_oo`Q100800007oooogooooooogooo02000P0000<8@ONnool00_Nn00Co
ooNnooooo`?g_P;oo`04023ogoNnoml200001?oOooooomkk0_oo00Kg__oo00008?oooml2ool01NmM
ooooooooked00_oo00O_OOooool08000ooog_P02ool00oNNooooo`01ool001[oo`800003oooogooo
09Woo`8000;oo`03omoooooo02Goo`03mooooooo00800003omoooooO00;oo`03mooooooo00kog`03
ooogooOo00;oo`09mooo_olMZ@FQ9Olmomk_ooOo07Soo`80027oo`08mkkoonmmooogW_Nnooog_P<0
00Goo`06mkkoo`00000@X_Nn0ooo00C_OOoooooog`Coo`03g__ooooo00;oo`0526400?ooomog_P03
ool01?NNool000000ooo00C_OOooooo_O@;oo`800003ooo_O@Q100800003ooogW_oo00;oo`7gWP7o
o`7oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool09Ooo00?gooooool00P0000?ogooo
oml06Ooo00WoWOkk/>Ba1?lKomcgo_onool00_onMOoo0P008_oo00?_OOoooml00_oo00T@PP0P4:80
0?oomikg__ooked00ooo00X00122000@P_ooomoooooOoooog`;oo`04mikooooooml2ool01>mmool0
00001?oo00Gg__oO2440000P00<00003kggooooO00;oo`04kggoo`000003ool00`004:;_G@02ool0
0oNNooooo`02ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Goo`03mooooooo0080
00?ogaCoo`03ookooooo00;oo`07oignfkST/>?o6onlood00_on0_omMOoo0P008ooo00CgW_ookggo
o`;g_P06iccoooooomoooooO0_oo00?g__oOool00_oo00?g__oOool00_oo00CgW^mMoooog`;oo`08
omoooooomikoooNnomooo`;g_P03oooogooo00;oo`07kegg__oooooogooooml00ooo00Gg__oooooo
ooNn00;og`03oooogooO00?oo`03mikogooo007oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?o
goooool0:?oo0P001?oO4ooo00?oo_ooool00_oo00KoWOkl/>Fa1?lLomd2mol2ool00oonooooo`1c
ool2000Qool00oNNoooog`07ool01ONNoooogoNNoml01Ooo00GgW_oOoooooooO00Coo`05kegooooO
mikoo`03oml00oNNooog_P03ool01?oOooog__NN0ooo00K_GONnoooooooOmih2ool00oNnooog_P02
ool2oml2ool00nLloooog`04ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02;oo`03
omoooooo00?oo`800003omkogooN00CooQ3oo`;ooP?oo`0;oigno:T5Z@Go7?nnmoo_ooOooooog`1e
ool2000Rool01?oOooooooNn0ooo0_oO00?ooooOool00ooo00?g__ooool01?oo00Gogoooooog__oO
00?oo`03omoooooo00Koo`05omog__oOoooog`02ool01OoOoooooooooml00_oo00WogoooomoooooO
ooog__oooml00_oo00Cg__oooooog`;oo`7og`7oo`7oo`006?oo00Kogooo00000?ooomnJool20002
ool00ooOooooo`0Qool2oml4ool01Oon00000?onomd00_om00?gVoolood04?oo00?ooOolmm`00_om
00co_OlKV>>@Xolmoik_ooOommoogonoomm_ool00oNnooo_G@02ool00`0P003oo`1Zool001[oo`80
00?oo`03mkkooooo09Koo`8000;oo`03omoooooo02;oo`03omoooooo00;oo`07omh80100o][oWOnL
og`00_nK00?o6_mMoed03OmM00?oG?mJogX00_nL00[oO?lKoUW1Q[66oY[o__oommog_`;ogg?oo`05
omog_PQ1003gWP1Zool001Soo`03mikoo`0000@000032440000009P000;oo`03omoooooo02;oo`0@
mooooooooooogonN800h09VWXBJY1J13`<FhQ<S4b:<>d8<04M22f<?0@KR3^:B`Y;RThDJ`0;22F00X
00P0000080PP2000M00000<080004880Jooo000Jool010002440000PW0000_oo00?ogoooool08_oo
013goooooooooooOoihP03P0TFNHiK46/:G8i[Q3d>G8P`o@PP0<f:?8H/S5`<FhYKS5b>G19K66@00P
0100M@0000<0800002000`0000?gW_ooool0J?oo000Jool00`00023oo`2Kool20002ool00ooOoooo
o`0Wool01OoN200H0?lLogd00omM0_ll00?oGOmmogd03?mm00WoO?mLoegoG_mOocoo?_kKoc`00_mm
00Cogooomoogog?oo`04mkkoooNnmkh2021[ool001[oo`0602000?oomikogoNnV?oo0P000_oo00?o
goooool08_oo00?ogoooool00_Oo00GgoP0P003oo_oN00;oW@03okkog_oN013oo`;ooP05okooOomo
okoog`02ooh00ooomkoWO`02mol00oookkkoo`1aool00ooOooooo`02001[ool001Woo`04oml00122
mkjKool20002ool00ooOooooo`0Uool3mol00`0P043oo`02oml2ool00ooOooooo`0?ool02oOnoooo
gooOoioogooNmmc_oOonmml00_oo00?ggoOMooh0L?oo00?ogooomih00_oo00<8@@0Poml0J_oo000H
ool01ooOool00000oooogoNn09Woo`8000;oo`03omoooooo02Goo`?go`808004mmoooooOmmlCool0
1oOnooog_ooookoogooo00?goP06omooooNnoooooOonLOoo00Kg__ooooooo`00245[ool001[oo`80
0003oooogooo09Woo`8000;oo`03omoooooo02Soo`8002Soo`05omooooooooog_P07ool2oml5ool0
1ooOoooooooOoooogoNn00;oo`03mkkooooo00;oo`03mkkooooo00Soo`03mikooooO00?oo`06kggo
ooooomoooooO0_oo00CgW_ooooogWP;oo`05omooooooooog_P0_ool2001[ool001[oo`800003oooo
gooo09Woo`8000;oo`03omoooooo02Soo`8002[oo`0=mkkoooooooog__oOooo_OONnooo_OOoooml0
0_oo00C_OOoomkk_O@;oo`07mikooooomkkogooomih01Ooo00Kg__oOoooooooOool2mkh2ool01NmM
ooooooookgd01?oo00Cogoooooog_P;oo`08mkkogoookegoooNNooo_O@;oo`03omoooooo02_oo`80
06_oo`006_oo0P0000?ooooOool0VOoo0P000_oo00?ogoooool0:?oo0P009ooo00Cogooomkkg_P;o
o`04kggooooomkh2ool01OoOooo_OOoooml00_oo00?ogoooool00ooo00?g__oOool00_Nn0ooo00?g
W_ooool00ooo00OgW_oooooooooOoooog`02ool00ooOooooo`02ool01ONnooooooNnkgd00_oo00K_
GOooooog__oomih4ool00ooOooooo`0/ool2001[ool001[oo`800003oooogooo09Woo`8000;oo`03
omoooooo02Soo`8002Ooo`03mkkooooo00Goo`03mkkooooo00Coo`03omooooNn00Coo`;g_P03mikg
__oo00Koo`05mikooooooooog`03ool00nLlomooo`03ool01?NNooog__oo0_oO00?oooNNool00ooo
00?gW_oooml00_oo00C_OOooooo_O@;ogbooo`8006_oo`006_oo0P0000?ooooOool0VOoo0P000_oo
00?ogoooool0:?oo0P00:?oo00OW??ooooooonLLoooog`03ool01?oOoooogoNn0ooo00C_GOooomo_
O@Goo`05omooooooooog_P02ool01nmMoooogooomkkgW_oO00Goo`07kggoooookegg__ookgd00_oo
0_oO00GoonmmoooooooO00?oo`03omog__oo037oo`8006_oo`006_oo0P0000?ooooOool0VOoo0P00
0_oo00?ogoooool0:?oo0P00:Ooo00GgW_oo000@PP0P00800006ool00000247ogooo0`000ooo00L8
@@00003g__oo000080020003ool01@002448H@Q100000_oo00L0800000000?Nnool@PP02000010Q1
ool0000P0ooo00D00122000@P_NN00;og`05ool0000026400002ool00ooOooooo`0/ool2001[ool0
01[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`8002coo`8000?oo`0300008?oO00;o
o`8000;oo`03mih0000000?oo`<00006omooo`00ooog__oo0P0000Oogooog__ooooO02000002ool3
00001?oomih8@@000_Nn00Ooo`0000000?ookgd8@@02ool00`0002000002ool00`00mikoo`0^ool2
001[ool001[oo`800003oooogooo09Woo`8000;oo`03omoooooo02Soo`8002Soo`04omog__oomkh2
02000ooOmkkoo`0202001_oomikoo`0P247og`;oo`05000@P_oOomooo`020002ool02?Nnool00?oo
oml0000Pmih4ool04000023ooooomih@XP00oooog`00023ooooO2640000P1?oo00H00?oo00000?oo
mkh2ool00`0Pooog_P0]ool2001[ool001[oo`800003oooogooo02Coo`03mkkoonmm00?oo`04mkko
oooomih5ool2mkh6ool2oml4ool01?oOooog__Nn1Ooo00?gW_oooml00_oo00?g__oomkh01Ooo00?g
__ooool00ooo00Cogooooooog`Goo`;g_P?oo`;g_P03oooogooo00;oo`06mkkoooNNomooooNn1_oo
0_Nn6Ooo0P000_oo00?ogoooool0:?oo0P00;?oo0P000ooo00D08000ooooooNn00800009ooog__oo
02000?oooml000Q100Soo`8000;oo`03omoooooo00800003omoooooo008000;oo`8000;oo`040200
0?oomih3ool00nmm48800003ool00ooOoooog`0_ool2001[ool001[oo`800003oooogooo02;oo`03
omoooooo00;oo`06mkkogoooooog__NN0ooo00?g__oOool00_oo00SgW_ooooo_GONnomooonmm0ooo
00SogooooooogooomkkogoNn1Ooo00?g__NNool00_oo00CgW_oomkkW?0;oo`0CmkkooooooooW??oo
mkkogoookggogoooiccooooOooo_GOoomkh01Ooo0_NN0_oo00?gW_oomkh01Ooo00GgW_NnoooooooO
01Soo`8000;oo`03omoooooo02Soo`8002coo`800003ooogW_oo00800005mkkooooo26408003ool2
0002ool0100P003ooooo0_oO1?oo00<000QQoml00_oo00g_GOoo2448HOoomikogooo24400?oo2640
0002ool01@0048;ooooomkh00ooo0P0000Cg__ooooog_P;oo`03mikooooo02coo`8006_oo`006_oo
0P0000?ooooOool08ooo00CogoNnooo_G@;oo`0;omooooookggoooNnmih8H@0Pkggog`02ool01^Ll
ooooo`0P003og`?oo`03mikoonmm00Koo`03omooooNn00?oo`03omoooooO00;oo`06kegooooooooo
goNN0_oO0_oo00Kg__ooooogW_oomkh2ool00ooOooo_O@02ool01ONnomooooNnked00ooo00WogoNn
ooogW_Nnoooogoookgd00_oo00CogoNnoooogaSoo`8000;oo`03omoooooo02Soo`8002coo`8000?o
o`03000H`oNN00;oo`800007iacooooo24408?Nnool00`0000D08000000Q100000;oo`800003ooog
__oo00;oo`8000;oo`09mkkoomkkooogWP00247gW_oo00800003omoooooo00;og`04ool000002442
00000a2R0008H@02oml]ool2001[ool001[oo`800003oooogooo02Goo`03omooooNn00?oo`08mkko
oooOmkkoo`00023og`;oo`;og`08oooog`00003ooooOmkkog`Coo`05mikoooNnoooog`04ool00ooO
kegoo`02ool01_oOoooooooOmkkog`Coo`03mikoonmm00?oo`;g_P;oo`06mkkoooooomooooNN1?oo
00?ogoooool00_oo00?g__oomkh00_oo00CogooooooW?0;oo`03mkkooooo01Ooo`8000;oo`03omoo
oooo02Soo`8002coo`8000;oo`04oml@PP00oml2ool00`0048;og`02ool02@00247ooooooml08?oo
kggoo`0200006QS3mikoo`Q1003g__ookggooooO0008HOookggoo`00267gW_oo24400?oomkkoo`00
ool2mkh02ooo0008@Ooo003_GOoomih000QQ0000;ooo0P00Jooo000Jool200000oooomooo`0Qool0
1?oOooogW_oO0ooo00GogoooooooooNn00?oo`800007ooo_GOoOoooogooomkh00P001?oo00?_GOoo
kgd01?oo00O_OOoomkkgW_oOooog_P03ool00ooOooog_P05ool01?Nnooog__NN0_oo00O_GOoOoooo
oooOoooog`02ool01^mmooooooookegog`Coo`05omogW_ooooo_G@02ool01?oOmkkogoNn0_oo00?g
__ooool06?oo0P000_oo00?ogoooool0:?oo0P00;?oo0P000_oo00Kog`0000008?ooked20003ool2
0003ool01P00023gW_oo264000;oo`0;ic`000000200000Pkegog`QQ003_O@02ool20002ool00`00
247oo`03ool00`0Pooooo`0200001?Nnool000QQ0_oo0P0000?ooooOool0;Ooo0P00Jooo000Jool2
00000oooomooo`0Qool00oNnoooog`02ool02_oOmkkooooomkkogooomkkooooO0P001Ooo00K_OOoo
00000?NNool2mih02_oomkkoonmmoooogoNnoooogoNn0_oo00GgW_ooooo_OOoO00;oo`0:omoooooo
mikogoooomog__oomkh3ool01?NnoooooooO0_oo0_oO0_oo00G_OOooooooooNn00;oo`04omoooooo
mih7ool01_oOoooooooOooogWQSoo`8000;oo`03omoooooo02Soo`8002coo`800006oooogoooool0
8?oo0P0000D8HONNooooooNn00<00005023g__oOool8@@020002mkh01OoOooooo`00ool00P0000H@
PPQQ000001S30002ool300002PQ1ooo_GOoomkkoooNN000080000_oo00SogoNnmkh000QQ247g__oO
;ooo0P00Jooo000Jool200000oooomooo`0Qool01OoO4:8@PP00oml00_oo00?og`0002000`0000Cg
__oo000080@0000=kggooooo2640012200008000oooogoNNool00`0000?ooooO24400P0000GoooNN
kgdH``Q100800005ooogW_oomih8@@0300001Nmm02000?oOool00`0000Soo`0002000?oOoooog`QQ
0`0000P@P^mmoooooooO0008@@000_oo00T0000P023_GOookegooooOmkh06Ooo0P000_oo00?ogooo
ool0:?oo0P00;?oo0P000_oo00?gW_ooool00ooo00?g__oomih00ooo00<00?oooml00ooo00[W??oo
oooooooOoooogoNnoooog`;oo`08mkkgWPQ1003oooNNooogWPKoo`05kggooooooooog`03ool2mkh3
ool00nLLooooo`0`ool2001[ool001[oo`800003oooogooo02;oo`06mkh00?oomkkoooNn0_oo0P00
00@8HONnoooog`80000<omoooooo0008HNmmool0000Pooog__oo0P000_oo00CgW_oo244000;oo`03
mkh0000000;oo`032440000000;oo`04003oonmm264200001?oooml@PP000_oo0P000_oo00Kogooo
00000?oooml20003ool00`00267g_P02ool02P00023ooooooml8@@00omoooooO0_oo00?ogooomkh0
6?oo0P000_oo00?ogoooool0:?oo0P00;?oo0P000_oo00?ogoooool00_oo00?ogoooool01?oo00<0
0?oooml00_oO0_oo00?gW_oomkh01_oo00C_OOooooooo`800003omoooooo00;oo`09mkkooooOmkko
oooOooog__NN00;oo`06mikooooOoooognmm0_oo00?g__ooool0;ooo0P00Jooo000Jool200000ooo
omooo`0Sool00`00omooo`04ool20000100Poooooooo0P000_oo00GgW_oo00000?oo00800006oooo
goooool0000P0_oo00[g_PQ1003gW_oomkh0000Pool8@@80000CooogW_oomkh00?oomkh@PP00ooog
_P004:;ogooo02000?oooml00_oo0P0000Sog`000008@OoOmkkogooo0P000_oo0P0000GooooOmih@
PP00023oo`8000;oo`03omoooooo02Soo`8002Soo`06kggoooNnoml080000_oO00OooooOoooooooO
ooog_P0Iool01P00023oooNn247ogdKoo`8006_oo`006_oo0P0000?ooooOool08_oo00cogooo023o
goookggooooO24400?ooic`2ool00`Q1003oo`02ool01oNN2448@Nmm24408>Ll00;oo`0;oml00000
mkkooooO0008@Ooomikoo`0200001Ooo00008?oOool00_oO0_oo00Kg__oo00000?Nnool200001Ooo
mkh0000Pmkh00_oo00C_O@0P003oo`800007mkkogoooooo_O@Q100000_oo00<000Q1mih00_oo00<0
000Pool07ooo0P000_oo00?ogoooool0:?oo0P009ooo00G_OOooia`8H@Q10080000824408>mMooo_
GOooomog_Q_oo`80000424400?oomki5ool2001[ool001[oo`800003oooogooo02;oo`03mikoo`00
008000036<<00000008000;oo`08mikoo`00267g__oomikoo`800003ool000QQ00?oo`03mkh000Q1
00?oo`800003ooo_OOoo00800008ool0000Pooog__ooomogWP;oo`0=iacoo`Q1023g_PQ1267ogooo
00008?oooml00_oo0P0000Koo`00023ogooomih2ool010QQ003ooooo0P0000?oonmmool00P008?oo
0P000_oo00?ogoooool0:?oo0P00:?oo00Cg__oomikoo`;og`04mkkooooooml2ool00ooOooogWP0H
ool01oNnooooooooomooonmM04Koo`8006_oo`006_oo0P0000?ooooOool08ooo00KgWP00003ogooo
ked200001OookggooooOool00P0000OooooOooooo`0048;oo`0200002oookggogooo0008@Oooomoo
o`0002000_oo00Cg_PQ1003og`8000Goo`;_O@;oo`03kggooooo0080000;ooo_G@00003oooNnooog
_PQ148;W?00200003?oomikooooooml0012Rkggg_P0P247g_P;oo`0302000?oo01ooo`8000;oo`03
omoooooo02Soo`8002Soo`04kggooooomih3ool00oNnomog_P02ool00oNnooooo`0Iool01ONNmkko
ooooked0Aooo0P00Jooo000Jool200000oooomooo`0Qool02?NNoooooooo48;oomkkool20004ool0
1_Nn0208@Oookegoo`<00004ked8H@00ic`2ool00`004:800002ool01_Nn0008HONNomooo`8000;o
o`05003NnooomkkgWP020002ool01P00023ognmm244000;oo`0648800?ooooogW_oo0P0000?oo`Q1
00000ooo00Cog`00488000;oo`808003omooooNn0080023oo`8000;oo`03omoooooo02Soo`8002So
o`03mkkogooo00;oo`03mikooooO00;oo`04iccooooomkhLool01ONNoooogooomih0AOoo0P00Jooo
000Jool200000oooomooo`0Rool01_Nnooooo`00mkkoo`800006mkkooooOmkkoooNn0`000_oo0PQ1
0_oo0`000_oo0P000_oo00Kogooo02000?oooml200001@Q1omogW^mm4:800_oo00L8H@00ooog_^mm
00008002ool011S3003ogooO0P000_Nn00C_G@QQ000000;oo`0:00008?oOmkkoo`Q1003_GOoomih2
00000`Q1ooooo`02000Pool20002ool00ooOooooo`0Xool2000Wool01ONnooooooNnmih01?oo00O_
OOoooooogoNnoooog`0Hool00ooOoooog`03ool00ooOooooo`14ool2001[ool001[oo`800003oooo
gooo02;oo`08omooooNNool00?NN0008H@Coo`05mkkooooo247oo`030002ool02?Nnool08?oo2440
000Pool2mkh03_oooml00122oooogooo26400?oOooog__oO000224400oNNomooo`02ool010002440
80000ooo0P0000H8H@0Pooo_O@Q10002oml01?oooml000Q10P000_oo00GgW_ooool00>mM00800003
023g__oo01ooo`8000;oo`03omoooooo02Soo`8002Ooo`03mkkooooo00;oo`03omogW_oo00?oo`05
mikg__oooooog`0Iool01ONnoooognmMool00_oOAOoo0P00Jooo000Jool200000oooomooo`0Sool0
3oNnooooo`0P00008000ooog__NNooog__oOooog_P03ool00oNnooooo`02ool01ONNooog__oomkh0
0ooo00C_OOoo020000;oo`05omogW_ooooog_P02ool01ooOoooogoooomooooNn00;oo`03omog__oo
00Coo`03003ogoNn00Coo`08kggooooOooog__oOooog_PCoo`;og`;oo`03kggooooo023oo`8000;o
o`03omoooooo02Soo`8002Woo`03mkkooooo00Soo`;g_Q[oo`05omoooooooooog`17ool2001[ool0
01[oo`0600008?oomkkoooNN8_oo0_oO00Coo`00244001_oo`04000@X_oOkgd3ool01OoOooog__oo
mih02_oo00Kogooomkkogooo0003ool01_NnoooogooOoooogc3oo`8000;oo`03omoooooo02Soo`80
0004ooogW_oomkh2ool00ooOooooo`2>ool00oNnooo_G@02ool00`0P003oo`1Zool001Soo`;og`80
0003oooogooo02;oo`05kggoooookegoo`02000Kool20002ool20002ool01?NNooooooNn2Ooo00?g
__ooool00ooo00Wogooomkkoo`00023g__oomih0<Ooo0P000_oo00?ogoooool0:?oo0P0000?gW_oo
ool00_oo00?_OOooool0T_oo00GogoNn24400?NN06[oo`006_oo00D8H@00ooooooNN027oo`03omoo
oooO00?oo`03247ooooo01Ooo`09mkkoo`0026400>mMool000QQ00;oo`03omooooNn00goo`05omoo
ooNNooog_P02ool01P00023ooooomkkgWS3oo`8000;oo`03omoooooo02Soo`8000032440000009P0
00030200012206_oo`006?oo00?_OOooool00_oo00?gW_ooool08Ooo00OogooomkkgW_Nnoooog`0I
ool00ooOooo_G@04ool01ONNoooogooooml03?oo0_oO00Cg__oooooNn`?oo`04mkkogooomkhbool2
0002ool00ooOooooo`0Xool4000010Q10000000PTP0000<0800002000`0000?gW_ooool0J?oo000K
ool01OoOoooogooooml08?oo00?ogoooool07Ooo00[ogooomkkooooOooogW_oOoooog`Coo`03kggo
oooo00Ooo`05mikoooNnoooog`04ool01nmmoooooooOooog__NN033oo`8000;oo`03omoooooo02So
o`040008@ONNool4omnBool01?Nnooog__Nn0P0PJooo000Iool01>mMoooooooO9_oo00Cg__oOooo_
GA_oo`03omooonmm00?oo`03kggooooo017oo`05mkkgW_oomikog`04ool00ooOooooo`0`ool20002
ool00ooOooooo`0Xool200000oooomog_P03ool00ooOooooo`2@ool00ooOooooo`02001[ool001So
o`07omooooooomoooooOic`08Ooo00?g__ooool00_oo0_Nn6ooo00Gogooooooognmm00Goo`03omog
W_oo00[oo`03mkkooooO00;oo`05mikoooooooog_P04ool00oNnooooo`0^ool20002ool00ooOoooo
o`0Xool02@00023oooNnoooogoNnooog_P2@ool00ooOooogWP02ool00`Q1023og`1Zool001[oo`03
mkkogooo02Goo`03omoooooo01ooo`08mkkoooooomoooooOoooog`;oo`03omoooooo00Soo`;og`04
oooogooomkh7ool00oNnooooo`0_ool20002ool00ooOooooo`0Xool20002ool01?NnoooooooOT_oo
00Kg__ooooooo`00245[ool00;Soo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`00^?oo0P00
0_oo00?ogoooool0:?oo0P00W?oo0P00Jooo002hool20002ool00ooOooooo`0Xool2002Lool2001[
ool00;Soo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo
0P00W?oo0P00Jooo002hool20002ool00ooOooooo`0Xool2002Lool2001[ool00;Soo`8000;oo`03
omoooooo02Soo`8009coo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo002h
ool20002ool00ooOooooo`0Xool2000Wool00oNnooooo`03ool01?NNoooooooO0_oo00G_OOoooooo
ooNn00;oo`04omoooooOoml4ool00ooOoooog`02ool00oNNooooo`03ool01ONnoooooooooml00_oo
00?ogooooml01?oo00?g__oOool01Ooo00KogoooooooooNnool2oml2ool01ONnooogW_oooml00_oo
00?ogoooool09Ooo0P00Jooo002hool20002ool00ooOooooo`0Xool2000Xool2oml00oooomog_P02
ool00oNnoooog`04ool01^mMooogW_ooomo_G@;oo`03mkkoooNn00?oo`06omooooNnoooognmm0_oo
00GogoooooooooNn00;oo`07mkkogoooooog__oomkh01?oo00?ogoookgd00ooo00?g__oooml02Ooo
00?g__oOool00_oo00?_GOooool09?oo0P00Jooo002hool20002ool00ooOooooo`0Xool2000Xool0
2oNNooooooNNooogW_Nnoooogooomkh00_oo00GgW_oomikoooNn00;oo`03mkkooooo00;oo`;gWP03
omooooNN00Soo`04kggg__oOoml3ool01_NNooooooooomog_P;oo`03omoooooo00?oo`03kegoooNn
00;oo`04mkkooooOmkh2ool01?Nnmikooooo0_oO:?oo0P00Jooo002hool20002ool00ooOooooo`0X
ool2000Wool01_oOooooonmmooog_PCoo`03kggooooO00;oo`04mkkoooooool2mkh3ool00ooOoooo
o`02ool00oNNooooo`02ool01?Nnooooonmm1Ooo00?g_^mmoml00ooo00G_OOooomooooNN00;og`;o
o`05mkkooooooooog`02ool2oml01?oomkkoooNN0_oo00CogoNnoooogbSoo`8006_oo`00^?oo0P00
0_oo00?ogoooool0:?oo0P00:_oo00Cogoooooo_O@;oo`03omoooooo00;og`05kggoooooooo_G@02
ool01?NNoooooooo0_Nn00CooooOmkkog`Coo`04mikogooomkh2ool01oNNmkkoooooomoooooO00Co
o`03omoooooo00?oo`03mkkognmM00;oo`04omogW_oooml2ool00oNnoooog`02ool00ooOooooo`02
ool00oNnooooo`0Sool2001[ool00;Soo`8000;oo`03omoooooo02Soo`8002Soo`05kggoooooooog
_P03ool2oml00oooomooo`02ool00ooOooooo`02ool01?oOooooooNn0_oo00?_OOoooml00_oo0_oO
0_oo00GgW_ooooooonmm00;oo`06mikoooNnkegoooNN0ooo00?_OOooic`00_oo00?ogoooool02?oo
00[gW_ooooog__NNoooogoNNooogWROoo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo0P00:_oo
00?gW_oo4:800`0000?ooooO00000_oo00?_O@0000000`000_oo0P0000<8H@00ool00P0000cogoNn
0008@@00oooog`QQ00008>mmool300001?oo264000QQ0P0P0P0000X@PP004:;_OOoo000@XP00ooog
_P800004023_OOoo020200002Ooo2648H@00ool8@@002640000Vool2001[ool00;Soo`8000;oo`03
omoooooo02Soo`8002Ooo`03omoooooo00;oo`03kgd08?oo00?oo`030008@Ooo00?oo`0726408?oO
ool0000P00000_oo00H8H@00omooo`0P0004ool00`0048;W7002ool200001oooomog_PQQ003ooooO
00;oo`03oml8@@0000;oo`07oml000Q1mkkoo`0024400_oo00?og`Q100000_oo0P000_oo00D000Q1
003oooNn02Goo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo0P009ooo00?g__oOool00ooo00@0
0?ooooog_P808005003g__Nnomooo`0200001Oooomoog`0P00000_oo00L000Q1mkkoo`Q1003og`03
ool00`0P003oo`02ool200003?oOooooo`0P003ooooOooog__oOool000;oo`05mih000Q1mikoo`02
0003ool20002ool20002ool2000Xool2001[ool00;Soo`8000;oo`03omoooooo02Soo`8002[oo`04
mkkooooo4:82ool01Nmm0000000002000_oo00?og`QQ00000ooo00X8@@00ooogWP0P247ogooo0008
@@;oo`09mkkoo`0048;oonmMoml0800000;oo`04mkh0000Pmkh5ool01_oOooogW_oo244000;oo`80
00;og`08ool8@@Q1omogWP0P247oo`800004ooo_OOookgdUool2001[ool00;Soo`8000;oo`03omoo
oooo02Soo`8002Soo`09mkkoooooooo_O@0Pkgg_GOoo00800003ool00>mm00;oo`0402000?oomkh2
ool00`0P267oo`0200002?oooml8@@00ooo_OOoooml200001ONnooog_QS300000ooo0P000ooo00Oo
gooomikoooNnoooog`0200002Ooomih000Q1oooW7?oo02000002ool3000010Q1ooog__Nn9ooo0P00
Jooo002hool20002ool00ooOooooo`0Xool2000Xool01_Nnoooooooooml080;oo`0600008?oomih8
H@000_oo00<000QQool00_oo00Sg__NNkegoo`0P003oooNn0P000ooo00_og`Q1247_GOoOool001S3
mikooooO00800004oooogooOmkh2ool02=kkooooonmm00008?oOool200000ooOooog_P0200001_oo
mih0000Poml080?oo`03mikg__oo02Coo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo0P00:_oo
00K_OOooool00?oOool20003ool01@00omogWQ2200000ooo00X080QQooooo`00023gW_oo000080;o
o`04mkkoo`000002ool03OoO00008?oomkkooa2R003gW_oomkkooooO00?oo`08omooo`0P003oonLl
488000;oo`05oml8@@00mikoo`0200001Ooomkh00?oomkh09ooo0P00Jooo002hool20002ool00ooO
ooooo`0Xool2000Wool2oml4ool03@00ool001S3003g__NNool08000ool8@@0000?oo`0402000>mM
ool200001?oomih8@@001?oo0`0000Cogooo020000;oo`03kgd0000000Coo`05mkkgW_oomikoo`02
0000100Pomooo`0P0P0000Cg__oo000000;oo`0300008>mM00;oo`04003ogooomihUool2001[ool0
0;Soo`8000;oo`03omoooooo02Soo`8002Soo`07omogW_oooooogaS3mih00P0000Oogoooooooonmm
267oo`0200003?oomikooooo0208H@Q1003g_^mmool080800003267g__oo00800006ool00000023o
oooO0_oo00H8@@00ooog__oooml2ool01_NNoooogooo000080;oo`0=mkh08?oo0200000Pooo_GOoo
24400?oomkh010009_oo0P00Jooo002hool20002ool00ooOooooo`0Xool2000Wool02ooOooogW_oo
omooo`0026408000ool00_oO0_oo00D00?oo0008@OoO00;oo`04mkkooooooml4ool01_NN023ooooO
mkkoo`800005oooogooooooog`02ool01?oO02000?oo0_oO00CooooOooog_P;oo`04mkkogooomih4
ool00ooOooooo`02ool00nmm00000002ool01?oOooooonmm9_oo0P00Jooo002hool20002ool00ooO
ooooo`0Xool2000Wool00ooOmikoo`02ool01?oO000000000ooo00?ogoooool00P0000<08000ool0
0_oo013_OOoomkkoooNNoooogooomih8HONNooog__oo020000;oo`03omogW_oo00;oo`05oml00000
ooog_P04ool00oNnoooog`03ool2oml3ool01_oOmkkooooomkkoo`800006ooog__ooooog__oO9_oo
0P00Jooo002hool20002ool00ooOooooo`0Xool2000Wool00ooOoooW?003ool30002ool00oNnooog
WP02ool200000aSSmkkgWP02ool01?oOooooonmm0_oo00?ogooomih00_oo00Cogooo000000?og`03
oooW??oo00;oo`800003ooogW_oO00;oo`04mikoooNnool20003ool00oNnooooo`02ool01?Nnmiko
oooo0PQQ0_oo00?gW_Nnool09ooo0P00Jooo002hool20002ool00ooOooooo`0Xool2000Zool00oNn
0200800200000ooomkkoo`04ool00nmM0000000200001Oookggooooooml01Ooo00CgW_ooooogWP;o
o`030008HOoo00Coo`03mkh0800P00<0000;267ooooomikoonmMooo_O@Q1003og`02ool00oNnooog
_P05ool01=kK00000=kK1Ooo00?g__ooool08ooo0P00Jooo002hool20002ool00ooOooooo`0Xool2
000Wool00oNNoooog`03ool01?oOooooooNN0_oo00?ogooooml01Ooo00G_GOoooooooooO00;oo`05
kegogooomkkog`02ool00oNNooooo`02ool01>mmmikooooO0ooo00Cogoooooo_O@?oo`03mkkoonmM
00Woo`04omoooooooml2ool2oml2ool01?oOoooooooO9_oo0P00Jooo002hool20002ool00ooOoooo
o`0Xool2000Xool01>mmoooogooO0ooo00CgW_ooooo_G@;oo`03iccoooNN00;oo`04mkkooooomkh6
ool02?oOoooooooOoooogooooml4ool01>mmoooogooO1_oo00Sg__oOoooogooomkkgW_oo0_oO00Kg
__ooooooooNNoml2ool2oml2mkh2oml2ool00ooOmikoo`0Uool2001[ool00;Soo`8000;oo`03omoo
oooo02Soo`8002Ooo`03omog__oo00?oo`04mikooooooml2ool01?NnomoooooO1?oo00?_OOoOool0
0_oo0_oO0_oo00?gW_oomih00ooo00Oogoooooo_GOooomog_P04ool01ONNooog__oooml00ooo00?g
__oOool00_oO1?oo0_oO0ooo00?ogoNNoml00_oo00?ogoNNoml00ooo00?ogoooool08ooo0P00Jooo
002hool20002ool00ooOooooo`0Xool2000Yool01ONNomoooooomih00ooo00?gW_ooool01?oo00Cg
__ooooog_P;oo`06omooooooomog__oO1?oo00CW??oOoooog`;oo`05omoooooomikog`02ool02?NN
oooogooomkkogooomih2ool01ONnoooooooooml01Ooo0_oO0ooo0_Nn0ooo0_oO9ooo0P00Jooo002h
ool20002ool00ooOooooo`0Xool2000Wool01?oOoooogooo0_oO1_oo00?ognmmool00ooo00Cg__oo
ooooo`;og`04mkkooooooml2ool00oNNooooo`03ool02?oOmkkoooooomoooooOool2oml3ool01NmM
ooog__oomkh00ooo00?g__ooool01?oo00?ogoooool00_oo00?ogoooool00_oo00?ogoooool00_oo
00?ogoooool08ooo0P00Jooo002hool20002ool00ooOooooo`0Xool2002Lool2001[ool00;Soo`80
00;oo`03omoooooo02Soo`8009coo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo0P00W?oo0P00
Jooo002hool20002ool00ooOooooo`0Xool2002Lool2001[ool00;Soo`8000;oo`03omoooooo02So
o`8009coo`8006_oo`00^?oo0P000_oo00?ogoooool0:?oo0P00W?oo0P00Jooo002hool20002ool0
0ooOooooo`0Xool2002Lool2001[ool00;Soo`8000;oo`03omoooooo02Soo`8009coo`8006_oo`00
^?oo0P000_oo00?ogoooool08_oo00ogW_ooooog__oOool000QQmikooooOooo_OOoomkh0UOoo0P00
00CooooOooog_P;oo`05omooooooooogWP02ool01?oOoooooooO0_oo00?gW_oomkh01?oo00GgW_oo
mkkooooO01coo`05omooooNnooogWP0[ool00;Soo`8000;oo`03omoooooo02;oo`03mikogooO00;o
o`04ked@XP006<<2000010Q10000000PT@0000D8@@00000000Q100P00004mkkooooooml4ool010Q1
0000000P0P0000<8@@0000000_oo00Cg__ooooogWP;oo`T000Soo`T000;oo`04mikooooomkh[ool0
0;Soo`8000;oo`03omoooooo027oo`09omoooooomkkoooNnoooW?0Q1008000030200000P09<00003
2440000000808003000@PP00008000808003003ooooO00?oo`?og`0:000080000008@@0024408000
mkh2ool00oNnoooog`02ool00`QQ000000060008ool800001PQQoooooooOooog_Rcoo`00^?oo0P00
0_oo00?ogoooool0:_oo00Cg__ooooo_OIOoo`04oml08000oml4ool01_oOkegooooomkkog`Coo`09
mikooooOoooogooomikooooO00Coo`05omoooooOooogWP0Hool01ONNoooogooooml0;Ooo002hool2
0002ool00ooOooooo`0Rool00oNnomooo`02ool2mih2ool2oml00oooomoog`2Bool02?NNoooooooo
00008?oomkh5ool00nmMooooo`03ool01?NniccooooO0_oo00?_OOooool00_oo00?g__ookgd01?oo
00?ogoooool06?oo00?ogoooool00_oo00?_OOooool0:Ooo002hool20002ool00ooOooooo`0Rool0
1OoOooooonmmoml00_oo00?gW_oomih00_oo0_oOUOoo00Cg_P0P003_O@Coo`05omog__oooooog`07
ool00oNnoooog`04oml8ool00nmmooooo`0Fool00nmmooooo`0_ool00;Soo`8000;oo`03omoooooo
02Soo`07kggooooooooogoNnoml0T_oo00?ogooomkh00_oo0P000_oo00Sg__oooooooooOooog__oO
0_oo0_oO00GoonmmoooooooO00;oo`04omoooooomkh2ool00oNNomooo`0Oool00ooOmikoo`0[ool0
0;Soo`8000;oo`03omoooooo02Koo`05mkkoooooooog_P05ool00oNnooooo`2?ool01_oOoooooooo
000080Ooo`05mkkooooOoooog`02ool00ooOooooo`02ool00ooOmkkoo`04ool01_oOoooooooOoooo
ga[oo`03omoooooO00;oo`03omoooooo02Woo`00^?oo0P000_oo00?ogoooool0a_oo0P00Jooo002h
ool20002ool00ooOooooo`36ool2001[ool00;Soo`8000;oo`03omoooooo0<Koo`8006_oo`00^?oo
0P000_oo00?ogoooool0a_oo0P00Jooo002hool20002ool00ooOooooo`36ool2001[ool00;Soo`80
00;oo`03omoooooo0<Koo`8006_oo`00^?oo0P000_oo00?ogoooool0a_oo0P00Jooo002hool20002
ool00ooOooooo`36ool2001[ool00;Soo`8000;oo`03omoooooo0<Koo`8006_oo`00^?oo0P000_oo
00?ogoooool0a_oo0P00Jooo002hool20002ool00ooOooooo`36ool2001[ool00;Soo`8000;oo`03
omoooooo0<Koo`8006_oo`00^?oo0P000_oo00?ogoooool0a_oo0P00Jooo002hool20002ool00ooO
ooooo`36ool2001[ool00;Soo`8000;oo`03omoooooo0<Koo`8006_oo`00^?oo0P000_oo00?ogooo
ool0a_oo0P00Jooo002hool20002ool00ooOooooo`19ool00oNnooog_P03ool00oNnooogWP08ool0
0oNnooooo`02oml2ool02_oOooog__oOooogW_ooomooooNn0_oo00G_OOoooooooooO00Coo`07miko
ooNNoooogooomkh00_oo00?ogoooool00_oo00?ogooooml00ooo00Kogooooooogooooml3ool01_oO
ooooooNnooog_PCoo`03mkkogooo00;og`[oo`03omoooooo01Ooo`8006_oo`00^?oo0P000_oo00?o
goooool0B_oo00CW7?ooooogWPCoo`06iacooooomkkooooO1?oo00O_OOooooooooNnoooog`02ool0
1oNnomooooookegoooNn00;oo`05mkkoooNNooo_G@02ool00ooOooooo`02ool01?oOooooonLl0_oo
00CgW_oOooo_O@?oo`05mikognmmoooW?003ool01nmmoooooooomikoonmM00Goo`04omo_OOoooml4
ool01>mmooooooNN0ooo00?ogoooool00ooo00?ogoooool04ooo0P00Jooo002hool20002ool00ooO
ooooo`19ool01?NNoooogoNN1?oo00?W??oomkh00ooo00Sg__ooooooooNNooogW_oO0ooo00?gW_oo
ool00_oo00Og__oooooooooOoooog`03ool00oNNoooog`02ool01ONnooog__oooml00ooo00WgW_oo
ooooooNnooog__oomih01Ooo00?_OOooool00_oo00OognmMooog__oomikoo`02mkh2ool01?Nnoooo
gnmm0_oo00CgW_oomikg_P;oo`03omog__oo00;oo`03omogW_oo01Koo`8006_oo`00^?oo0P000_oo
00?ogoooool0BOoo00X0800000000?oooml00?oOooo_O@88@@<00003ool0000P00800003ool08000
00?oo`<0000<ool00000003_GOoo0200000Pomooo`0P0P0000L08?oOooog__oo0000800200002Ooo
000000Q1003oo`0024400002ool01@0024400000ool00P0000cogoNN0208H@00mkh8@@00247oooNn
ool300000a2Roooog`02ool02Q2200008000ool000QQkggoonmM0ooo00?g__ooool04ooo0P00Jooo
002hool20002ool00ooOooooo`1:ool04@00oooooooOkgd8@@0PoooW??oooml8H@00ool000Q10000
0_oo0P000ooo00D08000ooooooNn008000?oo`040008@OoOoml30002ool01000omoooooO0P000_oo
00g_OA22003g__oooml0012Roooog`0002000002ool200001ONNool8H@00ic`00ooo0P000_oo0`00
00GogoNN003ooooO00<000;oo`0500008?oomkk_O@02ool00nmmooog_P0Eool2001[ool00;Soo`80
00;oo`03omoooooo04[oo`05003W??oomih8H@020002ool01_Nnool00000oooog`8000;og`070008
@Oooomo_O@0024400_oO00Koo`0P003gW_oOool20002ool200001Oooomo_OOoo4:800_oo00L080QQ
mikgW_oo0008@@03ool200001oooomog_P004:;g__oo008000;oo`0<0008HOoomkkooooO0008@ONN
0008H@001?oo00<00?ooool00P0000GoooNn6<<00?oO00;oo`03mkkoooNn01Ooo`8006_oo`00^?oo
0P000_oo00?ogoooool0B_oo00@00?oooooog`80000726400?oomikog`QQ00000_oo00@000QQmiko
o`800003oooogooo00800005oooogooO0008@@02ool01>mm0208HOoO0P000_oo00Cogooomik_O@;o
o`8000?oo`800006omooonLL6<<00?oO0_oo0P0000Cogooo000000;oo`800004oooogoooool20000
1ooo0008@OoomkkoonmM00;oo`06mkkoo`00267oooNn0P0000?g__oOmih00ooo00?g__ooool05?oo
0P00Jooo002hool20002ool00ooOooooo`1:ool02`00oooooooO26400?oO247ogooooml00P000ooo
0P00013oo`00247ogooomih000Q1kegooooO02000?oOmkkoo`800004ool00000mkh7ool00`Q1003o
o`02oml00`0P003oo`02ool200001ooomkkooooO0008@ONn00808004mikoo`000202ool02_Nnool0
8000ool08000omoooooO0_oo00Og__oomikoo`00023oo`0200001Oooomooooookgd06?oo0P00Jooo
002hool00`0P003oo`03ool2omm0ool01?NnoooooooO0_oo00CgW_oooml000;oo`8000;oo`8000;o
o`8000;oo`04mkkoooNnool200002ooOooooo`00267oonmmool08000oml00_oo00T8@@00ool000QQ
0000800002000P000_oo0P000_oo00?og`0P00000_oO00?oo`0000000_oo00?_OOoooml00_oo00l0
00QQooogWP0P247g__ooomooo`00023og`Q100000_oo00GogooooooooooO00Coo`03oml0000P01_o
o`04mkkoo`00001[ool00;Soo`03000@P_NN00;oo`03omoooooo04;oo`03omog__oO00Coo`06003o
ooNn0008HONN0_oo00D00?ookgdH``0000;oo`0624400?oomkh081220ooo0P000_oo00Kg_P00003o
ooNnoml200001ooOool00?ooomooo`QQ008000;oo`8000;oo`03oml8H@0000?oo`0748800?NNmkko
o`004:800_oO00@08000ooooo`800004mkkogoooool20002ool00`00ooogWP02ool01000023oooNn
0P000_oo00<@PP00ool06?oo00K_OOooooogWP00021[ool00;Woo`04kggooooooml2ool00oNnoooo
o`0oool2oml2ool02ONNooogW^Ll6<?g_P0048800002ool03?NN02000>mm2448HNmmool00122miko
o`8000?oo`0302000?oO00;oo`050008H@0Pkggoo`0202003_oooml00000oooog`00023ogoNnool8
@@002442ool30002ool20002ool00ooO00000002ool20002ool20003ool200001A22kggogooo0000
0_oo00D08000omogW_oo00800004oooog`00020Kool01>mmoooooooOJooo002iool2oml4ool00oNN
ooooo`13ool02ooOoooooooo003g_P00267g__oomih00_oo00@00?oo000000;oo`05mkh000000208
H@02ool01?oOool000Q10P0000Coo`00003g_P<000?oo`06omooo`000008@ONn0_oo00O_GNmm6>?o
g`0002000002ool200005@Q1oooogooOoooog`Q10200000PoooogoNN244@PP00023_GOoo26400002
ool00oNnoml000020004ool00oNN00000002000Jool01_oOoooooooomikogf_oo`00_?oo00?gW_oO
oml0@Ooo00kogoooooo_GOoOooog__oOool000Q102000?Nn1?oo00P00?oO00000?oomikoooNn0_oo
00?g__oOool00ooo00H8HOoOoooog`002445ool00nmmomooo`02ool01ONnooo_OOooked00_oo00Oo
goNNooooonmmooogWP03ool00nmMooo_O@02ool2mkh2ool01_Nnoooooooo003gWP;oo`05mkkoooNn
oooW7005ool01Nmmooo_OOoomkh07Ooo00Cogoooomoogfkoo`00^Ooo00?ogooooml00_oo00?gW_oO
ool0?ooo00?ogoooool00ooo00KgW_ooool0000P0002ool01^mmooooooNn0208@@800003kggooooo
00;oo`03mikoooNN00;oo`;g_P0;003ooooOool@PP00mikoooNnmikog`02ool01OoOmikoooooked0
0ooo00?_OOoomkh01_oo00?ogooomkh01?oo00?ogoooool00_oo00KognmMooog_PQQmih5ool00ooO
ooo_O@07ool01nLlooog__ooomoooooO01goo`03omogW_oo06[oo`00^ooo00Cogoooomoogd?oo`07
kggoooooomooooNNool00P0000@08?NnooogWPCoo`800004247ooooOool2oml4ool01OoOoooooooo
oml00_Nn00@000QQooo_G@;oo`0:omoooooooooogoooomooooNnoml2ool01>mmooog__oo0_Nn00go
oooOoooooooOmkkogoNnooogW_oomikg_P05ool02ooOooooonLl02000?oOooog__ookgd00_oo00?g
W_ooool01?oo00?_OOoooml06Ooo00CogoooooogWVkoo`00^_oo0_oO00CooooOoooogd3oo`08mkko
ooNNoooogooomih8H@800003247ooooO00Koo`@00003ooog__oo00?oo`06mkkoooooomoooooO0ooo
0P001Ooo00Gg__ooooooonmm00Coo`04mkkooooomih3ool01OoOoooooooomkh01?oo00Gogoooomoo
ooNn00;oo`03mkkooooo00Coo`0324400?oo00;og`;oo`03mkkogooo00?oo`03omoooooo00;oo`03
mkkooooo01Soo`07omooooooooog__oooml0J_oo0000\
\>"],
  ImageRangeCache->{{{0, 497}, {270, 0}} -> {0, 1, 1, 1}}]], "NumberedFigure",\

  TextAlignment->Center,
  TextJustification->0,
  CellTags->"MathLibIdea"]
}, Closed]],

Cell[CellGroupData[{

Cell["General remarks on timing", "Subsubsection"],

Cell[TextData[{
  "For the measure of computational speed two different timing mechanism were \
employed during our investigation. The ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " internal ",
  StyleBox["Timing",
    FontSlant->"Italic"],
  " command measures the time required ",
  StyleBox["by the ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" kernel",
    FontWeight->"Bold"],
  " to evaluate an expression. Since the ATLAS interface is an external \
program, we need a method take into account the time passed in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["and",
    FontWeight->"Bold"],
  " the external program. A solution is to measure the total ",
  StyleBox["SessionTime",
    FontSlant->"Italic"],
  " time passed and averaging over it, since ",
  StyleBox["SessionTime",
    FontSlant->"Italic"],
  " unfortunately is rounded to full seconds.\nThe second reason for using an \
averaged session timing is the fact that interfacing an external program and \
measuring computational times can wary greatly. This observation is in \
accordance with [",
  ButtonBox["6",
    ButtonData:>"MathlinkTransferTime",
    ButtonStyle->"Hyperlink"],
  "]. Averaging over the measured time is an accurate enough remedy.\nA third \
reason is the curiosity that the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["Timing",
    FontSlant->"Italic"],
  " command returns non trustworthy results on long computations."
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Performance comparison between ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and MathLib"
}], "Subsection",
  CellTags->"Performance comparison between Mathematica and MathLib"],

Cell[CellGroupData[{

Cell[TextData[{
  "The overhead of ",
  StyleBox["MathLink",
    FontSlant->"Italic"]
}], "Subsubsection"],

Cell[TextData[{
  "If we whish to export a large problem to an external program, we should \
know the computational cost for doing so. To measure we have written a small \
C program that receives a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " matrix and sends the same matrix back to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". No modifications are done to the matrix in the external program.\n\
Considering a square matrix of size ",
  Cell[BoxData[
      \(TraditionalForm\`N\ x\ N\)]],
  ". We have ",
  Cell[BoxData[
      \(TraditionalForm\`N\^2\)]],
  "matrix elements to be transferred to the external program and back again. \
Some testing revealed a symmetric transfer rate. The time needed to send ",
  Cell[BoxData[
      \(TraditionalForm\`N\^2\)]],
  " and to receive ",
  Cell[BoxData[
      \(TraditionalForm\`N\^2\)]],
  " elements is the same. The exporting overhead is ",
  Cell[BoxData[
      \(TraditionalForm\`2  N\^2\)]],
  ". When we speak about transfer time we talk about the time needed to send \
",
  StyleBox["and",
    FontWeight->"Bold"],
  " receive an object. The question is how long does it take to transfer a ",
  Cell[BoxData[
      \(TraditionalForm\`N\ x\ N\)]],
  " matrix compared to for example an LU decomposition."
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0166532 0.0363866 [
[.30952 .00415 -9 -9 ]
[.30952 .00415 9 0 ]
[.5 .00415 -12 -9 ]
[.5 .00415 12 0 ]
[.69048 .00415 -12 -9 ]
[.69048 .00415 12 0 ]
[.88095 .00415 -12 -9 ]
[.88095 .00415 12 0 ]
[1.025 .01665 0 -4.90625 ]
[1.025 .01665 10 4.90625 ]
[.10655 .10762 -18 -4.5 ]
[.10655 .10762 0 4.5 ]
[.10655 .19859 -6 -4.5 ]
[.10655 .19859 0 4.5 ]
[.10655 .28955 -18 -4.5 ]
[.10655 .28955 0 4.5 ]
[.10655 .38052 -12 -4.5 ]
[.10655 .38052 0 4.5 ]
[.10655 .47149 -24 -4.5 ]
[.10655 .47149 0 4.5 ]
[.10655 .56245 -12 -4.5 ]
[.10655 .56245 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01665 m
.30952 .0229 L
s
[(800)] .30952 .00415 0 1 Mshowa
.5 .01665 m
.5 .0229 L
s
[(1000)] .5 .00415 0 1 Mshowa
.69048 .01665 m
.69048 .0229 L
s
[(1200)] .69048 .00415 0 1 Mshowa
.88095 .01665 m
.88095 .0229 L
s
[(1400)] .88095 .00415 0 1 Mshowa
.125 Mabswid
.16667 .01665 m
.16667 .0204 L
s
.21429 .01665 m
.21429 .0204 L
s
.2619 .01665 m
.2619 .0204 L
s
.35714 .01665 m
.35714 .0204 L
s
.40476 .01665 m
.40476 .0204 L
s
.45238 .01665 m
.45238 .0204 L
s
.54762 .01665 m
.54762 .0204 L
s
.59524 .01665 m
.59524 .0204 L
s
.64286 .01665 m
.64286 .0204 L
s
.7381 .01665 m
.7381 .0204 L
s
.78571 .01665 m
.78571 .0204 L
s
.83333 .01665 m
.83333 .0204 L
s
.07143 .01665 m
.07143 .0204 L
s
.02381 .01665 m
.02381 .0204 L
s
.92857 .01665 m
.92857 .0204 L
s
.97619 .01665 m
.97619 .0204 L
s
.25 Mabswid
0 .01665 m
1 .01665 L
s
gsave
1.025 .01665 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10762 m
.1253 .10762 L
s
[(2.5)] .10655 .10762 1 0 Mshowa
.11905 .19859 m
.1253 .19859 L
s
[(5)] .10655 .19859 1 0 Mshowa
.11905 .28955 m
.1253 .28955 L
s
[(7.5)] .10655 .28955 1 0 Mshowa
.11905 .38052 m
.1253 .38052 L
s
[(10)] .10655 .38052 1 0 Mshowa
.11905 .47149 m
.1253 .47149 L
s
[(12.5)] .10655 .47149 1 0 Mshowa
.11905 .56245 m
.1253 .56245 L
s
[(15)] .10655 .56245 1 0 Mshowa
.125 Mabswid
.11905 .03485 m
.1228 .03485 L
s
.11905 .05304 m
.1228 .05304 L
s
.11905 .07123 m
.1228 .07123 L
s
.11905 .08943 m
.1228 .08943 L
s
.11905 .12581 m
.1228 .12581 L
s
.11905 .14401 m
.1228 .14401 L
s
.11905 .1622 m
.1228 .1622 L
s
.11905 .18039 m
.1228 .18039 L
s
.11905 .21678 m
.1228 .21678 L
s
.11905 .23497 m
.1228 .23497 L
s
.11905 .25317 m
.1228 .25317 L
s
.11905 .27136 m
.1228 .27136 L
s
.11905 .30775 m
.1228 .30775 L
s
.11905 .32594 m
.1228 .32594 L
s
.11905 .34413 m
.1228 .34413 L
s
.11905 .36233 m
.1228 .36233 L
s
.11905 .39871 m
.1228 .39871 L
s
.11905 .41691 m
.1228 .41691 L
s
.11905 .4351 m
.1228 .4351 L
s
.11905 .45329 m
.1228 .45329 L
s
.11905 .48968 m
.1228 .48968 L
s
.11905 .50787 m
.1228 .50787 L
s
.11905 .52607 m
.1228 .52607 L
s
.11905 .54426 m
.1228 .54426 L
s
.11905 .58065 m
.1228 .58065 L
s
.11905 .59884 m
.1228 .59884 L
s
.11905 .61703 m
.1228 .61703 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02322 L
.10458 .03398 L
.14415 .04549 L
.18221 .05784 L
.22272 .07238 L
.26171 .08773 L
.30316 .10549 L
.34309 .12401 L
.3815 .14315 L
.42237 .16491 L
.46172 .18725 L
.49955 .20999 L
.53984 .23558 L
.57861 .26155 L
.61984 .29059 L
.65954 .31996 L
.69774 .34951 L
.73838 .38235 L
.77751 .41532 L
.81909 .45182 L
.85916 .48842 L
.89771 .52495 L
.93871 .56523 L
.97619 .60332 L
s
1 0 .6 r
.02381 .0391 m
.06244 .04312 L
.10458 .04786 L
.14415 .05268 L
.18221 .05764 L
.22272 .06326 L
.26171 .06902 L
.30316 .07551 L
.34309 .08211 L
.3815 .0888 L
.42237 .09627 L
.46172 .10381 L
.49955 .11139 L
.53984 .1198 L
.57861 .12823 L
.61984 .13755 L
.65954 .14689 L
.69774 .1562 L
.73838 .16646 L
.77751 .17668 L
.81909 .18791 L
.85916 .19909 L
.89771 .21018 L
.93871 .22234 L
.97619 .23378 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.28571 .38045 m
.28571 .49949 L
.7619 .49949 L
.7619 .38045 L
F
1 g
.2619 .40426 m
.2619 .5233 L
.7381 .5233 L
.7381 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.2619 .40426 m
.7381 .40426 L
.7381 .5233 L
.2619 .5233 L
.2619 .40426 L
s
% Start of sub-graphic
p
0.261905 0.404255 0.738095 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00992063 0.0992063 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0178571 0.126068 0.117063 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .06746 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Matrix) show
105.000 11.562 moveto
(to) show
123.000 11.562 moveto
(Matrix) show
159.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.132937 0.126068 0.232143 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .18254 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
135.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(LU) show
147.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
  ImageSize->{514, 317.5},
  ImageMargins->{{69, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000820001?A000`40n007h00OonmHonmH1>mH003o
keSokeP4keP00?o_F?o_F0C_F000onmHonmH1>mH003okeSokeP4keP00?o_F?o_F0C_F000onmHonmH
1>mH003okeSokeP4keP00?o_F?o_F0C_F000onmHonmH1>mH002JkeP20004keP20004keP20012keP4
0003keP20004keP20004keP20010keP40002keP40003keP20004keP2000okeP40004keP00`00keS_
F002keP20004keP2001JkeP009W_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP004?_
F005003_F>mHkeP00002keP01000keS_F0000^mH00@00>mHkeP000;_F003003_F>mH03o_F005003_
F>mHkeP00005keP01000keS_F0000^mH00@00>mHkeP0043_F003003_F>mH00?_F005003_F>mHkeP0
0002keP01000keS_F0000^mH00<00>mHkeP0EnmH002IkeP01000keS_F0000^mH00@00>mHkeP000;_
F004003_F>mH0013keP01@00keS_F>mH00000^mH00@00>mHkeP000;_F004003_F>mH0002keP00`00
keS_F00okeP00`00keS_F002keP00`00keS_F002keP01000keS_F0000^mH00@00>mHkeP0043_F003
003_F>mH00D000;_F004003_F>mH0002keP01000keS_F000FNmH002JkeP20003keP01000keS_F000
0^mH00@00>mHkeP004?_F005003_F>mHkeP00002keP01000keS_F0000^mH00@00>mHkeP000;_F003
003_F>mH03o_F003003_F>mH00?_F005003_F>mHkeP00002keP01000keS_F0000^mH00<00>mHkeP0
?^mH00@00>mHkeP000;_F005003_F>mHkeP00002keP01000keS_F0000^mH00<00>mHkeP0EnmH002I
keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0013keP01@00keS_F>mH00000^mH00@0
0>mHkeP000;_F004003_F>mH0002keP00`00keS_F00okeP00`00keS_F004keP01000keS_F0000^mH
00@00>mHkeP000;_F003003_F>mH03k_F007003_F>mHkeP00>mH00000nmH00@00>mHkeP000;_F004
003_F>mH001IkeP004g_F003003_F>mH04W_F004003_F>mH0002keP01000keS_F0000^mH00@00>mH
keP0047_F0<000?_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP003o_F0<000?_F004
003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP003k_F0<000C_F08000?_F004003_F>mH0002
keP01000keS_F000FNmH001=keP00`00keS_F01:keP20004keP20004keP20014keP00`00keS_F002
keP20004keP20004keP20012keP00`00keS_F002keP20004keP20004keP20011keP00`00keS_F003
keP00`00keS_F002keP20004keP2001JkeP004g_F003003_F>mH0?o_F;?_F000CNmH00<00>mHkeP0
onmH/nmH001=keP00`00keS_F03okeRckeP004g_F003003_F>mH0?o_F;?_F0008nmH0c0O9nmH00<0
0>mHkeP0onmHTNmH0P000^mH00<00>mHkeP06nmH000HkeP>0004<1oo002[000=keP01000keS_F000
7NmH000SkeP00`00keS_F004keP4<1l:keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00B
keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00B
keP00`00keS_F00BkeP00`00keS_F00CkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00B
keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00B
keP00`00keS_F00BkeP00`00keS_F00FkeP01000keP000007NmH000SkeP00`00keS_F008keP4<1l6
keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00B
keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00C
keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00B
keP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00BkeP00`00keS_F00F
keP200000nmH003_F00LkeP003;_F0@`7aO_F003003_F>mH057_F003003_F>mH057_F003003_F>mH
05;_F003003_F>mH057_F003003_F>mH043_F004003_F>mH000MkeP003K_F0@`7a?_F003003_F>mH
0?o_F97_F0800003keP0000001g_F000>^mH130O3nmH00<00>mHkeP0onmH/nmH000nkeP4<1l;keP0
0`00keS_F03okeRckeP004;_F0@`7`O_F003003_F>mH0?o_F;?_F000A^mH0c0O1>mH0`00onmH/nmH
0019keP4<1l00`00keS_F03okeRckeP002?_F0Gh4bG_F0<`7oo_F;?_F000:>mH2?PC7NmH00<00>mH
keP00c0OonmH/>mH000`keP9n1<DkeP00`00keS_F003keP4<1ookeR/keP003W_F0[h4`[_F003003_
F>mH00O_F0<`7oo_F:W_F000@nmH2OPC00?_F000keP02nmH130OonmHYNmH001<keP8n1<:keP3<1oo
keRRkeP004g_F0<000C_F0Wh4`C_F0<`7oo_F9o_F000CNmH00<00>mHkeP03NmH2?PC0c0OonmHVnmH
001=keP00`00keS_F00EkeP8n1?okeRFkeP004g_F003003_F>mH01__F08`7`Kh4oo_F93_F000CNmH
00<00>mHkeP07NmH0c0O0nmH1_PConmHR^mH001=keP00`00keS_F00PkeP3<1l6keP7n1?okeR3keP0
04g_F003003_F>mH02?_F08`7`__F0Sh4oo_F7__F000CNmH00<00>mHkeP09NmH0c0O4>mH2?PConmH
LnmH001=keP3000XkeP2<1lFkeP6n1?okeQ]keP004g_F003003_F>mH02[_F0<`7aW_F0Kh4oo_F6O_
F000CNmH00<00>mHkeP0;NmH0S0O7NmH1_PConmHHNmH001=keP00`00keS_F00_keP3<1lPkeP6n1?o
keQKkeP004g_F003003_F>mH03;_F08`7bC_F0Kh4oo_F5G_F000CNmH00<00>mHkeP0=>mH0S0O:>mH
1OPConmHD>mH001=keP00`00keS_F00fkeP3<1lZkeP6n1?okeQ:keP004g_F003003_F>mH03W_F08`
7bk_F0Kh4oo_F4C_F000CNmH0`00>nmH0c0O<NmH1_PConmH?^mH001=keP00`00keS_F00nkeP2<1le
keP6n1?okePhkeP004g_F003003_F>mH043_F0<`7cS_F0Kh4oo_F3;_F000CNmH00<00>mHkeP0@nmH
0c0O>nmH1OPConmH;NmH001=keP00`00keS_F016keP2<1lnkeP4n1?okePYkeP004g_F003003_F>mH
04S_F0<`7co_F0Gh4oo_F2C_F000=^mH10000nmH00<00>mHkeP00^mH0`002>mH00<00>mHkeP0BnmH
0S0O@^mH1?PConmH8>mH000fkeP00`00keS_F00<keP00`00keS_F005keP00`00keS_F01=keP3<1m3
keP5n1?okePKkeP003O_F003003_F>mH00__F003003_F>mH00G_F0@004o_F08`7dK_F0Kh4oo_F1G_
F000>>mH00<00>mHkeP01nmH0`002>mH00<00>mHkeP0D^mH0S0OB^mH1OPConmH4>mH000ikeP00`00
keS_F006keP00`00keS_F008keP00`00keS_F01DkeP2<1m=keP5n1?okeP;keP003K_F004003_F>mH
0008keP00`00keS_F008keP00`00keS_F01FkeP2<1m@keP4n1?okeP7keP003O_F08000W_F0@000O_
F003003_F>mH05S_F08`7e;_F0Gh4oo_F0;_F000CNmH00<00>mHkeP0F^mH0S0OENmH1?PCoNmH001=
keP00`00keS_F01LkeP2<1mGkeP5n1?hkeP004g_F003003_F>mH05k_F08`7e[_F0Kh4o;_F000CNmH
0`00H>mH0S0OG^mH1_PCk>mH001=keP00`00keS_F01RkeP2<1mRkeP4n1?XkeP004g_F003003_F>mH
06C_F08`7fC_F0Ch4nC_F000CNmH00<00>mHkeP0I^mH0S0OI^mH1?PCh>mH001=keP00`00keS_F01X
keP2<1mXkeP3n1?MkeP004g_F003003_F>mH06[_F08`7fW_F0Ch4mW_F000CNmH00<00>mHkeP0K>mH
0S0OJnmH1?PCeNmH001=keP00`00keS_F01^keP2<1m]keP4n1?AkeP004g_F0<0073_F08`7fo_F0Gh
4lc_F000CNmH00<00>mHkeP0L^mH0S0OL^mH1?PCb>mH001=keP00`00keS_F01dkeP2<1mdkeP5n1?3
keP004g_F003003_F>mH07K_F08`7gO_F0Ch4ko_F000CNmH00<00>mHkeP0N>mH0S0ONNmH1?PC^nmH
001=keP00`00keS_F01jkeP00c0OkeS_F01jkeP4n1>gkeP004g_F003003_F>mH07__F08`7gk_F0Gh
4k;_F000CNmH00<00>mHkeP0ONmH0S0OPNmH1?PC[^mH001=keP3001okeP2<1n3keP5n1>YkeP004g_
F003003_F>mH087_F08`7hK_F0Ch4jG_F000CNmH00<00>mHkeP0PnmH00<`7nmHkeP0QnmH1?PCXNmH
001=keP00`00keS_F024keP2<1n;keP4n1>MkeP004g_F003003_F>mH08K_F08`7hg_F0?h4i[_F000
CNmH00<00>mHkeP0R>mH0S0OS^mH0oPCUnmH001=keP00`00keS_F02:keP2<1n?keP4n1>CkeP004g_
F003003_F>mH08c_F003<1o_F>mH093_F0?h4i3_F000CNmH00<00>mHkeP0SNmH0S0OTnmH1?PCS>mH
001=keP3002?keP2<1nEkeP4n1>8keP004g_F003003_F>mH097_F08`7iO_F0Ch4hC_F000CNmH00<0
0>mHkeP0TnmH0S0OVNmH1?PCP>mH001=keP00`00keS_F02EkeP00c0OkeS_F02JkeP3n1=mkeP004g_
F003003_F>mH09K_F08`7ig_F0Ch4gW_F000CNmH00<00>mHkeP0V>mH0S0OWnmH0oPCM^mH0012keP3
0008keP00`00keS_F02JkeP00c0OkeS_F02OkeP3n1=ckeP004G_F003003_F>mH00G_F003003_F>mH
09__F08`7j;_F0Ch4fo_F000ANmH00<00>mHkeP01NmH1000W>mH00<`7nmHkeP0XnmH0oPCK>mH0012
keP30008keP00`00keS_F02NkeP2<1nVkeP4n1=XkeP004;_F003003_F>mH00S_F003003_F>mH0:3_
F08`7jS_F0?h4fG_F000@^mH00<00>mHkeP02>mH00<00>mHkeP0X^mH00<`7nmHkeP0Z>mH0oPCH^mH
0012keP40007keP00`00keS_F02SkeP2<1n[keP4n1=NkeP004g_F003003_F>mH0:G_F003<1o_F>mH
0:c_F0?h4e__F000CNmH00<00>mHkeP0Y^mH0S0O[nmH1?PCEnmH001=keP00`00keS_F02XkeP2<1na
keP4n1=CkeP004g_F0<00:[_F003<1o_F>mH0;;_F0Ch4do_F000CNmH00<00>mHkeP0ZnmH0S0O]^mH
1?PCBnmH001=keP00`00keS_F02]keP2<1nhkeP3n1=8keP004g_F003003_F>mH0:o_F003<1o_F>mH
0;S_F0?h4dG_F000CNmH00<00>mHkeP0/>mH0S0O^nmH1?PC@NmH001=keP00`00keS_F02bkeP00c0O
keS_F02lkeP3n1<nkeP004g_F003003_F>mH0;?_F08`7ko_F0?h4c__F000CNmH00<00>mHkeP0]NmH
0S0O`>mH0_PC>NmH001=keP3002gkeP00c0OkeS_F03hkeP004g_F003003_F>mH0;S_F08`7oS_F000
CNmH00<00>mHkeP0^^mH00<`7nmHkeP0mNmH001=keP00`00keS_F02kkeP2<1oekeP004g_F003003_
F>mH0;g_F003<1o_F>mH0?;_F000CNmH00<00>mHkeP0_^mH0S0Ol^mH001=keP00`00keS_F030keP2
<1o`keP004g_F003003_F>mH0<;_F003<1o_F>mH0>g_F000CNmH0`00`nmH0S0OkNmH001=keP00`00
keS_F035keP00c0OkeS_F03ZkeP004g_F003003_F>mH0<K_F08`7n[_F000CNmH00<00>mHkeP0b>mH
00<`7nmHkeP0inmH001=keP00`00keS_F039keP2<1oWkeP004g_F003003_F>mH0<__F003<1o_F>mH
0>C_F000CNmH00<00>mHkeP0c>mH00<`7nmHkeP0hnmH001=keP00`00keS_F03=keP2<1oSkeP004g_
F0<00<o_F003<1o_F>mH0>3_F000CNmH00<00>mHkeP0d>mH0S0Oh>mH001=keP00`00keS_F03BkeP0
0c0OkeS_F03MkeP004g_F003003_F>mH0=?_F003<1o_F>mH0=c_F000CNmH00<00>mHkeP0e>mH0S0O
g>mH001=keP00`00keS_F03FkeP00c0OkeS_F03IkeP003O_F003003_F>mH00?_F003003_F>mH00;_
F0<000S_F003003_F>mH0=O_F003<1o_F>mH0=S_F000=nmH00<00>mHkeP02nmH00<00>mHkeP01NmH
00<00>mHkeP0f>mH0S0Of>mH000hkeP00`00keS_F00:keP00`00keS_F005keP4003IkeP00c0OkeS_
F03EkeP003S_F003003_F>mH00O_F0<000S_F003003_F>mH0=__F08`7mG_F000>NmH00<00>mHkeP0
1^mH00<00>mHkeP02>mH00<00>mHkeP0gNmH00<`7nmHkeP0d^mH000fkeP01000keS_F0002>mH00<0
0>mHkeP02>mH00<00>mHkeP0g^mH00<`7nmHkeP0dNmH000fkeP40008keP40007keP00`00keS_F03O
keP2<1oAkeP004g_F003003_F>mH0>7_F003<1o_F>mH0<k_F000CNmH00<00>mHkeP0h^mH0S0Oc^mH
001=keP00`00keS_F03TkeP00c0OkeS_F03;keP004g_F0<00>G_F003<1o_F>mH0<[_F000CNmH00<0
0>mHkeP0i^mH0S0Ob^mH001=keP00`00keS_F03XkeP00c0OkeS_F037keP004g_F003003_F>mH0>W_
F003<1o_F>mH0<K_F000CNmH00<00>mHkeP0j^mH0S0Oa^mH001=keP00`00keS_F03/keP00c0OkeS_
F033keP004g_F003003_F>mH0>g_F003<1o_F>mH0<;_F000CNmH00<00>mHkeP0k^mH0S0O`^mH001=
keP3003`keP00c0OkeS_F02okeP004g_F003003_F>mH0?7_F003<1o_F>mH0;k_F000CNmH00<00>mH
keP0l^mH0S0O_^mH001=keP00`00keS_F03dkeP00c0OkeS_F02kkeP004g_F003003_F>mH0?G_F003
<1o_F>mH0;[_F000CNmH00<00>mHkeP0m^mH0S0O^^mH001=keP00`00keS_F03hkeP00c0OkeS_F02g
keP004g_F003003_F>mH0?W_F003<1o_F>mH0;K_F000CNmH0`00n^mH0S0O]^mH001=keP00`00keS_
F03lkeP00c0OkeS_F02ckeP004g_F003003_F>mH0?g_F003<1o_F>mH0;;_F000CNmH00<00>mHkeP0
o^mH00<`7nmHkeP0/NmH001=keP00`00keS_F03okeP2<1nakeP004g_F003003_F>mH0?o_F0;_F003
<1o_F>mH0:k_F000CNmH00<00>mHkeP0onmH0nmH00<`7nmHkeP0[NmH001=keP00`00keS_F03okeP4
keP00c0OkeS_F02/keP004g_F0<00?o_F0G_F003<1o_F>mH0:__F000CNmH00<00>mHkeP0onmH1^mH
0S0OZnmH001=keP00`00keS_F03okeP8keP00c0OkeS_F02XkeP004g_F003003_F>mH0?o_F0W_F003
<1o_F>mH0:O_F000CNmH00<00>mHkeP0onmH2^mH00<`7nmHkeP0Y^mH001=keP00`00keS_F03okeP;
keP00c0OkeS_F02UkeP003c_F0@000?_F08000S_F003003_F>mH0?o_F0c_F08`7jG_F000?^mH00D0
0>mHkeS_F00000;_F003003_F>mH00G_F003003_F>mH0?o_F0k_F003<1o_F>mH0:;_F000?^mH00D0
0>mHkeS_F00000;_F003003_F>mH00G_F0@00?o_F0k_F003<1o_F>mH0:7_F000?^mH00D00>mHkeS_
F00000;_F003003_F>mH00G_F003003_F>mH0?o_F13_F003<1o_F>mH0:3_F000?^mH00D00>mHkeS_
F00000;_F003003_F>mH00G_F003003_F>mH0?o_F17_F003<1o_F>mH09o_F000?>mH0`000nmH00@0
0>mHkeP000O_F003003_F>mH0?o_F1;_F08`7io_F000?^mH00<00>mHkeP00^mH0P002>mH00<00>mH
keP0onmH5>mH00<`7nmHkeP0W>mH001=keP00`00keS_F03okePEkeP00c0OkeS_F02KkeP004g_F003
003_F>mH0?o_F1K_F003<1o_F>mH09[_F000CNmH00<00>mHkeP0onmH5nmH00<`7nmHkeP0VNmH001=
keP3003okePHkeP2<1nIkeP004g_F003003_F>mH0?o_F1[_F003<1o_F>mH09K_F000CNmH00<00>mH
keP0onmH6nmH00<`7nmHkeP0UNmH001=keP00`00keS_F03okePLkeP00c0OkeS_F02DkeP004g_F003
003_F>mH0?o_F1g_F003<1o_F>mH09?_F000CNmH00<00>mHkeP0@^mHm000O>mH001=keP00`00keS_
F012keSd001lkeP004g_F003003_F>mH04;_F?@007c_F000CNmH0`00@^mHm000O>mH001=keP00`00
keS_F012keSd001lkeP004g_F003003_F>mH04;_F?@007c_F000CNmH00<00>mHkeP0@^mHm000O>mH
001=keP00`00keS_F012keSd001lkeP004g_F003003_F>mH04;_F?@007c_F000CNmH00<00>mHkeP0
@^mHm000O>mH001=keP00`00keS_F012keSd001lkeP004g_F0<003K_F?l0004007c_F000CNmH00<0
0>mHkeP0=^mH00<00?ooool0lOoo3000O>mH001=keP00`00keS_F00fkeP00`00ooooo`3aool<001l
keP004g_F003003_F>mH03K_F003003ooooo0?7oo``007c_F000CNmH00<00>mHkeP0=^mH00<00?oo
ool0lOoo3000O>mH001=keP00`00keS_F00fkeP00`00ooooo`3aool<001lkeP004g_F003003_F>mH
03K_F003003ooooo0?7oo``007c_F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo3000O>mH001=
keP3000fkeP00`00ooooo`3aool<001lkeP004g_F003003_F>mH03K_F003003ooooo0?7oo``007c_
F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo3000O>mH001=keP00`00keS_F00fkeP00`00oooo
o`3aool<00000c0OkeS_F01ikeP004g_F003003_F>mH03K_F003003ooooo0?7oo``00003keP`7nmH
07W_F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo30000^mH00<`7nmHkeP0MnmH000`keP40002
keP40003keP00`00keS_F002keP30008keP00`00keS_F00fkeP00`00ooooo`3aool<0003keP00c0O
keS_F01fkeP003;_F005003_F>mHkeP0000>keP00`00keS_F005keP00`00keS_F00fkeP00`00oooo
o`0Qool200000ooo00000003ool200000ooo003oo`02ool20002ool40002ool700000ooo0000000:
ool20003ool20008ool200000ooo00000003ool200000ooo003oo`02ool20002ool40002ool70000
0ooo0000001aool<0004keP00c0OkeS_F01ekeP003;_F003003_F>mH00;_F003003_F>mH00__F003
003_F>mH00G_F0@003G_F003003ooooo027oo`05003oooooool00002ool01000ooooo`000ooo00@0
0?ooool000;oo`03003ooooo00Coo`07003oooooool00?oo00002_oo00H00?ooool00?oo0002ool0
0`00ooooo`05ool01@00oooooooo00000_oo00@00?ooool000?oo`04003ooooo0002ool00`00oooo
o`04ool01`00oooooooo003oo`0007;oo``000G_F08`7gG_F000<^mH00<00>mHkeP00nmH00<00>mH
keP01nmH0`002>mH00<00>mHkeP0=^mH00<00?ooool00_oo6_PC1Ooo00D00?oo003oo`0000?oo`<0
00?oo`03003ooooo00?oo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo00Woo`03003ooooo
00;oo`04003ooooo0007ool01@00ool00?oo00000ooo0`000ooo00<00?ooool00ooo00<00?ooool0
1?oo00<00?ooool00_oo00<00?ooool0LOoo30001nmH00<`7nmHkeP0L^mH000bkeP00`00keS_F004
keP00`00keS_F006keP00`00keS_F008keP00`00keS_F00fkeP00`00ooooo`0Qool01@00ool00?oo
00001Ooo00D00?ooooooo`0000Goo`03003ooooo00Coo`07003oooooool00?oo00002_oo00<00?oo
ool00_oo00@00?ooool000Ooo`05003oo`00ool00005ool01@00oooooooo00001Ooo00<00?ooool0
1?oo00L00?ooooooo`00ool0001bool<0008keP00c0OkeS_F01akeP0033_F0<000?_F004003_F>mH
0008keP00`00keS_F008keP00`00keS_F00fkeP00`00ooooo`0Qool200000ooo00000003ool20003
ool40002ool00`00ool000020002ool20002ool200000ooo00000008ool40003ool20008ool20000
0ooo00000003ool20003ool40002ool00`00ool000020002ool20002ool200000ooo0000001aool<
0009keP00c0OkeS_F01`keP003;_F003003_F>mH00;_F08000W_F0@000O_F003003_F>mH03K_F003
003ooooo027oo`05003oooooool00009ool00`00ooooo`0Kool00`00ooooo`0=ool01@00oooooooo
00002Ooo00<00?ooool0Pooo30002^mH00<`7nmHkeP0KnmH001=keP00`00keS_F00fkeP00`00oooo
o`0_ool00`00ooooo`0:ool00`00ooooo`0>ool00`00ooooo`0Kool00`00ooooo`0:ool00`00oooo
o`1fool<000;keP00c0OkeS_F01^keP004g_F003003_F>mH03K_F003003ooooo0?7oo``000c_F003
<1o_F>mH06g_F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo30003NmH00<`7nmHkeP0K>mH001=
keP3000fkeP00`00ooooo`3aool<000>keP00c0OkeS_F01[keP004g_F003003_F>mH03K_F003003o
oooo0?7oo``000o_F003<1o_F>mH06[_F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo30004>mH
00<`7nmHkeP0JNmH001=keP00`00keS_F00fkeP00`00ooooo`3aool<000AkeP00c0OkeS_F01XkeP0
04g_F003003_F>mH03K_F003003ooooo0?7oo``001;_F003<1o_F>mH06O_F000CNmH00<00>mHkeP0
=^mH00<00?ooool0lOoo30004nmH00<`7nmHkeP0I^mH001=keP00`00keS_F00fkeP00`00ooooo`3a
ool<000DkeP00c0OkeS_F01UkeP004g_F003003_F>mH03K_F003003ooooo0?7oo``001G_F003<1o_
F>mH06C_F000CNmH0`00=^mH00<00?ooool0lOoo30005^mH0S0OI>mH001=keP00`00keS_F00fkeP0
0`00ooooo`3aool<000HkeP00c0OkeS_F01QkeP004g_F003003_F>mH03K_F003003ooooo0?7oo``0
01W_F003<1o_F>mH063_F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo30006^mH00<`7nmHkeP0
GnmH001=keP00`00keS_F00fkeP00`00ooooo`3aool<000KkeP00c0OkeS_F01NkeP004g_F003003_
F>mH03K_F003003ooooo0?7oo``001c_F003<1o_F>mH05g_F000CNmH00<00>mHkeP0=^mH00<00?oo
ool0lOoo30007NmH00<`7nmHkeP0G>mH001=keP00`00keS_F00fkeP00`00ooooo`3aool<000NkeP0
0c0OkeS_F01KkeP004g_F0<003K_F003003ooooo0?7oo``001o_F003<1o_F>mH05[_F000CNmH00<0
0>mHkeP0=^mH00<00?ooool0lOoo30008>mH00<`7nmHkeP0FNmH001=keP00`00keS_F00fkeP00`00
ooooo`3aool<000QkeP00c0OkeS_F01HkeP004g_F003003_F>mH03K_F003003ooooo027oo`800003
ool0000000?oo`800003ool00?oo00;oo`800005ool00000003oo`020002ool300001Ooo003oo`00
ool00P000_oo0P0000?oo`00ool00_oo0P000_oo1@000_oo0P001?oo0P0000?oo`00ool01Ooo1@00
0ooo0P00O_oo30008^mH00<`7nmHkeP0EnmH001=keP00`00keS_F00fkeP00`00ooooo`0Qool01@00
oooooooo00000_oo00@00?ooool000?oo`06003ooooo003oo`000_oo00@00?ooool000Coo`05003o
o`00ool00002ool01000ooooo`000ooo00@00?ooool000?oo`05003oooooool00002ool01000oooo
o`000_oo00<00?ooool01_oo00@00?ooool000;oo`04003ooooo001mool<000SkeP00c0OkeS_F01F
keP004g_F003003_F>mH03K_F003003ooooo00;ooaX`7`Goo`05003oo`00ool00003ool30003ool0
0`00ooooo`02ool01000ooooo`000_oo0`000_oo00D00?oo003oo`0000?oo`<000?oo`03003ooooo
00Coo`05003oooooool00006ool30008ool00`00ooooo`03ool01000ooooo`00OOoo30009>mH00<`
7nmHkeP0ENmH001=keP00`00keS_F00fkeP00`00ooooo`0Qool01@00ool00?oo00001Ooo00D00?oo
ooooo`0000Coo`04003ooooo0002ool02P00ooooo`00ool00?oo003oo`001Ooo00D00?ooooooo`00
00Koo`05003oooooool00002ool00`00ooooo`03ool00`00ooooo`06ool00`00ooooo`03ool01000
ooooo`00OOoo30009NmH00<`7nmHkeP0E>mH001=keP00`00keS_F00fkeP00`00ooooo`0Qool20000
0ooo00000003ool20003ool40002ool30004ool20002ool200000ooo003oo`03ool20003ool40003
ool20004ool20004ool20009ool00`00ooooo`03ool01000ooooo`00OOoo30009^mH00<`7nmHkeP0
DnmH001=keP3000fkeP00`00ooooo`0Qool01@00oooooooo00002Ooo00<00?ooool00_oo00<00?oo
ool05_oo00<00?ooool06Ooo0`000ooo0P000_oo0P00O?oo30009nmH00<`7nmHkeP0D^mH001=keP0
0`00keS_F00fkeP00`00ooooo`0_ool01000oooooooo0P006?oo00<00?ooool01?oo00<00?ooool0
V_oo3000:>mH0S0OD^mH001=keP00`00keS_F00fkeP00`00ooooo`3aool00`00keS_F00ckeP00c0O
keS_F01?keP004g_F003003_F>mH03K_F003003ooooo0?7oo`03003_F>mH03C_F003<1o_F>mH04k_
F000CNmH00<00>mHkeP0=^mH00<00?ooool0lOoo00<00>mHkeP0=NmH00<`7nmHkeP0CNmH001=keP0
0`00keS_F00fkeP00`00ooooo`3aool00`00keS_F00fkeP00c0OkeS_F01<keP004g_F003003_F>mH
03K_F003003ooooo0?7oo`03003_F>mH03O_F003<1o_F>mH04__F000?>mH10000^mH0`002>mH00<0
0>mHkeP0=^mH00<00?ooool0lOoo00<00>mHkeP0>>mH00<`7nmHkeP0B^mH000nkeP00`00keS_F004
keP00`00keS_F005keP00`00keS_F00fkeP00`00ooooo`3aool00`00keS_F00ikeP00c0OkeS_F019
keP003k_F003003_F>mH00C_F003003_F>mH00G_F0@003G_F003003ooooo0?7oo`03003_F>mH03[_
F003<1o_F>mH04S_F000?^mH00@00>mHkeS_F0<000S_F003003_F>mH03K_F003003ooooo0?7oo`03
003_F>mH03__F003<1o_F>mH04O_F000?^mH00D00>mHkeS_F00000[_F003003_F>mH03K_F003003o
oooo0?7oo`03003_F>mH03c_F003<1o_F>mH04K_F000?>mH0`000nmH00<00>mHkeP02>mH00<00>mH
keP0=^mH00<00?ooool0lOoo00<00>mHkeP0?NmH00<`7nmHkeP0ANmH000nkeP01000keS_F>mH1000
1nmH00<00>mHkeP0=^mHm@00@>mH00<`7nmHkeP0A>mH001=keP00`00keS_F03okeQ]keP00c0OkeS_
F013keP004g_F003003_F>mH0?o_F6k_F003<1o_F>mH04;_F000CNmH00<00>mHkeP0onmHKnmH00<`
7nmHkeP0@NmH001=keP3003okeQ`keP00c0OkeS_F010keP004g_F003003_F>mH0?o_F77_F003<1o_
F>mH03o_F000CNmH00<00>mHkeP0onmHLNmH00<`7nmHkeP0?nmH001=keP00`00keS_F03okeQbkeP0
0c0OkeS_F00nkeP004g_F003003_F>mH0?o_F7?_F003<1o_F>mH03g_F000CNmH00<00>mHkeP0onmH
M>mH00<`7nmHkeP0?>mH001=keP00`00keS_F03okeQekeP00c0OkeS_F00kkeP004g_F003003_F>mH
0?o_F7K_F003<1o_F>mH03[_F000CNmH0`00onmHMnmH00<`7nmHkeP0>NmH001=keP00`00keS_F03o
keQhkeP00c0OkeS_F00hkeP004g_F003003_F>mH0?o_F7W_F003<1o_F>mH03O_F000CNmH00<00>mH
keP0onmH/nmH001=keP00`00keS_F03okeRckeP004g_F003003_F>mH0?o_F;?_F000CNmH00<00>mH
keP0onmH/nmH001=keP00`00keS_F03okeRckeP004g_F0<00?o_F;?_F000onmHonmH1>mH003okeSo
keP4keP00?o_F?o_F0C_F000onmHonmH1>mH003okeSokeP4keP00?o_F?o_F0C_F000onmHonmH1>mH
003okeSokeP4keP00?o_F?o_F0C_F000onmHonmH1>mH003okeSokeP4keP00?o_F?o_F0C_F000onmH
onmH1>mH003okeSokeP4keP003W_F0<000C_F0<000?_F08000C_F08000;_F0<00003keP0000000;_
F0800003keP00>mH00<00?o_F:?_F000>NmH00@00>mHkeP000;_F003003_F>mH00?_F004003_F>mH
0002keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0005keP00`00keS_F03okeRPkeP0
03c_F003003_F>mH00<000?_F003003_F>mH00?_F004003_F>mH0002keP01000keS_F0000^mH00@0
0>mHkeP000?_F0800?o_F:?_F000>^mH0P000nmH00@00>mHkeP000;_F004003_F>mH0002keP01000
keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0002keP00`00keS_F03okeRSkeP003W_F003003_
F>mH00C_F08000C_F08000C_F08000;_F004003_F0000004keP30003keP3003okeRRkeP003[_F0<0
01g_F003003_F>mH0?o_F:K_F000FNmH0P00onmHZ>mH003okeSokeP4keP00?o_F?o_F0C_F000onmH
onmH1>mH003okeSokeP4keP00?o_F?o_F0C_F000onmHonmH1>mH003okeSokeP4keP00001\
\>"],
  ImageRangeCache->{{{0, 513}, {316.5, 0}} -> {-1.05183, -0.648943, \
0.00410072, 0.00410072}, {{12.625, 500.312}, {308.938, 7.5}} -> {416.246, \
-1.37267, 2.37357, 0.0621257}, {{134.562, 378.375}, {109.438, 48.5}} -> \
{-5.26848, -8.66293, 0.0384002, 0.0413543}, {{139.25, 165.312}, {105.062, \
80.875}} -> {-5.63513, -29.1429, 0.0402882, 0.130375}, {{139.25, 165.312}, \
{77, 52.8125}} -> {-5.63513, -32.8016, 0.0402882, 0.130375}},
  CellTags->"Mat_LU_vs_MaToMa"],

Cell[TextData[{
  "Discussion: The blue line in Figure ",
  
  CounterBox["NumberedFigure", "Mat_LU_vs_MaToMa"],
  " indicates the time needed for a LU decomposition in ",
  StyleBox["Mathematica.",
    FontSlant->"Italic"],
  " The red line is the expected cost for transferring the problem to an \
external program. It is noteworthy that for matrices smaller than about 700 x \
700 on this machine the exporting cost is higher than the overall solving \
cost in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". We call the point where exporting does take less time than doing a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " internal computation on the same expression the export threshold.\nSo, \
the following conclusion can be drawn: ",
  StyleBox["If you decide to move outside of ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" then you should stay there as long as possible and reduce the \
sending and/or receiving overhead cost.",
    FontWeight->"Bold"],
  " For our specific goal, thinking about an external LU solving: send only \
back what you need. If you do not further need the LU decomposed matrix do \
not send it back, merely the result vector. Try to minimize the amount of \
data transferred."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["DGETRF (LU decomposition) in C", "Subsubsection"],

Cell[TextData[{
  "In the following step we compute the LU decomposition in external C \
program linked to the ATLAS generated subset of the LAPACK libraries. The \
resulting  LU decomposition - computed by the DGETRF function - will in \
general be different from the one computed in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". The result returned by DGETRF is the decomposed matrix and information \
about pivoting needed for the backsubsitution."
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0155575 0.0365414 [
[.30952 .00306 -9 -9 ]
[.30952 .00306 9 0 ]
[.5 .00306 -12 -9 ]
[.5 .00306 12 0 ]
[.69048 .00306 -12 -9 ]
[.69048 .00306 12 0 ]
[.88095 .00306 -12 -9 ]
[.88095 .00306 12 0 ]
[1.025 .01556 0 -4.90625 ]
[1.025 .01556 10 4.90625 ]
[.10655 .10691 -18 -4.5 ]
[.10655 .10691 0 4.5 ]
[.10655 .19826 -6 -4.5 ]
[.10655 .19826 0 4.5 ]
[.10655 .28962 -18 -4.5 ]
[.10655 .28962 0 4.5 ]
[.10655 .38097 -12 -4.5 ]
[.10655 .38097 0 4.5 ]
[.10655 .47232 -24 -4.5 ]
[.10655 .47232 0 4.5 ]
[.10655 .56368 -12 -4.5 ]
[.10655 .56368 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01556 m
.30952 .02181 L
s
[(800)] .30952 .00306 0 1 Mshowa
.5 .01556 m
.5 .02181 L
s
[(1000)] .5 .00306 0 1 Mshowa
.69048 .01556 m
.69048 .02181 L
s
[(1200)] .69048 .00306 0 1 Mshowa
.88095 .01556 m
.88095 .02181 L
s
[(1400)] .88095 .00306 0 1 Mshowa
.125 Mabswid
.16667 .01556 m
.16667 .01931 L
s
.21429 .01556 m
.21429 .01931 L
s
.2619 .01556 m
.2619 .01931 L
s
.35714 .01556 m
.35714 .01931 L
s
.40476 .01556 m
.40476 .01931 L
s
.45238 .01556 m
.45238 .01931 L
s
.54762 .01556 m
.54762 .01931 L
s
.59524 .01556 m
.59524 .01931 L
s
.64286 .01556 m
.64286 .01931 L
s
.7381 .01556 m
.7381 .01931 L
s
.78571 .01556 m
.78571 .01931 L
s
.83333 .01556 m
.83333 .01931 L
s
.07143 .01556 m
.07143 .01931 L
s
.02381 .01556 m
.02381 .01931 L
s
.92857 .01556 m
.92857 .01931 L
s
.97619 .01556 m
.97619 .01931 L
s
.25 Mabswid
0 .01556 m
1 .01556 L
s
gsave
1.025 .01556 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10691 m
.1253 .10691 L
s
[(2.5)] .10655 .10691 1 0 Mshowa
.11905 .19826 m
.1253 .19826 L
s
[(5)] .10655 .19826 1 0 Mshowa
.11905 .28962 m
.1253 .28962 L
s
[(7.5)] .10655 .28962 1 0 Mshowa
.11905 .38097 m
.1253 .38097 L
s
[(10)] .10655 .38097 1 0 Mshowa
.11905 .47232 m
.1253 .47232 L
s
[(12.5)] .10655 .47232 1 0 Mshowa
.11905 .56368 m
.1253 .56368 L
s
[(15)] .10655 .56368 1 0 Mshowa
.125 Mabswid
.11905 .03383 m
.1228 .03383 L
s
.11905 .0521 m
.1228 .0521 L
s
.11905 .07037 m
.1228 .07037 L
s
.11905 .08864 m
.1228 .08864 L
s
.11905 .12518 m
.1228 .12518 L
s
.11905 .14345 m
.1228 .14345 L
s
.11905 .16172 m
.1228 .16172 L
s
.11905 .17999 m
.1228 .17999 L
s
.11905 .21654 m
.1228 .21654 L
s
.11905 .23481 m
.1228 .23481 L
s
.11905 .25308 m
.1228 .25308 L
s
.11905 .27135 m
.1228 .27135 L
s
.11905 .30789 m
.1228 .30789 L
s
.11905 .32616 m
.1228 .32616 L
s
.11905 .34443 m
.1228 .34443 L
s
.11905 .3627 m
.1228 .3627 L
s
.11905 .39924 m
.1228 .39924 L
s
.11905 .41751 m
.1228 .41751 L
s
.11905 .43578 m
.1228 .43578 L
s
.11905 .45405 m
.1228 .45405 L
s
.11905 .4906 m
.1228 .4906 L
s
.11905 .50887 m
.1228 .50887 L
s
.11905 .52714 m
.1228 .52714 L
s
.11905 .54541 m
.1228 .54541 L
s
.11905 .58195 m
.1228 .58195 L
s
.11905 .60022 m
.1228 .60022 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02328 L
.10458 .03409 L
.14415 .04565 L
.18221 .05805 L
.22272 .07262 L
.26171 .088 L
.30316 .10579 L
.34309 .12434 L
.3815 .14349 L
.42237 .16527 L
.46172 .18761 L
.49955 .21036 L
.53984 .23595 L
.57861 .2619 L
.61984 .29093 L
.65954 .32028 L
.69774 .34981 L
.73838 .38262 L
.77751 .41556 L
.81909 .45202 L
.85916 .48858 L
.89771 .52506 L
.93871 .56528 L
.97619 .60332 L
s
1 0 .6 r
.02381 .03532 m
.06244 .03963 L
.10458 .04479 L
.14415 .05008 L
.18221 .05557 L
.22272 .06185 L
.26171 .06831 L
.30316 .07564 L
.34309 .08313 L
.3815 .09076 L
.42237 .09931 L
.46172 .10797 L
.49955 .1167 L
.53984 .12642 L
.57861 .1362 L
.61984 .14704 L
.65954 .15792 L
.69774 .16878 L
.73838 .18079 L
.77751 .19277 L
.81909 .20596 L
.85916 .21911 L
.89771 .23218 L
.93871 .24652 L
.97619 .26003 L
s
.2 1 0 r
.02381 .04865 m
.06244 .05467 L
.10458 .06181 L
.14415 .06906 L
.18221 .07653 L
.22272 .08501 L
.26171 .09369 L
.30316 .10348 L
.34309 .11346 L
.3815 .12356 L
.42237 .13485 L
.46172 .14625 L
.49955 .15771 L
.53984 .17043 L
.57861 .18319 L
.61984 .19731 L
.65954 .21145 L
.69774 .22555 L
.73838 .24109 L
.77751 .25658 L
.81909 .2736 L
.85916 .29055 L
.89771 .30737 L
.93871 .3258 L
.97619 .34315 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.28571 .38045 m
.28571 .49949 L
.7619 .49949 L
.7619 .38045 L
F
1 g
.2619 .40426 m
.2619 .5233 L
.7381 .5233 L
.7381 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.2619 .40426 m
.7381 .40426 L
.7381 .5233 L
.2619 .5233 L
.2619 .40426 L
s
% Start of sub-graphic
p
0.261905 0.404255 0.738095 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00679348 0.0679348 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0122283 0.126068 0.080163 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 1 0 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0462 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DGETRF) show
99.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0910326 0.126068 0.158967 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .125 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Matrix) show
105.000 11.562 moveto
(to) show
123.000 11.562 moveto
(Matrix) show
159.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.169837 0.126068 0.237772 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .2038 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
  ImageSize->{487, 300.812},
  ImageMargins->{{78, 10}, {10, 7}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007W0001;1000`40n007h00OonmHj>mH003okeSX
keP00?o_F>S_F000onmHj>mH003okeSXkeP00?o_F>S_F000onmHj>mH003okeSXkeP00?o_F>S_F000
T^mH0P001>mH0P001>mH0P00?NmH10000nmH0P001>mH0P001>mH0P00>nmH10000^mH10000nmH0P00
1>mH0P00>^mH10001>mH00<00>mHkeP00^mH0P001>mH0P00E^mH002AkeP01000keS_F0000^mH00@0
0>mHkeP000;_F004003_F>mH000nkeP01@00keS_F>mH00000^mH00@00>mHkeP000;_F004003_F>mH
0002keP00`00keS_F00jkeP01@00keS_F>mH00001NmH00@00>mHkeP000;_F004003_F>mH000kkeP0
0`00keS_F003keP01@00keS_F>mH00000^mH00@00>mHkeP000;_F003003_F>mH05?_F000TNmH00@0
0>mHkeP000;_F004003_F>mH0002keP01000keS_F000?^mH00D00>mHkeS_F00000;_F004003_F>mH
0002keP01000keS_F0000^mH00<00>mHkeP0>^mH00<00>mHkeP00^mH00<00>mHkeP00^mH00@00>mH
keP000;_F004003_F>mH000kkeP00`00keS_F0050002keP01000keS_F0000^mH00@00>mHkeP005G_
F000T^mH0P000nmH00@00>mHkeP000;_F004003_F>mH000nkeP01@00keS_F>mH00000^mH00@00>mH
keP000;_F004003_F>mH0002keP00`00keS_F00jkeP00`00keS_F003keP01@00keS_F>mH00000^mH
00@00>mHkeP000;_F003003_F>mH03W_F004003_F>mH0002keP01@00keS_F>mH00000^mH00@00>mH
keP000;_F003003_F>mH05?_F000TNmH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F000
?^mH00D00>mHkeS_F00000;_F004003_F>mH0002keP01000keS_F0000^mH00<00>mHkeP0>^mH00<0
0>mHkeP01>mH00@00>mHkeP000;_F004003_F>mH0002keP00`00keS_F00ikeP01`00keS_F>mH003_
F00000?_F004003_F>mH0002keP01000keS_F000ENmH002AkeP01000keS_F0000^mH00@00>mHkeP0
00;_F004003_F>mH000lkeP30003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000j
keP30003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000ikeP30004keP20003keP0
1000keS_F0000^mH00@00>mHkeP005G_F000B^mH00<00>mHkeP0ANmH0P001>mH0P001>mH0P00?nmH
00<00>mHkeP00^mH0P001>mH0P001>mH0P00?NmH00<00>mHkeP00^mH0P001>mH0P001>mH0P00?>mH
00<00>mHkeP00nmH00<00>mHkeP00^mH0P001>mH0P00E^mH001:keP00`00keS_F03okeRKkeP004[_
F003003_F>mH0?o_F9__F000B^mH00<00>mHkeP0onmHVnmH001:keP00`00keS_F03okeRKkeP004[_
F003003_F>mH0?o_F7W_F08000;_F003003_F>mH01__F0006>mH2P000c0Oo`00UP003>mH00@00>mH
keP001g_F0008^mH00<00>mHkeP01S0O2nmH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP0
4NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP0
4>mH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP0
4NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP0
4NmH00<00>mHkeP04NmH00<00>mHkeP05>mH00@00>mH000001g_F0008^mH00<00>mHkeP01^mH1C0O
1^mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP0
4NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP0
4NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP0
4NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP0
5>mH0P0000?_F000keP07>mH000`keP4<1lFkeP00`00keS_F01<keP00`00keS_F01<keP00`00keS_
F01=keP00`00keS_F01<keP00`00keS_F00lkeP01000keS_F0007NmH000dkeP4<1lBkeP00`00keS_
F03okeQikeP200000nmH0000000MkeP003S_F0<`7`o_F003003_F>mH0?o_F9__F000>nmH0c0O3>mH
00<00>mHkeP0onmHVnmH000nkeP4<1l8keP00`00keS_F03okeRKkeP002;_F0Gh4a__F0<`7`G_F080
0?o_F9c_F0009nmH2?PC5^mH130O00?_F000keP0onmHW>mH000_keP8n1<BkeP3<1ookeRLkeP003O_
F0Sh4`__F003003_F30O008`7oo_F9W_F000?nmH2OPC0^mH00<00>mHkeP00^mH130OonmHUNmH0018
keP8n1<3keP3<1ookeRBkeP002;_F0Dgh2?_F003003_F>mH00?_F0Oh4`8`7oo_F8o_F0009nmH23OP
6nmH0P002nmH1_PConmHRnmH000_keP6=n0EkeP00`00keS_F00@keP5n1?okeR6keP003G_F0Hgh0o_
F003003_F>mH01?_F08`7`Oh4oo_F7o_F000>nmH1SOP2NmH00<00>mHkeP05^mH0c0O0nmH2?PConmH
MnmH0011keP5=n04keP00`00keS_F00IkeP3<1l8keP7n1?okeQ`keP004K_F0Hgh1g_F0<`7`c_F0Kh
4oo_F6[_F000B^mH00<00>mH=n001COP6^mH0S0O4>mH1OPConmHINmH001:keP00`00keS_F005keP5
=n0GkeP3<1lBkeP5n1?okeQPkeP004[_F08000__F0Hgh1C_F0<`7aC_F0Kh4oo_F5[_F000B^mH00<0
0>mHkeP04>mH1COP4^mH0c0O5nmH1_PConmHE>mH001:keP00`00keS_F00EkeP5=n0@keP3<1lJkeP5
n1?okeQ?keP004[_F003003_F>mH01[_F0@gh0o_F08`7ag_F0Kh4oo_F4W_F000B^mH00<00>mHkeP0
7^mH13OP3NmH0c0O8>mH1_PConmH@nmH001:keP00`00keS_F00RkeP4=n0<keP3<1lSkeP5n1?okePn
keP004[_F003003_F>mH02K_F0Dgh0[_F08`7bK_F0Kh4oo_F3S_F000B^mH00<00>mHkeP0:nmH13OP
2>mH0c0O:NmH1OPConmH<nmH001:keP2000`keP4=n07keP2<1l/keP5n1?okeP^keP004[_F003003_
F>mH03?_F0@gh0G_F08`7bo_F0Ch4oo_F2[_F000B^mH00<00>mHkeP0=nmH13OP0nmH0S0O<NmH1?PC
onmH9^mH001:keP00`00keS_F00kkeP4=n000nmH<1l`7`0ckeP4n1?okePRkeP004[_F003003_F>mH
03o_F0@gh003<1o_F>mH03?_F0Gh4oo_F1g_F000<nmH10000nmH00<00>mHkeP00^mH0`002>mH00<0
0>mHkeP0@nmH13OP=nmH1?PConmH6NmH000ckeP00`00keS_F00<keP00`00keS_F005keP00`00keS_
F016keP00c0O=n0gh003=n0fkeP4n1?okePEkeP003C_F003003_F>mH00__F003003_F>mH00G_F0<0
04S_F0<`7`03kePgh3OP008gh3K_F0Ch4oo_F17_F000=NmH00<00>mHkeP01nmH0`002>mH00<00>mH
keP0BnmH0S0O0nmH13OP=^mH1?PConmH3NmH000fkeP00`00keS_F006keP00`00keS_F008keP00`00
keS_F01=keP3<1l4keP4=n0fkeP6n1?okeP7keP003?_F004003_F>mH0008keP00`00keS_F008keP0
0`00keS_F01@keP2<1l6keP5=n0gkeP5n1?okeP2keP003C_F08000W_F0@000O_F003003_F>mH05;_
F08`7`W_F0@gh3S_F0Gh4oc_F000B^mH00<00>mHkeP0E>mH0c0O2^mH13OP>NmH1?PCn>mH001:keP0
0`00keS_F01GkeP2<1l<keP4=n0ikeP4n1?dkeP004[_F003003_F>mH05W_F0<`7`g_F0<gh3[_F0Ch
4o3_F000B^mH0P00GNmH0S0O3^mH13OP>^mH1OPCjnmH001:keP00`00keS_F01NkeP2<1l@keP3=n0l
keP4n1?WkeP004[_F003003_F>mH063_F08`7a7_F0<gh3g_F0Ch4n?_F000B^mH00<00>mHkeP0H^mH
0S0O4^mH13OP?NmH1?PCgnmH001:keP00`00keS_F01TkeP2<1lDkeP3=n0nkeP3n1?LkeP004[_F003
003_F>mH06K_F08`7aG_F0<gh3k_F0Ch4mS_F000B^mH00<00>mHkeP0J>mH0S0O5^mH13OP?^mH0oPC
eNmH001:keP2001[keP00c0OkeS_F00GkeP3=n0nkeP3n1?BkeP004[_F003003_F>mH06__F08`7a[_
F0<gh3k_F0Ch4lk_F000B^mH00<00>mHkeP0KNmH0S0O6nmH13OP?^mH1?PCb^mH001:keP00`00keS_
F01_keP2<1lMkeP4=n0nkeP4n1?6keP004[_F003003_F>mH077_F08`7ao_F0@gh3k_F0Ch4l;_F000
B^mH00<00>mHkeP0LnmH0S0O8NmH13OP?^mH1?PC_^mH001:keP00`00keS_F01ekeP2<1lSkeP3=n0o
keP4n1>jkeP004[_F003003_F>mH07O_F08`7bC_F0<gh43_F0?h4kO_F000B^mH0P00N^mH0S0O9NmH
0cOP@>mH1?PC/nmH001:keP00`00keS_F01kkeP00c0OkeS_F00UkeP2=n12keP3n1>`keP004[_F003
003_F>mH07c_F08`7bO_F0<gh4;_F0?h4jg_F000B^mH00<00>mHkeP0O^mH0S0O:>mH0cOP@^mH0oPC
Z^mH001:keP00`00keS_F020keP00c0OkeS_F00XkeP3=n12keP4n1>VkeP004[_F003003_F>mH087_
F08`7b__F0<gh4?_F0?h4j?_F000B^mH00<00>mHkeP0PnmH00<`7nmHkeP0:nmH13OP@^mH0oPCX>mH
001:keP00`00keS_F024keP2<1l_keP3=n12keP4n1>LkeP004[_F08008O_F08`7c3_F0<gh4?_F0?h
4iW_F000B^mH00<00>mHkeP0R>mH00<`7nmHkeP0<>mH0cOP@nmH0oPCU^mH001:keP00`00keS_F029
keP2<1lckeP3=n13keP4n1>BkeP004[_F003003_F>mH08__F003<1o_F>mH03?_F0<gh4C_F0?h4ho_
F000B^mH00<00>mHkeP0S>mH0S0O=^mH0SOPANmH0oPCS>mH000okeP30008keP00`00keS_F02>keP2
<1lfkeP3=n15keP3n1>9keP004;_F003003_F>mH00G_F003003_F>mH093_F08`7cO_F0<gh4G_F0Ch
4hG_F000@^mH00<00>mHkeP01NmH0`00T^mH0S0O>>mH0cOPA^mH0oPCP^mH000okeP30008keP00`00
keS_F02DkeP00c0OkeS_F00hkeP3=n16keP3n1=okeP003o_F003003_F>mH00S_F003003_F>mH09G_
F08`7c__F0<gh4K_F0Ch4g__F000?nmH00<00>mHkeP02>mH00<00>mHkeP0UnmH0S0O?>mH0SOPB>mH
0oPCN>mH000okeP40007keP00`00keS_F02IkeP2<1llkeP3=n18keP3n1=ekeP004[_F003003_F>mH
09__F003<1o_F>mH03c_F0<gh4S_F0?h4g;_F000B^mH00<00>mHkeP0W>mH0S0O?nmH0cOPB>mH0_PC
L>mH001:keP00`00keS_F02NkeP00c0OkeS_F00okeP3=n17keP3n1=]keP004[_F0800:3_F08`7d;_
F08gh4S_F0?h4f[_F000B^mH00<00>mHkeP0XNmH00<`7nmHkeP0@NmH0cOPB>mH0oPCInmH001:keP0
0`00keS_F02RkeP2<1m4keP3=n18keP3n1=TkeP004[_F003003_F>mH0:C_F08`7dG_F08gh4W_F0Ch
4f3_F000B^mH00<00>mHkeP0Y^mH00<`7nmHkeP0A>mH0cOPB^mH0oPCGNmH001:keP00`00keS_F02W
keP2<1m7keP3=n1:keP3n1=JkeP004[_F003003_F>mH0:W_F003<1o_F>mH04O_F0<gh4[_F0?h4eO_
F000B^mH0P00ZnmH0S0OB^mH0SOPBnmH0oPCE>mH001:keP00`00keS_F02/keP00c0OkeS_F019keP3
=n1;keP3n1=AkeP004[_F003003_F>mH0:g_F08`7dc_F0<gh4__F0;h4do_F000B^mH00<00>mHkeP0
[nmH00<`7nmHkeP0C>mH0cOPB^mH0oPCC>mH001:keP00`00keS_F02`keP2<1m?keP2=n1;keP3n1=9
keP004[_F003003_F>mH0;;_F003<1o_F>mH04k_F08gh4c_F0?h4dK_F000B^mH00<00>mHkeP0/nmH
0S0OD>mH0cOPC>mH0oPC@nmH001:keP00`00keS_F02ekeP00c0OkeS_F01@keP2=n1=keP2n1=1keP0
04[_F0800;O_F003<1o_F>mH057_F08gh4g_F0?h4ck_F000B^mH00<00>mHkeP0]nmH0S0ODnmH0SOP
C^mH0oPC>nmH001:keP00`00keS_F02ikeP00c0OkeS_F01BkeP3=n1>keP2n1<ikeP004[_F003003_
F>mH0;[_F08`7eG_F08gh4k_F0;h4cO_F000B^mH00<00>mHkeP0_>mH00<`7nmHkeP0E>mH0cOPQ>mH
001:keP00`00keS_F02mkeP2<1mGkeP2=n22keP004[_F003003_F>mH0;o_F003<1o_F>mH05K_F08g
h83_F000B^mH00<00>mHkeP0`>mH00<`7nmHkeP0EnmH0cOPONmH001:keP20032keP2<1mJkeP2=n1k
keP004[_F003003_F>mH0<?_F003<1o_F>mH05W_F0<gh7S_F000B^mH00<00>mHkeP0a>mH0S0OG>mH
0SOPM^mH001:keP00`00keS_F036keP00c0OkeS_F01KkeP3=n1ckeP004[_F003003_F>mH0<O_F08`
7ek_F08gh77_F000=>mH00<00>mHkeP00nmH00<00>mHkeP00^mH0`002>mH00<00>mHkeP0bNmH00<`
7nmHkeP0GNmH0SOPKnmH000dkeP00`00keS_F00;keP00`00keS_F005keP00`00keS_F03:keP00c0O
keS_F01NkeP3=n1/keP003G_F003003_F>mH00[_F003003_F>mH00G_F0<00<__F08`7f7_F08gh6[_
F000=NmH00<00>mHkeP01nmH0`002>mH00<00>mHkeP0cNmH00<`7nmHkeP0H>mH0cOPInmH000fkeP0
0`00keS_F006keP00`00keS_F008keP00`00keS_F03>keP2<1mSkeP2=n1UkeP003?_F004003_F>mH
0008keP00`00keS_F008keP00`00keS_F03@keP00c0OkeS_F01RkeP2=n1SkeP003?_F0@000S_F0@0
00O_F003003_F>mH0=7_F003<1o_F>mH06?_F0<gh63_F000B^mH00<00>mHkeP0d^mH0S0OI^mH0SOP
G^mH001:keP00`00keS_F03DkeP00c0OkeS_F01UkeP2=n1LkeP004[_F003003_F>mH0=G_F08`7fO_
F08gh5[_F000B^mH0P00f>mH00<`7nmHkeP0I^mH0cOPEnmH001:keP00`00keS_F03HkeP2<1mYkeP2
=n1EkeP004[_F003003_F>mH0=[_F003<1o_F>mH06S_F0<gh5;_F000B^mH00<00>mHkeP0fnmH00<`
7nmHkeP0J^mH0SOPD>mH001:keP00`00keS_F03LkeP2<1m/keP2=n1>keP004[_F003003_F>mH0=k_
F003<1o_F>mH06__F0<gh4__F000B^mH00<00>mHkeP0gnmH0S0OK^mH0SOPBNmH001:keP00`00keS_
F03QkeP00c0OkeS_F01]keP3=n16keP004[_F0800>?_F003<1o_F>mH06o_F08gh4C_F000B^mH00<0
0>mHkeP0hnmH0S0OLNmH0SOP@^mH001:keP00`00keS_F03UkeP00c0OkeS_F01`keP2=n10keP004[_
F003003_F>mH0>K_F003<1o_F>mH077_F08gh3k_F000B^mH00<00>mHkeP0inmH0S0OLnmH0SOP?>mH
001:keP00`00keS_F03YkeP00c0OkeS_F01bkeP2=n0jkeP004[_F003003_F>mH0>[_F003<1o_F>mH
07?_F08gh3S_F000B^mH0P00k>mH0S0OMNmH00<gh>mHkeP0=NmH001:keP00`00keS_F03]keP00c0O
keS_F02ZkeP004[_F003003_F>mH0>k_F003<1o_F>mH0:W_F000B^mH00<00>mHkeP0knmH00<`7nmH
keP0Z>mH001:keP00`00keS_F03`keP2<1nXkeP004[_F003003_F>mH0?;_F003<1o_F>mH0:G_F000
B^mH00<00>mHkeP0lnmH00<`7nmHkeP0Y>mH001:keP00`00keS_F03dkeP00c0OkeS_F02SkeP004[_
F0800?K_F003<1o_F>mH0:;_F000B^mH00<00>mHkeP0m^mH0S0OX^mH001:keP00`00keS_F03hkeP0
0c0OkeS_F02OkeP004[_F003003_F>mH0?W_F003<1o_F>mH09k_F000B^mH00<00>mHkeP0n^mH00<`
7nmHkeP0WNmH000ikeP40003keP20008keP00`00keS_F03kkeP00c0OkeS_F02LkeP003__F005003_
F>mHkeP00002keP00`00keS_F005keP00`00keS_F03lkeP2<1nLkeP003__F005003_F>mHkeP00002
keP00`00keS_F005keP3003nkeP00c0OkeS_F02IkeP003__F005003_F>mHkeP00002keP00`00keS_
F005keP00`00keS_F03okeP00c0OkeS_F02HkeP003__F005003_F>mHkeP00002keP00`00keS_F005
keP00`00keS_F03okeP1keP00c0OkeS_F02GkeP003W_F0<000?_F004003_F>mH0007keP00`00keS_
F03okeP2keP00c0OkeS_F02FkeP003__F003003_F>mH00;_F08000S_F003003_F>mH0?o_F0?_F08`
7iK_F000B^mH00<00>mHkeP0onmH1NmH00<`7nmHkeP0TnmH001:keP00`00keS_F03okeP6keP00c0O
keS_F02BkeP004[_F003003_F>mH0?o_F0O_F003<1o_F>mH097_F000B^mH0P00onmH2NmH00<`7nmH
keP0T>mH001:keP00`00keS_F03okeP9keP00c0OkeS_F02?keP004[_F003003_F>mH0?o_F0[_F003
<1o_F>mH08k_F000B^mH00<00>mHkeP0onmH2nmH0S0OS^mH001:keP00`00keS_F00nkeSW001ekeP0
04[_F003003_F>mH03k_F>L007G_F000B^mH00<00>mHkeP0?^mHi`00MNmH001:keP00`00keS_F00n
keSW001ekeP004[_F08003o_F>L007G_F000B^mH00<00>mHkeP0?^mHi`00MNmH001:keP00`00keS_
F00nkeSW001ekeP004[_F003003_F>mH03k_F>L007G_F000B^mH00<00>mHkeP0?^mHi`00MNmH001:
keP00`00keS_F00nkeSW001ekeP004[_F003003_F>mH03k_F>L007G_F000B^mH0P00<nmHl`00MNmH
001:keP00`00keS_F00bkeP00`00ooooo`3Tool<001ekeP004[_F003003_F>mH03;_F003003ooooo
0>Coo``007G_F000B^mH00<00>mHkeP0<^mH00<00?ooool0i?oo3000MNmH001:keP00`00keS_F00b
keP00`00ooooo`3Tool<001ekeP004[_F003003_F>mH03;_F003003ooooo0>Coo``007G_F000B^mH
00<00>mHkeP0<^mH00<00?ooool0i?oo3000MNmH001:keP00`00keS_F00bkeP00`00ooooo`3Tool<
001ekeP004[_F08003?_F003003ooooo0>Coo``007G_F000B^mH00<00>mHkeP0<^mH00<00?ooool0
7ooo10001?oo0P000_oo1@000_oo0`000_oo0`000_oo1000Y?oo3000MNmH001:keP00`00keS_F00b
keP00`00ooooo`0Pool01000ooooo`000_oo00@00?ooool000;oo`04003ooooo0003ool00`00oooo
o`02ool01000ooooo`000_oo00<00?ooool0Xooo3000MNmH001:keP00`00keS_F00bkeP00`00oooo
o`02oolH=n06ool01000ooooo`000_oo00@00?oo000000;oo`03003ooooo00Coo`03003ooooo00;o
o`<000?oo`03003oo`000:?oo``00003<1o_F>mH07;_F000B^mH00<00>mHkeP0<^mH00<00?ooool0
8?oo00@00?ooool000;oo`03003ooooo00?oo`<000Coo`03003ooooo00;oo`04003ooooo0002ool3
002Sool<00000nmH<1o_F01bkeP002g_F0@000;_F0@000?_F003003_F>mH00;_F0<000S_F003003_
F>mH03;_F003003ooooo023oo`04003ooooo0002ool01000ooooo`000_oo00X00?ooool00?oo003o
o`00ool000;oo`04003ooooo0002ool01000ooooo`00X_oo30000^mH00<`7nmHkeP0L>mH000_keP0
1@00keS_F>mH00003^mH00<00>mHkeP01NmH00<00>mHkeP0<^mH00<00?ooool07ooo10001?oo0P00
0_oo1@0000?oo`0000000`0000?oo`0000000P000_oo1@00X_oo30000nmH00<`7nmHkeP0KnmH000_
keP00`00keS_F002keP00`00keS_F00;keP00`00keS_F005keP3000bkeP00`00ooooo`3Tool<0004
keP00c0OkeS_F01^keP002o_F003003_F>mH00?_F003003_F>mH00O_F0<000S_F003003_F>mH03;_
F003003ooooo0>Coo``000G_F003<1o_F>mH06g_F000;nmH00<00>mHkeP01>mH00<00>mHkeP01^mH
00<00>mHkeP02>mH00<00>mHkeP0<^mH00<00?ooool0i?oo30001^mH00<`7nmHkeP0K>mH000]keP3
0003keP01000keS_F0002>mH00<00>mHkeP02>mH00<00>mHkeP0<^mH00<00?ooool0i?oo30001nmH
0S0OK>mH000_keP00`00keS_F002keP20009keP40007keP00`00keS_F00bkeP00`00ooooo`3Tool<
0009keP00c0OkeS_F01YkeP004[_F003003_F>mH03;_F003003ooooo0>Coo``000[_F003<1o_F>mH
06S_F000B^mH00<00>mHkeP0<^mH00<00?ooool0i?oo30002nmH00<`7nmHkeP0InmH001:keP00`00
keS_F00bkeP00`00ooooo`3Tool<000<keP00c0OkeS_F01VkeP004[_F08003?_F003003ooooo0>Co
o``000g_F003<1o_F>mH06G_F000B^mH00<00>mHkeP0<^mH00<00?ooool0i?oo30003^mH00<`7nmH
keP0I>mH001:keP00`00keS_F00bkeP00`00ooooo`3Tool<000?keP00c0OkeS_F01SkeP004[_F003
003_F>mH03;_F003003ooooo0>Coo``0013_F003<1o_F>mH06;_F000B^mH00<00>mHkeP0<^mH00<0
0?ooool07ooo0P0000?oo`0000000ooo0P0000?oo`00ool00_oo0P000_oo10000_oo1`0000?oo`00
00002_oo0P000ooo0P002?oo0P0000?oo`0000000ooo0P0000?oo`00ool00_oo0P000_oo10000_oo
1`0000?oo`000000I_oo30004NmH00<`7nmHkeP0HNmH001:keP00`00keS_F00bkeP00`00ooooo`0O
ool01@00oooooooo00000_oo00@00?ooool000?oo`04003ooooo0002ool00`00ooooo`04ool01`00
oooooooo003oo`0000[oo`06003ooooo003oo`000_oo00<00?ooool01Ooo00D00?ooooooo`0000;o
o`04003ooooo0003ool01000ooooo`000_oo00<00?ooool01?oo00L00?ooooooo`00ool0001Wool<
000BkeP00c0OkeS_F01PkeP004[_F003003_F>mH03;_F003003ooooo00;ooaSh4`Goo`05003oo`00
ool00003ool30003ool00`00ooooo`03ool00`00ooooo`04ool00`00ooooo`02ool00`00ooooo`09
ool00`00ooooo`02ool01000ooooo`001ooo00D00?oo003oo`0000?oo`<000?oo`03003ooooo00?o
o`03003ooooo00Coo`03003ooooo00;oo`03003ooooo06Koo``001?_F08`7f3_F000B^mH00<00>mH
keP0<^mH00<00?ooool07ooo00D00?oo003oo`0000Goo`05003oooooool00005ool00`00ooooo`04
ool01`00oooooooo003oo`0000[oo`03003ooooo00;oo`04003ooooo0007ool01@00ool00?oo0000
1Ooo00D00?ooooooo`0000Goo`03003ooooo00Coo`07003oooooool00?oo0000Iooo30005NmH00<`
7nmHkeP0GNmH001:keP2000ckeP00`00ooooo`0Oool200000ooo00000003ool20003ool40002ool0
0`00ool000020002ool20002ool200000ooo00000008ool40003ool20008ool200000ooo00000003
ool20003ool40002ool00`00ool000020002ool20002ool200000ooo0000001Vool<000FkeP00c0O
keS_F01LkeP004[_F003003_F>mH03;_F003003ooooo01ooo`05003oooooool00009ool00`00oooo
o`0Kool00`00ooooo`0=ool01@00oooooooo00002Ooo00<00?ooool0N?oo30005nmH00<`7nmHkeP0
FnmH001:keP00`00keS_F00bkeP00`00ooooo`0]ool00`00ooooo`0:ool00`00ooooo`0>ool00`00
ooooo`0Kool00`00ooooo`0:ool00`00ooooo`1[ool<000HkeP00c0OkeS_F01JkeP004[_F003003_
F>mH03;_F003003ooooo0>Coo``001W_F003<1o_F>mH05W_F000B^mH00<00>mHkeP0<^mH00<00?oo
ool0i?oo30006^mH00<`7nmHkeP0F>mH001:keP00`00keS_F00bkeP00`00ooooo`3Tool<000KkeP0
0c0OkeS_F01GkeP004[_F003003_F>mH03;_F003003ooooo0>Coo``001c_F003<1o_F>mH05K_F000
B^mH0P00<nmH00<00?ooool0i?oo30007NmH00<`7nmHkeP0ENmH001:keP00`00keS_F00bkeP00`00
ooooo`3Tool<000NkeP00c0OkeS_F01DkeP004[_F003003_F>mH03;_F003003ooooo0>Coo``001o_
F003<1o_F>mH05?_F000B^mH00<00>mHkeP0<^mH00<00?ooool0i?oo30008>mH00<`7nmHkeP0D^mH
001:keP00`00keS_F00bkeP00`00ooooo`3Tool<000QkeP00c0OkeS_F01AkeP004[_F003003_F>mH
03;_F003003ooooo0>Coo``002;_F003<1o_F>mH053_F000B^mH00<00>mHkeP0<^mH00<00?ooool0
i?oo30008nmH00<`7nmHkeP0CnmH001:keP00`00keS_F00bkeP00`00ooooo`0Oool200000ooo0000
0003ool200000ooo003oo`02ool200001Ooo00000000ool00P000_oo0`0000Goo`00ool00?oo0080
00;oo`800003ool00?oo00;oo`8000;oo`D000;oo`8000Coo`800003ool00?oo08;oo``002C_F003
<1o_F>mH04k_F000B^mH0P00<nmH00<00?ooool07ooo00D00?ooooooo`0000;oo`04003ooooo0003
ool01P00ooooo`00ool000;oo`04003ooooo0004ool01@00ool00?oo00000_oo00@00?ooool000?o
o`04003ooooo0003ool01@00oooooooo00000_oo00@00?ooool000;oo`03003ooooo08;oo``002G_
F003<1o_F>mH04g_F000B^mH00<00>mHkeP0<^mH00<00?ooool00_oo630O1Ooo00D00?oo003oo`00
00?oo`<000?oo`03003ooooo00;oo`04003ooooo0002ool30002ool01@00ool00?oo00000ooo0`00
0ooo00<00?ooool01?oo00D00?ooooooo`0000Koo`<008Coo`03003_F>mH02o_F003<1o_F>mH04c_
F000B^mH00<00>mHkeP0<^mH00<00?ooool07ooo00D00?oo003oo`0000Goo`05003oooooool00004
ool01000ooooo`000_oo00X00?ooool00?oo003oo`00ool000Goo`05003oooooool00006ool01@00
oooooooo00000_oo00<00?ooool00ooo00<00?ooool0P_oo00<00>mHkeP0<>mH00<`7nmHkeP0BnmH
001:keP00`00keS_F00bkeP00`00ooooo`0Oool200000ooo00000003ool20003ool40002ool30004
ool20002ool200000ooo003oo`03ool20003ool40003ool20004ool20004ool20025ool00`00keS_
F00akeP00c0OkeS_F01:keP004[_F003003_F>mH03;_F003003ooooo01ooo`05003oooooool00009
ool00`00ooooo`02ool00`00ooooo`0Fool00`00ooooo`2Fool00`00keS_F00bkeP00c0OkeS_F019
keP003W_F0@000;_F0<000S_F003003_F>mH03;_F003003ooooo02goo`04003oooooool2000Hool0
0`00ooooo`04ool00`00ooooo`2?ool00`00keS_F00ckeP00c0OkeS_F018keP003__F003003_F>mH
00C_F003003_F>mH00G_F003003_F>mH03;_F003003ooooo0>Coo`03003_F>mH03C_F003<1o_F>mH
04O_F000>nmH00<00>mHkeP01>mH00<00>mHkeP01NmH0`00<^mH00<00?ooool0i?oo00<00>mHkeP0
=NmH00<`7nmHkeP0A^mH000kkeP01000keS_F>mH0`002>mH00<00>mHkeP0<^mH00<00?ooool0i?oo
00<00>mHkeP0=^mH00<`7nmHkeP0ANmH000kkeP01@00keS_F>mH00002^mH00<00>mHkeP0<^mH00<0
0?ooool0i?oo00<00>mHkeP0=nmH00<`7nmHkeP0A>mH000ikeP30003keP00`00keS_F008keP00`00
keS_F00bkeP00`00ooooo`3Tool00`00keS_F00hkeP00c0OkeS_F013keP003__F004003_F>mHkeP4
0007keP00`00keS_F00bkeP00`00ooooo`3Tool00`00keS_F00ikeP00c0OkeS_F012keP004[_F003
003_F>mH03;_F>P003c_F003<1o_F>mH047_F000B^mH00<00>mHkeP0onmHF>mH00<`7nmHkeP0@>mH
001:keP00`00keS_F03okeQIkeP00c0OkeS_F00okeP004[_F0800?o_F5__F003<1o_F>mH03k_F000
B^mH00<00>mHkeP0onmHFnmH00<`7nmHkeP0?NmH001:keP00`00keS_F03okeQLkeP00c0OkeS_F00l
keP004[_F003003_F>mH0?o_F5g_F003<1o_F>mH03__F000B^mH00<00>mHkeP0onmHG^mH00<`7nmH
keP0>^mH001:keP00`00keS_F03okeQOkeP00c0OkeS_F00ikeP004[_F003003_F>mH0?o_F63_F003
<1o_F>mH03S_F000B^mH00<00>mHkeP0onmHHNmH00<`7nmHkeP0=nmH001:keP2003okeQSkeP00c0O
keS_F00fkeP004[_F003003_F>mH0?o_F6?_F003<1o_F>mH03G_F000B^mH00<00>mHkeP0onmHVnmH
001:keP00`00keS_F03okeRKkeP004[_F003003_F>mH0?o_F9__F000B^mH00<00>mHkeP0onmHVnmH
001:keP00`00keS_F03okeRKkeP004[_F003003_F>mH0?o_F9__F000onmHj>mH003okeSXkeP00?o_
F>S_F000onmHj>mH003okeSXkeP00?o_F>S_F000onmHj>mH003okeSXkeP00?o_F>S_F000onmHj>mH
003okeSXkeP00?o_F>S_F000onmHj>mH000fkeP30004keP30003keP20004keP20002keP300000nmH
00000002keP200000nmH003_F003003okeR;keP003K_F004003_F>mH0002keP00`00keS_F003keP0
1000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0001NmH00<00>mHkeP0
onmHR>mH000ikeP00`00keS_F0030003keP00`00keS_F003keP01000keS_F0000^mH00@00>mHkeP0
00;_F004003_F>mH0003keP2003okeR;keP003O_F08000?_F004003_F>mH0002keP01000keS_F000
0^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000^mH00<00>mHkeP0onmHRnmH000f
keP00`00keS_F004keP20004keP20004keP20002keP01000keP000001>mH0`000nmH0`00onmHR^mH
000gkeP3000MkeP00`00keS_F03okeR>keP005K_F0800?o_F93_F000onmHj>mH003okeSXkeP00?o_
F>S_F000onmHj>mH003okeSXkeP00?o_F>S_F000onmHj>mH0000\
\>"],
  ImageRangeCache->{{{0, 486}, {299.812, 0}} -> {-1.05193, -0.648936, \
0.00432892, 0.00432892}, {{11.9375, 474}, {292.625, 7.125}} -> {413.513, \
-1.40515, 2.51971, 0.0656714}, {{127.438, 358.5}, {103.688, 45.9375}} -> \
{-5.26505, -12.5978, 0.0405197, 0.0637236}, {{131.875, 156.562}, {100.812, \
85.125}} -> {-5.63392, -28.4693, 0.0425321, 0.137637}, {{131.875, 156.562}, \
{82.625, 66.9375}} -> {-5.63392, -30.9725, 0.0425321, 0.137637}, {{131.875, \
156.562}, {64.4375, 48.75}} -> {-5.63392, -33.4758, 0.0425321, 0.137637}},
  CellTags->"LUDec_vs_DGETRF"],

Cell[TextData[{
  "In Figure ",
  
  CounterBox["NumberedFigure", "LUDec_vs_DGETRF"],
  " again the blue line indicates the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " LUDecomposition, red the overhead for sending and receiving a matrix. The \
green line the LU decomposition done by the DGETRF routine. Again note that \
moving to an external program and doing some computation only really pays for \
matrices larger than a certain size. On this machine larger than 900 x 900. \
So we ",
  StyleBox["add the exporting threshold plus the external computational \
cost.",
    FontWeight->"Bold"],
  "\nDiscussion: As it can be seen, ",
  StyleBox["the largest part of computing the LU decomposition and sending it \
back is in the transfer of data.",
    FontWeight->"Bold"],
  "\nAnother point: ",
  StyleBox["Exporting also means double memory requirements.",
    FontWeight->"Bold"],
  " Only a copy of the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " kernel is send to the foreign program. This imposes a serious \
restriction. Since storing two copies of the matrix is very inefficient. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " should provide a mechanism to modify the kernel memory contends \
directly!"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Decomposition and back substitution with focus on the timing of the \
computation\
\>", "Subsubsection"],

Cell[TextData[{
  "The next step is to LU decompose the matrix and back substitute. This \
means sending a matrix ",
  StyleBox["and",
    FontWeight->"Bold"],
  " a load vector to the interface, solving the problem and receiving a \
solution vector. Thus the exporting overhead is ",
  Cell[BoxData[
      \(TraditionalForm\`N\^2 + \(\(2\)  \(N\)\(\ \)\)\)]],
  ". In Figure ",
  
  CounterBox["NumberedFigure", "LU_vs_ATLAS_LU"],
  " the blue line represents the cost in terms of time consumed for the LU \
decomposition and back substitution in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", the red line the cost for the external solution"
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0163141 0.0360263 [
[.30952 .00381 -9 -9 ]
[.30952 .00381 9 0 ]
[.5 .00381 -12 -9 ]
[.5 .00381 12 0 ]
[.69048 .00381 -12 -9 ]
[.69048 .00381 12 0 ]
[.88095 .00381 -12 -9 ]
[.88095 .00381 12 0 ]
[1.025 .01631 0 -4.90625 ]
[1.025 .01631 10 4.90625 ]
[.10655 .10638 -18 -4.5 ]
[.10655 .10638 0 4.5 ]
[.10655 .19645 -6 -4.5 ]
[.10655 .19645 0 4.5 ]
[.10655 .28651 -18 -4.5 ]
[.10655 .28651 0 4.5 ]
[.10655 .37658 -12 -4.5 ]
[.10655 .37658 0 4.5 ]
[.10655 .46664 -24 -4.5 ]
[.10655 .46664 0 4.5 ]
[.10655 .55671 -12 -4.5 ]
[.10655 .55671 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01631 m
.30952 .02256 L
s
[(800)] .30952 .00381 0 1 Mshowa
.5 .01631 m
.5 .02256 L
s
[(1000)] .5 .00381 0 1 Mshowa
.69048 .01631 m
.69048 .02256 L
s
[(1200)] .69048 .00381 0 1 Mshowa
.88095 .01631 m
.88095 .02256 L
s
[(1400)] .88095 .00381 0 1 Mshowa
.125 Mabswid
.16667 .01631 m
.16667 .02006 L
s
.21429 .01631 m
.21429 .02006 L
s
.2619 .01631 m
.2619 .02006 L
s
.35714 .01631 m
.35714 .02006 L
s
.40476 .01631 m
.40476 .02006 L
s
.45238 .01631 m
.45238 .02006 L
s
.54762 .01631 m
.54762 .02006 L
s
.59524 .01631 m
.59524 .02006 L
s
.64286 .01631 m
.64286 .02006 L
s
.7381 .01631 m
.7381 .02006 L
s
.78571 .01631 m
.78571 .02006 L
s
.83333 .01631 m
.83333 .02006 L
s
.07143 .01631 m
.07143 .02006 L
s
.02381 .01631 m
.02381 .02006 L
s
.92857 .01631 m
.92857 .02006 L
s
.97619 .01631 m
.97619 .02006 L
s
.25 Mabswid
0 .01631 m
1 .01631 L
s
gsave
1.025 .01631 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10638 m
.1253 .10638 L
s
[(2.5)] .10655 .10638 1 0 Mshowa
.11905 .19645 m
.1253 .19645 L
s
[(5)] .10655 .19645 1 0 Mshowa
.11905 .28651 m
.1253 .28651 L
s
[(7.5)] .10655 .28651 1 0 Mshowa
.11905 .37658 m
.1253 .37658 L
s
[(10)] .10655 .37658 1 0 Mshowa
.11905 .46664 m
.1253 .46664 L
s
[(12.5)] .10655 .46664 1 0 Mshowa
.11905 .55671 m
.1253 .55671 L
s
[(15)] .10655 .55671 1 0 Mshowa
.125 Mabswid
.11905 .03433 m
.1228 .03433 L
s
.11905 .05234 m
.1228 .05234 L
s
.11905 .07035 m
.1228 .07035 L
s
.11905 .08837 m
.1228 .08837 L
s
.11905 .12439 m
.1228 .12439 L
s
.11905 .14241 m
.1228 .14241 L
s
.11905 .16042 m
.1228 .16042 L
s
.11905 .17843 m
.1228 .17843 L
s
.11905 .21446 m
.1228 .21446 L
s
.11905 .23247 m
.1228 .23247 L
s
.11905 .25049 m
.1228 .25049 L
s
.11905 .2685 m
.1228 .2685 L
s
.11905 .30452 m
.1228 .30452 L
s
.11905 .32254 m
.1228 .32254 L
s
.11905 .34055 m
.1228 .34055 L
s
.11905 .35856 m
.1228 .35856 L
s
.11905 .39459 m
.1228 .39459 L
s
.11905 .4126 m
.1228 .4126 L
s
.11905 .43062 m
.1228 .43062 L
s
.11905 .44863 m
.1228 .44863 L
s
.11905 .48466 m
.1228 .48466 L
s
.11905 .50267 m
.1228 .50267 L
s
.11905 .52068 m
.1228 .52068 L
s
.11905 .5387 m
.1228 .5387 L
s
.11905 .57472 m
.1228 .57472 L
s
.11905 .59274 m
.1228 .59274 L
s
.11905 .61075 m
.1228 .61075 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02324 L
.10458 .03401 L
.14415 .04554 L
.18221 .05791 L
.22272 .07246 L
.26171 .08781 L
.30316 .10558 L
.34309 .12411 L
.3815 .14325 L
.42237 .16502 L
.46172 .18736 L
.49955 .21011 L
.53984 .2357 L
.57861 .26166 L
.61984 .29069 L
.65954 .32006 L
.69774 .3496 L
.73838 .38243 L
.77751 .41539 L
.81909 .45188 L
.85916 .48847 L
.89771 .52498 L
.93871 .56524 L
.97619 .60332 L
s
1 0 .6 r
.02381 .02762 m
.06244 .02974 L
.10458 .03225 L
.14415 .03481 L
.18221 .03745 L
.22272 .04045 L
.26171 .04352 L
.30316 .04699 L
.34309 .05053 L
.3815 .05411 L
.42237 .05812 L
.46172 .06218 L
.49955 .06625 L
.53984 .07077 L
.57861 .07531 L
.61984 .08034 L
.65954 .08538 L
.69774 .0904 L
.73838 .09594 L
.77751 .10146 L
.81909 .10753 L
.85916 .11357 L
.89771 .11957 L
.93871 .12615 L
.97619 .13234 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.2381 .38045 m
.2381 .49949 L
.71429 .49949 L
.71429 .38045 L
F
1 g
.21429 .40426 m
.21429 .5233 L
.69048 .5233 L
.69048 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.21429 .40426 m
.69048 .40426 L
.69048 .5233 L
.21429 .5233 L
.21429 .40426 L
s
% Start of sub-graphic
p
0.214286 0.404255 0.690476 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00710227 0.0710227 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0127841 0.126068 0.0838068 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0483 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0951705 0.126068 0.166193 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .13068 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .20739 -108 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(One) show
87.000 11.250 moveto
(load) show
117.000 11.250 moveto
(vector) show
153.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
  ImageSize->{449, 277.375},
  ImageMargins->{{83, 10}, {10, 9}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007100015A000`40n007h00OonmH`^mH003okeS2
keP00?o_F<;_F000onmH`^mH003okeS2keP00?o_F<;_F000onmH`^mH003okeS2keP00?o_F<;_F000
Q^mH0P001>mH0P001>mH0P00=nmH10000nmH0P001>mH0P001>mH0P00=>mH10000^mH10000nmH0P00
1>mH0P00<nmH10001>mH00<00>mHkeP00^mH0P001>mH0P00D>mH0025keP01000keS_F0000^mH00@0
0>mHkeP000;_F004003_F>mH000hkeP01@00keS_F>mH00000^mH00@00>mHkeP000;_F004003_F>mH
0002keP00`00keS_F00ckeP01@00keS_F>mH00001NmH00@00>mHkeP000;_F004003_F>mH000dkeP0
0`00keS_F003keP01@00keS_F>mH00000^mH00@00>mHkeP000;_F003003_F>mH04g_F000QNmH00@0
0>mHkeP000;_F004003_F>mH0002keP01000keS_F000>>mH00D00>mHkeS_F00000;_F004003_F>mH
0002keP01000keS_F0000^mH00<00>mHkeP0<nmH00<00>mHkeP00^mH00<00>mHkeP00^mH00@00>mH
keP000;_F004003_F>mH000dkeP00`00keS_F0050002keP01000keS_F0000^mH00@00>mHkeP004o_
F000Q^mH0P000nmH00@00>mHkeP000;_F004003_F>mH000hkeP01@00keS_F>mH00000^mH00@00>mH
keP000;_F004003_F>mH0002keP00`00keS_F00ckeP00`00keS_F003keP01@00keS_F>mH00000^mH
00@00>mHkeP000;_F003003_F>mH03;_F004003_F>mH0002keP01@00keS_F>mH00000^mH00@00>mH
keP000;_F003003_F>mH04g_F000QNmH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F000
>>mH00D00>mHkeS_F00000;_F004003_F>mH0002keP01000keS_F0000^mH00<00>mHkeP0<nmH00<0
0>mHkeP01>mH00@00>mHkeP000;_F004003_F>mH0002keP00`00keS_F00bkeP01`00keS_F>mH003_
F00000?_F004003_F>mH0002keP01000keS_F000CnmH0014keP00`00keS_F00nkeP01000keS_F000
0^mH00@00>mHkeP000;_F004003_F>mH000fkeP30003keP01000keS_F0000^mH00@00>mHkeP000;_
F004003_F>mH000ckeP30003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000bkeP3
0004keP20003keP01000keS_F0000^mH00@00>mHkeP004o_F000A>mH00<00>mHkeP0?nmH0P001>mH
0P001>mH0P00>NmH00<00>mHkeP00^mH0P001>mH0P001>mH0P00=^mH00<00>mHkeP00^mH0P001>mH
0P001>mH0P00=NmH00<00>mHkeP00nmH00<00>mHkeP00^mH0P001>mH0P00D>mH0014keP00`00keS_
F03okeQkkeP004C_F003003_F>mH0?o_F7__F000A>mH00<00>mHkeP0onmHNnmH0014keP00`00keS_
F03okeQJkeP20002keP00`00keS_F00JkeP0023_F0<`7b7_F003003_F>mH0?o_F5__F004003_F>mH
000LkeP001O_F0`000D`7ol006l000__F004003_F000000LkeP0023_F003003_F>mH00G_F0@`7`K_
F003003_F>mH00o_F003003_F>mH00o_F003003_F>mH00o_F003003_F>mH013_F003003_F>mH00o_
F003003_F>mH00o_F003003_F>mH00o_F003003_F>mH00o_F003003_F>mH013_F003003_F>mH00o_
F003003_F>mH00o_F003003_F>mH00o_F003003_F>mH013_F003003_F>mH00o_F003003_F>mH00o_
F003003_F>mH00o_F003003_F>mH00o_F003003_F>mH013_F003003_F>mH00o_F003003_F>mH01;_
F0800003keP00>mH01__F000;>mH1C0O4nmH00<00>mHkeP0A^mH00<00>mHkeP0A^mH00<00>mHkeP0
A^mH00<00>mHkeP0ANmH00<00>mHkeP0=nmH00@00>mHkeP001c_F000<NmH130O3nmH00<00>mHkeP0
onmHF^mH0P0000?_F00000007>mH000PkeP8n1<=keP4<1l;keP00`00keS_F03okeQkkeP002S_F0oh
4`;_F0@`7`O_F003003_F>mH0?o_F7__F000=nmH4?PConmHNnmH0011keP3<1l00`00keS_F00?n1?o
keQ/keP004C_F0<`7`o_F0oh4oo_F5g_F000A>mH00<00>mHkeP00c0O6nmH3oPConmHC^mH0014keP0
0`00keS_F003keP3<1lWkeP?n1?okePokeP004C_F003003_F>mH00K_F0<`7c?_F0ch4oo_F3?_F000
A>mH00<00>mHkeP02NmH130O>nmH2?PConmH:nmH0014keP2000>keP3<1m0keP;n1?okePPkeP004C_
F003003_F>mH013_F0@`7dO_F0_h4oo_F1G_F000A>mH00<00>mHkeP05>mH0c0OCnmH2?PConmH3NmH
0014keP00`00keS_F00GkeP3<1mDkeP;n1?okeP2keP004C_F003003_F>mH01[_F08`7eg_F0_h4oK_
F000A>mH00<00>mHkeP07>mH0c0OINmH2?PCk^mH0014keP00`00keS_F00OkeP3<1mZkeP;n1?SkeP0
04C_F08002?_F08`7g?_F0_h4mS_F000A>mH00<00>mHkeP09>mH0c0ONnmH2?PCd>mH0014keP00`00
keS_F00WkeP2<1n1keP8n1?8keP004C_F003003_F>mH02W_F0<`7hK_F0Sh4l3_F000A>mH00<00>mH
keP0;>mH0S0OS>mH1oPC^NmH0014keP00`00keS_F00^keP3<1n@keP8n1>akeP004C_F003003_F>mH
037_F08`7iK_F0Oh4j[_F000A>mH0P00=>mH0c0OV^mH1oPCXnmH0014keP00`00keS_F00fkeP2<1nO
keP8n1>KkeP004C_F003003_F>mH03S_F08`7jG_F0Sh4i?_F000A>mH00<00>mHkeP0>^mH0S0OZnmH
1oPCS>mH0014keP00`00keS_F00lkeP2<1n`keP8n1>4keP002k_F0@000?_F003003_F>mH00;_F0<0
00O_F003003_F>mH03k_F08`7kK_F0Sh4gc_F000;^mH00<00>mHkeP03>mH00<00>mHkeP01>mH00<0
0>mHkeP0@>mH0S0O_>mH2?PCM>mH000_keP00`00keS_F00;keP00`00keS_F004keP30012keP3<1o1
keP6n1=^keP0033_F003003_F>mH00O_F0<000O_F003003_F>mH04G_F08`7lG_F0Gh4fW_F000<NmH
00<00>mHkeP01^mH00<00>mHkeP01nmH00<00>mHkeP0AnmH0S0Ob>mH1OPCI>mH000^keP01000keS_
F0002>mH00<00>mHkeP01nmH00<00>mHkeP0BNmH0c0Ob^mH1_PCG^mH000_keP20009keP40006keP0
0`00keS_F01<keP2<1o>keP8n1=FkeP004C_F003003_F>mH04k_F08`7mC_F0Kh4e3_F000A>mH00<0
0>mHkeP0D>mH0S0Of>mH1OPCBnmH0014keP2001CkeP3<1oJkeP5n1=6keP004C_F003003_F>mH05G_
F08`7mg_F0Kh4d3_F000A>mH00<00>mHkeP0EnmH0S0OhNmH2?PC>>mH0014keP00`00keS_F01IkeP2
<1oWkeP4n1<dkeP004C_F003003_F>mH05__F08`7oo_F1k_F000A>mH00<00>mHkeP0GNmH0S0OonmH
7>mH0014keP00`00keS_F01OkeP2<1ookePJkeP004C_F08006;_F08`7oo_F1S_F000A>mH00<00>mH
keP0HnmH0S0OonmH5^mH0014keP00`00keS_F01UkeP2<1ookePDkeP004C_F003003_F>mH06O_F08`
7oo_F1;_F000A>mH00<00>mHkeP0JNmH0S0OonmH4>mH0014keP00`00keS_F01[keP2<1ookeP>keP0
04C_F003003_F>mH06g_F08`7oo_F0c_F000A>mH0P00L>mH0S0OonmH2^mH0014keP00`00keS_F01a
keP00c0OkeS_F03okeP7keP004C_F003003_F>mH07;_F08`7oo_F0O_F000A>mH00<00>mHkeP0M>mH
0S0OonmH1NmH0014keP00`00keS_F01fkeP00c0OkeS_F03okeP2keP004C_F003003_F>mH07O_F08`
7oo_F0;_F000A>mH00<00>mHkeP0NNmH0S0OonmH0014keP2001lkeP00c0OkeS_F03lkeP004C_F003
003_F>mH07c_F08`7oc_F000A>mH00<00>mHkeP0O^mH0S0On^mH0014keP00`00keS_F020keP00c0O
keS_F03gkeP003[_F0<000O_F003003_F>mH087_F08`7oO_F000?NmH00<00>mHkeP01>mH00<00>mH
keP0PnmH0S0OmNmH000mkeP00`00keS_F004keP30025keP00c0OkeS_F03bkeP003[_F0<000O_F003
003_F>mH08K_F08`7o;_F000>^mH00<00>mHkeP01nmH00<00>mHkeP0R>mH0S0Ol>mH000jkeP00`00
keS_F007keP00`00keS_F02:keP00c0OkeS_F03]keP003[_F0@000K_F003003_F>mH08__F08`7ng_
F000A>mH00<00>mHkeP0SNmH0S0OjnmH0014keP00`00keS_F02?keP00c0OkeS_F03XkeP004C_F080
097_F08`7nS_F000A>mH00<00>mHkeP0T^mH0S0Oi^mH0014keP00`00keS_F02DkeP00c0OkeS_F03S
keP004C_F003003_F>mH09G_F08`7n?_F000A>mH00<00>mHkeP0UnmH0S0OhNmH0014keP00`00keS_
F02IkeP00c0OkeS_F03NkeP004C_F003003_F>mH09[_F08`7mk_F000A>mH0P00WNmH0S0Og>mH0014
keP00`00keS_F02NkeP00c0OkeS_F03IkeP004C_F003003_F>mH09o_F08`7mW_F000A>mH00<00>mH
keP0XNmH00<`7nmHkeP0e^mH0014keP00`00keS_F02RkeP2<1oFkeP004C_F003003_F>mH0:C_F003
<1o_F>mH0=?_F000A>mH00<00>mHkeP0YNmH0S0OdnmH0014keP2002XkeP00c0OkeS_F03@keP004C_
F003003_F>mH0:S_F08`7m3_F000A>mH00<00>mHkeP0Z^mH00<`7nmHkeP0cNmH0014keP00`00keS_
F02[keP2<1o=keP004C_F003003_F>mH0:g_F003<1o_F>mH0<[_F000A>mH00<00>mHkeP0[^mH0S0O
b^mH0014keP00`00keS_F02`keP00c0OkeS_F037keP004C_F0800;;_F08`7lO_F000A>mH00<00>mH
keP0/nmH00<`7nmHkeP0a>mH0014keP00`00keS_F02dkeP2<1o4keP004C_F003003_F>mH0;K_F003
<1o_F>mH0<7_F000A>mH00<00>mHkeP0]nmH00<`7nmHkeP0`>mH000_keP00`00keS_F003keP00`00
keS_F002keP30007keP00`00keS_F02hkeP2<1o0keP002o_F003003_F>mH00__F003003_F>mH00C_
F003003_F>mH0;[_F003<1o_F>mH0;g_F000<>mH00<00>mHkeP02^mH00<00>mHkeP01>mH0`00^nmH
0S0O_NmH000`keP00`00keS_F007keP30007keP00`00keS_F02mkeP00c0OkeS_F02jkeP0037_F003
003_F>mH00K_F003003_F>mH00O_F003003_F>mH0;k_F003<1o_F>mH0;W_F000;^mH00@00>mHkeP0
00S_F003003_F>mH00O_F003003_F>mH0;o_F08`7kW_F000;^mH10002>mH10001^mH00<00>mHkeP0
`NmH00<`7nmHkeP0]^mH0014keP00`00keS_F032keP00c0OkeS_F02ekeP004C_F003003_F>mH0<?_
F003<1o_F>mH0;C_F000A>mH0P00aNmH0S0O]>mH0014keP00`00keS_F036keP00c0OkeS_F02akeP0
04C_F003003_F>mH0<O_F003<1o_F>mH0;3_F000A>mH00<00>mHkeP0b>mH00<`7nmHkeP0[nmH0014
keP00`00keS_F039keP2<1n_keP004C_F003003_F>mH0<__F003<1o_F>mH0:c_F000A>mH00<00>mH
keP0c>mH00<`7nmHkeP0ZnmH0014keP2003>keP00c0OkeS_F02ZkeP004C_F003003_F>mH0<k_F08`
7j[_F000A>mH00<00>mHkeP0d>mH00<`7nmHkeP0YnmH0014keP00`00keS_F03AkeP00c0OkeS_F02V
keP004C_F003003_F>mH0=;_F08`7jK_F000A>mH00<00>mHkeP0e>mH00<`7nmHkeP0XnmH0014keP2
003FkeP00c0OkeS_F02RkeP004C_F003003_F>mH0=K_F003<1o_F>mH0:7_F000A>mH00<00>mHkeP0
enmH0S0OXNmH0014keP00`00keS_F03IkeP00c0OkeS_F02NkeP004C_F003003_F>mH0=[_F003<1o_
F>mH09g_F000A>mH00<00>mHkeP0fnmH0S0OWNmH0014keP00`00keS_F03MkeP00c0OkeS_F02JkeP0
04C_F0800=o_F003<1o_F>mH09W_F000A>mH00<00>mHkeP0gnmH0S0OVNmH0014keP00`00keS_F03Q
keP00c0OkeS_F02FkeP004C_F003003_F>mH0>;_F003<1o_F>mH09G_F000A>mH00<00>mHkeP0hnmH
0S0OUNmH000dkeP40003keP20007keP00`00keS_F03UkeP00c0OkeS_F02BkeP003K_F005003_F>mH
keP00002keP00`00keS_F004keP00`00keS_F03VkeP00c0OkeS_F02AkeP003K_F005003_F>mHkeP0
0002keP00`00keS_F004keP3003WkeP2<1nAkeP003K_F005003_F>mHkeP00002keP00`00keS_F004
keP00`00keS_F03YkeP00c0OkeS_F02>keP003K_F005003_F>mHkeP00002keP00`00keS_F004keP0
0`00keS_F03ZkeP00c0OkeS_F02=keP003C_F0<000?_F004003_F>mH0006keP00`00keS_F03[keP0
0c0OkeS_F02<keP003K_F003003_F>mH00;_F08000O_F003003_F>mH0>c_F003<1o_F>mH08__F000
A>mH00<00>mHkeP0kNmH0S0ORnmH0014keP00`00keS_F03_keP00c0OkeS_F028keP004C_F0800?7_
F003<1o_F>mH08O_F000A>mH00<00>mHkeP0lNmH00<`7nmHkeP0Q^mH0014keP00`00keS_F03bkeP0
0c0OkeS_F025keP004C_F003003_F>mH0??_F003<1o_F>mH08C_F000A>mH00<00>mHkeP0m>mH00<`
7nmHkeP0PnmH0014keP00`00keS_F03ekeP2<1n3keP004C_F003003_F>mH02?_F=D008;_F000A>mH
0P009>mHe@0000<`7nmHkeP0OnmH0014keP00`00keS_F00SkeSE00000nmH<1o_F01okeP004C_F003
003_F>mH02?_F=D000;_F003<1o_F>mH07g_F000A>mH00<00>mHkeP08nmHe@000nmH00<`7nmHkeP0
O>mH0014keP00`00keS_F00SkeSE0004keP2<1mlkeP004C_F003003_F>mH02?_F=D000K_F003<1o_
F>mH07W_F000A>mH00<00>mHkeP08nmHe@001nmH00<`7nmHkeP0N>mH0014keP2000TkeSE0008keP0
0c0OkeS_F01gkeP004C_F003003_F>mH02?_F=D000W_F003<1o_F>mH07K_F000A>mH00<00>mHkeP0
6NmHg`002^mH00<`7nmHkeP0MNmH0014keP00`00keS_F00IkeP00`00ooooo`3Bool:000;keP00c0O
keS_F01dkeP004C_F003003_F>mH01W_F003003ooooo0=;oo`X000c_F08`7gC_F000A>mH00<00>mH
keP06NmH00<00?ooool0d_oo2P003^mH00<`7nmHkeP0LNmH0014keP00`00keS_F00IkeP00`00oooo
o`3Bool:000?keP00c0OkeS_F01`keP004C_F08001[_F003003ooooo0=;oo`X0013_F003<1o_F>mH
06o_F000A>mH00<00>mHkeP06NmH00<00?ooool0d_oo2P004NmH00<`7nmHkeP0K^mH0014keP00`00
keS_F00IkeP00`00ooooo`3Bool:000BkeP00c0OkeS_F01]keP004C_F003003_F>mH01W_F003003o
oooo0=;oo`X001?_F003<1o_F>mH06c_F000A>mH00<00>mHkeP06NmH00<00?ooool07?oo0P000_oo
0P0000Coo`00000000;oo`D00003ool0000000;oo`800004ool00000002Jool:000DkeP00c0OkeS_
F01[keP002S_F0@000;_F0@000?_F003003_F>mH00;_F0<000O_F003003_F>mH01W_F004003ooooo
oolGn1<5ool01000ooooo`000ooo00<00?ooool00_oo00@00?ooool000;oo`04003ooooo0002ool0
1000ooooo`00VOoo2P005NmH00<`7nmHkeP0J^mH000ZkeP01@00keS_F>mH00003^mH00<00>mHkeP0
1>mH00<00>mHkeP06NmH00<00?ooool07Ooo10000ooo00<00?ooool00_oo00<00?ooool00ooo1000
1Ooo00<00?ooool0Uooo2P005^mH00<`7nmHkeP0JNmH000ZkeP00`00keS_F002keP00`00keS_F00;
keP00`00keS_F004keP3000IkeP00`00ooooo`0Mool01000ooooo`000ooo00<00?ooool00_oo00<0
0?ooool00ooo00@00?ooool000?oo`8009[oo`X001O_F003<1o_F>mH06S_F000:^mH00<00>mHkeP0
0nmH00<00>mHkeP01nmH0`001nmH00<00>mHkeP06NmH00<00?ooool07_oo00T00?oo003oo`00ool0
0?oo00000_oo00<00?ooool01?oo00<00?oo00000_oo00<00?ooool0V_oo2P006>mH0S0OJ>mH000Z
keP00`00keS_F004keP00`00keS_F006keP00`00keS_F007keP00`00keS_F00IkeP00`00ooooo`0M
ool30002ool500001?oo000000001?oo0`001?oo0`00VOoo2P006^mH00<`7nmHkeP0INmH000XkeP3
0003keP01000keS_F0002>mH00<00>mHkeP01nmH00<00>mHkeP06NmH00<00?ooool0d_oo2P006nmH
00<`7nmHkeP0I>mH000ZkeP00`00keS_F002keP20009keP40006keP00`00keS_F00IkeP00`00oooo
o`3Bool:000LkeP00c0OkeS_F01SkeP004C_F003003_F>mH01W_F003003ooooo0=;oo`X001g_F003
<1o_F>mH06;_F000A>mH00<00>mHkeP06NmH00<00?ooool0d_oo2P007^mH00<`7nmHkeP0HNmH0014
keP2000JkeP00`00ooooo`3Bool:000OkeP00c0OkeS_F01PkeP004C_F003003_F>mH01W_F003003o
oooo0=;oo`X0023_F003<1o_F>mH05o_F000A>mH00<00>mHkeP06NmH00<00?ooool0d_oo2P008NmH
00<`7nmHkeP0G^mH0014keP00`00keS_F00IkeP00`00ooooo`3Bool:000RkeP00c0OkeS_F01MkeP0
04C_F003003_F>mH01W_F003003ooooo0=;oo`X002?_F003<1o_F>mH05c_F000A>mH00<00>mHkeP0
6NmH00<00?ooool0d_oo2P009>mH00<`7nmHkeP0FnmH0014keP2000JkeP00`00ooooo`3Bool:000U
keP00c0OkeS_F01JkeP004C_F003003_F>mH01W_F003003ooooo01coo`800003ool0000000?oo`80
0003ool00?oo00;oo`800005ool00000003oo`020002ool300001Ooo003oo`00ool00P000_oo0P00
00?oo`00ool00_oo0P000_oo1@000_oo0P001?oo0P0000?oo`00ool0Looo2P009^mH00<`7nmHkeP0
FNmH0014keP00`00keS_F00IkeP00`00ooooo`0Lool01@00oooooooo00000_oo00@00?ooool000?o
o`06003ooooo003oo`000_oo00@00?ooool000Coo`05003oo`00ool00002ool01000ooooo`000ooo
00@00?ooool000?oo`05003oooooool00002ool01000ooooo`000_oo00<00?ooool0Looo2P009nmH
0S0OFNmH0014keP00`00keS_F00IkeP01000oooooooo5c0O1?oo00D00?oo003oo`0000?oo`<000?o
o`03003ooooo00;oo`04003ooooo0002ool30002ool01@00ool00?oo00000ooo0`000ooo00<00?oo
ool01?oo00D00?ooooooo`0000Koo`<007Goo`X002W_F003<1o_F>mH05K_F000A>mH00<00>mHkeP0
6NmH00<00?ooool07?oo00D00?oo003oo`0000Goo`05003oooooool00004ool01000ooooo`000_oo
00X00?ooool00?oo003oo`00ool000Goo`05003oooooool00006ool01@00oooooooo00000_oo00<0
0?ooool00ooo00<00?ooool0Looo2P00:^mH00<`7nmHkeP0ENmH0014keP00`00keS_F00IkeP00`00
ooooo`0Lool200000ooo00000003ool20003ool40002ool30004ool20002ool200000ooo003oo`03
ool20003ool40003ool20004ool20004ool2001fool:000[keP00c0OkeS_F01DkeP004C_F003003_
F>mH01W_F003003ooooo01coo`05003oooooool00009ool00`00ooooo`02ool00`00ooooo`0Fool0
0`00ooooo`27ool:000/keP00c0OkeS_F01CkeP004C_F08001[_F003003ooooo02[oo`04003ooooo
ool2000Hool00`00ooooo`04ool00`00ooooo`20ool:000]keP00c0OkeS_F01BkeP004C_F003003_
F>mH01W_F003003ooooo0=;oo`X002k_F003<1o_F>mH057_F000A>mH00<00>mHkeP06NmH00<00?oo
ool0d_oo2P00;nmH00<`7nmHkeP0D>mH0014keP00`00keS_F00IkeP00`00ooooo`3Bool:000`keP0
0c0OkeS_F01?keP004C_F003003_F>mH01W_F003003ooooo0=;oo`X0037_F003<1o_F>mH04k_F000
A>mH00<00>mHkeP06NmH00<00?ooool0d_oo2P00<^mH00<`7nmHkeP0CNmH0014keP00`00keS_F00I
keP00`00ooooo`3Bool:000ckeP00c0OkeS_F01<keP004C_F08001[_F003003ooooo0=;oo`X003C_
F003<1o_F>mH04__F000A>mH00<00>mHkeP06NmH00<00?ooool0d_oo2P00=NmH00<`7nmHkeP0B^mH
0014keP00`00keS_F00IkeP00`00ooooo`3Bool:000fkeP00c0OkeS_F019keP004C_F003003_F>mH
01W_F003003ooooo0=;oo`X003O_F003<1o_F>mH04S_F000A>mH00<00>mHkeP06NmH00<00?ooool0
??oo0P000_oo0`0000?oo`0000000_oo0`002?oo1@000_oo0P001?oo0P0000Coo`00ooooo`800003
ool00?oo00Soo`03003ooooo00;oo`<000?oo`8000Goo`8000?oo`8000?oo`@003ooo`03003_F>mH
03o_F003<1o_F>mH04O_F000=>mH10000^mH0`001nmH00<00>mHkeP06NmH00<00?ooool0>ooo00@0
0?ooool000;oo`04003ooooo0002ool00`00ooooo`0;ool01@00oooooooo00000_oo00@00?ooool0
00;oo`04003ooooo0002ool00`00ooooo`07ool00`00ool00002ool00`00ooooo`03ool01000oooo
o`000ooo00H00?ooool00?oo0002ool01@00oooooooo0000@Ooo00<00>mHkeP0@>mH00<`7nmHkeP0
A^mH000fkeP00`00keS_F004keP00`00keS_F004keP00`00keS_F00IkeP00`00ooooo`0kool01000
ooooo`000_oo00@00?ooool000;oo`<000_oo`05003oooooool00002ool01000oooooooo0`000_oo
00@00?ooool000Woo`03003oo`0000;oo`<000?oo`03003ooooo00Coo`03003ooooo00;oo`04003o
oooo0003ool00`00ooooo`0oool00`00keS_F011keP00c0OkeS_F015keP003K_F003003_F>mH00C_
F003003_F>mH00C_F0<001W_F003003ooooo03_oo`04003ooooo0002ool01000ooooo`000_oo00@0
0?ooool000[oo`05003oooooool00002ool00`00ooooo`03ool01000ooooo`000_oo00<00?ooool0
1_oo00L00?ooooooo`00ool00002ool01000ooooo`000_oo00D00?ooooooo`0000Coo`04003ooooo
0003ool00`00ooooo`0oool00`00keS_F012keP00c0OkeS_F014keP003K_F004003_F>mHkeP30007
keP00`00keS_F00IkeP00`00ooooo`0kool01`00ooooo`00ool00?oo008000Coo`8000_oo`03003o
oooo00;oo`8000Coo`8000Coo`<000Ooo`8000;oo`8000;oo`8000Coo`8000?oo`@000?oo`8000?o
o`03003oo`00008003koo`03003_F>mH04?_F003<1o_F>mH04?_F000=^mH00D00>mHkeS_F00000W_
F003003_F>mH01W_F003003ooooo03coo`8001Ooo`03003ooooo013oo`03003ooooo01Woo`03003o
oooo04_oo`03003_F>mH04C_F003<1o_F>mH04;_F000=>mH0`000nmH00<00>mHkeP01nmH00<00>mH
keP06NmH00<00?ooool0E?oo0P004Ooo0P006ooo00<00?ooool0Booo00<00>mHkeP0ANmH00<`7nmH
keP0@NmH000fkeP01000keS_F>mH10001^mH00<00>mHkeP06NmH00<00?ooool0d_oo00<00>mHkeP0
A^mH00<`7nmHkeP0@>mH0014keP00`00keS_F00IkeP00`00ooooo`3Bool00`00keS_F017keP00c0O
keS_F00okeP004C_F003003_F>mH01W_F003003ooooo0=;oo`03003_F>mH04S_F003<1o_F>mH03k_
F000A>mH0P006^mHeP00BnmH00<`7nmHkeP0?NmH0014keP00`00keS_F03okePlkeP00c0OkeS_F00l
keP004C_F003003_F>mH0?o_F3g_F003<1o_F>mH03__F000A>mH00<00>mHkeP0onmH?^mH00<`7nmH
keP0>^mH0014keP00`00keS_F03okePokeP00c0OkeS_F00ikeP004C_F003003_F>mH0?o_F43_F003
<1o_F>mH03S_F000A>mH00<00>mHkeP0onmH@NmH00<`7nmHkeP0=nmH0014keP2003okeQ3keP00c0O
keS_F00fkeP004C_F003003_F>mH0?o_F4?_F003<1o_F>mH03G_F000A>mH00<00>mHkeP0onmHA>mH
00<`7nmHkeP0=>mH0014keP00`00keS_F03okeQ5keP00c0OkeS_F00ckeP004C_F003003_F>mH0?o_
F4K_F003<1o_F>mH03;_F000A>mH00<00>mHkeP0onmHNnmH0014keP00`00keS_F03okeQkkeP004C_
F0800?o_F7c_F000A>mH00<00>mHkeP0onmHNnmH0014keP00`00keS_F03okeQkkeP004C_F003003_
F>mH0?o_F7__F000onmH`^mH003okeS2keP00?o_F<;_F000onmH`^mH003okeS2keP00?o_F<;_F000
onmH`^mH003okeS2keP00?o_F<;_F000onmH`^mH003okeS2keP00?o_F<;_F000<>mH0`001>mH0`00
0nmH0P001>mH0P000^mH0`0000?_F00000000^mH0P0000?_F000keP00`00onmHJnmH000`keP01000
keS_F0000^mH00<00>mHkeP00nmH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000^mH
00@00>mHkeP000G_F003003_F>mH0?o_F6S_F000<nmH00<00>mHkeP00`000nmH00<00>mHkeP00nmH
00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000nmH0P00onmHJnmH000akeP20003keP0
1000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP0
00;_F003003_F>mH0?o_F6__F000<>mH00<00>mHkeP01>mH0P001>mH0P001>mH0P000^mH00@00>mH
000000C_F0<000?_F0<00?o_F6[_F000<NmH0`007NmH00<00>mHkeP0onmHK^mH001@keP2003okeQ`
keP00?o_F<;_F000onmH`^mH003okeS2keP00?o_F<;_F000onmH`^mH003okeS2keP00001\
\>"],
  ImageRangeCache->{{{0, 448}, {276.375, 0}} -> {-1.05192, -0.648943, \
0.00469607, 0.00469607}, {{11, 436.938}, {269.75, 6.5625}} -> {411.717, \
-1.48166, 2.74655, 0.072607}, {{96.1875, 309.125}, {95.5625, 42.3125}} -> \
{-4.32815, -12.0565, 0.0439568, 0.0661234}, {{100.25, 123}, {92.8125, \
77.6875}} -> {-4.65197, -28.5461, 0.0461543, 0.149358}, {{100.25, 123}, \
{75.25, 60.125}} -> {-4.65197, -31.1692, 0.0461543, 0.149358}},
  CellTags->"LU_vs_ATLAS_LU"],

Cell[TextData[{
  "Usually you get the most of a LU Decomposition and back substitution if \
you have many load vectors. So the decomposition is done once and the back \
substitution is done many times. In our testing we applied a square load \
matrix also by size ",
  Cell[BoxData[
      \(TraditionalForm\`N\ x\ N\)]],
  ". This procedure resulted in a further speed up as shown in Figure ",
  
  CounterBox["NumberedFigure", "LU_Many_vs_ATLAS_LU_Many"],
  "."
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0157453 0.00758386 [
[.30952 .00325 -9 -9 ]
[.30952 .00325 9 0 ]
[.5 .00325 -12 -9 ]
[.5 .00325 12 0 ]
[.69048 .00325 -12 -9 ]
[.69048 .00325 12 0 ]
[.88095 .00325 -12 -9 ]
[.88095 .00325 12 0 ]
[1.025 .01575 0 -4.90625 ]
[1.025 .01575 10 4.90625 ]
[.10655 .16742 -12 -4.5 ]
[.10655 .16742 0 4.5 ]
[.10655 .3191 -12 -4.5 ]
[.10655 .3191 0 4.5 ]
[.10655 .47078 -12 -4.5 ]
[.10655 .47078 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01575 m
.30952 .022 L
s
[(800)] .30952 .00325 0 1 Mshowa
.5 .01575 m
.5 .022 L
s
[(1000)] .5 .00325 0 1 Mshowa
.69048 .01575 m
.69048 .022 L
s
[(1200)] .69048 .00325 0 1 Mshowa
.88095 .01575 m
.88095 .022 L
s
[(1400)] .88095 .00325 0 1 Mshowa
.125 Mabswid
.16667 .01575 m
.16667 .0195 L
s
.21429 .01575 m
.21429 .0195 L
s
.2619 .01575 m
.2619 .0195 L
s
.35714 .01575 m
.35714 .0195 L
s
.40476 .01575 m
.40476 .0195 L
s
.45238 .01575 m
.45238 .0195 L
s
.54762 .01575 m
.54762 .0195 L
s
.59524 .01575 m
.59524 .0195 L
s
.64286 .01575 m
.64286 .0195 L
s
.7381 .01575 m
.7381 .0195 L
s
.78571 .01575 m
.78571 .0195 L
s
.83333 .01575 m
.83333 .0195 L
s
.07143 .01575 m
.07143 .0195 L
s
.02381 .01575 m
.02381 .0195 L
s
.92857 .01575 m
.92857 .0195 L
s
.97619 .01575 m
.97619 .0195 L
s
.25 Mabswid
0 .01575 m
1 .01575 L
s
gsave
1.025 .01575 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .16742 m
.1253 .16742 L
s
[(20)] .10655 .16742 1 0 Mshowa
.11905 .3191 m
.1253 .3191 L
s
[(40)] .10655 .3191 1 0 Mshowa
.11905 .47078 m
.1253 .47078 L
s
[(60)] .10655 .47078 1 0 Mshowa
.125 Mabswid
.11905 .05366 m
.1228 .05366 L
s
.11905 .09158 m
.1228 .09158 L
s
.11905 .1295 m
.1228 .1295 L
s
.11905 .20534 m
.1228 .20534 L
s
.11905 .24326 m
.1228 .24326 L
s
.11905 .28118 m
.1228 .28118 L
s
.11905 .35702 m
.1228 .35702 L
s
.11905 .39494 m
.1228 .39494 L
s
.11905 .43286 m
.1228 .43286 L
s
.11905 .5087 m
.1228 .5087 L
s
.11905 .54662 m
.1228 .54662 L
s
.11905 .58453 m
.1228 .58453 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02327 L
.10458 .03407 L
.14415 .04562 L
.18221 .05801 L
.22272 .07258 L
.26171 .08795 L
.30316 .10574 L
.34309 .12428 L
.3815 .14343 L
.42237 .16521 L
.46172 .18755 L
.49955 .2103 L
.53984 .23588 L
.57861 .26184 L
.61984 .29087 L
.65954 .32023 L
.69774 .34976 L
.73838 .38257 L
.77751 .41552 L
.81909 .45199 L
.85916 .48855 L
.89771 .52504 L
.93871 .56527 L
.97619 .60332 L
s
1 0 .6 r
.02381 .02032 m
.06244 .022 L
.10458 .02405 L
.14415 .02619 L
.18221 .02844 L
.22272 .03105 L
.26171 .03376 L
.30316 .03686 L
.34309 .04007 L
.3815 .04334 L
.42237 .04704 L
.46172 .05081 L
.49955 .05463 L
.53984 .0589 L
.57861 .06321 L
.61984 .06801 L
.65954 .07285 L
.69774 .07769 L
.73838 .08306 L
.77751 .08843 L
.81909 .09436 L
.85916 .10029 L
.89771 .10619 L
.93871 .11268 L
.97619 .11881 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.2381 .38045 m
.2381 .49949 L
.71429 .49949 L
.71429 .38045 L
F
1 g
.21429 .40426 m
.21429 .5233 L
.69048 .5233 L
.69048 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.21429 .40426 m
.69048 .40426 L
.69048 .5233 L
.21429 .5233 L
.21429 .40426 L
s
% Start of sub-graphic
p
0.214286 0.404255 0.690476 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00710227 0.0710227 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0127841 0.126068 0.0838068 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0483 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0951705 0.126068 0.166193 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .13068 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .20739 -114 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Many) show
93.000 11.250 moveto
(load) show
123.000 11.250 moveto
(vectors) show
165.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
  ImageSize->{480, 296.562},
  ImageMargins->{{91, 10}, {10, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007P0001:1000`40n007h00OonmHhNmH003okeSQ
keP00?o_F>7_F000onmHhNmH003okeSQkeP00?o_F>7_F000onmHhNmH003okeSQkeP00?o_F>7_F000
T>mH0P001>mH0P001>mH0P00?>mH10000nmH0P001>mH0P001>mH0P00>NmH10000^mH10000nmH0P00
1>mH0P00>NmH10001>mH00<00>mHkeP00^mH0P001>mH0P00ENmH002?keP01000keS_F0000^mH00@0
0>mHkeP000;_F004003_F>mH000mkeP01@00keS_F>mH00000^mH00@00>mHkeP000;_F004003_F>mH
0002keP00`00keS_F00hkeP01@00keS_F>mH00001NmH00@00>mHkeP000;_F004003_F>mH000jkeP0
0`00keS_F003keP01@00keS_F>mH00000^mH00@00>mHkeP000;_F003003_F>mH05;_F000SnmH00@0
0>mHkeP000;_F004003_F>mH0002keP01000keS_F000?NmH00D00>mHkeS_F00000;_F004003_F>mH
0002keP01000keS_F0000^mH00<00>mHkeP0>>mH00<00>mHkeP00^mH00<00>mHkeP00^mH00@00>mH
keP000;_F004003_F>mH000jkeP00`00keS_F0050002keP01000keS_F0000^mH00@00>mHkeP005C_
F000T>mH0P000nmH00@00>mHkeP000;_F004003_F>mH000mkeP01@00keS_F>mH00000^mH00@00>mH
keP000;_F004003_F>mH0002keP00`00keS_F00hkeP00`00keS_F003keP01@00keS_F>mH00000^mH
00@00>mHkeP000;_F003003_F>mH03S_F004003_F>mH0002keP01@00keS_F>mH00000^mH00@00>mH
keP000;_F003003_F>mH05;_F000SnmH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F000
?NmH00D00>mHkeS_F00000;_F004003_F>mH0002keP01000keS_F0000^mH00<00>mHkeP0>>mH00<0
0>mHkeP01>mH00@00>mHkeP000;_F004003_F>mH0002keP00`00keS_F00hkeP01`00keS_F>mH003_
F00000?_F004003_F>mH0002keP01000keS_F000E>mH002?keP01000keS_F0000^mH00@00>mHkeP0
00;_F004003_F>mH000kkeP30003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000h
keP30003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000hkeP30004keP20003keP0
1000keS_F0000^mH00@00>mHkeP005C_F000B>mH00<00>mHkeP0ANmH0P001>mH0P001>mH0P00?^mH
00<00>mHkeP00^mH0P001>mH0P001>mH0P00>nmH00<00>mHkeP00^mH0P001>mH0P001>mH0P00>nmH
00<00>mHkeP00nmH00<00>mHkeP00^mH0P001>mH0P00ENmH0018keP00`00keS_F03okeRFkeP004S_
F003003_F>mH0?o_F9K_F000B>mH00<00>mHkeP0onmHU^mH0018keP00`00keS_F03okeRFkeP004S_
F003003_F>mH0?o_F7C_F08000;_F003003_F>mH01__F0006>mH2@000c0Oo`00T0003>mH00@00>mH
keP001g_F0008NmH00<00>mHkeP01S0O2nmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP0
4NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP0
4>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP0
4NmH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP0
4NmH00<00>mHkeP04>mH00<00>mHkeP05>mH00@00>mH000001g_F0008NmH2OPC1C0O1^mH00<00>mH
keP04>mH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mH
keP04>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mH
keP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mH
keP04NmH00<00>mHkeP04>mH00<00>mHkeP04NmH00<00>mHkeP04>mH00<00>mHkeP05>mH0P0000?_
F000keP07>mH000ZkeP@n1<>keP00`00keS_F01<keP00`00keS_F01;keP00`00keS_F01;keP00`00
keS_F01;keP00`00keS_F00kkeP01000keS_F0007NmH000ckeP4<1l3kePQn1?okeQTkeP200000nmH
0000000MkeP003O_F0<`7`k_F003003_F>mH013_F13h4oo_F7K_F000>^mH0c0O2nmH00<00>mHkeP0
8>mH3OPConmHJNmH000mkeP4<1l7keP00`00keS_F00]keP8n1?okeQQkeP0047_F0@`7`?_F003003_
F>mH03G_F0ch4oo_F5G_F000ANmH130O@nmH4OPConmHA>mH0018keP00`00<1l`7`02<1m@keP@n1?o
kePdkeP004S_F003003_F>mH00;_F0@`7ec_F0ch4oo_F2S_F000B>mH00<00>mHkeP01^mH130OI>mH
2?PConmH8>mH0018keP00`00keS_F00:keP3<1mYkeP9n1?okePGkeP004S_F003003_F>mH00g_F0<`
7fo_F0Sh4oo_F0o_F000B>mH00<00>mHkeP04>mH0c0OM>mH3?PConmH0nmH0018keP3000CkeP3<1mm
keP<n1?fkeP004S_F003003_F>mH01K_F0<`7hK_F0Sh4nk_F000B>mH00<00>mHkeP06NmH0c0ORnmH
2?PCi^mH0018keP00`00keS_F00LkeP3<1n@keP8n1?NkeP004S_F003003_F>mH01o_F08`7iK_F0Sh
4mK_F000B>mH00<00>mHkeP08NmH0c0OVnmH2?PCc^mH0018keP00`00keS_F00TkeP3<1nPkeP9n1?5
keP004S_F003003_F>mH02O_F0<`7jK_F0Sh4kg_F000B>mH00<00>mHkeP0:^mH0S0O[>mH2?PC]NmH
0018keP00`00keS_F00/keP2<1nbkeP8n1>]keP004S_F003003_F>mH02k_F0<`7kO_F0Sh4jG_F000
B>mH00<00>mHkeP0<NmH0S0O_NmH2?PCWNmH0018keP00`00keS_F00ckeP2<1o3keP9n1>DkeP004S_
F003003_F>mH03G_F08`7l[_F0Sh4hc_F000B>mH00<00>mHkeP0=nmH0c0OcnmH2?PCQ>mH0018keP3
000jkeP2<1oEkeP8n1=lkeP004S_F003003_F>mH03c_F0<`7m[_F0Oh4gG_F000B>mH00<00>mHkeP0
?nmH0S0OgnmH1_PCKnmH0018keP00`00keS_F011keP2<1oSkeP5n1=ZkeP004S_F003003_F>mH04?_
F0<`7nG_F0Oh4f?_F000B>mH00<00>mHkeP0A^mH0S0Oj^mH2?PCFnmH0018keP00`00keS_F018keP3
<1o_keP6n1=EkeP004S_F003003_F>mH04__F08`7o?_F0Kh4do_F000B>mH00<00>mHkeP0CNmH0S0O
mnmH1_PCBNmH0018keP00`00keS_F01?keP2<1okkeP6n1=3keP004S_F003003_F>mH057_F08`7oo_
F0Sh4c__F000B>mH00<00>mHkeP0DnmH0S0OonmH1^mH1?PC=nmH0018keP00`00keS_F01EkeP2<1oo
kePokeP004S_F003003_F>mH05O_F08`7oo_F3g_F000B>mH00<00>mHkeP0FNmH0S0OonmH>nmH0018
keP00`00keS_F01KkeP2<1ookePikeP004S_F0<005g_F08`7oo_F3O_F000B>mH00<00>mHkeP0GnmH
0S0OonmH=NmH0018keP00`00keS_F01QkeP2<1ookePckeP004S_F003003_F>mH06?_F08`7oo_F37_
F000B>mH00<00>mHkeP0INmH0S0OonmH;nmH0018keP00`00keS_F01WkeP2<1ookeP]keP004S_F003
003_F>mH06W_F08`7oo_F2__F000B>mH00<00>mHkeP0JnmH0S0OonmH:NmH0018keP00`00keS_F01]
keP2<1ookePWkeP004S_F003003_F>mH06o_F08`7oo_F2G_F000B>mH00<00>mHkeP0LNmH0S0OonmH
8nmH0018keP00`00keS_F01ckeP2<1ookePQkeP004S_F003003_F>mH07G_F08`7oo_F1o_F000>>mH
10000nmH0P001nmH00<00>mHkeP0MnmH0S0OonmH7NmH000hkeP00`00keS_F003keP01000keS_F000
1^mH00<00>mHkeP0NNmH0S0OonmH6nmH000ikeP00`00keS_F002keP01000keS_F0001^mH1000N^mH
0S0OonmH6NmH000jkeP01@00keS_F>mH00000^mH00<00>mHkeP01>mH00<00>mHkeP0ONmH0S0OonmH
5nmH000kkeP01000keS_F0000^mH00<00>mHkeP01>mH00<00>mHkeP0OnmH00<`7nmHkeP0onmH5>mH
000hkeP01000keS_F0000^mH00@00>mHkeP000K_F003003_F>mH083_F08`7oo_F1C_F000>NmH0P00
1>mH0P001nmH00<00>mHkeP0P^mH00<`7nmHkeP0onmH4NmH0018keP00`00keS_F023keP2<1ookePA
keP004S_F003003_F>mH08G_F08`7oo_F0o_F000B>mH00<00>mHkeP0QnmH00<`7nmHkeP0onmH3>mH
0018keP00`00keS_F028keP2<1ookeP<keP004S_F003003_F>mH08[_F003<1o_F>mH0?o_F0W_F000
B>mH00<00>mHkeP0RnmH0S0OonmH2NmH0018keP00`00keS_F02=keP2<1ookeP7keP004S_F003003_
F>mH08o_F08`7oo_F0G_F000B>mH00<00>mHkeP0TNmH0S0OonmH0nmH0018keP00`00keS_F02CkeP0
0c0OkeS_F03okeP004S_F003003_F>mH09C_F08`7oo_F000B>mH0`00U^mH0S0OoNmH0018keP00`00
keS_F02HkeP2<1okkeP004S_F003003_F>mH09[_F003<1o_F>mH0?S_F000B>mH00<00>mHkeP0VnmH
0S0On>mH0018keP00`00keS_F02MkeP00c0OkeS_F03ekeP004S_F003003_F>mH09k_F08`7oG_F000
B>mH00<00>mHkeP0X>mH00<`7nmHkeP0l^mH0018keP00`00keS_F02QkeP2<1obkeP004S_F003003_
F>mH0:?_F003<1o_F>mH0>o_F000B>mH00<00>mHkeP0Y>mH00<`7nmHkeP0k^mH0018keP00`00keS_
F02UkeP2<1o^keP004S_F003003_F>mH0:O_F003<1o_F>mH0>__F000B>mH00<00>mHkeP0Z>mH0S0O
jnmH0018keP00`00keS_F02ZkeP00c0OkeS_F03XkeP004S_F003003_F>mH0:__F08`7nS_F000B>mH
00<00>mHkeP0[NmH0S0Oi^mH0018keP3002_keP00c0OkeS_F03SkeP004S_F003003_F>mH0;3_F08`
7n?_F000B>mH00<00>mHkeP0/^mH00<`7nmHkeP0h>mH0018keP00`00keS_F02ckeP2<1oPkeP004S_
F003003_F>mH0;G_F08`7mk_F000B>mH00<00>mHkeP0]nmH00<`7nmHkeP0fnmH0018keP00`00keS_
F02hkeP2<1oKkeP004S_F003003_F>mH0;[_F003<1o_F>mH0=S_F000B>mH00<00>mHkeP0^nmH0S0O
f>mH0018keP00`00keS_F02mkeP00c0OkeS_F03EkeP004S_F003003_F>mH0;k_F003<1o_F>mH0=C_
F000B>mH00<00>mHkeP0_nmH0S0Oe>mH0018keP00`00keS_F031keP00c0OkeS_F03AkeP004S_F003
003_F>mH0<;_F08`7m7_F000B>mH00<00>mHkeP0a>mH00<`7nmHkeP0c^mH0018keP30035keP2<1o>
keP004S_F003003_F>mH0<O_F003<1o_F>mH0<__F000B>mH00<00>mHkeP0b>mH00<`7nmHkeP0b^mH
0018keP00`00keS_F039keP2<1o:keP004S_F003003_F>mH0<__F003<1o_F>mH0<O_F000B>mH00<0
0>mHkeP0c>mH0S0OanmH0018keP00`00keS_F03>keP00c0OkeS_F034keP004S_F003003_F>mH0<o_
F003<1o_F>mH0<?_F000B>mH00<00>mHkeP0d>mH0S0O`nmH0018keP00`00keS_F03BkeP00c0OkeS_
F030keP004S_F003003_F>mH0=?_F003<1o_F>mH0;o_F000B>mH00<00>mHkeP0e>mH0S0O_nmH0018
keP00`00keS_F03FkeP00c0OkeS_F02lkeP004S_F003003_F>mH0=O_F003<1o_F>mH0;__F000>^mH
00<00>mHkeP00^mH0P001nmH00<00>mHkeP0f>mH0S0O^nmH000jkeP01@00keS_F>mH00000^mH00<0
0>mHkeP01>mH00<00>mHkeP0f^mH00<`7nmHkeP0^>mH000gkeP50002keP01000keS_F0001^mH1000
f^mH00<`7nmHkeP0]nmH000gkeP01000keS_F0000nmH00@00>mHkeP000K_F003003_F>mH0=c_F08`
7kO_F000>>mH00<00>mH00000nmH00@00>mHkeP000K_F003003_F>mH0=k_F003<1o_F>mH0;C_F000
>NmH0P000nmH00@00>mHkeP000K_F003003_F>mH0=o_F003<1o_F>mH0;?_F000>^mH00<00>mHkeP0
0^mH0P001nmH00<00>mHkeP0h>mH0S0O/nmH0018keP00`00keS_F03RkeP00c0OkeS_F02`keP004S_
F003003_F>mH0>?_F003<1o_F>mH0:o_F000B>mH00<00>mHkeP0i>mH0S0O[nmH0018keP00`00keS_
F03VkeP00c0OkeS_F02/keP004S_F003003_F>mH0>O_F003<1o_F>mH0:__F000B>mH00<00>mHkeP0
j>mH0S0OZnmH0018keP00`00keS_F03ZkeP00c0OkeS_F02XkeP004S_F003003_F>mH0>__F003<1o_
F>mH0:O_F000B>mH00<00>mHkeP0k>mH00<`7nmHkeP0Y^mH0018keP00`00keS_F03]keP2<1nVkeP0
04S_F0<00>o_F003<1o_F>mH0:?_F000B>mH00<00>mHkeP0l>mH00<`7nmHkeP0X^mH0018keP00`00
keS_F03akeP00c0OkeS_F02QkeP004S_F003003_F>mH0?;_F003<1o_F>mH0:3_F000B>mH00<00>mH
keP0lnmH0S0OX>mH0018keP00`00keS_F03ekeP00c0OkeS_F02MkeP004S_F003003_F>mH0?K_F003
<1o_F>mH09c_F000B>mH00<00>mHkeP0mnmH00<`7nmHkeP0VnmH0018keP00`00keS_F03hkeP00c0O
keS_F02JkeP004S_F003003_F>mH0?W_F08`7i[_F000B>mH00<00>mHkeP0nnmH00<`7nmHkeP0UnmH
0018keP00`00keS_F03lkeP00c0OkeS_F02FkeP004S_F003003_F>mH0?g_F003<1o_F>mH09G_F000
B>mH00<00>mHkeP0o^mH0S0OUNmH0018keP00`00keS_F03okeP1keP00c0OkeS_F02BkeP004S_F003
003_F>mH0?o_F0;_F003<1o_F>mH097_F000B>mH0`00onmH0nmH00<`7nmHkeP0T>mH0018keP00`00
keS_F03okeP4keP2<1n@keP004S_F003003_F>mH0?o_F0K_F003<1o_F>mH08g_F000B>mH00<00>mH
keP0onmH1nmH00<`7nmHkeP0S>mH0018keP00`00keS_F03okeP8keP00c0OkeS_F02;keP004S_F003
003_F>mH0?o_F0W_F003<1o_F>mH08[_F000B>mH00<00>mHkeP09nmHh`0000<`7nmHkeP0R>mH0018
keP00`00keS_F00WkeSS00000nmH<1o_F028keP004S_F003003_F>mH02O_F><000;_F003<1o_F>mH
08K_F000B>mH00<00>mHkeP09nmHh`000nmH00<`7nmHkeP0QNmH0018keP00`00keS_F00WkeSS0004
keP00c0OkeS_F024keP004S_F003003_F>mH02O_F><000G_F003<1o_F>mH08?_F000B>mH00<00>mH
keP09nmHh`001^mH0S0OPnmH0018keP00`00keS_F00WkeSS0008keP00c0OkeS_F020keP004S_F003
003_F>mH02O_F><000W_F003<1o_F>mH07o_F000B>mH0`009nmHh`002^mH00<`7nmHkeP0O^mH0018
keP00`00keS_F00KkeS_000;keP00c0OkeS_F01mkeP004S_F003003_F>mH01__F003003ooooo0>7o
o`/000c_F003<1o_F>mH07c_F000B>mH00<00>mHkeP06nmH00<00?ooool0hOoo2`003NmH00<`7nmH
keP0NnmH0018keP00`00keS_F00KkeP00`00ooooo`3Qool;000>keP2<1mkkeP004S_F003003_F>mH
01__F003003ooooo0>7oo`/0013_F003<1o_F>mH07S_F000B>mH00<00>mHkeP06nmH00<00?ooool0
hOoo2`004NmH00<`7nmHkeP0MnmH0018keP00`00keS_F00KkeP00`00ooooo`3Qool;000BkeP00c0O
keS_F01fkeP004S_F003003_F>mH01__F003003ooooo0>7oo`/001?_F003<1o_F>mH07G_F000B>mH
00<00>mHkeP06nmH00<00?ooool0hOoo2`005>mH00<`7nmHkeP0M>mH0018keP00`00keS_F00KkeP0
0`00ooooo`3Qool;000EkeP00c0OkeS_F01ckeP004S_F003003_F>mH01__F003003ooooo01ooo`80
00;oo`800004ool000000002ool500000ooo00000002ool200001?oo00000000Y_oo2`005^mH00<`
7nmHkeP0L^mH0018keP00`00keS_F00KkeP00`00ooooo`02oolHn1<6ool01000ooooo`000ooo00<0
0?ooool00_oo00@00?ooool000;oo`04003ooooo0002ool01000ooooo`00YOoo2`005nmH00<`7nmH
keP0LNmH0018keP00`00keS_F00KkeP00`00ooooo`0Pool40003ool00`00ooooo`02ool00`00oooo
o`03ool40005ool00`00ooooo`2Sool;000HkeP00c0OkeS_F01`keP003W_F08000C_F08000O_F003
003_F>mH01__F003003ooooo023oo`04003ooooo0003ool00`00ooooo`02ool00`00ooooo`03ool0
1000ooooo`000ooo0P00Y_oo2`006NmH00<`7nmHkeP0KnmH000hkeP01000keS_F0000^mH00@00>mH
keP000K_F003003_F>mH01__F003003ooooo027oo`09003oo`00ool00?oo003oo`0000;oo`03003o
oooo00Coo`03003oo`0000;oo`03003ooooo0:Koo`/001[_F08`7fo_F000>>mH00@00>mHkeP000;_
F004003_F>mH0006keP4000JkeP00`00ooooo`0Pool30002ool500001?oo000000001?oo0`001?oo
0`00YOoo2`007>mH00<`7nmHkeP0K>mH000hkeP30003keP01000keS_F0001^mH00<00>mHkeP06nmH
00<00?ooool0hOoo2`007NmH00<`7nmHkeP0JnmH000hkeP00`00keS_F003keP01000keS_F0001^mH
00<00>mHkeP06nmH00<00?ooool0hOoo2`007^mH00<`7nmHkeP0J^mH000hkeP00`00keS_F003keP0
1000keS_F0001^mH00<00>mHkeP06nmH00<00?ooool0hOoo2`007nmH00<`7nmHkeP0JNmH000ikeP3
0003keP20007keP00`00keS_F00KkeP00`00ooooo`3Qool;000PkeP00c0OkeS_F01XkeP004S_F003
003_F>mH01__F003003ooooo0>7oo`/0027_F003<1o_F>mH06O_F000B>mH00<00>mHkeP06nmH00<0
0?ooool0hOoo2`008^mH00<`7nmHkeP0I^mH0018keP00`00keS_F00KkeP00`00ooooo`3Qool;000S
keP00c0OkeS_F01UkeP004S_F003003_F>mH01__F003003ooooo0>7oo`/002C_F003<1o_F>mH06C_
F000B>mH00<00>mHkeP06nmH00<00?ooool0hOoo2`009NmH00<`7nmHkeP0HnmH0018keP00`00keS_
F00KkeP00`00ooooo`3Qool;000VkeP00c0OkeS_F01RkeP004S_F003003_F>mH01__F003003ooooo
0>7oo`/002O_F003<1o_F>mH067_F000B>mH00<00>mHkeP06nmH00<00?ooool0hOoo2`00:>mH00<`
7nmHkeP0H>mH0018keP00`00keS_F00KkeP00`00ooooo`3Qool;000YkeP00c0OkeS_F01OkeP004S_
F003003_F>mH01__F003003ooooo01ooo`800003ool0000000?oo`800003ool00?oo00;oo`800005
ool00000003oo`020002ool300001Ooo003oo`00ool00P000_oo0P0000?oo`00ool00_oo0P000_oo
1@000_oo0P001?oo0P0000?oo`00ool0Oooo2`00:^mH0S0OGnmH0018keP00`00keS_F00KkeP00`00
ooooo`02oolH<1l5ool01@00oooooooo00000_oo00@00?ooool000?oo`06003ooooo003oo`000_oo
00@00?ooool000Coo`05003oo`00ool00002ool01000ooooo`000ooo00@00?ooool000?oo`05003o
ooooool00002ool01000ooooo`000_oo00<00?ooool0Oooo2`00;>mH00<`7nmHkeP0G>mH0018keP3
000KkeP00`00ooooo`0Oool01@00ool00?oo00000ooo0`000ooo00<00?ooool00_oo00@00?ooool0
00;oo`<000;oo`05003oo`00ool00003ool30003ool00`00ooooo`04ool01@00oooooooo00001_oo
0`00POoo2`00;NmH00<`7nmHkeP0FnmH0018keP00`00keS_F00KkeP00`00ooooo`0Oool01@00ool0
0?oo00001Ooo00D00?ooooooo`0000Coo`04003ooooo0002ool02P00ooooo`00ool00?oo003oo`00
1Ooo00D00?ooooooo`0000Koo`05003oooooool00002ool00`00ooooo`03ool00`00ooooo`1oool;
000^keP00c0OkeS_F01JkeP004S_F003003_F>mH01__F003003ooooo01ooo`800003ool0000000?o
o`8000?oo`@000;oo`<000Coo`8000;oo`800003ool00?oo00?oo`8000?oo`@000?oo`8000Coo`80
00Coo`8008;oo`/002o_F003<1o_F>mH05W_F000B>mH00<00>mHkeP06nmH00<00?ooool07ooo00D0
0?ooooooo`0000Woo`03003ooooo00;oo`03003ooooo01Koo`03003ooooo09?oo`/0033_F003<1o_
F>mH05S_F000B>mH00<00>mHkeP06nmH00<00?ooool0;Ooo00@00?ooooooo`8001Soo`03003ooooo
00Coo`03003ooooo08coo`/0037_F003<1o_F>mH05O_F000B>mH00<00>mHkeP06nmH00<00?ooool0
hOoo2`00<^mH00<`7nmHkeP0E^mH0018keP00`00keS_F00KkeP00`00ooooo`3Qool;000ckeP00c0O
keS_F01EkeP004S_F003003_F>mH01__F003003ooooo0>7oo`/003C_F003<1o_F>mH05C_F000B>mH
00<00>mHkeP06nmH00<00?ooool0hOoo2`00=NmH00<`7nmHkeP0DnmH0018keP00`00keS_F00KkeP0
0`00ooooo`3Qool;000fkeP00c0OkeS_F01BkeP004S_F003003_F>mH01__F003003ooooo0>7oo`/0
03O_F003<1o_F>mH057_F000B>mH00<00>mHkeP06nmH00<00?ooool0hOoo2`00>>mH00<`7nmHkeP0
D>mH0018keP00`00keS_F00KkeP00`00ooooo`3Qool;000ikeP00c0OkeS_F01?keP004S_F003003_
F>mH01__F003003ooooo04koo`80097oo`/003[_F003<1o_F>mH04k_F000B>mH00<00>mHkeP06nmH
00<00?ooool0D?oo00<00?ooool0S_oo2`00>nmH00<`7nmHkeP0CNmH0018keP3000KkeP00`00oooo
o`0lool200000ooo00000003ool200000ooo0000000200000ooo00000002ool20009ool50002ool2
0004ool200001?oo003ooooo0P0000?oo`00ool02?oo00<00?ooool00_oo0`000ooo0P001Ooo0P00
0ooo0P000ooo10000_oo0`00@Ooo2`00?>mH00<`7nmHkeP0C>mH0018keP00`00keS_F00KkeP00`00
ooooo`0lool01@00oooooooo00000_oo00@00?ooool000;oo`04003ooooo0002ool01000ooooo`00
2_oo00D00?ooooooo`0000;oo`04003ooooo0002ool01000ooooo`000_oo00<00?ooool01ooo00<0
0?oo00000_oo00<00?ooool00ooo00@00?ooool000?oo`06003ooooo003oo`000_oo00D00?oooooo
o`0000Ooo`03003ooooo03koo`03003_F>mH04G_F003<1o_F>mH04__F000B>mH00<00>mHkeP06nmH
00<00?ooool0??oo00D00?oo003oo`0000?oo`<000;oo`04003ooooo0002ool01000ooooo`002_oo
00D00?ooooooo`0000;oo`04003oooooool30002ool01000ooooo`002Ooo00<00?oo00000_oo0`00
0ooo00<00?ooool01?oo00<00?ooool00_oo00@00?ooool000?oo`03003ooooo00?oo`80047oo`03
003_F>mH04K_F003<1o_F>mH04[_F000B>mH00<00>mHkeP06nmH00<00?ooool0??oo00D00?oo003o
o`0000Goo`04003ooooo0002ool01000ooooo`000_oo00<00?ooool02?oo00D00?ooooooo`0000;o
o`03003ooooo00?oo`04003ooooo0002ool00`00ooooo`06ool01`00oooooooo003oo`0000;oo`04
003ooooo0002ool01@00oooooooo00001?oo00@00?ooool000?oo`03003ooooo00;oo`03003ooooo
047oo`03003_F>mH04O_F003<1o_F>mH04W_F000B>mH00<00>mHkeP06nmH00<00?ooool0??oo0P00
00?oo`0000000ooo0P000_oo00@00?oo000000;oo`800003ool0000000[oo`03003ooooo00;oo`80
00Coo`8000Coo`<000Ooo`8000;oo`8000;oo`8000Coo`8000?oo`@000?oo`8000?oo`03003oo`00
008000;oo`<0043oo`03003_F>mH04S_F003<1o_F>mH04S_F000B>mH00<00>mHkeP06nmH00<00?oo
ool0??oo00D00?ooooooo`0001coo`03003ooooo013oo`03003ooooo01Woo`03003ooooo05;oo`03
003_F>mH04W_F003<1o_F>mH04O_F000B>mH00<00>mHkeP06nmH00<00?ooool0G?oo0P004Ooo0P00
6ooo00<00?ooool0D_oo00<00>mHkeP0B^mH00<`7nmHkeP0A^mH0018keP00`00keS_F00KkeP00`00
ooooo`3Qool00`00keS_F01;keP00c0OkeS_F015keP004S_F003003_F>mH01__F003003ooooo0>7o
o`03003_F>mH04c_F003<1o_F>mH04C_F000B>mH00<00>mHkeP06nmH00<00?ooool0hOoo00<00>mH
keP0CNmH00<`7nmHkeP0@nmH0018keP00`00keS_F00KkeP00`00ooooo`3Qool00`00keS_F01>keP0
0c0OkeS_F012keP004S_F003003_F>mH01__F>D0057_F003<1o_F>mH047_F000B>mH00<00>mHkeP0
onmHDnmH00<`7nmHkeP0@>mH0018keP00`00keS_F03okeQDkeP00c0OkeS_F00okeP004S_F003003_
F>mH0?o_F5G_F003<1o_F>mH03k_F000B>mH00<00>mHkeP0onmHE^mH00<`7nmHkeP0?NmH0018keP3
003okeQGkeP00c0OkeS_F00lkeP004S_F003003_F>mH0?o_F5S_F003<1o_F>mH03__F000B>mH00<0
0>mHkeP0onmHFNmH00<`7nmHkeP0>^mH0018keP00`00keS_F03okeQJkeP00c0OkeS_F00ikeP004S_
F003003_F>mH0?o_F5__F003<1o_F>mH03S_F000B>mH00<00>mHkeP0onmHG>mH00<`7nmHkeP0=nmH
0018keP00`00keS_F03okeQMkeP00c0OkeS_F00fkeP004S_F003003_F>mH0?o_F5k_F003<1o_F>mH
03G_F000B>mH00<00>mHkeP0onmHU^mH0018keP00`00keS_F03okeRFkeP004S_F003003_F>mH0?o_
F9K_F000B>mH00<00>mHkeP0onmHU^mH0018keP00`00keS_F03okeRFkeP004S_F003003_F>mH0?o_
F9K_F000onmHhNmH003okeSQkeP00?o_F>7_F000onmHhNmH003okeSQkeP00?o_F>7_F000onmHhNmH
003okeSQkeP00?o_F>7_F000onmHhNmH003okeSQkeP00?o_F>7_F000onmHhNmH000dkeP30004keP3
0003keP20004keP20002keP300000nmH00000002keP200000nmH003_F003003okeR6keP003C_F004
003_F>mH0002keP00`00keS_F003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0002
keP01000keS_F0001NmH00<00>mHkeP0onmHPnmH000gkeP00`00keS_F0030003keP00`00keS_F003
keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0003keP2003okeR6keP003G_F08000?_
F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_
F0000^mH00<00>mHkeP0onmHQ^mH000dkeP00`00keS_F004keP20004keP20004keP20002keP01000
keP000001>mH0`000nmH0`00onmHQNmH000ekeP3000MkeP00`00keS_F03okeR9keP005C_F0800?o_
F8__F000onmHhNmH003okeSQkeP00?o_F>7_F000onmHhNmH003okeSQkeP00?o_F>7_F000onmHhNmH
0000\
\>"],
  ImageRangeCache->{{{0, 479}, {295.562, 0}} -> {-1.05168, -0.648936, \
0.00439117, 0.00439117}, {{11.75, 467.188}, {288.5, 7}} -> {413.514, \
-6.80648, 2.55732, 0.321148}, {{102.812, 330.562}, {102.188, 45.25}} -> \
{-4.32543, -12.055, 0.041098, 0.0618228}, {{107.188, 131.5}, {99.25, \
83.0625}} -> {-4.65423, -28.5677, 0.0431881, 0.13976}, {{107.188, 131.5}, \
{80.5, 64.3125}} -> {-4.65423, -31.1882, 0.0431881, 0.13976}},
  CellTags->"LU_Many_vs_ATLAS_LU_Many"]
}, Closed]],

Cell[CellGroupData[{

Cell["A big problem", "Subsubsection"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.384354 0.000340136 0.0253098 0.000473468 [
[.29592 .01281 -12 -9 ]
[.29592 .01281 12 0 ]
[.46599 .01281 -12 -9 ]
[.46599 .01281 12 0 ]
[.63605 .01281 -12 -9 ]
[.63605 .01281 12 0 ]
[.80612 .01281 -12 -9 ]
[.80612 .01281 12 0 ]
[.97619 .01281 -12 -9 ]
[.97619 .01281 12 0 ]
[1.025 .02531 0 -4.90625 ]
[1.025 .02531 10 4.90625 ]
[.11335 .12 -18 -4.5 ]
[.11335 .12 0 4.5 ]
[.11335 .2147 -18 -4.5 ]
[.11335 .2147 0 4.5 ]
[.11335 .30939 -18 -4.5 ]
[.11335 .30939 0 4.5 ]
[.11335 .40408 -18 -4.5 ]
[.11335 .40408 0 4.5 ]
[.11335 .49878 -24 -4.5 ]
[.11335 .49878 0 4.5 ]
[.11335 .59347 -24 -4.5 ]
[.11335 .59347 0 4.5 ]
[.12585 .64303 -23 0 ]
[.12585 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.29592 .02531 m
.29592 .03156 L
s
[(2000)] .29592 .01281 0 1 Mshowa
.46599 .02531 m
.46599 .03156 L
s
[(2500)] .46599 .01281 0 1 Mshowa
.63605 .02531 m
.63605 .03156 L
s
[(3000)] .63605 .01281 0 1 Mshowa
.80612 .02531 m
.80612 .03156 L
s
[(3500)] .80612 .01281 0 1 Mshowa
.97619 .02531 m
.97619 .03156 L
s
[(4000)] .97619 .01281 0 1 Mshowa
.125 Mabswid
.15986 .02531 m
.15986 .02906 L
s
.19388 .02531 m
.19388 .02906 L
s
.22789 .02531 m
.22789 .02906 L
s
.2619 .02531 m
.2619 .02906 L
s
.32993 .02531 m
.32993 .02906 L
s
.36395 .02531 m
.36395 .02906 L
s
.39796 .02531 m
.39796 .02906 L
s
.43197 .02531 m
.43197 .02906 L
s
.5 .02531 m
.5 .02906 L
s
.53401 .02531 m
.53401 .02906 L
s
.56803 .02531 m
.56803 .02906 L
s
.60204 .02531 m
.60204 .02906 L
s
.67007 .02531 m
.67007 .02906 L
s
.70408 .02531 m
.70408 .02906 L
s
.7381 .02531 m
.7381 .02906 L
s
.77211 .02531 m
.77211 .02906 L
s
.84014 .02531 m
.84014 .02906 L
s
.87415 .02531 m
.87415 .02906 L
s
.90816 .02531 m
.90816 .02906 L
s
.94218 .02531 m
.94218 .02906 L
s
.09184 .02531 m
.09184 .02906 L
s
.05782 .02531 m
.05782 .02906 L
s
.02381 .02531 m
.02381 .02906 L
s
.25 Mabswid
0 .02531 m
1 .02531 L
s
gsave
1.025 .02531 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.12585 .12 m
.1321 .12 L
s
[(200)] .11335 .12 1 0 Mshowa
.12585 .2147 m
.1321 .2147 L
s
[(400)] .11335 .2147 1 0 Mshowa
.12585 .30939 m
.1321 .30939 L
s
[(600)] .11335 .30939 1 0 Mshowa
.12585 .40408 m
.1321 .40408 L
s
[(800)] .11335 .40408 1 0 Mshowa
.12585 .49878 m
.1321 .49878 L
s
[(1000)] .11335 .49878 1 0 Mshowa
.12585 .59347 m
.1321 .59347 L
s
[(1200)] .11335 .59347 1 0 Mshowa
.125 Mabswid
.12585 .04898 m
.1296 .04898 L
s
.12585 .07266 m
.1296 .07266 L
s
.12585 .09633 m
.1296 .09633 L
s
.12585 .14368 m
.1296 .14368 L
s
.12585 .16735 m
.1296 .16735 L
s
.12585 .19102 m
.1296 .19102 L
s
.12585 .23837 m
.1296 .23837 L
s
.12585 .26204 m
.1296 .26204 L
s
.12585 .28572 m
.1296 .28572 L
s
.12585 .33306 m
.1296 .33306 L
s
.12585 .35674 m
.1296 .35674 L
s
.12585 .38041 m
.1296 .38041 L
s
.12585 .42776 m
.1296 .42776 L
s
.12585 .45143 m
.1296 .45143 L
s
.12585 .4751 m
.1296 .4751 L
s
.12585 .52245 m
.1296 .52245 L
s
.12585 .54612 m
.1296 .54612 L
s
.12585 .5698 m
.1296 .5698 L
s
.12585 .00164 m
.1296 .00164 L
s
.12585 .61714 m
.1296 .61714 L
s
.25 Mabswid
.12585 0 m
.12585 .61803 L
s
gsave
.12585 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02188 L
.10458 .03131 L
.14415 .0417 L
.18221 .05308 L
.22272 .06671 L
.26171 .08129 L
.30316 .09837 L
.34309 .11636 L
.3815 .13509 L
.42237 .15656 L
.46172 .17872 L
.49955 .20141 L
.53984 .22706 L
.57861 .25319 L
.61984 .28254 L
.65954 .31234 L
.69774 .3424 L
.73838 .37591 L
.77751 .40965 L
.81909 .44709 L
.85916 .48472 L
.89771 .52235 L
.93871 .56393 L
.97619 .60332 L
s
1 0 .6 r
.02381 .02767 m
.06244 .02869 L
.10458 .02997 L
.14415 .03132 L
.18221 .03276 L
.22272 .03444 L
.26171 .0362 L
.30316 .03822 L
.34309 .04033 L
.3815 .04249 L
.42237 .04494 L
.46172 .04745 L
.49955 .05 L
.53984 .05286 L
.57861 .05576 L
.61984 .05899 L
.65954 .06225 L
.69774 .06553 L
.73838 .06916 L
.77751 .07281 L
.81909 .07684 L
.85916 .08088 L
.89771 .0849 L
.93871 .08934 L
.97619 .09353 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.2381 .38045 m
.2381 .49949 L
.71429 .49949 L
.71429 .38045 L
F
1 g
.21429 .40426 m
.21429 .5233 L
.69048 .5233 L
.69048 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.21429 .40426 m
.69048 .40426 L
.69048 .5233 L
.21429 .5233 L
.21429 .40426 L
s
% Start of sub-graphic
p
0.214286 0.404255 0.690476 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00710227 0.0710227 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0127841 0.126068 0.0838068 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0483 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0951705 0.126068 0.166193 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .13068 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .20739 -96 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Big) show
87.000 11.562 moveto
(problem) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
  ImageSize->{413, 255.125},
  ImageMargins->{{112, 10}, {10, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006M0000oa000`40n007h00OonmHW^mH003okeRN
keP00?o_F9k_F000onmHW^mH003okeRNkeP00?o_F9k_F000onmHW^mH003okeRNkeP0077_F0@000?_
F08000C_F08000C_F08002O_F0@000;_F0<000C_F08000C_F08002S_F08000C_F08000C_F08000C_
F08002S_F08000?_F0<000C_F08000C_F08002[_F003003_F>mH00;_F08000C_F08000C_F08002K_
F000LNmH00<00>mHkeP00nmH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0009^mH00<0
0>mHkeP01^mH00@00>mHkeP000;_F004003_F>mH0002keP00`00keS_F00TkeP01000keS_F0000^mH
00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0009^mH00@00>mHkeP000G_F004003_F>mH
0002keP01000keS_F0000^mH00<00>mHkeP09nmH00D00>mHkeS_F00000;_F004003_F>mH0002keP0
1000keS_F0000^mH00<00>mHkeP08nmH001bkeP00`00keS_F002keP01000keS_F0000^mH00@00>mH
keP000;_F004003_F>mH000WkeP00`00keS_F005keP01000keS_F0000^mH00@00>mHkeP000;_F003
003_F>mH02O_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP000;_F003003_F>mH02O_
F003003_F>mH00?_F004003_F>mH0002keP01000keS_F0000^mH00<00>mHkeP09>mH1@000^mH00@0
0>mHkeP000;_F004003_F>mH0002keP01000keS_F0009NmH0010keP2000akeP01@00keS_F>mH0000
0^mH00@00>mHkeP000;_F004003_F>mH0002keP00`00keS_F00VkeP01000keS_F>mH0`000nmH00@0
0>mHkeP000;_F004003_F>mH000WkeP20003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_
F>mH000WkeP20003keP30003keP01000keS_F0000^mH00@00>mHkeP002K_F004003_F>mH0003keP0
1000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000UkeP0043_F003003_F>mH037_F004003_
F>mH0002keP01000keS_F0000^mH00@00>mHkeP000;_F003003_F>mH02O_F004003_F>mH0005keP0
1000keS_F0000^mH00@00>mHkeP002W_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP0
00;_F003003_F>mH02O_F004003_F>mH0005keP01000keS_F0000^mH00@00>mHkeP002O_F003003_
F00000?_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP002G_F000@>mH00<00>mHkeP0
;^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP002K_F004003_
F>mH0002keP00`00keS_F003keP01000keS_F0000^mH00@00>mHkeP002K_F004003_F>mH0002keP0
1000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH000VkeP01000keS_F0000^mH00<00>mHkeP0
0nmH00@00>mHkeP000;_F004003_F>mH000XkeP20003keP01000keS_F0000^mH00@00>mHkeP000;_
F004003_F>mH000UkeP0043_F003003_F>mH02o_F08000C_F08000C_F08000C_F08002S_F08000?_
F0@000?_F08000C_F08002S_F08000C_F08000C_F08000C_F08002S_F08000?_F0@000?_F08000C_
F08002[_F003003_F>mH00;_F08000C_F08000C_F08002K_F000@>mH00<00>mHkeP0onmHFnmH000K
keP3<1lRkeP00`00keS_F03okeQKkeP001k_F0D`7ag_F003003_F>mH0?o_F5__F0008nmH130O6NmH
00<00>mHkeP0onmHFnmH000WkeP5<1lDkeP00`00keS_F03okePnkeP20002keP00`00keS_F00FkeP0
01?_F1T000D`7ol004H000__F004003_F>mH000HkeP001__F1Kh4`D`7`[_F003003_F>mH00W_F003
003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003
003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003
003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003
003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00[_F003
003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH00W_F003003_F>mH017_F004
003_F000000HkeP0037_F1ch4bo_F003003_F>mH03W_F003003_F>mH03W_F003003_F>mH03W_F003
003_F>mH03[_F003003_F>mH017_F0800003keP00>mH01O_F000>^mH130O0^mH00<00>mHkeP02^mH
7OPConmH6>mH00@00>mHkeP001S_F000?^mH0c0O:NmH7?PCn^mH0P0000?_F00000006>mH0010keP0
0`00<1l`7`02<1m1keP>n1?okeP:keP0043_F003003_F>mH00;_F0<`7dc_F0kh4o__F000@>mH00<0
0>mHkeP01NmH0c0OEnmH3_PCkNmH0010keP20009keP4<1mQkeP>n1?OkeP0043_F003003_F>mH00c_
F0<`7fc_F0kh4m7_F000@>mH00<00>mHkeP03nmH0c0OMnmH3_PC`nmH0010keP00`00keS_F00BkeP3
<1n2keP>n1>ekeP0043_F003003_F>mH01G_F0<`7hg_F0kh4jO_F000@>mH00<00>mHkeP06>mH0c0O
V>mH3_PCVNmH0010keP00`00keS_F00KkeP3<1nSkeP>n1>;keP0043_F003003_F>mH01k_F0<`7jk_
F0[h4h7_F000@>mH00<00>mHkeP08NmH0c0O]NmH1oPCN^mH0010keP2000UkeP3<1nikeP;n1=_keP0
043_F003003_F>mH02O_F08`7l;_F0_h4fC_F000@>mH00<00>mHkeP0:NmH0c0Ob^mH1oPCGNmH0010
keP00`00keS_F00/keP3<1o>keP;n1=BkeP0043_F003003_F>mH02o_F08`7mO_F0[h4dS_F000@>mH
00<00>mHkeP0<NmH0S0OgnmH1oPC@NmH0010keP00`00keS_F00ckeP3<1oSkeP;n1<fkeP0043_F003
003_F>mH03K_F08`7nc_F0Oh4bo_F000@>mH0P00>NmH0S0OonmH8NmH0010keP00`00keS_F00jkeP3
<1ookePNkeP0043_F003003_F>mH03g_F08`7oo_F1c_F000@>mH00<00>mHkeP0?nmH0S0OonmH6^mH
0010keP00`00keS_F011keP3<1ookePGkeP0043_F003003_F>mH04C_F08`7oo_F1G_F000:^mH1000
0nmH0P001>mH0P001nmH00<00>mHkeP0A^mH0S0OonmH4nmH000ZkeP00`00keS_F003keP01000keS_
F0000^mH00@00>mHkeP000K_F003003_F>mH04S_F0<`7oo_F13_F000:nmH00<00>mHkeP00^mH00@0
0>mHkeP000;_F004003_F>mH0006keP3001;keP2<1ookeP>keP002c_F005003_F>mHkeP00002keP0
1000keS_F0000^mH00<00>mHkeP01>mH00<00>mHkeP0CNmH0S0OonmH3>mH000]keP01000keS_F000
0^mH00@00>mHkeP000;_F003003_F>mH00C_F003003_F>mH04o_F08`7oo_F0[_F000:^mH00@00>mH
keP000;_F004003_F>mH0002keP01000keS_F0001^mH00<00>mHkeP0DNmH0S0OonmH2>mH000[keP2
0004keP20004keP20007keP00`00keS_F01CkeP2<1ookeP6keP0043_F003003_F>mH05G_F08`7oo_
F0C_F000@>mH00<00>mHkeP0EnmH0S0OonmH0^mH0010keP00`00keS_F01IkeP2<1ookeP0043_F003
003_F>mH05__F08`7og_F000@>mH0P00G^mH0S0OnnmH0010keP00`00keS_F01OkeP2<1oikeP0043_
F003003_F>mH067_F08`7oO_F000@>mH00<00>mHkeP0HnmH0S0OmNmH0010keP00`00keS_F01UkeP2
<1ockeP0043_F003003_F>mH06O_F08`7o7_F000@>mH00<00>mHkeP0JNmH0S0OknmH0010keP00`00
keS_F01[keP00c0OkeS_F03/keP0043_F08006g_F08`7nc_F000@>mH00<00>mHkeP0K^mH00<`7nmH
keP0jNmH0010keP00`00keS_F01_keP2<1oYkeP0043_F003003_F>mH077_F08`7nO_F000@>mH00<0
0>mHkeP0LnmH00<`7nmHkeP0i>mH0010keP00`00keS_F01dkeP2<1oTkeP0043_F003003_F>mH07K_
F08`7n;_F000@>mH00<00>mHkeP0N>mH0S0Oh>mH0010keP00`00keS_F01jkeP00c0OkeS_F03MkeP0
043_F08007c_F08`7mg_F000@>mH00<00>mHkeP0ONmH0S0OfnmH0010keP00`00keS_F01okeP2<1oI
keP0043_F003003_F>mH087_F003<1o_F>mH0=K_F000@>mH00<00>mHkeP0P^mH0S0Oe^mH0010keP0
0`00keS_F024keP00c0OkeS_F03CkeP002c_F003003_F>mH00;_F08000C_F08000O_F003003_F>mH
08G_F08`7m?_F000;>mH00D00>mHkeS_F00000;_F004003_F>mH0002keP00`00keS_F004keP00`00
keS_F027keP2<1oAkeP002W_F0D000;_F004003_F>mH0002keP01000keS_F0001^mH0`00RNmH00<`
7nmHkeP0c^mH000YkeP01000keS_F0000nmH00@00>mHkeP000;_F004003_F>mH0006keP00`00keS_
F02:keP2<1o>keP002[_F003003_F00000?_F004003_F>mH0002keP01000keS_F0001^mH00<00>mH
keP0S>mH00<`7nmHkeP0bnmH000[keP20003keP01000keS_F0000^mH00@00>mHkeP000K_F003003_
F>mH08g_F08`7l__F000;>mH00<00>mHkeP00^mH0P001>mH0P001nmH00<00>mHkeP0SnmH00<`7nmH
keP0b>mH0010keP00`00keS_F02@keP2<1o8keP0043_F003003_F>mH09;_F003<1o_F>mH0<G_F000
@>mH00<00>mHkeP0TnmH00<`7nmHkeP0a>mH0010keP2002EkeP2<1o4keP0043_F003003_F>mH09K_
F003<1o_F>mH0<7_F000@>mH00<00>mHkeP0UnmH0S0O`NmH0010keP00`00keS_F02IkeP00c0OkeS_
F02nkeP0043_F003003_F>mH09[_F003<1o_F>mH0;g_F000@>mH00<00>mHkeP0VnmH0S0O_NmH0010
keP00`00keS_F02MkeP00c0OkeS_F02jkeP0043_F003003_F>mH09k_F08`7k[_F000@>mH00<00>mH
keP0X>mH00<`7nmHkeP0]nmH0010keP2002RkeP00c0OkeS_F02fkeP0043_F003003_F>mH0:;_F08`
7kK_F000@>mH00<00>mHkeP0Y>mH00<`7nmHkeP0/nmH0010keP00`00keS_F02UkeP2<1nckeP0043_
F003003_F>mH0:O_F003<1o_F>mH0;3_F000@>mH00<00>mHkeP0Z>mH00<`7nmHkeP0[nmH0010keP0
0`00keS_F02YkeP2<1n_keP0043_F003003_F>mH0:__F003<1o_F>mH0:c_F000@>mH0P00[NmH0S0O
[>mH0010keP00`00keS_F02^keP00c0OkeS_F02YkeP0043_F003003_F>mH0:o_F003<1o_F>mH0:S_
F000@>mH00<00>mHkeP0/>mH0S0OZ>mH0010keP00`00keS_F02bkeP00c0OkeS_F02UkeP0043_F003
003_F>mH0;?_F003<1o_F>mH0:C_F000:nmH0P001>mH0P001>mH0P001nmH00<00>mHkeP0]>mH0S0O
Y>mH000ZkeP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0006keP00`00keS_F02fkeP0
0c0OkeS_F02QkeP002[_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP000K_F0<00;O_
F003<1o_F>mH0:3_F000:^mH0`000nmH00@00>mHkeP000;_F004003_F>mH0006keP00`00keS_F02h
keP2<1nPkeP002[_F003003_F>mH00?_F004003_F>mH0002keP01000keS_F0001^mH00<00>mHkeP0
^^mH00<`7nmHkeP0WNmH000ZkeP00`00keS_F003keP01000keS_F0000^mH00@00>mHkeP000K_F003
003_F>mH0;__F003<1o_F>mH09c_F000:nmH0`000nmH0P001>mH0P001nmH00<00>mHkeP0_>mH0S0O
W>mH0010keP00`00keS_F02nkeP00c0OkeS_F02IkeP0043_F003003_F>mH0;o_F003<1o_F>mH09S_
F000@>mH00<00>mHkeP0`>mH0S0OV>mH0010keP00`00keS_F032keP00c0OkeS_F02EkeP0043_F080
0<C_F003<1o_F>mH09C_F000@>mH00<00>mHkeP0a>mH0S0OU>mH0010keP00`00keS_F036keP00c0O
keS_F02AkeP0043_F003003_F>mH0<O_F003<1o_F>mH093_F000@>mH00<00>mHkeP0b>mH00<`7nmH
keP0SnmH0010keP00`00keS_F039keP00c0OkeS_F02>keP0043_F003003_F>mH0<[_F08`7hk_F000
@>mH00<00>mHkeP0c>mH00<`7nmHkeP0RnmH0010keP2003>keP00c0OkeS_F02:keP0043_F003003_
F>mH0<k_F003<1o_F>mH08W_F000@>mH00<00>mHkeP0cnmH00<`7nmHkeP0R>mH0010keP00`00keS_
F03@keP00c0OkeS_F027keP0043_F003003_F>mH0=7_F08`7hO_F000@>mH00<00>mHkeP0dnmH00<`
7nmHkeP0Q>mH0010keP00`00keS_F03DkeP00c0OkeS_F023keP0043_F003003_F>mH0=G_F003<1o_
F>mH08;_F000@>mH00<00>mHkeP0e^mH00<`7nmHkeP0PNmH0010keP2003HkeP00c0OkeS_F020keP0
043_F003003_F>mH0=S_F08`7h3_F000@>mH00<00>mHkeP0f^mH00<`7nmHkeP0ONmH0010keP00`00
keS_F03KkeP00c0OkeS_F01lkeP0043_F003003_F>mH0=c_F003<1o_F>mH07__F000@>mH00<00>mH
keP0gNmH00<`7nmHkeP0N^mH000[keP20004keP20004keP20007keP00`00keS_F03NkeP00c0OkeS_
F01ikeP002[_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP000K_F003003_F>mH0=o_
F08`7gW_F000:^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0001^mH0`00hNmH00<`
7nmHkeP0M^mH000[keP20003keP01000keS_F0000^mH00@00>mHkeP000K_F003003_F>mH0>;_F003
<1o_F>mH07G_F000:^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0001^mH00<00>mH
keP0hnmH00<`7nmHkeP0M>mH000ZkeP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0006
keP00`00keS_F03TkeP00c0OkeS_F01ckeP002__F08000C_F08000C_F08000O_F003003_F>mH01o_
F<@000;_F003<1o_F>mH07;_F000@>mH00<00>mHkeP07nmHa0000nmH0S0OL^mH0010keP00`00keS_
F00OkeS40005keP00c0OkeS_F01_keP0043_F003003_F>mH01o_F<@000K_F003<1o_F>mH06k_F000
@>mH0P008>mHa0001nmH00<`7nmHkeP0KNmH0010keP00`00keS_F00OkeS40008keP00c0OkeS_F01/
keP0043_F003003_F>mH01o_F<@000W_F003<1o_F>mH06__F000@>mH00<00>mHkeP07nmHa0002^mH
00<`7nmHkeP0J^mH0010keP00`00keS_F00OkeS4000;keP2<1mZkeP0043_F003003_F>mH01G_F<h0
00g_F003<1o_F>mH06O_F000@>mH00<00>mHkeP05NmH00<00?ooool0`Ooo2P003^mH00<`7nmHkeP0
I^mH0010keP00`00keS_F00EkeP00`00ooooo`31ool:000?keP00c0OkeS_F01UkeP0043_F003003_
F>mH01G_F003003ooooo0<7oo`X0013_F003<1o_F>mH06C_F000@>mH0P005^mH00<00?ooool0`Ooo
2P004NmH00<`7nmHkeP0HnmH0010keP00`00keS_F00EkeP00`00ooooo`31ool:000BkeP00c0OkeS_
F01RkeP0043_F003003_F>mH01G_F003003ooooo0<7oo`X001?_F003<1o_F>mH067_F000@>mH00<0
0>mHkeP05NmH00<00?ooool0`Ooo2P005>mH00<`7nmHkeP0H>mH0010keP00`00keS_F00EkeP00`00
ooooo`0Jool20002ool200001?oo000000000_oo1@0000?oo`0000000_oo0P0000Coo`00000008_o
o`X001G_F003<1o_F>mH05o_F000@>mH00<00>mHkeP05NmH00@00?oooooooaGh4`Goo`04003ooooo
0003ool00`00ooooo`02ool01000ooooo`000_oo00@00?ooool000;oo`04003ooooo002:ool:000F
keP00c0OkeS_F01NkeP0043_F003003_F>mH01G_F003003ooooo01_oo`@000?oo`03003ooooo00;o
o`03003ooooo00?oo`@000Goo`03003ooooo08Soo`X001O_F003<1o_F>mH05g_F000@>mH00<00>mH
keP05NmH00<00?ooool06ooo00@00?ooool000?oo`03003ooooo00;oo`03003ooooo00?oo`04003o
oooo0003ool2002;ool:000HkeP00c0OkeS_F01LkeP0043_F08001K_F003003ooooo01coo`09003o
o`00ool00?oo003oo`0000;oo`03003ooooo00Coo`03003oo`0000;oo`03003ooooo08_oo`X001W_
F003<1o_F>mH05__F000@>mH00<00>mHkeP05NmH00<00?ooool06ooo0`000_oo1@0000Coo`000000
00Coo`<000Coo`<008[oo`X001[_F003<1o_F>mH05[_F000@>mH00<00>mHkeP05NmH00<00?ooool0
`Ooo2P006nmH00<`7nmHkeP0FNmH0010keP00`00keS_F00EkeP00`00ooooo`31ool:000LkeP00c0O
keS_F01HkeP0043_F003003_F>mH01G_F003003ooooo0<7oo`X001g_F003<1o_F>mH05O_F000@>mH
00<00>mHkeP05NmH00<00?ooool0`Ooo2P007^mH00<`7nmHkeP0E^mH0010keP00`00keS_F00EkeP0
0`00ooooo`31ool:000OkeP00c0OkeS_F01EkeP002C_F0@000?_F08000C_F08000C_F08000O_F003
003_F>mH01G_F003003ooooo0<7oo`X0023_F003<1o_F>mH05C_F0009^mH00D00>mHkeS_F00000;_
F004003_F>mH0002keP01000keS_F0000^mH00<00>mHkeP01>mH00<00>mHkeP05NmH00<00?ooool0
`Ooo2P008NmH00<`7nmHkeP0DnmH000VkeP01@00keS_F>mH00000^mH00@00>mHkeP000;_F004003_
F>mH0002keP00`00keS_F004keP3000EkeP00`00ooooo`31ool:000RkeP00c0OkeS_F01BkeP002K_
F005003_F>mHkeP00002keP01000keS_F0000^mH00@00>mHkeP000;_F003003_F>mH00C_F003003_
F>mH01G_F003003ooooo0<7oo`X002?_F08`7e;_F0009^mH00D00>mHkeS_F00000;_F004003_F>mH
0002keP01000keS_F0000^mH00<00>mHkeP01>mH00<00>mHkeP05NmH00<00?ooool0`Ooo2P009NmH
00<`7nmHkeP0CnmH000TkeP30003keP01000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0006
keP00`00keS_F00EkeP00`00ooooo`0Jool200000ooo00000003ool200000ooo003oo`02ool20000
1Ooo00000000ool00P000_oo0`0000Goo`00ool00?oo008000;oo`800003ool00?oo00;oo`8000;o
o`D000;oo`8000Coo`800003ool00?oo06Coo`X002K_F003<1o_F>mH04k_F0009^mH00<00>mHkeP0
0^mH0P001>mH0P001>mH0P001nmH00<00>mHkeP05NmH00@00?oooooooaD`7`Coo`05003oooooool0
0002ool01000ooooo`000ooo00H00?ooool00?oo0002ool01000ooooo`001?oo00D00?oo003oo`00
00;oo`04003ooooo0003ool01000ooooo`000ooo00D00?ooooooo`0000;oo`04003ooooo0002ool0
0`00ooooo`1Tool:000WkeP00c0OkeS_F01=keP0043_F003003_F>mH01G_F003003ooooo01[oo`05
003oo`00ool00003ool30003ool00`00ooooo`02ool01000ooooo`000_oo0`000_oo00D00?oo003o
o`0000?oo`<000?oo`03003ooooo00Coo`05003oooooool00006ool3001Vool:000XkeP00c0OkeS_
F01<keP0043_F003003_F>mH01G_F003003ooooo01[oo`05003oo`00ool00005ool01@00oooooooo
00001?oo00@00?ooool000;oo`0:003ooooo003oo`00ool00?oo0005ool01@00oooooooo00001_oo
00D00?ooooooo`0000;oo`03003ooooo00?oo`03003ooooo06Coo`X002W_F003<1o_F>mH04__F000
@>mH00<00>mHkeP05NmH00<00?ooool06_oo0P0000?oo`0000000ooo0P000ooo10000_oo0`001?oo
0P000_oo0P0000?oo`00ool00ooo0P000ooo10000ooo0P001?oo0P001?oo0P00Iooo2P00:^mH00<`
7nmHkeP0B^mH0010keP2000FkeP00`00ooooo`0Jool01@00oooooooo00002Ooo00<00?ooool00_oo
00<00?ooool05_oo00<00?ooool0N?oo2P00:nmH00<`7nmHkeP0BNmH0010keP00`00keS_F00EkeP0
0`00ooooo`0Xool01000oooooooo0P006?oo00<00?ooool01?oo00<00?ooool0LOoo2P00;>mH00<`
7nmHkeP0B>mH0010keP00`00keS_F00EkeP00`00ooooo`31ool:000]keP00c0OkeS_F017keP0043_
F003003_F>mH01G_F003003ooooo0<7oo`X002k_F003<1o_F>mH04K_F000@>mH00<00>mHkeP05NmH
00<00?ooool0`Ooo2P00;nmH00<`7nmHkeP0ANmH0010keP00`00keS_F00EkeP00`00ooooo`31ool:
000`keP00c0OkeS_F014keP0043_F003003_F>mH01G_F003003ooooo0<7oo`X0037_F003<1o_F>mH
04?_F000@>mH00<00>mHkeP05NmH00<00?ooool0`Ooo2P00<^mH00<`7nmHkeP0@^mH0010keP2000F
keP00`00ooooo`1;ool30008ool3001Xool:000bkeP00c0OkeS_F012keP0043_F003003_F>mH01G_
F003003ooooo04koo`03003ooooo00Koo`03003ooooo06Ooo`X003?_F003<1o_F>mH047_F000@>mH
00<00>mHkeP05NmH00<00?ooool0?_oo10000ooo1@000_oo0`002?oo0`000ooo10000ooo0P000_oo
10000ooo1@000_oo0`0000Goo`00ool00?oo0080047oo`X003C_F003<1o_F>mH043_F000@>mH00<0
0>mHkeP05NmH00<00?ooool0?ooo00@00?ooool000Coo`05003oooooool00002ool00`00ooooo`06
ool01000ooooo`000ooo00<00?ooool00_oo00@00?ooool000;oo`04003ooooo0004ool01@00oooo
oooo00001?oo00D00?oo003oo`0004;oo`03003_F>mH03c_F003<1o_F>mH03o_F000@>mH00<00>mH
keP05NmH00<00?ooool0?ooo00@00?ooool000Coo`05003oooooool00002ool00`00ooooo`06ool0
1000ooooo`000ooo00<00?ooool00_oo00@00?ooool000;oo`04003ooooo0004ool01000oooooooo
0`000_oo00D00?oo003oo`0004;oo`03003_F>mH03g_F003<1o_F>mH03k_F000@>mH00<00>mHkeP0
5NmH00<00?ooool0?ooo0`001Ooo00D00?ooooooo`0000;oo`03003ooooo00Koo`04003ooooo0003
ool00`00ooooo`02ool01000ooooo`000_oo00@00?ooool000Coo`05003oooooool00002ool01`00
ool00?oo003oo`0004;oo`03003_F>mH03k_F003<1o_F>mH03g_F000@>mH00<00>mHkeP05NmH00<0
0?ooool0?ooo00@00?ooool000?oo`8000Coo`800003ool00?oo00Goo`04003oo`000003ool00`00
ool000020002ool20003ool30005ool00`00ooooo`02ool20002ool200000ooo003oo`12ool00`00
keS_F00okeP00c0OkeS_F00lkeP0043_F003003_F>mH01G_F003003ooooo03koo`@002Ooo`03003o
oooo00Goo`03003ooooo04goo`03003_F>mH043_F003<1o_F>mH03__F000@>mH00<00>mHkeP05NmH
00<00?ooool0Aooo00<00?ooool07_oo0P001_oo0P00Cooo00<00>mHkeP0@NmH00<`7nmHkeP0>^mH
0010keP2000FkeP00`00ooooo`31ool00`00keS_F012keP00c0OkeS_F00ikeP0043_F003003_F>mH
01G_F003003ooooo0<7oo`03003_F>mH04?_F003<1o_F>mH03S_F000@>mH00<00>mHkeP05NmH00<0
0?ooool0`Ooo00<00>mHkeP0A>mH00<`7nmHkeP0=nmH0010keP00`00keS_F00EkeS50017keP00c0O
keS_F00fkeP0043_F003003_F>mH0?o_F2?_F003<1o_F>mH03G_F000@>mH00<00>mHkeP0onmH9>mH
00<`7nmHkeP0=>mH000TkeP40002keP40003keP20004keP20007keP00`00keS_F03okePUkeP00c0O
keS_F00ckeP002K_F005003_F>mHkeP00005keP01000keS_F0000^mH00@00>mHkeP000K_F003003_
F>mH0?o_F2K_F003<1o_F>mH03;_F0009^mH00<00>mHkeP00^mH00<00>mHkeP00^mH00@00>mHkeP0
00;_F004003_F>mH0006keP3003okePWkeP00c0OkeS_F00akeP002K_F003003_F>mH00?_F005003_
F>mHkeP00002keP01000keS_F0000^mH00<00>mHkeP01>mH00<00>mHkeP0onmH:>mH00<`7nmHkeP0
<>mH000VkeP00`00keS_F004keP01000keS_F0000^mH00@00>mHkeP000;_F003003_F>mH00C_F003
003_F>mH0?o_F2W_F003<1o_F>mH02o_F0009>mH0`000nmH00@00>mHkeP000;_F004003_F>mH0002
keP01000keS_F0001^mH00<00>mHkeP0onmH:^mH00<`7nmHkeP0;^mH000VkeP00`00keS_F002keP2
0004keP20004keP20007keP00`00keS_F03okeP[keP00c0OkeS_F00]keP0043_F003003_F>mH0?o_
F5__F000@>mH00<00>mHkeP0onmHFnmH0010keP00`00keS_F03okeQKkeP0043_F003003_F>mH0?o_
F5__F000@>mH0P00onmHG>mH003okeRNkeP00?o_F9k_F000onmHW^mH003okeRNkeP00?o_F9k_F000
onmHW^mH003okeRNkeP00?o_F9k_F000onmHW^mH003okeRNkeP00?o_F9k_F000;>mH0`001>mH0`00
0nmH0P001>mH0P000^mH0`0000?_F00000000^mH0P0000?_F000keP00`00onmHBnmH000/keP01000
keS_F0000^mH00<00>mHkeP00nmH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000^mH
00@00>mHkeP000G_F003003_F>mH0?o_F4S_F000;nmH00<00>mHkeP00`000nmH00<00>mHkeP00nmH
00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000nmH0P00onmHBnmH000]keP20003keP0
1000keS_F0000^mH00@00>mHkeP000;_F004003_F>mH0002keP01000keS_F0000^mH00@00>mHkeP0
00;_F003003_F>mH0?o_F4__F000;>mH00<00>mHkeP01>mH0P001>mH0P001>mH0P000^mH00@00>mH
000000C_F0<000?_F0<00?o_F4[_F000;NmH0`007NmH00<00>mHkeP0onmHC^mH001<keP2003okeQ@
keP00?o_F9k_F000onmHW^mH003okeRNkeP00?o_F9k_F000onmHW^mH003okeRNkeP00001\
\>"],
  ImageRangeCache->{{{0, 412}, {254.125, 0}} -> {-1.05208, -0.648936, \
0.00510719, 0.00510719}, {{10.1875, 401.75}, {248.062, 6}} -> {968.809, \
-116.214, 8.29951, 5.96231}, {{88.5, 284.312}, {87.875, 38.9375}} -> \
{-4.33329, -12.0583, 0.0478164, 0.0719292}, {{92.25, 113.188}, {85.3125, \
71.4375}} -> {-4.65132, -28.5221, 0.0501498, 0.162288}, {{92.25, 113.188}, \
{69.1875, 55.3125}} -> {-4.65132, -31.139, 0.0501498, 0.162288}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Accuracy of the result", "Subsection",
  CellTags->"Accuracy of the result"],

Cell[TextData[{
  "According to ",
  ButtonBox["Weller",
    ButtonData:>"Weller",
    ButtonStyle->"Hyperlink"],
  " an estimate for the accuracy can be computed by the following formula:\n\t\
accuracy = ",
  StyleBox["t",
    FontSlant->"Italic"],
  " - \[Alpha] - 1\nwhere ",
  StyleBox["t",
    FontSlant->"Italic"],
  " is the floating-point digits (16 in our case), \[Alpha] computes from ",
  StyleBox["cond",
    FontSlant->"Italic"],
  "( ",
  StyleBox["m",
    FontSlant->"Italic"],
  " ) = ",
  Cell[BoxData[
      \(TraditionalForm\`10\^\[Alpha]\)]],
  ", where ",
  StyleBox["cond",
    FontSlant->"Italic"],
  "( ",
  StyleBox["m",
    FontSlant->"Italic"],
  " ) is the condition number of matrix ",
  StyleBox["m",
    FontSlant->"Italic"],
  " and is computed by ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(||\)\(m\)\( || \_\[Infinity]\)\(\(.\)\(\(||\)\(m\
\^\(-1\)\)\( || \_\[Infinity]\)\)\)\)\)]],
  "\nWe have found that the solutions returned (for small problem sizes) \
always full filled the accuracy request."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["The transparent user interface prototype", "Subsection",
  CellTags->"The transparent user interface"],

Cell["The following is a suggestion for a user interface.", "Text"],

Cell[BoxData[{
    \(\(Options[\ LUSolve\ ]\  := \ {\ 
          ATLAS\  \[Rule] \ False\ };\)\), "\[IndentingNewLine]", 
    \(\(\(LUSolve::"\<Error\>" = \ "\<in the wrapper\>";\)\(\
\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(\(LUSolve[\ inMatrix_, \ loadMatrix_, \ opts___\ ?OptionQ]\  := \ 
        Module[\ {\ 
            res\ }, \[IndentingNewLine]ATLASQ\  = \ \(ATLAS\  /. \ {\ 
                  opts\ }\)\  /. \ 
              Options[\ 
                imsLUSolve\ ]; \[IndentingNewLine]\[IndentingNewLine]If[\ 
            ATLASQ, \[IndentingNewLine]res\  := 
              atLUSolve[\ inMatrix, \ 
                loadMatrix\ ], \[IndentingNewLine]res\  := \ 
              Transpose[\ 
                LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ 
                  Transpose[
                    loadMatrix\ ]\ ]\ ], \[IndentingNewLine]\(\(Message[\ 
                  LUSolve::"\<Error\>"\ ];\);\)\[IndentingNewLine]\ ]; \
\[IndentingNewLine]\[IndentingNewLine]Return[\ 
            res\ ];\[IndentingNewLine]]\ ;\)\)}], "InputOnly"]
}, Closed]],

Cell[CellGroupData[{

Cell["Portability", "Subsection",
  CellTags->"Portability"],

Cell[CellGroupData[{

Cell["Makefiles", "Subsubsection"],

Cell["\<\
Our first attempt was to use ordinary make files. This, however, imposed the \
following problems: In our heterogenous university computer environment it \
was difficult to maintain different makefiles simultaneously. \
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["GNU configure", "Subsubsection"],

Cell[TextData[{
  "The GNU configure script provides a mean to automate makefile generation \
to a great extend. Due to the ever increasing popularity of GNU software, the \
familiarity with the ",
  StyleBox["configure-make-install",
    FontSlant->"Italic"],
  " cycle is also increasing. The ease to dictate the installation \
requirements is astonishing.\nThe problem encountered on MacOS X platform - \
where it is common to have spaces in path names - will surely be overcome in \
the near future, since Apples new affiliation with UNIX would leave them out \
the tremendous wealth of GNU software, ignoring this problem.\nSince the \
average ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " user can not be expected to be a programming expert the installation of \
the missing link, the interface should be as easy as possible. We found that \
configure scripts helped us doing this."
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Conclusion", "Subsection",
  CellTags->"Conclusion"],

Cell[TextData[{
  "We would like to draw the following conclusions.\nFirst there is a need \
for the flexibility to decide whether to use arbitrary precision,  a high \
level of abstraction or fast libraries. \nWe appreciate that ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " is straight forward to use for an average C programmer. We see ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  "s main purpose in distributed connections to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " but find the overhead too restrictive for large numerical applications. \
Closely related there is a need for the possibility to access the kernel \
memory in order to circumvent to duplicate memory in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["and",
    FontWeight->"Bold"],
  " the external program. With all this in mind, it would be preferable that \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " should keep the option for power users to supply their own machine tuned \
libraries. At the current state it is possible to have a high level of \
abstraction ",
  StyleBox["or",
    FontWeight->"Bold"],
  " good performance; however not both.\nWe delivered a prototype for an \
interface, ensuring its portability with GNU configure scripts."
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Quadpack Interface", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  "In the Lapack case, the use of ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " is straightforward, most of the effort being in performing tidy \
interfacing and argument checking in the calling package. In effect, one just \
needs to pass a data array back and forth between the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " kernel and an external library. In general, however, requirements exist \
where it is also necessary to pass a user-defined function to an external \
subroutine. To illustrate the point we consider the case where we wish to \
numerically integrate an expression (a function) in a high-dimensional space. \
We show how this can be also done with ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  ", and that the performance gains of using ",
  ButtonBox["Quadpack",
    ButtonData:>"Quadpack",
    ButtonStyle->"Hyperlink"],
  " over ",
  StyleBox["NIntegrate",
    FontSlant->"Italic"],
  " are worth the effort. Most importantly, this case shows that the \
combination of ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and Netlib offers significant advantages over packages that also make \
available the Quadpack subroutine, since the user is able to exploit the full \
expressive power of ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " for the integrand. In this case care must be taken in constructing the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " package so that use of the functionality remains transparent to the user, \
but robust, and we discuss this aspect extensively in the full paper."
}], "Text"],

Cell[CellGroupData[{

Cell["The problem set", "Subsection"],

Cell[TextData[{
  "Starting from the need to integrate a function, we explore to \
possibilities:\n\ta) Compile the integral kernel into the external interface \
code\n\tb) Leave the evaluation of the integral kernel to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " "
}], "Text"],

Cell["Consider the performance of the example integral:", "Text"],

Cell[BoxData[
    \(\[Integral]\_\(-1000\)\%1000\ e\^\(-x\^2\)\ dx\)], "Input"],

Cell[TextData[{
  " The DQAGS routine uses 735 function evaluations versus NIntegrate, which \
uses 440. The result was found to have a relative precision ",
  Cell[BoxData[
      \(TraditionalForm\`10\^\(-6\)\)]],
  ". The",
  " pure C-Code Quadpack in double precision was found to be 40 times faster \
than NIntegrate. Compiling the kernel function ",
  Cell[BoxData[
      \(TraditionalForm\`e\^\(-x\^2\)\)]],
  " into the external interface and calling the interface (integralExp) via \
",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " was 11 times faster than NIntegrate. The improvement is thus of interest \
for high dimensional problems. This means we have an ",
  StyleBox["increased number of function evaluations in the external code but \
",
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " overhead remains constant. \nTo overcome the restriction of compiling the \
integral kernel function into the external code ",
  StyleBox["a",
    FontVariations->{"CompatibilityType"->0}],
  " more flexible solution is proposed. The idea is now to compute the \
function evaluations in ",
  StyleBox["Mathematica.",
    FontSlant->"Italic"],
  " This, however, proved to be 6 times slower than by NInegrate. An \
improvement could be found by  compiling the kernel function.  We found this \
procedere still slower than NIntegrate.\nAnalysing the measured computation \
times transferring a double 735 times",
  StyleBox[" between ",
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["Mathematica",
    FontSlant->"Italic",
    FontVariations->{"CompatibilityType"->0}],
  StyleBox[" and the external code makes up for almost all the consumed time. \
The ",
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["MathLink",
    FontSlant->"Italic",
    FontVariations->{"CompatibilityType"->0}],
  StyleBox[" overhead is not negligible.",
    FontVariations->{"CompatibilityType"->0}]
}], "Text",
  CellDingbat->None,
  FontSize->12]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Conclusion", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  "We have created a user-transparent and efficient interfacing of the Netlib \
packages Lapack and Quadpack using ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  ", providing the full power of optimized numerical linear algebra packages \
to the average ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " user. In doing so, we have addressed the careful interfacing of these \
packages to achieve robustness of use. We have compared the performance of \
our package, including overhead, on a number of platforms available in our \
heterogeneous university computing environment, and have shown that the \
increase in computational speed over the built-in functions is significant. \
This work forms part of an on-going ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " effort at our site a) to develop robust numerical tools that combine \
symbolic computation with a primarily functional implementation, and b) the \
application of the tools to the simulation of complex nanosystems."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Setup", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  "This section describes on how to prepare your system for interfacing ATLAS \
from ",
  StyleBox["Mathematica.",
    FontSlant->"Italic"],
  " "
}], "Text"],

Cell[CellGroupData[{

Cell["Get ATLAS and compile it.", "Subsection"],

Cell[TextData[{
  "As a first step you will need ATLAS, which stands for Automatically Tuned \
Linear Algebra Software (ATLAS). You'll get ATLAS from\n",
  ButtonBox["http://math-atlas.sourceforge.net",
    ButtonData:>{
      URL[ "http://math-atlas.sourceforge.net/"], None},
    Active->True,
    ButtonStyle->"Hyperlink"],
  "\nAsk your local guru to help install it for you ;-) To fully utilise the \
power of ATLAS, it must be compiled on each host platform you want to use the \
interface on. "
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Get MathLib and install it", "Subsection"],

Cell["\<\
The MathLib provides us with extended timing tools and the C source code for \
the interface to ATLAS.\
\>", "Text"],

Cell[CellGroupData[{

Cell["All operating systems", "Subsubsection"],

Cell["Connect to", "Text"],

Cell["\<\
me@local:>ftp ftp://elmo.imtek.uni-freiburg.de
ftp>cd /pub/Mathematica/MathLib
ftp> get MathLib.tgz
ftp> quit\
\>", "Program"],

Cell[TextData[{
  "unpack the MathLib.tgz in a temporary directory. Put the contents into the \
proper place. That is either in the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " home directory or in you personal ./",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " directory"
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Results", "Subsubsection"],

Cell[TextData[{
  "As a result you fill have the MathLib packages that may either be in the \
system-wide ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " directory or in a personal directory, for example in ~/.",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "/4.2/\nIn any case you have an ../Applications/Imtek/ directory under \
which you'll find everything needed for the MathLib interface"
}], "Text"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Compile the ATLAS interface", "Subsection"],

Cell[TextData[{
  "Change into the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " home directory where you have installed the MathLib interface to. You \
will find an Imtek directory under which there is an Interfaces directory and \
inside that the ATLAS directory. In the ATLAS directory you will find a GNU \
configure script,which we will use to set up the interface between \
Mathematica and ATLAS."
}], "Text"],

Cell[CellGroupData[{

Cell["Configure the interface", "Subsubsection"],

Cell[TextData[{
  "The GNU configure script will help you build the C interface between ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and ATLAS on a variety of platforms and to install the interface.\nThe \
configure script will help to link the interface to your hosts ATLAS \
libraries. Typically the ATLAS libraries will reside in directories called \
according to the platform they were compiled on.\nRun "
}], "Text"],

Cell[TextData[{
  "./",
  StyleBox["configure.",
    FontSlant->"Italic"]
}], "Program"],

Cell[TextData[{
  "If the scripts fails it will print detailed information which options you \
can use to assist the script in finding the necessary libraries\nIf you would \
later like to install the binaries of the interface in a non standard place \
(standard is /usr/local/bin ) you must also give the ",
  StyleBox["--prefix=dir",
    FontSlant->"Italic"],
  " option to the configure script and specify an alternative directory ",
  StyleBox["dir",
    FontSlant->"Italic"],
  ". Remember that the interface will be overwritten should you recompile the \
code (on another machine for example). You could create a directory according \
to the ATLAS name of your architecture and install the binaries there. E.g : \
/usr/local/Wolfram/Linux_P4SSE2\n",
  StyleBox["./configure --help",
    FontSlant->"Italic"],
  " prints some additional hints."
}], "Text"],

Cell["\<\
Unfortunately the configure script does not handle spaces in path names well. \
Please use a path without spaces.\
\>", "Text",
  CellDingbat->"\[SadSmiley]"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Compile the interface", "Subsubsection"],

Cell["Next compile the code by typing", "Text"],

Cell[TextData[StyleBox["make",
  FontSlant->"Italic"]], "Program"],

Cell["You can then", "Text"],

Cell[TextData[{
  StyleBox["make install",
    FontSlant->"Italic"],
  ". "
}], "Program"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Load the necessary packages", "Subsection"],

Cell[BoxData[{
    \(<< Imtek`Utilities`ExtendedTiming`\), "\[IndentingNewLine]", 
    \(<< LinearAlgebra`MatrixManipulation`\), "\[IndentingNewLine]", 
    \(<< Graphics`Legend`\)}], "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Linear algebra with Lapack", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  ButtonBox["LAPACK",
    ButtonData:>"Lapack",
    ButtonStyle->"Hyperlink"],
  " is currently one of the most powerful publicly-available linear algebra \
numerical libraries. It is also very robust and hence reliable. Many of its \
subroutines are designed in a way that efficiently utilizes the processor's \
cache. This is done by introducing the so-called third level ",
  ButtonBox["BLAS",
    ButtonData:>"BLAS",
    ButtonStyle->"Hyperlink"],
  "  (Basic Linear Algebra Subprograms) in which a dense matrix is split to \
smaller blocks, each closely matching the size of the processor cache. We \
demonstrate how we have packaged Lapack so that using its subroutines from \
within ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " appears completely consistent to the user. In addition, we show that this \
works on any of a number of platforms (SunOS, Linux, MacOS-X ) and that the \
attained performance gains when compared to ",
  StyleBox["LUDecomposition",
    FontSlant->"Italic"],
  " are significant."
}], "Text"],

Cell[CellGroupData[{

Cell["Set me up - YOU must edit this!", "Subsection"],

Cell[TextData[{
  "Sine the ",
  StyleBox["Mathematica ",
    FontSlant->"Italic"],
  "ATLAS interface binaries are installed in a computer architecture \
dependent directory you must specify the path to that directory. The Imtek \
default is"
}], "Text"],

Cell[BoxData[
    \(\(atlasInterfacePath = \
"\</usr/groups/simulation/platform/common/binMathematica\>";\)\)], "Input"],

Cell["On my laptop", "Text"],

Cell[BoxData[
    \(\(atlasInterfacePath = "\</usr/local/Wolfram\>";\)\)], "Input"],

Cell["Specify the architecture and binary directory.", "Text"],

Cell[BoxData[
    \(\(arch = "\</Linux_P4SSE2/bin\>";\)\)], "Input"],

Cell["Other possibilities here at Imtek are:", "Text"],

Cell["\<\
$arch=\"SunOS_SunUSX/bin\"
$arch=\"SunOS_SunUSX_4/bin\"\
\>", "Program"]
}, Closed]],

Cell[CellGroupData[{

Cell["Prerequisites - functions and wrappers", "Subsection"],

Cell["\<\
We define some functions and wrappers for convenience. The test vectors and \
matrices depend on a problem size, say N and return a 1 x N column vector and \
a N x N matrix, respectively. Both entities are filled with random data.\
\>", "Text"],

Cell[BoxData[{
    \(\(TestMatrix[\ orderN_Integer\ ] := \ 
        Table[\ Random[\ Real\ ], {\ orderN\ }, {\ 
            orderN\ }\ ];\)\), "\[IndentingNewLine]", 
    \(\(TestVector[\ orderN_Integer\ ]\  := \ 
        Table[\ Random[\ Real\ ], \ {\ orderN\ }, \ {\ 1\ }\ ];\)\)}], "Input",\

  InitializationCell->True],

Cell[TextData[{
  "To analyses the timing behavior of a range of different problems sizes we \
have two wrapper functions which will simplify this. One is for ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " internal timing and the other for external timing. The reason why an \
external timing is necessary will be discussed below."
}], "Text"],

Cell[BoxData[
    \(\(internalTiming[\ function_, \ start_, \ stop_, \ 
          stepSize_\ ]\  := \ \(\((\[IndentingNewLine]inMatrix\  = \ 
                TestMatrix[\ #1\ ]; \[IndentingNewLine]\ {\ #1, \ \(Timing[\ \
\(function[\ inMatrix\ ];\)\ ]\)[\([\ 1\ ]\)]\  /. \ 
                  Second\  \[Rule] \ 
                    1\ \ }\ \[IndentingNewLine])\) &\)\  /@ \ 
          Range[\ start, \ stop, \ \ stepSize\ ];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(externalTiming[\ function_, \ start_, \ stop_, \ 
          stepSize_\ ]\  := \ \(\((\[IndentingNewLine]inMatrix\  = \ 
                TestMatrix[\ #1\ ]; \[IndentingNewLine]\ {\ #1, \ 
                AveragedTiming[\ function[\ inMatrix\ ], \ 
                  10\ ]\ }\ \[IndentingNewLine])\) &\)\  /@ \ 
          Range[\ start, \ stop, \ \ stepSize\ ];\)\)], "Input",
  InitializationCell->True],

Cell["\<\
In the last part of the paper the previously defined timing wrappers will not \
suffice and hence some additional wrapper are defined. They differ in the way \
they call the internal and external LU decomposition and the timing mechanism \
at hand.\
\>", "Text"],

Cell[BoxData[
    \(\(timingMatLU[\ start_, \ stop_, \ 
          stepSize_\ ]\  := \ \(\((\[IndentingNewLine]inMatrix\  = \ 
                TestMatrix[\ #1\ ]; \[IndentingNewLine]loadVector\  = \ 
                TestVector[\ #1\ ]; \[IndentingNewLine]{#1\ , \ \(Timing[\ 
                      LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ 
                        loadVector\ ]\ ]\)[\([\ 1\ ]\)]\  /. \ 
                  Second\  \[Rule] \ 1\ \ }\[IndentingNewLine])\) &\)\  /@ \ 
          Range[\ start, \ stop, \ \ stepSize\ ];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(timingMatLUMany[\ start_, \ stop_, \ 
          stepSize_\ ]\  := \ \(\((\[IndentingNewLine]inMatrix\  = \ 
                TestMatrix[\ #1\ ]; \[IndentingNewLine]loadMatrix\  = \ 
                Transpose[\ 
                  TestMatrix[\ #1\ ]\ ]; \[IndentingNewLine]{#1\ , \ \
\(Timing[\ LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ 
                        loadMatrix\ ]\ ]\)[\([\ 1\ ]\)]\  /. \ 
                  Second\  \[Rule] \ 1\ \ }\[IndentingNewLine])\) &\)\  /@ \ 
          Range[\ start, \ stop, \ \ stepSize\ ];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(timingATLU[\ start_, \ stop_, \ 
          stepSize_\ ]\  := \ \(\((\[IndentingNewLine]inMatrix\  = \ 
                TestMatrix[\ #1\ ]; \[IndentingNewLine]loadVector\  = \ 
                TestVector[\ #1\ ]; \[IndentingNewLine]{#1\ , \ 
                AveragedTiming[\ atLUSolve[\ inMatrix\ , \ loadVector\ ], \ 
                  10\ ]\ \ }\[IndentingNewLine])\) &\)\  /@ \ 
          Range[\ start, \ stop, \ \ stepSize\ ];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(timingATLUMany[\ start_, \ stop_, \ 
          stepSize_\ ]\  := \ \(\((\[IndentingNewLine]inMatrix\  = \ 
                TestMatrix[\ #1\ ]; \[IndentingNewLine]loadMatrix\  = 
                TestMatrix[\ #1\ ]\ ; \[IndentingNewLine]{#1\ , \ 
                AveragedTiming[\ atLUSolve[\ inMatrix\ , \ loadMatrix\ ], \ 
                  10\ ]\ \ }\[IndentingNewLine])\) &\)\  /@ \ 
          Range[\ start, \ stop, \ \ stepSize\ ];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Timing", "Subsection"],

Cell[TextData[{
  "As indicated above two different timing mechanism were employed during our \
investigation. The reason follows. The ",
  StyleBox["Timing",
    FontSlant->"Italic"],
  " command measures the time required ",
  StyleBox["by the ",
    FontWeight->"Bold"],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" kernel",
    FontWeight->"Bold"],
  " to evaluate an expression. Since the ATLAS interface is an external \
program, we need a method take into account the time passed in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  StyleBox["and",
    FontWeight->"Bold"],
  " the external program. A solution is to measure the total time passed. The \
command ",
  StyleBox["ExtendedTiming",
    FontSlant->"Italic"],
  " from the MathLib interface provides just that. ",
  StyleBox["ExtendedTiming",
    FontSlant->"Italic"],
  " is based on measuring the ",
  StyleBox["SessionTime",
    FontSlant->"Italic"],
  " passed since the start of a particular (external) evaluation (See the ",
  "MathLib interface",
  " package description for further information)\nComparing ",
  StyleBox["Timing",
    FontSlant->"Italic"],
  " and ",
  StyleBox["ExtendedTiming",
    FontSlant->"Italic"],
  " reveals, however, the following problem"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(inMatrix\  = \ TestMatrix[\ 800\ ];\)\), "\[IndentingNewLine]", 
    \(Timing[\ \(LUDecomposition[\ inMatrix\ ];\)\ \ ]\)}], "Input"],

Cell[BoxData[
    \({2.56`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ExtendedTiming[\ \(LUDecomposition[\ inMatrix\ ];\)\ ]\)], "Input"],

Cell[BoxData[
    \({3.`, Null}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Since ",
  StyleBox["ExtendedTiming",
    FontSlant->"Italic"],
  " will return the ",
  StyleBox["SessionTime",
    FontSlant->"Italic"],
  " passed in units of integer seconds, a more precise measure is necessary: \
",
  StyleBox["AveragedTiming",
    FontSlant->"Italic"],
  " provides that. ",
  StyleBox["AveragedTiming",
    FontSlant->"Italic"],
  " will run the ",
  StyleBox["ExtendedTiming",
    FontSlant->"Italic"],
  " any number of times and average over the result.\nThe second reason for \
using ",
  StyleBox["AveragedTiming",
    FontSlant->"Italic"],
  " is the fact that interfacing an external program can wary greatly in \
terms of computational times. This observation is in accordance with ",
  ButtonBox["Miyaji",
    ButtonData:>"Miyaji",
    ButtonStyle->"Hyperlink"],
  ". Averaging over the measured time is an accurate enough remedy."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(inMatrix\  = \ TestMatrix[\ 800\ ];\)\), "\[IndentingNewLine]", 
    \(AveragedTiming[\ LUDecomposition[\ inMatrix\ ], \ 10\ ]\)}], "Input"],

Cell[BoxData[
    \(2.6`\)], "Output"]
}, Open  ]],

Cell["\<\
To additionally perform the back substitution does not cost much \
computational time.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(loadVector\  = \ TestVector[\ 800\ ];\)\), "\[IndentingNewLine]", 
    \(AveragedTiming[\ 
      LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ loadVector\ ], \ 
      10\ ]\)}], "Input"],

Cell[BoxData[
    \(2.6`\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "One additional note: Some of the old Unix ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " libraries were buggy. Make sure to download the latest version from \
Wolfram Research"
}], "Text",
  CellDingbat->"\[HappySmiley]"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "LUDecomposition in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Subsection"],

Cell[TextData[{
  StyleBox["We start our enterprise to speed up the LU decomposition by doing \
a timing analysis for the ",
    FontSlant->"Plain"],
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  StyleBox[" LUDecomposition.",
    FontSlant->"Plain"]
}], "Text",
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstMatLUDe\  = \ 
      internalTiming[\ LUDecomposition, \ 500, \ 1500, \ 100\ ]\)], "Input"],

Cell[BoxData[
    \({{500, 0.5700000000000114`}, {600, 1.0500000000000034`}, {700, 
        1.6899999999999944`}, {800, 2.530000000000007`}, {900, 
        3.620000000000003`}, {1000, 4.950000000000004`}, {1100, 
        6.5300000000000065`}, {1200, 8.58000000000001`}, {1300, 
        10.950000000000001`}, {1400, 13.620000000000013`}, {1500, 
        16.769999999999996`}}\)], "Output"]
}, Open  ]],

Cell["\<\
It is interesting to see a fit of the result. The time used to compute a LU \
decomposition increases with power of 3 with size of the matrix under \
consideration.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitMatLUDe\  = \ Fit[\ lstMatLUDe, \ {\ x^2, \ x\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.005534166920375881`\)\ x + 
      0.000010855274107451122`\ x\^2\)], "Output"]
}, Open  ]],

Cell["The result", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[\[IndentingNewLine]\ 
      ListPlot[\ lstMatLUDe\ , \ 
        DisplayFunction -> Identity], \[IndentingNewLine]Plot[\ 
        fitMatLUDe, \[IndentingNewLine]{x, \ 500, \ 1500}, 
        PlotStyle \[Rule] \ Hue[0.7], \ 
        DisplayFunction -> 
          Identity\[IndentingNewLine]], \[IndentingNewLine]AxesLabel \[Rule] \
{\ "\<N\>", \ "\<Seconds\>"\ }, \[IndentingNewLine]DisplayFunction \[Rule] \
$DisplayFunction\ \[IndentingNewLine]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0165787 0.0349875 [
[.30952 .00408 -9 -9 ]
[.30952 .00408 9 0 ]
[.5 .00408 -12 -9 ]
[.5 .00408 12 0 ]
[.69048 .00408 -12 -9 ]
[.69048 .00408 12 0 ]
[.88095 .00408 -12 -9 ]
[.88095 .00408 12 0 ]
[1.025 .01658 0 -4.90625 ]
[1.025 .01658 10 4.90625 ]
[.10655 .10405 -18 -4.5 ]
[.10655 .10405 0 4.5 ]
[.10655 .19152 -6 -4.5 ]
[.10655 .19152 0 4.5 ]
[.10655 .27898 -18 -4.5 ]
[.10655 .27898 0 4.5 ]
[.10655 .36645 -12 -4.5 ]
[.10655 .36645 0 4.5 ]
[.10655 .45392 -24 -4.5 ]
[.10655 .45392 0 4.5 ]
[.10655 .54139 -12 -4.5 ]
[.10655 .54139 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01658 m
.30952 .02283 L
s
[(800)] .30952 .00408 0 1 Mshowa
.5 .01658 m
.5 .02283 L
s
[(1000)] .5 .00408 0 1 Mshowa
.69048 .01658 m
.69048 .02283 L
s
[(1200)] .69048 .00408 0 1 Mshowa
.88095 .01658 m
.88095 .02283 L
s
[(1400)] .88095 .00408 0 1 Mshowa
.125 Mabswid
.16667 .01658 m
.16667 .02033 L
s
.21429 .01658 m
.21429 .02033 L
s
.2619 .01658 m
.2619 .02033 L
s
.35714 .01658 m
.35714 .02033 L
s
.40476 .01658 m
.40476 .02033 L
s
.45238 .01658 m
.45238 .02033 L
s
.54762 .01658 m
.54762 .02033 L
s
.59524 .01658 m
.59524 .02033 L
s
.64286 .01658 m
.64286 .02033 L
s
.7381 .01658 m
.7381 .02033 L
s
.78571 .01658 m
.78571 .02033 L
s
.83333 .01658 m
.83333 .02033 L
s
.07143 .01658 m
.07143 .02033 L
s
.02381 .01658 m
.02381 .02033 L
s
.92857 .01658 m
.92857 .02033 L
s
.97619 .01658 m
.97619 .02033 L
s
.25 Mabswid
0 .01658 m
1 .01658 L
s
gsave
1.025 .01658 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10405 m
.1253 .10405 L
s
[(2.5)] .10655 .10405 1 0 Mshowa
.11905 .19152 m
.1253 .19152 L
s
[(5)] .10655 .19152 1 0 Mshowa
.11905 .27898 m
.1253 .27898 L
s
[(7.5)] .10655 .27898 1 0 Mshowa
.11905 .36645 m
.1253 .36645 L
s
[(10)] .10655 .36645 1 0 Mshowa
.11905 .45392 m
.1253 .45392 L
s
[(12.5)] .10655 .45392 1 0 Mshowa
.11905 .54139 m
.1253 .54139 L
s
[(15)] .10655 .54139 1 0 Mshowa
.125 Mabswid
.11905 .03407 m
.1228 .03407 L
s
.11905 .05157 m
.1228 .05157 L
s
.11905 .06906 m
.1228 .06906 L
s
.11905 .08655 m
.1228 .08655 L
s
.11905 .12154 m
.1228 .12154 L
s
.11905 .13903 m
.1228 .13903 L
s
.11905 .15653 m
.1228 .15653 L
s
.11905 .17402 m
.1228 .17402 L
s
.11905 .20901 m
.1228 .20901 L
s
.11905 .2265 m
.1228 .2265 L
s
.11905 .244 m
.1228 .244 L
s
.11905 .26149 m
.1228 .26149 L
s
.11905 .29648 m
.1228 .29648 L
s
.11905 .31397 m
.1228 .31397 L
s
.11905 .33147 m
.1228 .33147 L
s
.11905 .34896 m
.1228 .34896 L
s
.11905 .38395 m
.1228 .38395 L
s
.11905 .40144 m
.1228 .40144 L
s
.11905 .41893 m
.1228 .41893 L
s
.11905 .43643 m
.1228 .43643 L
s
.11905 .47142 m
.1228 .47142 L
s
.11905 .48891 m
.1228 .48891 L
s
.11905 .5064 m
.1228 .5064 L
s
.11905 .5239 m
.1228 .5239 L
s
.11905 .55888 m
.1228 .55888 L
s
.11905 .57638 m
.1228 .57638 L
s
.11905 .59387 m
.1228 .59387 L
s
.11905 .61137 m
.1228 .61137 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .03652 Mdot
.11905 .05332 Mdot
.21429 .07571 Mdot
.30952 .1051 Mdot
.40476 .14323 Mdot
.5 .18977 Mdot
.59524 .24505 Mdot
.69048 .31677 Mdot
.78571 .39969 Mdot
.88095 .49311 Mdot
.97619 .60332 Mdot
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02289 L
.10458 .03324 L
.14415 .0443 L
.18221 .05618 L
.22272 .07016 L
.26171 .08492 L
.30316 .102 L
.34309 .11981 L
.3815 .13821 L
.42237 .15914 L
.46172 .18061 L
.49955 .20248 L
.53984 .22709 L
.57861 .25205 L
.61984 .27998 L
.65954 .30822 L
.69774 .33663 L
.73838 .36821 L
.77751 .39992 L
.81909 .43501 L
.85916 .4702 L
.89771 .50533 L
.93871 .54406 L
.97619 .58069 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{453.75, 280.438},
  ImageMargins->{{10, 10}, {10, 10}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`400075000161000`40n007h00OomkKa]kK003og]_6
g]/008?Nf`8000CNf`8000CNf`8003cNf`@000?Nf`8000CNf`8000CNf`8003SNf`@000;Nf`@000?N
f`8000CNf`8003WNf`@000CNf`03003NfmkK00;Nf`8000CNf`8004SNf`00P]kK00@00=kKg]/000;N
f`04003NfmkK0002g]/01000g]_Nf`00?MkK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000
g]_Nf`000]kK00<00=kKg]/0=mkK00D00=kKg]_Nf`0000GNf`04003NfmkK0002g]/01000g]_Nf`00
>]kK00<00=kKg]/00mkK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/00`00g]_Nf`15g]/008;N
f`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/003gNf`05003NfmkKg]/00002g]/01000
g]_Nf`000]kK00@00=kKg]/000;Nf`03003NfmkK03ONf`03003NfmkK00;Nf`03003NfmkK00;Nf`04
003NfmkK0002g]/01000g]_Nf`00>]kK00<00=kKg]/01@000]kK00@00=kKg]/000;Nf`04003NfmkK
0017g]/008?Nf`8000?Nf`04003NfmkK0002g]/01000g]_Nf`00?MkK00D00=kKg]_Nf`0000;Nf`04
003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/0=mkK00<00=kKg]/00mkK00D00=kKg]_Nf`00
00;Nf`04003NfmkK0002g]/00`00g]_Nf`0hg]/01000g]_Nf`000]kK00D00=kKg]_Nf`0000;Nf`04
003NfmkK0002g]/00`00g]_Nf`15g]/008;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kK
g]/003gNf`05003NfmkKg]/00002g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`03003NfmkK03ON
f`03003NfmkK00CNf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/0>=kK00L00=kKg]_N
f`00g]/00003g]/01000g]_Nf`000]kK00@00=kKg]/004ONf`00?=kK00<00=kKg]/0@mkK00@00=kK
g]/000;Nf`04003NfmkK0002g]/01000g]_Nf`00>mkK0`000mkK00@00=kKg]/000;Nf`04003NfmkK
0002g]/01000g]_Nf`00=mkK0`000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`00
>=kK0`001=kK0P000mkK00@00=kKg]/000;Nf`04003NfmkK0017g]/003cNf`03003NfmkK04CNf`80
00CNf`8000CNf`8003kNf`03003NfmkK00;Nf`8000CNf`8000CNf`8003[Nf`03003NfmkK00;Nf`80
00CNf`8000CNf`8003_Nf`03003NfmkK00?Nf`03003NfmkK00;Nf`8000CNf`8004SNf`00?=kK00<0
0=kKg]/0omkKQmkK000lg]/00`00g]_Nf`3og]^7g]/003cNf`03003NfmkK0?oNfhONf`00?=kK00<0
0=kKg]/0omkKQmkK000Fg]/2<1lTg]/00`00g]_Nf`3og]]bg]/20002g]/00`00g]_Nf`0>g]/000cN
f``000@`7ol008X000cNf`04003NfmkK000@g]/001KNf`03003NfmkK00?Nf`@`7`WNf`03003NfmkK
013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK
017Nf`03003NfmkK013Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK
017Nf`03003NfmkK013Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK
017Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK01CNf`04003Nf`00
000@g]/001KNf`03003NfmkK00ONf`@`7`GNf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK
013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK
013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK
013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK017Nf`03003NfmkK013Nf`03003NfmkK
017Nf`03003NfmkK013Nf`03003NfmkK01CNf`800003g]/00=kK00oNf`009=kK130O5=kK00<00=kK
g]/0BmkK00<00=kKg]/0BmkK00<00=kKg]/0B]kK00<00=kKg]/0BmkK00<00=kKg]/0>mkK00@00=kK
g]/0013Nf`00:=kK130O4=kK00<00=kKg]/0omkKL]kK0P0000?Nf`0000004=kK000/g]/4<1l<g]/0
0`00g]_Nf`3og]^7g]/0033Nf`@`7`SNf`03003NfmkK0?oNfhONf`005MkK0P007MkK1C0O0mkK0`00
omkKQmkK000Eg]/2000Rg]/4<1oog]^9g]/003cNf`03000`7c0O008`7ooNfhGNf`00?=kK00<00=kK
g]/00]kK130OomkKPMkK000lg]/00`00g]_Nf`06g]/4<1oog]]mg]/003cNf`03003NfmkK00[Nf`<`
7ooNfg[Nf`00?=kK00<00=kKg]/03MkK0c0OomkKMmkK000lg]/3000@g]/3<1oog]]dg]/003cNf`80
01CNf`<`7ooNfg7Nf`00?=kK00<00=kKg]/05]kK0c0OomkKK]kK000lg]/00`00g]_Nf`0Ig]/3<1oo
g]][g]/003cNf`03003NfmkK01cNf`<`7ooNffSNf`00?=kK00<00=kKg]/07mkK0S0OomkKI]kK000l
g]/00`00g]_Nf`0Qg]/3<1oog]]Sg]/003cNf`03003NfmkK02CNf`<`7ooNff3Nf`00?=kK0`009mkK
0c0OomkKGMkK000lg]/00`00g]_Nf`0Tg]/20004g]/3<1oog]]Jg]/003cNf`03003NfmkK02CNf`80
00ONf`8`7ooNfeSNf`00?=kK00<00=kKg]/0;mkK0c0OomkKEMkK000lg]/00`00g]_Nf`0bg]/3<1oo
g]]Bg]/003cNf`03003NfmkK03GNf`8`7ooNfe3Nf`00?=kK00<00=kKg]/0=mkK0c0OomkKCMkK000l
g]/3000jg]/2<1oog]];g]/003cNf`03003NfmkK03cNf`8`7ooNfdWNf`00?=kK00<00=kKg]/0?]kK
0c0OomkKA]kK000lg]/00`00g]_Nf`11g]/2<1oog]]4g]/003cNf`03003NfmkK04?Nf`8`7ooNfd;N
f`009]kK10000mkK00<00=kKg]/00]kK0`001mkK00<00=kKg]/0AMkK0S0OomkK@=kK000Vg]/00`00
g]_Nf`0<g]/00`00g]_Nf`04g]/00`00g]_Nf`17g]/3<1l00mkK0000003og]/jg]/002ONf`03003N
fmkK00_Nf`03003NfmkK00CNf`@004WNf`8`7`03003NfmkK0?oNfcSNf`00:=kK00<00=kKg]/01mkK
0`001mkK00<00=kKg]/0C=kK0c0OomkK>=kK000Yg]/00`00g]_Nf`06g]/00`00g]_Nf`07g]/00`00
g]_Nf`1?g]/2<1oog]/fg]/002KNf`04003NfmkK0008g]/00`00g]_Nf`07g]/00`00g]_Nf`1Ag]/2
<1oog]/dg]/002ONf`8000WNf`@000KNf`03003NfmkK05?Nf`<`7ooNfc7Nf`00?=kK00<00=kKg]/0
E]kK0S0OomkK;mkK000lg]/00`00g]_Nf`1Hg]/2<1oog]/]g]/003cNf`<005[Nf`8`7ooNfb_Nf`00
?=kK00<00=kKg]/0G=kK0S0OomkK:MkK000lg]/00`00g]_Nf`1Ng]/2<1oog]/Wg]/003cNf`03003N
fmkK063Nf`8`7ooNfbGNf`00?=kK00<00=kKg]/0H]kK0S0OomkK8mkK000lg]/00`00g]_Nf`1Tg]/2
<1oog]/Qg]/003cNf`03003NfmkK06KNf`8`7ooNfaoNf`00?=kK0`00J=kK0S0OomkK7MkK000lg]/0
0`00g]_Nf`1Zg]/2<1l6g]/2003og]/Cg]/003cNf`03003NfmkK06cNf`8`7`CNf`800?oNfa?Nf`00
?=kK00<00=kKg]/0K]kK0S0OomkK5mkK000lg]/00`00g]_Nf`1`g]/2<1oog]/Eg]/003cNf`03003N
fmkK07;Nf`8`7ooNfa?Nf`00?=kK00<00=kKg]/0M=kK0S0OomkK4MkK000lg]/3001fg]/2<1oog]/?
g]/003cNf`03003NfmkK07SNf`8`7ooNf`gNf`00?=kK00<00=kKg]/0N]kK0S0OomkK2mkK000lg]/0
0`00g]_Nf`1lg]/2<1oog]/9g]/003cNf`03003NfmkK07kNf`8`7ooNf`ONf`00?=kK00<00=kKg]/0
P=kK0S0OomkK1MkK000lg]/00`00g]_Nf`22g]/00c0Og]_Nf`3og]/2g]/003cNf`<008?Nf`8`7ooN
f`;Nf`00?=kK00<00=kKg]/0QMkK0S0OomkK000lg]/00`00g]_Nf`27g]/2<1omg]/003cNf`03003N
fmkK08WNf`03<1oNfmkK0?[Nf`00?=kK00<00=kKg]/0R]kK0S0On]kK000lg]/00`00g]_Nf`2<g]/2
<1ohg]/003;Nf`<000ONf`03003NfmkK08kNf`8`7`WNf`800>_Nf`00=MkK00<00=kKg]/01=kK00<0
0=kKg]/0T=kK0S0O1mkK0P00jmkK000eg]/00`00g]_Nf`04g]/4002Ag]/00c0Og]_Nf`3ag]/003;N
f`<000ONf`03003NfmkK09?Nf`8`7o7Nf`00<]kK00<00=kKg]/01mkK00<00=kKg]/0UMkK0S0OkmkK
000bg]/00`00g]_Nf`07g]/00`00g]_Nf`2Gg]/2<1o]g]/003;Nf`@000KNf`03003NfmkK09WNf`03
<1oNfmkK0>[Nf`00?=kK00<00=kKg]/0V]kK0S0Oj]kK000lg]/00`00g]_Nf`2Lg]/2<1oXg]/003cN
f`<009kNf`03<1oNfmkK0>GNf`00?=kK00<00=kKg]/0WmkK0S0OiMkK000lg]/00`00g]_Nf`2Qg]/0
0c0Og]_Nf`3Rg]/003cNf`03003NfmkK0:;Nf`8`7n;Nf`00?=kK00<00=kKg]/0Y=kK0S0Oh=kK000l
g]/00`00g]_Nf`2Vg]/00c0Og]_Nf`3Mg]/003cNf`03003NfmkK0:ONf`8`7mgNf`00?=kK0`00ZMkK
00<`7mkKg]/0f]kK000lg]/00`00g]_Nf`2Zg]/2<1oJg]/003cNf`03003NfmkK0:cNf`8`7mSNf`00
?=kK00<00=kKg]/0[]kK00<`7mkKg]/0eMkK000lg]/00`00g]_Nf`2_g]/2<1oEg]/003cNf`03003N
fmkK0;7Nf`03<1oNfmkK0=;Nf`00?=kK00<00=kKg]/0/]kK0S0O3=kK0P00a=kK000lg]/3002dg]/2
<1l:g]/20034g]/003cNf`03003NfmkK0;KNf`03<1oNfmkK0<gNf`00?=kK00<00=kKg]/0]mkK0S0O
cMkK000lg]/00`00g]_Nf`2ig]/00c0Og]_Nf`3:g]/003cNf`03003NfmkK0;[Nf`8`7l[Nf`00?=kK
00<00=kKg]/0_=kK00<`7mkKg]/0amkK000lg]/00`00g]_Nf`2mg]/00c0Og]_Nf`36g]/003cNf`<0
0;kNf`8`7lKNf`00?=kK00<00=kKg]/0`=kK00<`7mkKg]/0`mkK000lg]/00`00g]_Nf`31g]/2<1o3
g]/003cNf`03003NfmkK0<?Nf`03<1oNfmkK0<3Nf`00?=kK00<00=kKg]/0a=kK0S0O`=kK000Wg]/0
0`00g]_Nf`03g]/00`00g]_Nf`02g]/30007g]/00`00g]_Nf`36g]/00c0Og]_Nf`2mg]/002ONf`03
003NfmkK00_Nf`03003NfmkK00CNf`03003NfmkK0<ONf`03<1oNfmkK0;cNf`00:=kK00<00=kKg]/0
2]kK00<00=kKg]/01=kK1000amkK0S0O_=kK000Xg]/00`00g]_Nf`07g]/30007g]/00`00g]_Nf`3:
g]/00c0Og]_Nf`2ig]/002WNf`03003NfmkK00KNf`03003NfmkK00ONf`03003NfmkK0<_Nf`8`7kWN
f`009]kK00@00=kKg]/000SNf`03003NfmkK00ONf`03003NfmkK0<gNf`03<1oNfmkK0;KNf`009]kK
10002=kK10001]kK00<00=kKg]/0c]kK0S0O]]kK000lg]/00`00g]_Nf`3@g]/00c0Og]_Nf`2cg]/0
03cNf`03003NfmkK0=7Nf`8`7k?Nf`00?=kK0`00dmkK00<`7mkKg]/0/=kK000lg]/00`00g]_Nf`3D
g]/00c0Og]_Nf`2_g]/003cNf`03003NfmkK0=GNf`8`7joNf`00?=kK00<00=kKg]/0emkK00<`7mkK
g]/0[=kK000lg]/00`00g]_Nf`3Hg]/2<1n/g]/003cNf`03003NfmkK0=[Nf`03<1oNfmkK0:WNf`00
?=kK00<00=kKg]/0fmkK00<`7mkKg]/0Z=kK000lg]/3003Lg]/2<1nXg]/003cNf`03003NfmkK0=kN
f`03<1oNfmkK00GNf`8009kNf`00?=kK00<00=kKg]/0gmkK00<`7mkKg]/01=kK0P00W]kK000lg]/0
0`00g]_Nf`3Pg]/00c0Og]_Nf`2Sg]/003cNf`03003NfmkK0>7Nf`8`7j?Nf`00?=kK00<00=kKg]/0
hmkK00<`7mkKg]/0X=kK000lg]/00`00g]_Nf`3Tg]/00c0Og]_Nf`2Og]/003cNf`03003NfmkK0>GN
f`03<1oNfmkK09kNf`00?=kK0`00i]kK0S0OW]kK000lg]/00`00g]_Nf`3Xg]/00c0Og]_Nf`2Kg]/0
03cNf`03003NfmkK0>WNf`03<1oNfmkK09[Nf`00?=kK00<00=kKg]/0j]kK00<`7mkKg]/0VMkK000l
g]/00`00g]_Nf`3[g]/2<1nIg]/003cNf`03003NfmkK0>gNf`03<1oNfmkK09KNf`00?=kK00<00=kK
g]/0k]kK00<`7mkKg]/0UMkK000lg]/3003_g]/2<1nEg]/003cNf`03003NfmkK0?7Nf`03<1oNfmkK
09;Nf`00?=kK00<00=kKg]/0l]kK00<`7mkKg]/0TMkK000lg]/00`00g]_Nf`3cg]/2<1nAg]/003cN
f`03003NfmkK0?GNf`03<1oNfmkK08kNf`00;=kK10000mkK0P001mkK00<00=kKg]/0m]kK00<`7mkK
g]/0SMkK000^g]/01@00g]_NfmkK00000]kK00<00=kKg]/01=kK00<00=kKg]/0mmkK0S0OSMkK000^
g]/01@00g]_NfmkK00000]kK00<00=kKg]/01=kK1000n=kK00<`7mkKg]/0R]kK000^g]/01@00g]_N
fmkK00000]kK00<00=kKg]/01=kK00<00=kKg]/0n]kK00<`7mkKg]/0RMkK000^g]/01@00g]_NfmkK
00000]kK00<00=kKg]/01=kK00<00=kKg]/0nmkK00<`7mkKg]/0R=kK000/g]/30003g]/01000g]_N
f`001]kK00<00=kKg]/0o=kK0S0OR=kK000^g]/00`00g]_Nf`02g]/20007g]/00`00g]_Nf`3ng]/0
0c0Og]_Nf`25g]/003cNf`03003NfmkK0?oNf`03<1oNfmkK08CNf`00?=kK00<00=kKg]/0omkK0MkK
00<`7mkKg]/0PmkK000lg]/3003og]/2g]/2<1n3g]/003cNf`03003NfmkK0?oNf`CNf`03<1oNfmkK
083Nf`00?=kK00<00=kKg]/0omkK1MkK00<`7mkKg]/0OmkK000lg]/00`00g]_Nf`3og]/6g]/00c0O
g]_Nf`1ng]/003cNf`03003NfmkK0?oNf`ONf`03<1oNfmkK07gNf`00?=kK00<00=kKg]/0omkK2=kK
0S0OOMkK000lg]/00`00g]_Nf`3og]/:g]/0130Og]_NfmkK0P00MmkK000lg]/3003og]/;g]/00c0O
g]_Nf`02001gg]/003cNf`03003NfmkK0?oNf`cNf`03<1oNfmkK07SNf`00?=kK00<00=kKg]/0omkK
3MkK0S0ON=kK000lg]/00`00g]_Nf`3og]/?g]/00c0Og]_Nf`1eg]/003cNf`03003NfmkK0?oNfa3N
f`03<1oNfmkK07CNf`00?=kK00<00=kKg]/0omkK4MkK00<`7mkKg]/0LmkK000lg]/00`00g]_Nf`3o
g]/Bg]/00c0Og]_Nf`1bg]/003cNf`<00?oNfa?Nf`8`7g;Nf`00?=kK00<00=kKg]/0omkK5MkK00<`
7mkKg]/0KmkK000lg]/00`00g]_Nf`3og]/Fg]/00c0Og]_Nf`1^g]/003cNf`03003NfmkK0?oNfaON
f`03<1oNfmkK06gNf`00?=kK00<00=kKg]/0omkK6=kK00<`7mkKg]/0K=kK000lg]/00`00g]_Nf`3o
g]/Ig]/2<1m/g]/003cNf`03003NfmkK0?oNfa_Nf`03<1oNfmkK06WNf`00?=kK0`00omkK7=kK00<`
7mkKg]/0J=kK000lg]/00`00g]_Nf`3og]/Mg]/00c0Og]_Nf`1Wg]/003cNf`03003NfmkK0?oNfakN
f`03<1oNfmkK06KNf`00?=kK00<00=kKg]/0omkK7mkK0S0OI]kK000lg]/00`00g]_Nf`3og]/Qg]/0
0c0Og]_Nf`1Sg]/003cNf`03003NfmkK0?oNfb;Nf`03<1oNfmkK06;Nf`008=kK10000]kK10000mkK
00<00=kKg]/00]kK0`001mkK00<00=kKg]/0omkK8mkK00<`7mkKg]/0HMkK000Rg]/01@00g]_NfmkK
00003]kK00<00=kKg]/01=kK00<00=kKg]/0omkK9=kK00<`7mkKg]/0H=kK000Rg]/00`00g]_Nf`02
g]/00`00g]_Nf`0;g]/00`00g]_Nf`04g]/4003og]/Tg]/00c0Og]_Nf`1Og]/002;Nf`03003NfmkK
00?Nf`03003NfmkK00ONf`<000ONf`03003NfmkK0?oNfbKNf`03<1oNfmkK05kNf`008]kK00<00=kK
g]/01=kK00<00=kKg]/01]kK00<00=kKg]/01mkK00<00=kKg]/0omkK9mkK0S0OG]kK000Pg]/30003
g]/01000g]_Nf`002=kK00<00=kKg]/01mkK00<00=kKg]/0omkK:MkK00<`7mkKg]/0FmkK000Rg]/0
0`00g]_Nf`02g]/20009g]/40006g]/00`00g]_Nf`3og]/Zg]/00c0Og]_Nf`1Jg]/003cNf`03003N
fmkK0?oNfb_Nf`03<1oNfmkK05WNf`00?=kK00<00=kKg]/0omkK;=kK00<`7mkKg]/0F=kK000lg]/3
003og]/]g]/00c0Og]_Nf`1Gg]/003cNf`03003NfmkK0?oNfbkNf`03<1oNfmkK05KNf`00?=kK00<0
0=kKg]/0omkK;mkK00<`7mkKg]/0EMkK000lg]/00`00g]_Nf`3og]/`g]/00c0Og]_Nf`1Dg]/003cN
f`03003NfmkK0?oNfc7Nf`03<1oNfmkK05?Nf`00?=kK00<00=kKg]/0omkK<]kK00<`7mkKg]/0D]kK
000lg]/00`00g]_Nf`3og]/cg]/2<1mBg]/003cNf`<00?oNfcGNf`03<1oNfmkK04oNf`00?=kK00<0
0=kKg]/0omkK=MkK00<0030Og]/0CmkK000lg]/00`00g]_Nf`3og]/eg]/200000c0Og]_Nf`1=g]/0
03cNf`03003NfmkK0?oNfcSNf`03<1oNfmkK04cNf`00?=kK00<00=kKg]/0omkK>MkK00<`7mkKg]/0
BmkK000lg]/00`00g]_Nf`3og]/jg]/00c0Og]_Nf`1:g]/003cNf`03003NfmkK0?oNfc_Nf`03<1oN
fmkK04WNf`00?=kK0`00omkK?=kK00<`7mkKg]/0B=kK000lg]/00`00g]_Nf`3og]/mg]/00c0Og]_N
f`17g]/003cNf`03003NfmkK0?oNfckNf`03<1oNfmkK04KNf`00?=kK00<00=kKg]/0omkK?mkK00<`
7mkKg]/0AMkK000lg]/00`00g]_Nf`3og]]0g]/2<1m5g]/003cNf`03003NfmkK0?oNfd;Nf`03<1oN
fmkK04;Nf`00?=kK00<00=kKg]/0omkK@mkK00<`7mkKg]/0@MkK000lg]/3003og]]4g]/00c0Og]_N
f`10g]/003cNf`03003NfmkK0?oNfdGNf`03<1oNfmkK03oNf`00?=kK00<00=kKg]/0omkKA]kK00<`
7mkKg]/0?]kK000lg]/00`00g]_Nf`3og]]7g]/00c0Og]_Nf`0mg]/003cNf`03003NfmkK0?oNfdSN
f`8`7cgNf`00;=kK10000]kK0`001mkK00<00=kKg]/0omkKB]kK00<`7mkKg]/0>]kK000^g]/00`00
g]_Nf`04g]/00`00g]_Nf`04g]/00`00g]_Nf`3og]];g]/00c0Og]_Nf`0ig]/002kNf`03003NfmkK
00CNf`03003NfmkK00CNf`@00?oNfd_Nf`03<1oNfmkK03SNf`00;]kK00@00=kKg]_Nf`<000ONf`03
003NfmkK0?oNfdgNf`03<1oNfmkK03ONf`00;]kK00D00=kKg]_Nf`0000WNf`03003NfmkK0?oNfdkN
f`03<1oNfmkK03KNf`00;=kK0`000mkK00<00=kKg]/01mkK00<00=kKg]/0omkKCmkK00<`7mkKg]/0
=MkK000^g]/01000g]_NfmkK10001]kK00<00=kKg]/0omkKD=kK00<`7mkKg]/0==kK000lg]/00`00
g]_Nf`3og]]Ag]/00c0Og]_Nf`0cg]/003cNf`03003NfmkK0?oNfe;Nf`03<1oNfmkK03;Nf`00?=kK
0`00omkKDmkK00<`7mkKg]/0<MkK000lg]/00`00g]_Nf`3og]]Dg]/00c0Og]_Nf`0`g]/003cNf`03
003NfmkK0?oNfeGNf`03<1oNfmkK02oNf`00?=kK00<00=kKg]/0omkKE]kK00<`7mkKg]/0;]kK000l
g]/00`00g]_Nf`3og]]Gg]/00c0Og]_Nf`0]g]/003cNf`03003NfmkK0?oNfeSNf`03<1oNfmkK02cN
f`00?=kK00<00=kKg]/0omkKFMkK00<`7mkKg]/0:mkK000lg]/3003og]]Jg]/00c0Og]_Nf`0Zg]/0
03cNf`03003NfmkK0?oNfe_Nf`03<1oNfmkK02WNf`00?=kK00<00=kKg]/0omkKG=kK00<`7mkKg]/0
:=kK000lg]/00`00g]_Nf`3og]^7g]/003cNf`03003NfmkK0?oNfhONf`00?=kK00<00=kKg]/0omkK
QmkK000lg]/00`00g]_Nf`3og]^7g]/003cNf`03003NfmkK0?oNfhONf`00?=kK0`00omkKQmkK000l
g]/00`00g]_Nf`3og]^7g]/003cNf`03003NfmkK0?oNfhONf`00?=kK00<00=kKg]/0omkKG=kK0P00
:MkK000lg]/00`00g]_Nf`3og]]Lg]/2000Yg]/003cNf`03003NfmkK0?oNfhONf`00?=kK00<00=kK
g]/0omkKQmkK000lg]/3003og]^7g]/003cNf`03003NfmkK0?oNfhONf`00?=kK00<00=kKg]/0omkK
QmkK003og]_6g]/00?oNflKNf`00omkKa]kK003og]_6g]/00?oNflKNf`00omkKa]kK003og]_6g]/0
0?oNflKNf`00omkKa]kK003og]_6g]/00?oNflKNf`00omkKa]kK003og]_6g]/002SNf`<000CNf`<0
00?Nf`8000CNf`8000;Nf`<00003g]/0000000;Nf`800003g]/00=kK00<00?oNfgONf`00:=kK00@0
0=kKg]/000;Nf`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000;N
f`04003NfmkK0005g]/00`00g]_Nf`3og]]dg]/002_Nf`03003NfmkK00<000?Nf`03003NfmkK00?N
f`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000?Nf`800?oNfgONf`00:MkK0P000mkK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK
0002g]/00`00g]_Nf`3og]]gg]/002SNf`03003NfmkK00CNf`8000CNf`8000CNf`8000;Nf`04003N
f`000004g]/30003g]/3003og]]fg]/002WNf`<001gNf`03003NfmkK0?oNfg[Nf`00B=kK0P00omkK
O=kK0000\
\>"],
  ImageRangeCache->{{{0, 452.75}, {279.438, 0}} -> {443.259, -0.987969, \
2.57421, 0.0700716}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Exporting a problem to C; Or: the overhead of ",
  StyleBox["MathLink",
    FontSlant->"Italic"]
}], "Subsection"],

Cell[TextData[{
  "You must set the install path to wherever you installed the binaries of \
the interface to. It will be the path you gave with the ",
  StyleBox["--prefix=dir",
    FontSlant->"Italic"],
  " option to the configure script or the standard path (/usr/local/bin ).\n\
If we would like to export the LU decomposition to an external program via ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " we are interested in the overhead of a pure transfer. The external \
program, maToMa (matrix to matrix) receives a matrix from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and sends it back. In the external program no modifications are made to \
the matrix whatsoever. "
}], "Text",
  CellDingbat->"\[LightBulb]"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Install[atlasInterfacePath <> arch <> "\</maToMa\>"]\)], "Input"],

Cell[BoxData[
    \(LinkObject["/usr/local/Wolfram/Linux_P4SSE2/bin/maToMa", 2, 
      2]\)], "Output"]
}, Open  ]],

Cell["Here is a small example. Sending and receiving an matrix.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(maToMa[\ {{1.0, \ 2.1}, \ {3.1, \ 4.1}}\ ]\)], "Input"],

Cell[BoxData[
    \({{1.`, 2.1`}, {3.1`, 4.1`}}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "We now proceed in the same way as before... which takes time, except that \
we use ",
  StyleBox["externalTiming",
    FontSlant->"Italic"],
  " instead of ",
  StyleBox["internalTiming",
    FontSlant->"Italic"],
  ". (If you fell like it, run the same command using ",
  StyleBox["internalTiming",
    FontSlant->"Italic"],
  " to see the difference.)"
}], "Text",
  CellDingbat->"\[WatchIcon]"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstMaToMa\  = \ 
      externalTiming[\ maToMa, \ 500, \ 1500, \ 100\ ]\)], "Input"],

Cell[BoxData[
    \({{500, 0.8`}, {600, 1.2`}, {700, 1.2`}, {800, 1.5`}, {900, 
        2.1`}, {1000, 2.5`}, {1100, 3.`}, {1200, 3.7`}, {1300, 4.4`}, {1400, 
        5.4`}, {1500, 6.`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitMaToMa\  = \ Fit[\ lstMaToMa, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.0001379711380381192`\)\ x + 
      2.7440175363819047`*^-6\ x\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[\[IndentingNewLine]\ 
      ListPlot[\ lstMaToMa\ , \ 
        DisplayFunction -> Identity], \[IndentingNewLine]Plot[\ 
        fitMaToMa, \[IndentingNewLine]{x, \ 500, \ 1500}, 
        PlotStyle \[Rule] \ Hue[0.9], \ 
        DisplayFunction -> 
          Identity\[IndentingNewLine]], \[IndentingNewLine]AxesLabel \[Rule] \
{\ "\<N\>", \ "\<Seconds\>"\ }, \[IndentingNewLine]DisplayFunction \[Rule] \
$DisplayFunction\ \[IndentingNewLine]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0147151 0.0981006 [
[.30952 .00222 -9 -9 ]
[.30952 .00222 9 0 ]
[.5 .00222 -12 -9 ]
[.5 .00222 12 0 ]
[.69048 .00222 -12 -9 ]
[.69048 .00222 12 0 ]
[.88095 .00222 -12 -9 ]
[.88095 .00222 12 0 ]
[1.025 .01472 0 -4.90625 ]
[1.025 .01472 10 4.90625 ]
[.10655 .11282 -6 -4.5 ]
[.10655 .11282 0 4.5 ]
[.10655 .21092 -6 -4.5 ]
[.10655 .21092 0 4.5 ]
[.10655 .30902 -6 -4.5 ]
[.10655 .30902 0 4.5 ]
[.10655 .40712 -6 -4.5 ]
[.10655 .40712 0 4.5 ]
[.10655 .50522 -6 -4.5 ]
[.10655 .50522 0 4.5 ]
[.10655 .60332 -6 -4.5 ]
[.10655 .60332 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01472 m
.30952 .02097 L
s
[(800)] .30952 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(1000)] .5 .00222 0 1 Mshowa
.69048 .01472 m
.69048 .02097 L
s
[(1200)] .69048 .00222 0 1 Mshowa
.88095 .01472 m
.88095 .02097 L
s
[(1400)] .88095 .00222 0 1 Mshowa
.125 Mabswid
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.07143 .01472 m
.07143 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .11282 m
.1253 .11282 L
s
[(1)] .10655 .11282 1 0 Mshowa
.11905 .21092 m
.1253 .21092 L
s
[(2)] .10655 .21092 1 0 Mshowa
.11905 .30902 m
.1253 .30902 L
s
[(3)] .10655 .30902 1 0 Mshowa
.11905 .40712 m
.1253 .40712 L
s
[(4)] .10655 .40712 1 0 Mshowa
.11905 .50522 m
.1253 .50522 L
s
[(5)] .10655 .50522 1 0 Mshowa
.11905 .60332 m
.1253 .60332 L
s
[(6)] .10655 .60332 1 0 Mshowa
.125 Mabswid
.11905 .03434 m
.1228 .03434 L
s
.11905 .05396 m
.1228 .05396 L
s
.11905 .07358 m
.1228 .07358 L
s
.11905 .0932 m
.1228 .0932 L
s
.11905 .13244 m
.1228 .13244 L
s
.11905 .15206 m
.1228 .15206 L
s
.11905 .17168 m
.1228 .17168 L
s
.11905 .1913 m
.1228 .1913 L
s
.11905 .23054 m
.1228 .23054 L
s
.11905 .25016 m
.1228 .25016 L
s
.11905 .26978 m
.1228 .26978 L
s
.11905 .2894 m
.1228 .2894 L
s
.11905 .32864 m
.1228 .32864 L
s
.11905 .34826 m
.1228 .34826 L
s
.11905 .36788 m
.1228 .36788 L
s
.11905 .3875 m
.1228 .3875 L
s
.11905 .42674 m
.1228 .42674 L
s
.11905 .44636 m
.1228 .44636 L
s
.11905 .46598 m
.1228 .46598 L
s
.11905 .4856 m
.1228 .4856 L
s
.11905 .52484 m
.1228 .52484 L
s
.11905 .54446 m
.1228 .54446 L
s
.11905 .56408 m
.1228 .56408 L
s
.11905 .5837 m
.1228 .5837 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .0932 Mdot
.11905 .13244 Mdot
.21429 .13244 Mdot
.30952 .16187 Mdot
.40476 .22073 Mdot
.5 .25997 Mdot
.59524 .30902 Mdot
.69048 .37769 Mdot
.78571 .44636 Mdot
.88095 .54446 Mdot
.97619 .60332 Mdot
1 0 .6 r
.5 Mabswid
.02381 .07525 m
.06244 .08606 L
.10458 .09886 L
.14415 .11185 L
.18221 .12521 L
.22272 .14038 L
.26171 .1559 L
.30316 .17339 L
.34309 .1912 L
.3815 .20923 L
.42237 .22938 L
.46172 .24971 L
.49955 .27012 L
.53984 .2928 L
.57861 .31553 L
.61984 .34067 L
.65954 .36585 L
.69774 .39094 L
.73838 .4186 L
.77751 .44616 L
.81909 .47644 L
.85916 .50658 L
.89771 .53649 L
.93871 .56926 L
.97619 .60009 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 10}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/0057Nf`8000CNf`8000CNf`8001gNf`@000?Nf`8000CNf`8000CNf`8001[Nf`@000;Nf`@000?N
f`8000CNf`8001[Nf`@000CNf`03003NfmkK00;Nf`8000CNf`80037Nf`00D=kK00@00=kKg]/000;N
f`04003NfmkK0002g]/01000g]_Nf`007]kK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000
g]_Nf`000]kK00<00=kKg]/06MkK00D00=kKg]_Nf`0000GNf`04003NfmkK0002g]/01000g]_Nf`00
6mkK00<00=kKg]/00mkK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/00`00g]_Nf`0^g]/0053N
f`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/001kNf`05003NfmkKg]/00002g]/01000
g]_Nf`000]kK00@00=kKg]/000;Nf`03003NfmkK01WNf`03003NfmkK00;Nf`03003NfmkK00;Nf`04
003NfmkK0002g]/01000g]_Nf`006mkK00<00=kKg]/01@000]kK00@00=kKg]/000;Nf`04003NfmkK
000`g]/0057Nf`8000?Nf`04003NfmkK0002g]/01000g]_Nf`007]kK00D00=kKg]_Nf`0000;Nf`04
003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/06MkK00<00=kKg]/00mkK00D00=kKg]_Nf`00
00;Nf`04003NfmkK0002g]/00`00g]_Nf`0Ig]/01000g]_Nf`000]kK00D00=kKg]_Nf`0000;Nf`04
003NfmkK0002g]/00`00g]_Nf`0^g]/0053Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kK
g]/001kNf`05003NfmkKg]/00002g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`03003NfmkK01WN
f`03003NfmkK00CNf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/06MkK00L00=kKg]_N
f`00g]/00003g]/01000g]_Nf`000]kK00@00=kKg]/0033Nf`00D=kK00@00=kKg]/000;Nf`04003N
fmkK0002g]/01000g]_Nf`007=kK0`000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_N
f`006MkK0`000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`006MkK0`001=kK0P00
0mkK00@00=kKg]/000;Nf`04003NfmkK000`g]/002WNf`03003NfmkK02GNf`8000CNf`8000CNf`80
01oNf`03003NfmkK00;Nf`8000CNf`8000CNf`8001cNf`03003NfmkK00;Nf`8000CNf`8000CNf`80
01cNf`03003NfmkK00?Nf`03003NfmkK00;Nf`8000CNf`80037Nf`00:MkK00<00=kKg]/0m=kK000Y
g]/00`00g]_Nf`3Ng]/20002g]/00`00g]_Nf`0?g]/002WNf`03003NfmkK0=oNf`04003NfmkK000A
g]/000cNfoL000SNf`04003Nf`00000Ag]/0017Nf`03003NfmkK00WNf`03003NfmkK00WNf`03003N
fmkK00WNf`03003NfmkK00SNf`03003NfmkK00WNf`03003NfmkK00WNf`03003NfmkK00WNf`03003N
fmkK00SNf`03003NfmkK00WNf`03003NfmkK00WNf`03003NfmkK00WNf`03003NfmkK00SNf`03003N
fmkK00WNf`03003NfmkK00WNf`03003NfmkK00WNf`03003NfmkK00SNf`03003NfmkK00WNf`03003N
fmkK00WNf`03003NfmkK00WNf`03003NfmkK00SNf`03003NfmkK00cNf`800003g]/00=kK013Nf`00
:MkK00<00=kKg]/0gmkK00@00=kKg]/0017Nf`00:MkK00<00=kKg]/0g]kK0P0000?Nf`0000004MkK
000Yg]/2003eg]/002WNf`03003NfmkK0?CNf`00:MkK00<00=kKg]/0m=kK000Yg]/00`00g]_Nf`3d
g]/002WNf`03003NfmkK0?CNf`00:MkK0P00mMkK000Yg]/00`00g]_Nf`3dg]/002WNf`03003NfmkK
0?CNf`00:MkK00<00=kKg]/0m=kK000Yg]/00`00g]_Nf`3dg]/002WNf`800?GNf`004MkK0oPC5MkK
00<00=kKg]/0m=kK000Dg]/5n1<@g]/00`00g]_Nf`3dg]/001WNf`Ch4`cNf`03003NfmkK0?CNf`00
7MkK0oPC2MkK00<00=kKg]/0m=kK000Ag]/00`00g]_Nf`0<g]/4n1<5g]/2003eg]/002CNf`?h4`;N
f`03003NfmkK0?CNf`009mkK0_PC00<00=kKg]/0m=kK000Qg]/40004g]/3n1?dg]/002?Nf`03003N
fmkK00?Nf`03003NfmkK00;h4o;Nf`008mkK00<00=kKg]/00mkK0P000mkK0oPCkmkK000Sg]/00`00
g]_Nf`03g]/00`00g]_Nf`05g]/3n1?/g]/002?Nf`03003NfmkK00?Nf`03003NfmkK00SNf`Ch4nSN
f`008MkK0`001MkK00<00=kKg]/03=kK0oPCiMkK000Sg]/00`00g]_Nf`03g]/00`00g]_Nf`0?g]/2
n1?Sg]/002SNf`<001;Nf`;h4`03g]/00=kK0=kNf`00:MkK00<00=kKg]/04mkK0_PCgmkK000Yg]/0
0`00g]_Nf`0Eg]/3n1?Lg]/002WNf`03003NfmkK01SNf`?h4mWNf`00:MkK00<00=kKg]/06mkK1?PC
eMkK000Yg]/2000Pg]/2n1?Cg]/002WNf`03003NfmkK027Nf`;h4m7Nf`00:MkK00<00=kKg]/08mkK
0_PC1]kK00<00=kKg]/0a]kK000Yg]/00`00g]_Nf`0Ug]/2n1?=g]/002WNf`8002SNf`;h4l_Nf`00
:MkK00<00=kKg]/0:MkK0oPCb=kK000Yg]/00`00g]_Nf`0/g]/2n1?6g]/002WNf`03003NfmkK02kN
f`?h4l?Nf`00:MkK00<00=kKg]/0<MkK0_PC`MkK000Yg]/2000dg]/2n1>og]/002WNf`03003NfmkK
03GNf`;h4kgNf`00:MkK00<00=kKg]/0=mkK0_PC^mkK000Qg]/40004g]/00`00g]_Nf`0ig]/2n1>i
g]/0027Nf`03003NfmkK00GNf`03003NfmkK03_Nf`;h4kONf`008]kK00<00=kKg]/01=kK0P00?]kK
0_PC]MkK000Sg]/00`00g]_Nf`03g]/00`00g]_Nf`0og]/2n1>cg]/002CNf`03003NfmkK00;Nf`03
003NfmkK047Nf`;h4k7Nf`008MkK00@00=kKg]/000CNf`03003NfmkK04?Nf`;h4joNf`008]kK0P00
1MkK00<00=kKg]/0AMkK0_PC[MkK000Yg]/20018g]/2n1>[g]/002WNf`03003NfmkK04WNf`;h4jWN
f`00:MkK00<00=kKg]/0BmkK0_PCYmkK000Yg]/00`00g]_Nf`1=g]/2n1>Ug]/002WNf`03003NfmkK
04oNf`;h4j?Nf`00:MkK0P00D]kK00?h4mkKg]/0X=kK000Yg]/00`00g]_Nf`1Bg]/2n1>Pg]/002WN
f`03003NfmkK05CNf`;h4ikNf`00:MkK00<00=kKg]/0E]kK0_PC0]kK00<00=kKg]/0UmkK000Yg]/0
0`00g]_Nf`1Hg]/2n1>Jg]/002WNf`8005_Nf`;h4iSNf`00:MkK00<00=kKg]/0G=kK0_PCU]kK000Y
g]/00`00g]_Nf`1Ng]/2n1>Dg]/002WNf`03003NfmkK063Nf`;h4i;Nf`00:MkK0P00HmkK0_PCT=kK
000Yg]/00`00g]_Nf`1Tg]/2n1>>g]/002WNf`03003NfmkK06KNf`;h4hcNf`008]kK0P001MkK00<0
0=kKg]/0J=kK00?h4mkKg]/0RMkK000Qg]/01000g]_Nf`001=kK00<00=kKg]/0JMkK0_PCRMkK000T
g]/00`00g]_Nf`02g]/2001/g]/00oPCg]_Nf`26g]/002;Nf`8000GNf`03003NfmkK06cNf`;h4`CN
f`03003NfmkK07oNf`009=kK00<00=kKg]/00]kK00<00=kKg]/0K]kK00?h4mkKg]/0PmkK000Qg]/0
1000g]_Nf`001=kK00<00=kKg]/0KmkK0_PCPmkK000Rg]/20005g]/00`00g]_Nf`1ag]/2n1>1g]/0
02WNf`8007CNf`03n1?NfmkK07kNf`00:MkK00<00=kKg]/0M=kK0_PCO]kK000Yg]/00`00g]_Nf`1f
g]/2n1=lg]/002WNf`03003NfmkK07SNf`03n1?NfmkK07WNf`00:MkK00<00=kKg]/0NMkK0_PCNMkK
000Yg]/2001lg]/2n1=gg]/002WNf`03003NfmkK07gNf`03n1?NfmkK07CNf`00:MkK00<00=kKg]/0
O]kK0_PCM=kK000Yg]/00`00g]_Nf`20g]/2n1=bg]/002WNf`03003NfmkK08;Nf`03n1?NfmkK06oN
f`00:MkK0P00Q=kK0_PCKmkK000Yg]/00`00g]_Nf`25g]/2n1=]g]/002WNf`03003NfmkK08ONf`03
n1?NfmkK06[Nf`00:MkK00<00=kKg]/0R=kK0_PCJ]kK000Yg]/00`00g]_Nf`2:g]/2n1=Xg]/002WN
f`8008gNf`03n1?NfmkK06GNf`00:MkK00<00=kKg]/0SMkK0_PCIMkK000Sg]/00`00g]_Nf`03g]/0
0`00g]_Nf`2?g]/00oPCg]_Nf`1Rg]/002?Nf`03003NfmkK00?Nf`03003NfmkK093Nf`03n1?NfmkK
067Nf`008=kK1@001=kK0P00T]kK0_PCHMkK000Pg]/01000g]_Nf`001MkK00<00=kKg]/0TmkK00?h
4mkKg]/0G]kK000Qg]/00`00g]/00005g]/00`00g]_Nf`2Dg]/2n1=Ng]/002;Nf`8000GNf`03003N
fmkK09KNf`03n1?NfmkK05_Nf`008mkK00<00=kKg]/00mkK00<00=kKg]/0UmkK00?h4mkKg]/0F]kK
000Yg]/2002Ig]/2n1=Jg]/002WNf`03003NfmkK09[Nf`03n1?NfmkK05ONf`00:MkK00<00=kKg]/0
VmkK00?h4mkKg]/0E]kK000Yg]/00`00g]_Nf`2Lg]/2n1=Fg]/002WNf`03003NfmkK09kNf`03n1?N
fmkK05?Nf`00:MkK0P00X=kK00?h4mkKg]/0D]kK000Yg]/00`00g]_Nf`2Pg]/2n1=Bg]/002WNf`03
003NfmkK0:;Nf`03n1?NfmkK04oNf`00:MkK00<00=kKg]/0XmkK00?h4mkKg]/0C]kK000Yg]/00`00
g]_Nf`2Tg]/2n1=>g]/002WNf`800:ONf`03n1?NfmkK04_Nf`00:MkK00<00=kKg]/0YmkK00?h4mkK
g]/0B]kK000Yg]/00`00g]_Nf`2Xg]/2n1=:g]/002WNf`03003NfmkK0:[Nf`03n1?NfmkK04ONf`00
:MkK00<00=kKg]/0ZmkK0_PCAmkK000Yg]/2002^g]/00oPCg]_Nf`14g]/002WNf`03003NfmkK0:kN
f`03n1?NfmkK04?Nf`00:MkK00<00=kKg]/0[mkK0_PC@mkK000Qg]/30005g]/00`00g]_Nf`2ag]/0
0oPCg]_Nf`10g]/002CNf`03003NfmkK00;Nf`03003NfmkK0;;Nf`;h4d3Nf`009=kK00<00=kKg]/0
0]kK0P00]MkK00?h4mkKg]/0?MkK000Qg]/30005g]/00`00g]_Nf`2eg]/00oPCg]_Nf`0lg]/0027N
f`03003NfmkK00GNf`03003NfmkK0;KNf`;h4ccNf`008MkK00<00=kKg]/01MkK00<00=kKg]/0^=kK
00?h4mkKg]/0>MkK000Qg]/40004g]/00`00g]_Nf`2ig]/00oPCg]_Nf`0hg]/002WNf`800;_Nf`;h
4cSNf`00:MkK00<00=kKg]/0_=kK00?h4mkKg]/0=MkK000Yg]/00`00g]_Nf`2mg]/00oPCg]_Nf`0d
g]/002WNf`03003NfmkK0;kNf`03n1?NfmkK03?Nf`00:MkK0P00`=kK0_PC<mkK000Yg]/00`00g]_N
f`2hg]/00`00g]_Nf`06g]/00oPCg]_Nf`0`g]/002WNf`03003NfmkK0<;Nf`03n1?NfmkK02oNf`00
:MkK00<00=kKg]/0`mkK00?h4mkKg]/0;]kK000Yg]/00`00g]_Nf`34g]/2n1<^g]/002WNf`800<ON
f`03n1?NfmkK02_Nf`00:MkK00<00=kKg]/0amkK00?h4mkKg]/0:]kK000Yg]/00`00g]_Nf`38g]/0
0oPCg]_Nf`0Yg]/002WNf`03003NfmkK0<WNf`03n1?NfmkK02SNf`00:MkK00<00=kKg]/0b]kK00?h
4mkKg]/09mkK000Yg]/2003<g]/2n1<Wg]/002WNf`03003NfmkK0<gNf`03n1?NfmkK02CNf`00:MkK
00<00=kKg]/0c]kK00?h4mkKg]/08mkK000Rg]/20005g]/00`00g]_Nf`3?g]/00oPCg]_Nf`0Rg]/0
027Nf`04003NfmkK0004g]/00`00g]_Nf`3@g]/00oPCg]_Nf`0Qg]/0027Nf`04003NfmkK0004g]/2
003Ag]/00`00g]_Nf`0Qg]/0027Nf`<000GNf`03003NfmkK0?CNf`008MkK00<00=kKg]/01MkK00<0
0=kKg]/0m=kK000Qg]/00`00g]_Nf`05g]/00`00g]_Nf`3dg]/002;Nf`<000CNf`03003NfmkK0?CN
f`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003o
g]/Qg]/001GNf`<000CNf`<000?Nf`8000CNf`8000;Nf`<00003g]/0000000;Nf`800003g]/00=kK
00<00>CNf`005MkK00@00=kKg]/000;Nf`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`00
0]kK00@00=kKg]/000;Nf`04003NfmkK0005g]/00`00g]_Nf`3Qg]/001SNf`03003NfmkK00<000?N
f`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000?Nf`800>CNf`00
5]kK0P000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000;N
f`04003NfmkK0002g]/00`00g]_Nf`3Tg]/001GNf`03003NfmkK00CNf`8000CNf`8000CNf`8000;N
f`04003Nf`000004g]/30003g]/3003Sg]/001KNf`<001gNf`03003NfmkK0>ONf`00=MkK0P00jMkK
0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {423.777, -0.499198, 4.25522, \
0.0413106}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Comparison between LUDecomposition and a matrix transfer to an external \
program and back\
\>", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[\ {\ fitMatLUDe, \ fitMaToMa\ }, \ \ {\ x, \ 500, \ 1500\ }, 
      PlotStyle \[Rule] \ {\ Hue[0.7], \ Hue[0.9]\ }\ , \ 
      PlotLegend \[Rule] {\ \ "\<Mathematica LU\>", "\<Matrix to Matrix\>"}, 
      LegendPosition \[Rule] {\(-0.5\), 0.2}, LegendSize \[Rule] {1, 0.25}, 
      LegendTextSpace \[Rule] 8, \ 
      AxesLabel \[Rule] {\ "\<N\>", \ "\<Seconds\>"\ }\ ]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0166532 0.0363866 [
[.30952 .00415 -9 -9 ]
[.30952 .00415 9 0 ]
[.5 .00415 -12 -9 ]
[.5 .00415 12 0 ]
[.69048 .00415 -12 -9 ]
[.69048 .00415 12 0 ]
[.88095 .00415 -12 -9 ]
[.88095 .00415 12 0 ]
[1.025 .01665 0 -4.90625 ]
[1.025 .01665 10 4.90625 ]
[.10655 .10762 -18 -4.5 ]
[.10655 .10762 0 4.5 ]
[.10655 .19859 -6 -4.5 ]
[.10655 .19859 0 4.5 ]
[.10655 .28955 -18 -4.5 ]
[.10655 .28955 0 4.5 ]
[.10655 .38052 -12 -4.5 ]
[.10655 .38052 0 4.5 ]
[.10655 .47149 -24 -4.5 ]
[.10655 .47149 0 4.5 ]
[.10655 .56245 -12 -4.5 ]
[.10655 .56245 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01665 m
.30952 .0229 L
s
[(800)] .30952 .00415 0 1 Mshowa
.5 .01665 m
.5 .0229 L
s
[(1000)] .5 .00415 0 1 Mshowa
.69048 .01665 m
.69048 .0229 L
s
[(1200)] .69048 .00415 0 1 Mshowa
.88095 .01665 m
.88095 .0229 L
s
[(1400)] .88095 .00415 0 1 Mshowa
.125 Mabswid
.16667 .01665 m
.16667 .0204 L
s
.21429 .01665 m
.21429 .0204 L
s
.2619 .01665 m
.2619 .0204 L
s
.35714 .01665 m
.35714 .0204 L
s
.40476 .01665 m
.40476 .0204 L
s
.45238 .01665 m
.45238 .0204 L
s
.54762 .01665 m
.54762 .0204 L
s
.59524 .01665 m
.59524 .0204 L
s
.64286 .01665 m
.64286 .0204 L
s
.7381 .01665 m
.7381 .0204 L
s
.78571 .01665 m
.78571 .0204 L
s
.83333 .01665 m
.83333 .0204 L
s
.07143 .01665 m
.07143 .0204 L
s
.02381 .01665 m
.02381 .0204 L
s
.92857 .01665 m
.92857 .0204 L
s
.97619 .01665 m
.97619 .0204 L
s
.25 Mabswid
0 .01665 m
1 .01665 L
s
gsave
1.025 .01665 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10762 m
.1253 .10762 L
s
[(2.5)] .10655 .10762 1 0 Mshowa
.11905 .19859 m
.1253 .19859 L
s
[(5)] .10655 .19859 1 0 Mshowa
.11905 .28955 m
.1253 .28955 L
s
[(7.5)] .10655 .28955 1 0 Mshowa
.11905 .38052 m
.1253 .38052 L
s
[(10)] .10655 .38052 1 0 Mshowa
.11905 .47149 m
.1253 .47149 L
s
[(12.5)] .10655 .47149 1 0 Mshowa
.11905 .56245 m
.1253 .56245 L
s
[(15)] .10655 .56245 1 0 Mshowa
.125 Mabswid
.11905 .03485 m
.1228 .03485 L
s
.11905 .05304 m
.1228 .05304 L
s
.11905 .07123 m
.1228 .07123 L
s
.11905 .08943 m
.1228 .08943 L
s
.11905 .12581 m
.1228 .12581 L
s
.11905 .14401 m
.1228 .14401 L
s
.11905 .1622 m
.1228 .1622 L
s
.11905 .18039 m
.1228 .18039 L
s
.11905 .21678 m
.1228 .21678 L
s
.11905 .23497 m
.1228 .23497 L
s
.11905 .25317 m
.1228 .25317 L
s
.11905 .27136 m
.1228 .27136 L
s
.11905 .30775 m
.1228 .30775 L
s
.11905 .32594 m
.1228 .32594 L
s
.11905 .34413 m
.1228 .34413 L
s
.11905 .36233 m
.1228 .36233 L
s
.11905 .39871 m
.1228 .39871 L
s
.11905 .41691 m
.1228 .41691 L
s
.11905 .4351 m
.1228 .4351 L
s
.11905 .45329 m
.1228 .45329 L
s
.11905 .48968 m
.1228 .48968 L
s
.11905 .50787 m
.1228 .50787 L
s
.11905 .52607 m
.1228 .52607 L
s
.11905 .54426 m
.1228 .54426 L
s
.11905 .58065 m
.1228 .58065 L
s
.11905 .59884 m
.1228 .59884 L
s
.11905 .61703 m
.1228 .61703 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02322 L
.10458 .03398 L
.14415 .04549 L
.18221 .05784 L
.22272 .07238 L
.26171 .08773 L
.30316 .10549 L
.34309 .12401 L
.3815 .14315 L
.42237 .16491 L
.46172 .18725 L
.49955 .20999 L
.53984 .23558 L
.57861 .26155 L
.61984 .29059 L
.65954 .31996 L
.69774 .34951 L
.73838 .38235 L
.77751 .41532 L
.81909 .45182 L
.85916 .48842 L
.89771 .52495 L
.93871 .56523 L
.97619 .60332 L
s
1 0 .6 r
.02381 .0391 m
.06244 .04312 L
.10458 .04786 L
.14415 .05268 L
.18221 .05764 L
.22272 .06326 L
.26171 .06902 L
.30316 .07551 L
.34309 .08211 L
.3815 .0888 L
.42237 .09627 L
.46172 .10381 L
.49955 .11139 L
.53984 .1198 L
.57861 .12823 L
.61984 .13755 L
.65954 .14689 L
.69774 .1562 L
.73838 .16646 L
.77751 .17668 L
.81909 .18791 L
.85916 .19909 L
.89771 .21018 L
.93871 .22234 L
.97619 .23378 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.28571 .38045 m
.28571 .49949 L
.7619 .49949 L
.7619 .38045 L
F
1 g
.2619 .40426 m
.2619 .5233 L
.7381 .5233 L
.7381 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.2619 .40426 m
.7381 .40426 L
.7381 .5233 L
.2619 .5233 L
.2619 .40426 L
s
% Start of sub-graphic
p
0.261905 0.404255 0.738095 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00992063 0.0992063 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0178571 0.126068 0.117063 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .06746 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Matrix) show
105.000 11.562 moveto
(to) show
123.000 11.562 moveto
(Matrix) show
159.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.132937 0.126068 0.232143 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .18254 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
135.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(LU) show
147.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 9}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00DmkK0P001=kK0P001=kK0P006mkK1000
0mkK0P001=kK0P001=kK0P006=kK10000]kK10000mkK0P001=kK0P005mkK10001=kK00<00=kKg]/0
0]kK0P001=kK0P00=]kK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Lg]/0
1@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`0Gg]/01@00g]_N
fmkK00001MkK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00g]_Nf`03g]/01@00g]_NfmkK0000
0]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/0
1000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kK
g]/05mkK00<00=kKg]/00]kK00<00=kKg]/00]kK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00
g]_Nf`050002g]/01000g]_Nf`000]kK00@00=kKg]/003GNf`00DmkK0P000mkK00@00=kKg]/000;N
f`04003NfmkK000Lg]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00
g]_Nf`0Gg]/00`00g]_Nf`03g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK01KN
f`04003NfmkK0002g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05mkK00<00=kKg]/01=kK00@00=kKg]/000;Nf`04
003NfmkK0002g]/00`00g]_Nf`0Fg]/01`00g]_NfmkK003Nf`0000?Nf`04003NfmkK0002g]/01000
g]_Nf`00=MkK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Jg]/30003g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Gg]/30003g]/01000g]_Nf`000]kK00@0
0=kKg]/000;Nf`04003NfmkK000Fg]/30004g]/20003g]/01000g]_Nf`000]kK00@00=kKg]/003GN
f`00;]kK00<00=kKg]/08]kK0P001=kK0P001=kK0P007MkK00<00=kKg]/00]kK0P001=kK0P001=kK
0P006]kK00<00=kKg]/00]kK0P001=kK0P001=kK0P006MkK00<00=kKg]/00mkK00<00=kKg]/00]kK
0P001=kK0P00=]kK000^g]/00`00g]_Nf`3_g]/002kNf`03003NfmkK0=?Nf`8000;Nf`03003NfmkK
01GNf`005mkK0c0O5=kK00<00=kKg]/0e=kK00@00=kKg]/001ONf`004]kK20001C0OgP002=kK00@0
0=kK000001ONf`005mkK00<00=kKg]/01MkK130O00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kK
g]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02MkK00<00=kKg]/02=kK00<00=kK
g]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02MkK00<00=kK
g]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kK
g]/02=kK00<00=kKg]/02MkK00<00=kKg]/02mkK0P0000?Nf`00g]/05]kK000Sg]/3<1l8g]/00`00
g]_Nf`3Dg]/01000g]_Nf`005mkK000Vg]/3<1l5g]/00`00g]_Nf`3Cg]/200000mkK0000000Gg]/0
02WNf`@`7`03g]/000000?3Nf`005mkK1OPC4MkK1C0Ok]kK000Lg]/:n1<8g]/01000g]_NfmkK130O
j]kK000Vg]/9n1<7g]/3<1oWg]/002kNf`03003h4oPC00Sh4`<`7nCNf`00;]kK00<00=kKg]/02=kK
1oPCh=kK000^g]/00`00g]_Nf`0>g]/00c0On1?h4`02n1?Lg]/002kNf`03003NfmkK013Nf`8`7`03
g]_h4oPC00Gh4mGNf`00;]kK00<00=kKg]/04]kK0S0O1]kK1oPCc]kK000^g]/2000Eg]/3<1l:g]/5
n1?9g]/002kNf`03003NfmkK01ONf`<`7`cNf`Oh4l;Nf`00;]kK00<00=kKg]/06]kK0c0O4=kK1oPC
^mkK000^g]/00`00g]_Nf`0Mg]/2<1lEg]/4n1>gg]/002kNf`80023Nf`8`7aONf`Oh4k3Nf`00;]kK
00<00=kKg]/08MkK0S0O7=kK2?PCZ=kK000Jg]/40003g]/00`00g]_Nf`02g]/30005g]/00`00g]_N
f`0Sg]/2<1lRg]/4n1>Tg]/001[Nf`03003NfmkK00cNf`03003NfmkK00;Nf`03003NfmkK02GNf`8`
7bCNf`Gh4ioNf`006mkK00<00=kKg]/02mkK00<00=kKg]/00]kK0P00:=kK0c0O9]kK1?PCVmkK000L
g]/00`00g]_Nf`07g]/30005g]/00`00g]_Nf`0Zg]/2<1lXg]/5n1>Fg]/001gNf`03003NfmkK00KN
f`03003NfmkK00GNf`03003NfmkK02cNf`8`7b_Nf`Ch4i;Nf`006]kK00@00=kKg]/000SNf`03003N
fmkK00GNf`03003NfmkK02kNf`8`7bgNf`Gh4hgNf`006mkK0P002MkK10001=kK0P00<MkK0c0O;mkK
1?PCRMkK000^g]/00`00g]_Nf`0cg]/2<1lag]/5n1>4g]/002kNf`03003NfmkK03GNf`8`7cCNf`Gh
4goNf`00;]kK00<00=kKg]/0=mkK0S0O=mkK1OPCN]kK000^g]/00`00g]_Nf`0ig]/2<1ljg]/4n1=f
g]/002kNf`8003cNf`8`7ccNf`Gh4g7Nf`00;]kK00<00=kKg]/0?MkK0S0O?mkK1?PCKMkK000^g]/0
0`00g]_Nf`0og]/2<1m1g]/4n1=Yg]/002kNf`03003NfmkK047Nf`8`7d?Nf`?h4fKNf`00;]kK0P00
A=kK0S0OA=kK1?PCH]kK000^g]/00`00g]_Nf`15g]/2<1m6g]/4n1=Ng]/002kNf`03003NfmkK04ON
f`03<1oNfmkK04ONf`Ch4e[Nf`00;]kK00<00=kKg]/0B=kK0S0OBmkK1?PCE]kK000^g]/2001;g]/0
0c0Og]_Nf`1<g]/3n1=Cg]/002kNf`03003NfmkK04_Nf`8`7doNf`Ch4doNf`009]kK0`001MkK00<0
0=kKg]/0CMkK00<`7mkKg]/0D=kK1?PCBmkK000Yg]/00`00g]_Nf`02g]/00`00g]_Nf`1>g]/2<1mD
g]/4n1=7g]/002WNf`03003NfmkK00;Nf`80057Nf`8`7eKNf`Ch4d?Nf`009]kK0`001MkK00<00=kK
g]/0D]kK0S0OF=kK0oPC@=kK000Vg]/00`00g]_Nf`05g]/00`00g]_Nf`1Dg]/2<1mIg]/3n1<mg]/0
02KNf`03003NfmkK00GNf`03003NfmkK05KNf`03<1oNfmkK05WNf`?h4c[Nf`009]kK10001=kK00<0
0=kKg]/0EmkK0S0OG=kK0oPC=mkK000^g]/2001Jg]/00c0Og]_Nf`1Lg]/4n1<cg]/002kNf`03003N
fmkK05[Nf`8`7f3Nf`?h4c3Nf`00;]kK00<00=kKg]/0G=kK00<`7mkKg]/0H=kK0oPC;MkK000^g]/0
0`00g]_Nf`1Mg]/2<1mSg]/3n1<Zg]/002kNf`80063Nf`03<1oNfmkK06?Nf`;h4bSNf`00;]kK00<0
0=kKg]/0H=kK0S0OSMkK000^g]/00`00g]_Nf`1Rg]/00c0Og]_Nf`2:g]/002kNf`03003NfmkK06?N
f`8`7h[Nf`00;]kK0P00I]kK00<`7mkKg]/0QmkK000^g]/00`00g]_Nf`1Vg]/2<1n7g]/002kNf`03
003NfmkK06SNf`03<1oNfmkK08CNf`00;]kK00<00=kKg]/0JMkK0S0OQ=kK000^g]/2001/g]/00c0O
g]_Nf`21g]/002kNf`03003NfmkK06cNf`03<1oNfmkK083Nf`00;]kK00<00=kKg]/0KMkK0S0OP=kK
000Kg]/00`00g]_Nf`03g]/00`00g]_Nf`02g]/30005g]/00`00g]_Nf`1_g]/00c0Og]_Nf`1mg]/0
01_Nf`03003NfmkK00_Nf`03003NfmkK00;Nf`03003NfmkK073Nf`8`7ggNf`007=kK00<00=kKg]/0
2]kK00<00=kKg]/00]kK0P00LmkK00<`7mkKg]/0N]kK000Lg]/00`00g]_Nf`07g]/30005g]/00`00
g]_Nf`1cg]/00c0Og]_Nf`1ig]/001gNf`03003NfmkK00KNf`03003NfmkK00GNf`03003NfmkK07CN
f`8`7gWNf`006]kK00@00=kKg]/000SNf`03003NfmkK00GNf`03003NfmkK07KNf`03<1oNfmkK07KN
f`006]kK10002=kK10001=kK0P00N=kK00<`7mkKg]/0MMkK000^g]/00`00g]_Nf`1hg]/2<1meg]/0
02kNf`03003NfmkK07[Nf`03<1oNfmkK07;Nf`00;]kK00<00=kKg]/0NmkK00<`7mkKg]/0LMkK000^
g]/2001mg]/00c0Og]_Nf`1`g]/002kNf`03003NfmkK07gNf`8`7g3Nf`00;]kK00<00=kKg]/0OmkK
00<`7mkKg]/0KMkK000^g]/00`00g]_Nf`20g]/00c0Og]_Nf`1/g]/002kNf`8008;Nf`8`7fcNf`00
;]kK00<00=kKg]/0PmkK00<`7mkKg]/0JMkK000^g]/00`00g]_Nf`24g]/00c0Og]_Nf`1Xg]/002kN
f`03003NfmkK08GNf`8`7fSNf`00;]kK00<00=kKg]/0QmkK00<`7mkKg]/0IMkK000^g]/20029g]/0
0c0Og]_Nf`1Tg]/002kNf`03003NfmkK08WNf`8`7fCNf`008=kK10000mkK0P001MkK00<00=kKg]/0
RmkK00<`7mkKg]/0HMkK000Rg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0S=kK
0S0OHMkK000Rg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK0P00SmkK00<`7mkKg]/0G]kK000R
g]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0SmkK00<`7mkKg]/0GMkK000Rg]/0
1@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0T=kK00<`7mkKg]/0G=kK000Pg]/30003
g]/01000g]_Nf`001=kK00<00=kKg]/0TMkK00<`7mkKg]/0FmkK000Rg]/00`00g]_Nf`02g]/20005
g]/2002Cg]/2<1mKg]/002kNf`03003NfmkK09CNf`03<1oNfmkK05SNf`00;]kK00<00=kKg]/0UMkK
00<`7mkKg]/0EmkK000^g]/00`00g]_Nf`2Fg]/00c0Og]_Nf`1Fg]/002kNf`03003NfmkK027NfhP0
04KNf`00;]kK0P008]kKR000A]kK000^g]/00`00g]_Nf`0Qg]^80016g]/002kNf`03003NfmkK027N
fhP004KNf`00;]kK00<00=kKg]/08MkKR000A]kK000^g]/2000Rg]^80016g]/002kNf`03003NfmkK
01[Nfhl004KNf`00;]kK00<00=kKg]/06]kK00<00?ooool0QOoo1`00A]kK000^g]/00`00g]_Nf`0J
g]/00`00ooooo`25ool70016g]/002kNf`8001_Nf`03003ooooo08Goo`L004KNf`00;]kK00<00=kK
g]/06]kK00<00?ooool0QOoo1`00A]kK000Dg]/40002g]/40003g]/00`00g]_Nf`02g]/30005g]/0
0`00g]_Nf`0Jg]/00`00ooooo`25ool70016g]/001KNf`05003NfmkKg]/0000>g]/00`00g]_Nf`02
g]/00`00g]_Nf`0Jg]/00`00ooooo`25ool70016g]/001KNf`03003NfmkK00;Nf`03003NfmkK00_N
f`03003NfmkK00;Nf`8001_Nf`03003ooooo08Goo`L004KNf`005]kK00<00=kKg]/00mkK00<00=kK
g]/01mkK0`001MkK00<00=kKg]/06]kK00<00?ooool04_oo0P0000?oo`0000000ooo0P0000?oo`00
ool00_oo0P000_oo10000_oo1`0000?oo`0000002_oo0P000ooo0P002?oo0P0000?oo`0000000ooo
0P0000?oo`00ool00_oo0P000_oo10000_oo1`0000?oo`0000005?oo1`00A]kK000Fg]/00`00g]_N
f`04g]/00`00g]_Nf`06g]/00`00g]_Nf`05g]/00`00g]_Nf`0Jg]/00`00ooooo`0Bool01@00oooo
oooo00000_oo00@00?ooool000?oo`04003ooooo0002ool00`00ooooo`04ool01`00oooooooo003o
o`0000[oo`06003ooooo003oo`000_oo00<00?ooool01Ooo00D00?ooooooo`0000;oo`04003ooooo
0003ool01000ooooo`000_oo00<00?ooool01?oo00L00?ooooooo`00ool0000Eool70016g]/001CN
f`<000?Nf`04003NfmkK0008g]/00`00g]_Nf`05g]/00`00g]_Nf`0Jg]/00`00ooooo`0?n1<3ool0
1@00ool00?oo00000ooo0`000ooo00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00<0
0?ooool02Ooo00<00?ooool00_oo00@00?ooool000Ooo`05003oo`00ool00003ool30003ool00`00
ooooo`03ool00`00ooooo`04ool00`00ooooo`02ool00`00ooooo`0Dool700000c0Og]_Nf`13g]/0
01KNf`03003NfmkK00;Nf`8000WNf`@000CNf`03003NfmkK01[Nf`03003ooooo01;oo`05003oo`00
ool00005ool01@00oooooooo00001Ooo00<00?ooool01?oo00L00?ooooooo`00ool0000:ool00`00
ooooo`02ool01000ooooo`001ooo00D00?oo003oo`0000Goo`05003oooooool00005ool00`00oooo
o`04ool01`00oooooooo003oo`0001Goo`L00003g]/`7mkK04?Nf`00;]kK0P006mkK00<00?ooool0
4_oo0P0000?oo`0000000ooo0P000ooo10000_oo00<00?oo00000P000_oo0P000_oo0P0000?oo`00
00002?oo10000ooo0P002?oo0P0000?oo`0000000ooo0P000ooo10000_oo00<00?oo00000P000_oo
0P000_oo0P0000?oo`0000005?oo1`000]kK00<`7mkKg]/0@MkK000^g]/00`00g]_Nf`0Jg]/00`00
ooooo`0Bool01@00oooooooo00002Ooo00<00?ooool06ooo00<00?ooool03Ooo00D00?ooooooo`00
00Woo`03003ooooo02Koo`L000?Nf`03<1oNfmkK043Nf`00;]kK00<00=kKg]/06]kK00<00?ooool0
8?oo00<00?ooool02_oo00<00?ooool03_oo00<00?ooool06ooo00<00?ooool02_oo00<00?ooool0
6Ooo1`001=kK00<`7mkKg]/0?mkK000^g]/00`00g]_Nf`0Jg]/00`00ooooo`25ool70005g]/00c0O
g]_Nf`0ng]/002kNf`8001_Nf`03003ooooo08Goo`L000KNf`03<1oNfmkK03gNf`00;]kK00<00=kK
g]/06]kK00<00?ooool0QOoo1`001mkK00<`7mkKg]/0?=kK000^g]/00`00g]_Nf`0Jg]/00`00oooo
o`25ool70008g]/00c0Og]_Nf`0kg]/002kNf`03003NfmkK01[Nf`03003ooooo08Goo`L000WNf`03
<1oNfmkK03[Nf`00;]kK0P006mkK00<00?ooool0QOoo1`002]kK00<`7mkKg]/0>MkK000^g]/00`00
g]_Nf`0Jg]/00`00ooooo`25ool7000;g]/00c0Og]_Nf`0hg]/002kNf`03003NfmkK01[Nf`03003o
oooo08Goo`L000cNf`03<1oNfmkK03ONf`00;]kK00<00=kKg]/06]kK00<00?ooool0QOoo1`003MkK
00<`7mkKg]/0=]kK000^g]/2000Kg]/00`00ooooo`0Bool200000ooo00000003ool200000ooo003o
o`02ool200001Ooo00000000ool00P000_oo0`0000Goo`00ool00?oo008000;oo`800003ool00?oo
00;oo`8000;oo`D000;oo`8000Coo`800003ool00?oo00Goo`D000?oo`80027oo`L000kNf`03<1oN
fmkK03GNf`00;]kK00<00=kKg]/06]kK00<00?ooool03c0O0ooo00D00?ooooooo`0000;oo`04003o
oooo0003ool01P00ooooo`00ool000;oo`04003ooooo0004ool01@00ool00?oo00000_oo00@00?oo
ool000?oo`04003ooooo0003ool01@00oooooooo00000_oo00@00?ooool000;oo`03003ooooo00Ko
o`04003ooooo0002ool01000ooooo`008?oo1`003mkK0S0O=MkK000^g]/00`00g]_Nf`0Jg]/00`00
ooooo`0Bool01@00ool00?oo00000ooo0`000ooo00<00?ooool00_oo00@00?ooool000;oo`<000;o
o`05003oo`00ool00003ool30003ool00`00ooooo`04ool01@00oooooooo00001_oo0`002?oo00<0
0?ooool00ooo00@00?ooool0023oo`L0017Nf`03<1oNfmkK03;Nf`008=kK10000]kK0`001MkK00<0
0=kKg]/06]kK00<00?ooool04_oo00D00?oo003oo`0000Goo`05003oooooool00004ool01000oooo
o`000_oo00X00?ooool00?oo003oo`00ool000Goo`05003oooooool00006ool01@00oooooooo0000
0_oo00<00?ooool00ooo00<00?ooool01_oo00<00?ooool00ooo00@00?ooool0023oo`L001;Nf`03
<1oNfmkK037Nf`008]kK00<00=kKg]/01=kK00<00=kKg]/00]kK00<00=kKg]/06]kK00<00?ooool0
4_oo0P0000?oo`0000000ooo0P000ooo10000_oo0`001?oo0P000_oo0P0000?oo`00ool00ooo0P00
0ooo10000ooo0P001?oo0P001?oo0P002Ooo00<00?ooool00ooo00@00?ooool0023oo`L001?Nf`03
<1oNfmkK033Nf`008]kK00<00=kKg]/01=kK00<00=kKg]/00]kK0P006mkK00<00?ooool04_oo00D0
0?ooooooo`0000Woo`03003ooooo00;oo`03003ooooo01Koo`03003ooooo01Woo`<000?oo`8000;o
o`8001ooo`03003NfmkK01SNf`03<1oNfmkK02oNf`008]kK00@00=kKg]_Nf`<000GNf`03003NfmkK
01[Nf`03003ooooo023oo`04003oooooool2000Hool00`00ooooo`04ool00`00ooooo`0mool00`00
g]_Nf`0Ig]/00c0Og]_Nf`0^g]/002;Nf`05003NfmkKg]/00007g]/00`00g]_Nf`0Jg]/00`00oooo
o`25ool00`00g]_Nf`0Jg]/00c0Og]_Nf`0]g]/0023Nf`<000?Nf`03003NfmkK00GNf`03003NfmkK
01[Nf`03003ooooo08Goo`03003NfmkK01_Nf`03<1oNfmkK02cNf`008]kK00@00=kKg]_Nf`@000CN
f`8001_Nf`03003ooooo08Goo`03003NfmkK01cNf`03<1oNfmkK02_Nf`00;]kK00<00=kKg]/06]kK
R@007mkK00<`7mkKg]/0:]kK000^g]/00`00g]_Nf`33g]/00c0Og]_Nf`0Yg]/002kNf`03003NfmkK
0<CNf`03<1oNfmkK02SNf`00;]kK0P00a]kK00<`7mkKg]/09mkK000^g]/00`00g]_Nf`36g]/00c0O
g]_Nf`0Vg]/002kNf`03003NfmkK0>oNf`00;]kK00<00=kKg]/0kmkK000^g]/2003`g]/002kNf`03
003NfmkK0>oNf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00
omkK8MkK003og]/Qg]/001[Nf`<000CNf`<000?Nf`8000CNf`8000;Nf`<00003g]/0000000;Nf`80
0003g]/00=kK00<00=oNf`006]kK00@00=kKg]/000;Nf`03003NfmkK00?Nf`04003NfmkK0002g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0005g]/00`00g]_Nf`3Lg]/001gNf`03003N
fmkK00<000?Nf`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000?N
f`800=oNf`006mkK0P000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@0
0=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`3Og]/001[Nf`03003NfmkK00CNf`8000CNf`80
00CNf`8000;Nf`04003Nf`000004g]/30003g]/3003Ng]/001_Nf`<001gNf`03003NfmkK0>;Nf`00
>]kK0P00i=kK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.05261, -0.648943, \
0.00733523, 0.00733523}, {{7.125, 279.812}, {172.688, 4.1875}} -> {392.572, \
-1.89793, 4.48154, 0.1173}, {{75.3125, 211.625}, {61.1875, 27.0625}} -> \
{-5.27147, -8.66129, 0.0686662, 0.0739485}, {{77.875, 92.4375}, {58.6875, \
45.1875}} -> {-5.64008, -29.1666, 0.0721037, 0.233332}, {{77.875, 92.4375}, \
{43, 29.5}} -> {-5.64008, -32.827, 0.0721037, 0.233332}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  "Discussion: The blue line indicates the time needed for a LU decomposition \
in ",
  StyleBox["Mathematica.",
    FontSlant->"Italic"],
  " The read line is the expected cost for transferring the problem to an \
external program. It is noteworthy that for matrices smaller than about 800 x \
800 on this machine the exporting cost is higher than the overall solving \
cost in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". Furthermore we need to keep in mind that the exporting overhead is for a \
",
  StyleBox["matrix to matrix",
    FontWeight->"Bold"],
  " transfer. The overhead has been tested to be symmetric. There is no \
difference in sending or receiving data. \nSo, the following conclusion can \
be drawn: If you decide to move outside of ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " then you should stay there as long as possible to reduce the overhead \
cost. Thinking about an external LU solving: send only back what you need. If \
you do not further need the LU decomposed matrix do not send it back, merely \
the result vector. Try to minimize the amount of data transferred."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["DGETRF (LU decomposition) in C", "Subsection"],

Cell[TextData[{
  "In the following step we compute the LU decomposition in external C \
program linked to the ATLAS generated libraries. The resulting  LU \
decomposition - computed by the DGETRF function in LAPACK - will in general \
be different from the one computed in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Install[atlasInterfacePath <> arch <> "\</DGETRF\>"]\)], "Input"],

Cell[BoxData[
    \(LinkObject["/usr/local/Wolfram/Linux_P4SSE2/bin/DGETRF", 5, 
      3]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DGETRF[\ {\ {1.2, \ 2.1\ }, \ {2.3, \ 4.5}\ }\ ]\)], "Input"],

Cell[BoxData[
    \({{{2.1`, 0.5714285714285714`}, {4.5`, \(-0.27142857142857146`\)}}, {1, 
        1}}\)], "Output"]
}, Open  ]],

Cell["\<\
The result is the decomposed matrix and information about pivoting needed by \
the LAPACK routines.\
\>", "Text"],

Cell[BoxData[
    \(\(lstDGETRF\  = \ 
        externalTiming[\ DGETRF, \ 500, \ 1500, \ 100\ ];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitDGETRF\  = \ Fit[\ lstDGETRF, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.0002713836286508791`\)\ x + 
      4.165296636830463`*^-6\ x\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[{fitMatLUDe, fitMaToMa, \ fitDGETRF}, {x, 500, 1500}, 
      PlotStyle \[Rule] {Hue[0.7], Hue[0.9], \ Hue[0.3]\ }, 
      PlotLegend \[Rule] {"\<Mathematica\>", "\<Matrix to Matrix\>", \ \
"\<DGETRF\>"}, LegendPosition \[Rule] {\(-0.5\), 0.2}, 
      LegendSize \[Rule] {1, 0.25}, LegendTextSpace \[Rule] 8, 
      AxesLabel \[Rule] {"\<N\>", "\<Seconds\>"}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0155575 0.0365414 [
[.30952 .00306 -9 -9 ]
[.30952 .00306 9 0 ]
[.5 .00306 -12 -9 ]
[.5 .00306 12 0 ]
[.69048 .00306 -12 -9 ]
[.69048 .00306 12 0 ]
[.88095 .00306 -12 -9 ]
[.88095 .00306 12 0 ]
[1.025 .01556 0 -4.90625 ]
[1.025 .01556 10 4.90625 ]
[.10655 .10691 -18 -4.5 ]
[.10655 .10691 0 4.5 ]
[.10655 .19826 -6 -4.5 ]
[.10655 .19826 0 4.5 ]
[.10655 .28962 -18 -4.5 ]
[.10655 .28962 0 4.5 ]
[.10655 .38097 -12 -4.5 ]
[.10655 .38097 0 4.5 ]
[.10655 .47232 -24 -4.5 ]
[.10655 .47232 0 4.5 ]
[.10655 .56368 -12 -4.5 ]
[.10655 .56368 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01556 m
.30952 .02181 L
s
[(800)] .30952 .00306 0 1 Mshowa
.5 .01556 m
.5 .02181 L
s
[(1000)] .5 .00306 0 1 Mshowa
.69048 .01556 m
.69048 .02181 L
s
[(1200)] .69048 .00306 0 1 Mshowa
.88095 .01556 m
.88095 .02181 L
s
[(1400)] .88095 .00306 0 1 Mshowa
.125 Mabswid
.16667 .01556 m
.16667 .01931 L
s
.21429 .01556 m
.21429 .01931 L
s
.2619 .01556 m
.2619 .01931 L
s
.35714 .01556 m
.35714 .01931 L
s
.40476 .01556 m
.40476 .01931 L
s
.45238 .01556 m
.45238 .01931 L
s
.54762 .01556 m
.54762 .01931 L
s
.59524 .01556 m
.59524 .01931 L
s
.64286 .01556 m
.64286 .01931 L
s
.7381 .01556 m
.7381 .01931 L
s
.78571 .01556 m
.78571 .01931 L
s
.83333 .01556 m
.83333 .01931 L
s
.07143 .01556 m
.07143 .01931 L
s
.02381 .01556 m
.02381 .01931 L
s
.92857 .01556 m
.92857 .01931 L
s
.97619 .01556 m
.97619 .01931 L
s
.25 Mabswid
0 .01556 m
1 .01556 L
s
gsave
1.025 .01556 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10691 m
.1253 .10691 L
s
[(2.5)] .10655 .10691 1 0 Mshowa
.11905 .19826 m
.1253 .19826 L
s
[(5)] .10655 .19826 1 0 Mshowa
.11905 .28962 m
.1253 .28962 L
s
[(7.5)] .10655 .28962 1 0 Mshowa
.11905 .38097 m
.1253 .38097 L
s
[(10)] .10655 .38097 1 0 Mshowa
.11905 .47232 m
.1253 .47232 L
s
[(12.5)] .10655 .47232 1 0 Mshowa
.11905 .56368 m
.1253 .56368 L
s
[(15)] .10655 .56368 1 0 Mshowa
.125 Mabswid
.11905 .03383 m
.1228 .03383 L
s
.11905 .0521 m
.1228 .0521 L
s
.11905 .07037 m
.1228 .07037 L
s
.11905 .08864 m
.1228 .08864 L
s
.11905 .12518 m
.1228 .12518 L
s
.11905 .14345 m
.1228 .14345 L
s
.11905 .16172 m
.1228 .16172 L
s
.11905 .17999 m
.1228 .17999 L
s
.11905 .21654 m
.1228 .21654 L
s
.11905 .23481 m
.1228 .23481 L
s
.11905 .25308 m
.1228 .25308 L
s
.11905 .27135 m
.1228 .27135 L
s
.11905 .30789 m
.1228 .30789 L
s
.11905 .32616 m
.1228 .32616 L
s
.11905 .34443 m
.1228 .34443 L
s
.11905 .3627 m
.1228 .3627 L
s
.11905 .39924 m
.1228 .39924 L
s
.11905 .41751 m
.1228 .41751 L
s
.11905 .43578 m
.1228 .43578 L
s
.11905 .45405 m
.1228 .45405 L
s
.11905 .4906 m
.1228 .4906 L
s
.11905 .50887 m
.1228 .50887 L
s
.11905 .52714 m
.1228 .52714 L
s
.11905 .54541 m
.1228 .54541 L
s
.11905 .58195 m
.1228 .58195 L
s
.11905 .60022 m
.1228 .60022 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02328 L
.10458 .03409 L
.14415 .04565 L
.18221 .05805 L
.22272 .07262 L
.26171 .088 L
.30316 .10579 L
.34309 .12434 L
.3815 .14349 L
.42237 .16527 L
.46172 .18761 L
.49955 .21036 L
.53984 .23595 L
.57861 .2619 L
.61984 .29093 L
.65954 .32028 L
.69774 .34981 L
.73838 .38262 L
.77751 .41556 L
.81909 .45202 L
.85916 .48858 L
.89771 .52506 L
.93871 .56528 L
.97619 .60332 L
s
1 0 .6 r
.02381 .03532 m
.06244 .03963 L
.10458 .04479 L
.14415 .05008 L
.18221 .05557 L
.22272 .06185 L
.26171 .06831 L
.30316 .07564 L
.34309 .08313 L
.3815 .09076 L
.42237 .09931 L
.46172 .10797 L
.49955 .1167 L
.53984 .12642 L
.57861 .1362 L
.61984 .14704 L
.65954 .15792 L
.69774 .16878 L
.73838 .18079 L
.77751 .19277 L
.81909 .20596 L
.85916 .21911 L
.89771 .23218 L
.93871 .24652 L
.97619 .26003 L
s
.2 1 0 r
.02381 .04865 m
.06244 .05467 L
.10458 .06181 L
.14415 .06906 L
.18221 .07653 L
.22272 .08501 L
.26171 .09369 L
.30316 .10348 L
.34309 .11346 L
.3815 .12356 L
.42237 .13485 L
.46172 .14625 L
.49955 .15771 L
.53984 .17043 L
.57861 .18319 L
.61984 .19731 L
.65954 .21145 L
.69774 .22555 L
.73838 .24109 L
.77751 .25658 L
.81909 .2736 L
.85916 .29055 L
.89771 .30737 L
.93871 .3258 L
.97619 .34315 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.28571 .38045 m
.28571 .49949 L
.7619 .49949 L
.7619 .38045 L
F
1 g
.2619 .40426 m
.2619 .5233 L
.7381 .5233 L
.7381 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.2619 .40426 m
.7381 .40426 L
.7381 .5233 L
.2619 .5233 L
.2619 .40426 L
s
% Start of sub-graphic
p
0.261905 0.404255 0.738095 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00679348 0.0679348 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0122283 0.126068 0.080163 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 1 0 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0462 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(DGETRF) show
99.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0910326 0.126068 0.158967 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .125 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Matrix) show
105.000 11.562 moveto
(to) show
123.000 11.562 moveto
(Matrix) show
159.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.169837 0.126068 0.237772 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .2038 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 11}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00DmkK0P001=kK0P001=kK0P006mkK1000
0mkK0P001=kK0P001=kK0P006=kK10000]kK10000mkK0P001=kK0P005mkK10001=kK00<00=kKg]/0
0]kK0P001=kK0P00=]kK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Lg]/0
1@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`0Gg]/01@00g]_N
fmkK00001MkK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00g]_Nf`03g]/01@00g]_NfmkK0000
0]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/0
1000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kK
g]/05mkK00<00=kKg]/00]kK00<00=kKg]/00]kK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00
g]_Nf`050002g]/01000g]_Nf`000]kK00@00=kKg]/003GNf`00DmkK0P000mkK00@00=kKg]/000;N
f`04003NfmkK000Lg]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00
g]_Nf`0Gg]/00`00g]_Nf`03g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK01KN
f`04003NfmkK0002g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05mkK00<00=kKg]/01=kK00@00=kKg]/000;Nf`04
003NfmkK0002g]/00`00g]_Nf`0Fg]/01`00g]_NfmkK003Nf`0000?Nf`04003NfmkK0002g]/01000
g]_Nf`00=MkK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Jg]/30003g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Gg]/30003g]/01000g]_Nf`000]kK00@0
0=kKg]/000;Nf`04003NfmkK000Fg]/30004g]/20003g]/01000g]_Nf`000]kK00@00=kKg]/003GN
f`00;]kK00<00=kKg]/08]kK0P001=kK0P001=kK0P007MkK00<00=kKg]/00]kK0P001=kK0P001=kK
0P006]kK00<00=kKg]/00]kK0P001=kK0P001=kK0P006MkK00<00=kKg]/00mkK00<00=kKg]/00]kK
0P001=kK0P00=]kK000^g]/00`00g]_Nf`3_g]/002kNf`03003NfmkK0=?Nf`8000;Nf`03003NfmkK
01GNf`00;]kK00<00=kKg]/0e=kK00@00=kKg]/001ONf`004]kK1P000c0OhP002=kK00@00=kK0000
01ONf`006=kK00<00=kKg]/0130O1=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK
00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02MkK00<00=kKg]/02=kK00<00=kKg]/02=kK
00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02MkK
00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK
00<00=kKg]/02=kK00<00=kKg]/03=kK0P0000?Nf`00g]/05]kK000Og]/5<1l:g]/00`00g]_Nf`3D
g]/01000g]_Nf`005mkK000Tg]/5<1l5g]/00`00g]_Nf`3Cg]/200000mkK0000000Gg]/001SNf`Gh
4`cNf`@`7`03g]/000000?3Nf`007MkK1oPC2MkK0c0Ol=kK000Tg]/5n1<5g]/00`00g]/`7`02<1o]
g]/001SNf`<gh0kNf`Oh4`?Nf`<`7n[Nf`006mkK13OP3mkK0P002OPCimkK000Og]/5=n0:g]/00`00
g]_Nf`08g]/7n1?Pg]/002CNf`Dgh0GNf`03003NfmkK00_Nf`<`7`03g]_h4oPC00;h4mcNf`00:MkK
1cOP3mkK0c0O0]kK1oPCeMkK000^g]/00`00g]/gh006=n0;g]/3<1l6g]/7n1?>g]/002kNf`8000ON
f`@gh0[Nf`<`7`[Nf`Gh4lWNf`00;]kK00<00=kKg]/02]kK1COP2=kK0S0O3MkK1OPCa=kK000^g]/0
0`00g]_Nf`0?g]/4=n06g]/2<1l@g]/4n1?0g]/002kNf`03003NfmkK01?Nf`Dgh0?Nf`8`7a;Nf`Oh
4kWNf`00;]kK0P006MkK13OP00CNfc0O<1l`7aKNf`Oh4k;Nf`00;]kK00<00=kKg]/07=kK1COP00<`
7mkKg]/06MkK1OPC[MkK000Jg]/40003g]/00`00g]_Nf`02g]/30005g]/00`00g]_Nf`0Qg]/5=n0L
g]/5n1>Xg]/001[Nf`03003NfmkK00cNf`03003NfmkK00;Nf`03003NfmkK02GNf`03<1lgh3OP008g
h1gNf`Ch4jCNf`006mkK00<00=kKg]/02mkK00<00=kKg]/00]kK0P00:=kK0c0O0cOP7]kK1OPCWmkK
000Lg]/00`00g]_Nf`07g]/30005g]/00`00g]_Nf`0Zg]/2<1l01=kK=n0gh3OP8=kK1?PCVmkK000M
g]/00`00g]_Nf`06g]/00`00g]_Nf`05g]/00`00g]_Nf`0/g]/2<1l2g]/4=n0Pg]/4n1>Gg]/001[N
f`04003NfmkK0008g]/00`00g]_Nf`05g]/00`00g]_Nf`0^g]/2<1l4g]/4=n0Pg]/3n1>Dg]/001_N
f`8000WNf`@000CNf`80037Nf`8`7`KNf`@gh1oNf`?h4i7Nf`00;]kK00<00=kKg]/0<]kK0S0O2=kK
0cOP7mkK1?PCSMkK000^g]/00`00g]_Nf`0dg]/2<1l9g]/4=n0Og]/4n1>9g]/002kNf`03003NfmkK
03KNf`8`7`_Nf`@gh1oNf`Gh4hCNf`00;]kK00<00=kKg]/0>=kK0S0O3MkK13OP8=kK1OPCOmkK000^
g]/2000kg]/00c0Og]_Nf`0>g]/4=n0Qg]/4n1=kg]/002kNf`03003NfmkK03_Nf`8`7a;Nf`<gh2;N
f`?h4gSNf`00;]kK00<00=kKg]/0?MkK0S0O4mkK0cOP8]kK0oPCMMkK000^g]/00`00g]_Nf`0og]/2
<1lDg]/3=n0Rg]/3n1=bg]/002kNf`8004;Nf`8`7aGNf`<gh2;Nf`?h4foNf`00;]kK00<00=kKg]/0
@mkK0S0O5]kK0cOP8]kK0oPCK=kK000^g]/00`00g]_Nf`15g]/2<1lGg]/3=n0Rg]/4n1=Xg]/002kN
f`03003NfmkK04ONf`8`7aSNf`<gh2?Nf`Gh4f?Nf`00;]kK0P00B]kK0S0O6MkK0cOP9MkK1?PCGmkK
000^g]/00`00g]_Nf`1;g]/2<1lJg]/3=n0Vg]/3n1=Lg]/002KNf`<000GNf`03003NfmkK04gNf`03
<1oNfmkK01[Nf`<gh2KNf`?h4eWNf`00:MkK00<00=kKg]/00]kK00<00=kKg]/0C]kK0S0O7MkK13OP
9MkK0oPCE]kK000Yg]/00`00g]_Nf`02g]/2001Ag]/2<1lOg]/3=n0Ug]/3n1=Cg]/002KNf`<000GN
f`03003NfmkK05;Nf`8`7b3Nf`8gh2KNf`Ch4doNf`009]kK00<00=kKg]/01MkK00<00=kKg]/0E=kK
0S0O8=kK0SOP:=kK0oPCC=kK000Vg]/00`00g]_Nf`05g]/00`00g]_Nf`1Fg]/00c0Og]_Nf`0Og]/2
=n0Yg]/3n1=9g]/002KNf`@000CNf`03003NfmkK05ONf`8`7b7Nf`<gh2WNf`?h4dKNf`00;]kK0P00
F]kK00<`7mkKg]/08MkK0cOP:MkK0oPC@mkK000^g]/00`00g]_Nf`1Jg]/2<1lTg]/3=n0Yg]/3n1=0
g]/002kNf`03003NfmkK05cNf`03<1oNfmkK02CNf`<gh2WNf`?h4cgNf`00;]kK00<00=kKg]/0GMkK
0S0O9mkK0cOP:MkK0oPC>]kK000^g]/2001Pg]/00c0Og]_Nf`0Wg]/4=n0Xg]/2n1<hg]/002kNf`03
003NfmkK063Nf`8`7b_Nf`<gh2ONf`?h4cGNf`00;]kK00<00=kKg]/0H]kK00<`7mkKg]/0:mkK0SOP
:=kK0_PC<mkK000^g]/00`00g]_Nf`1Sg]/2<1l]g]/2=n0Xg]/3n1<`g]/002kNf`8006KNf`03<1oN
fmkK02cNf`8gh2WNf`;h4bkNf`00;]kK00<00=kKg]/0I]kK0S0O;]kK0cOP:=kK0oPC:mkK000^g]/0
0`00g]_Nf`1Xg]/00c0Og]_Nf`0^g]/2=n0Yg]/2n1<Yg]/002kNf`03003NfmkK06WNf`8`7c3Nf`<g
h57Nf`00;]kK00<00=kKg]/0JmkK00<`7mkKg]/0<=kK0SOPCmkK000^g]/2001]g]/00c0Og]_Nf`0a
g]/3=n1<g]/002kNf`03003NfmkK06gNf`8`7cCNf`8gh4[Nf`006mkK00<00=kKg]/00mkK00<00=kK
g]/00]kK0`001MkK00<00=kKg]/0KmkK00<`7mkKg]/0<mkK0SOPB=kK000Kg]/00`00g]_Nf`0;g]/0
0`00g]_Nf`02g]/00`00g]_Nf`1`g]/2<1leg]/2=n16g]/001cNf`03003NfmkK00[Nf`03003NfmkK
00;Nf`8007?Nf`03<1oNfmkK03CNf`<gh4?Nf`007=kK00<00=kKg]/01mkK0`001MkK00<00=kKg]/0
LmkK00<`7mkKg]/0=]kK0SOP@MkK000Mg]/00`00g]_Nf`06g]/00`00g]_Nf`05g]/00`00g]_Nf`1d
g]/2<1lhg]/2=n0og]/001[Nf`04003NfmkK0008g]/00`00g]_Nf`05g]/00`00g]_Nf`1fg]/00c0O
g]_Nf`0gg]/2=n0mg]/001[Nf`@000SNf`@000CNf`8007SNf`03<1oNfmkK03SNf`<gh3[Nf`00;]kK
00<00=kKg]/0N=kK0S0O>mkK0SOP>=kK000^g]/00`00g]_Nf`1jg]/00c0Og]_Nf`0jg]/3=n0eg]/0
02kNf`03003NfmkK07_Nf`03<1oNfmkK03cNf`8gh3?Nf`00;]kK0P00OMkK00<`7mkKg]/0?MkK0SOP
<MkK000^g]/00`00g]_Nf`1mg]/2<1log]/2=n0_g]/002kNf`03003NfmkK07oNf`03<1oNfmkK03kN
f`8gh2gNf`00;]kK00<00=kKg]/0P=kK00<`7mkKg]/0?mkK0SOP:mkK000^g]/00`00g]_Nf`21g]/2
<1m1g]/2=n0Yg]/002kNf`8008CNf`03<1oNfmkK06WNf`00;]kK00<00=kKg]/0Q=kK00<`7mkKg]/0
J=kK000^g]/00`00g]_Nf`25g]/00c0Og]_Nf`1Wg]/002kNf`03003NfmkK08KNf`8`7fONf`00;]kK
0P00RMkK00<`7mkKg]/0I=kK000^g]/00`00g]_Nf`29g]/00c0Og]_Nf`1Sg]/0023Nf`@000?Nf`80
00GNf`03003NfmkK08[Nf`03<1oNfmkK06;Nf`008]kK00D00=kKg]_Nf`0000;Nf`03003NfmkK00;N
f`03003NfmkK08_Nf`8`7f;Nf`008]kK00D00=kKg]_Nf`0000;Nf`03003NfmkK00;Nf`8008kNf`03
<1oNfmkK05oNf`008]kK00D00=kKg]_Nf`0000;Nf`03003NfmkK00;Nf`03003NfmkK08kNf`03<1oN
fmkK05kNf`008]kK00D00=kKg]_Nf`0000;Nf`03003NfmkK00;Nf`03003NfmkK08oNf`03<1oNfmkK
05gNf`008=kK0`000mkK00@00=kKg]/000CNf`03003NfmkK093Nf`8`7egNf`008]kK00<00=kKg]/0
0]kK0P001MkK0P00TmkK00<`7mkKg]/0F]kK000^g]/00`00g]_Nf`2Cg]/00c0Og]_Nf`1Ig]/002kN
f`03003NfmkK09CNf`8`7eWNf`00;]kK00<00=kKg]/0U]kK00<`7mkKg]/0E]kK000^g]/00`00g]_N
f`0Qg]^80016g]/002kNf`8002;NfhP004KNf`00;]kK00<00=kKg]/08MkKR000A]kK000^g]/00`00
g]_Nf`0Qg]^80016g]/002kNf`03003NfmkK027NfhP004KNf`00;]kK0P008]kKR000A]kK000^g]/0
0`00g]_Nf`0Jg]^?0016g]/002kNf`03003NfmkK01[Nf`03003ooooo08Goo`L004KNf`00;]kK00<0
0=kKg]/06]kK00<00?ooool0QOoo1`00A]kK000^g]/2000Kg]/00`00ooooo`25ool70016g]/002kN
f`03003NfmkK01[Nf`03003ooooo08Goo`L004KNf`00;]kK00<00=kKg]/06]kK00<00?ooool04_oo
10001?oo0P000_oo1@000_oo0`000_oo0`000_oo1000D_oo1`00A]kK000Dg]/40002g]/40003g]/0
0`00g]_Nf`02g]/30005g]/00`00g]_Nf`0Jg]/00`00ooooo`0Cool01000ooooo`000_oo00@00?oo
ool000;oo`04003ooooo0003ool00`00ooooo`02ool01000ooooo`000_oo00<00?ooool0DOoo1`00
A]kK000Fg]/01@00g]_NfmkK00003]kK00<00=kKg]/00]kK00<00=kKg]/06]kK00<00?ooool03cOP
1?oo00@00?ooool000;oo`04003oo`000002ool00`00ooooo`04ool00`00ooooo`02ool30003ool0
0`00ool0001Aool70016g]/001KNf`03003NfmkK00;Nf`03003NfmkK00_Nf`03003NfmkK00;Nf`80
01_Nf`03003ooooo01?oo`04003ooooo0002ool00`00ooooo`03ool30004ool00`00ooooo`02ool0
1000ooooo`000_oo0`00DOoo1`00A]kK000Fg]/00`00g]_Nf`03g]/00`00g]_Nf`07g]/30005g]/0
0`00g]_Nf`0Jg]/00`00ooooo`0Cool01000ooooo`000_oo00@00?ooool000;oo`0:003ooooo003o
o`00ool00?oo0002ool01000ooooo`000_oo00@00?ooool0053oo`L004KNf`005]kK00<00=kKg]/0
1=kK00<00=kKg]/01]kK00<00=kKg]/01MkK00<00=kKg]/06]kK00<00?ooool04_oo10001?oo0P00
0_oo1@0000?oo`0000000`0000?oo`0000000P000_oo1@00D?oo1`0000<`7mkKg]/0@mkK000Dg]/3
0003g]/01000g]_Nf`002=kK00<00=kKg]/01MkK00<00=kKg]/06]kK00<00?ooool0QOoo1`0000?N
fc0Og]/0@mkK000Fg]/00`00g]_Nf`02g]/20009g]/40004g]/2000Kg]/00`00ooooo`25ool70002
g]/00c0Og]_Nf`11g]/002kNf`03003NfmkK01[Nf`03003ooooo08Goo`L000?Nf`03<1oNfmkK043N
f`00;]kK00<00=kKg]/06]kK00<00?ooool0QOoo1`001=kK00<`7mkKg]/0?mkK000^g]/00`00g]_N
f`0Jg]/00`00ooooo`25ool70005g]/00c0Og]_Nf`0ng]/002kNf`8001_Nf`03003ooooo01;oo`80
0003ool0000000?oo`800003ool00?oo00;oo`8000;oo`@000;oo`L00003ool0000000[oo`8000?o
o`8000Soo`800003ool0000000?oo`800003ool00?oo00;oo`8000;oo`@000;oo`L00003ool00000
01Coo`L000KNf`03<1oNfmkK03gNf`00;]kK00<00=kKg]/06]kK00<00?ooool03oPC0ooo00D00?oo
ooooo`0000;oo`04003ooooo0003ool01000ooooo`000_oo00<00?ooool01?oo00L00?ooooooo`00
ool0000:ool01P00ooooo`00ool000;oo`03003ooooo00Goo`05003oooooool00002ool01000oooo
o`000ooo00@00?ooool000;oo`03003ooooo00Coo`07003oooooool00?oo00005Ooo1`001mkK00<`
7mkKg]/0?=kK000^g]/00`00g]_Nf`0Jg]/00`00ooooo`0Bool01@00ool00?oo00000ooo0`000ooo
00<00?ooool00ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool02Ooo00<00?ooool00_oo
00@00?ooool000Ooo`05003oo`00ool00003ool30003ool00`00ooooo`03ool00`00ooooo`04ool0
0`00ooooo`02ool00`00ooooo`0Dool70008g]/00c0Og]_Nf`0kg]/002kNf`03003NfmkK01[Nf`03
003ooooo01;oo`05003oo`00ool00005ool01@00oooooooo00001Ooo00<00?ooool01?oo00L00?oo
ooooo`00ool0000:ool00`00ooooo`02ool01000ooooo`001ooo00D00?oo003oo`0000Goo`05003o
ooooool00005ool00`00ooooo`04ool01`00oooooooo003oo`0001Goo`L000WNf`03<1oNfmkK03[N
f`00;]kK0P006mkK00<00?ooool04_oo0P0000?oo`0000000ooo0P000ooo10000_oo00<00?oo0000
0P000_oo0P000_oo0P0000?oo`0000002?oo10000ooo0P002?oo0P0000?oo`0000000ooo0P000ooo
10000_oo00<00?oo00000P000_oo0P000_oo0P0000?oo`0000005?oo1`002]kK00<`7mkKg]/0>MkK
000^g]/00`00g]_Nf`0Jg]/00`00ooooo`0Bool01@00oooooooo00002Ooo00<00?ooool06ooo00<0
0?ooool03Ooo00D00?ooooooo`0000Woo`03003ooooo02Koo`L000_Nf`03<1oNfmkK03SNf`00;]kK
00<00=kKg]/06]kK00<00?ooool08?oo00<00?ooool02_oo00<00?ooool03_oo00<00?ooool06ooo
00<00?ooool02_oo00<00?ooool06Ooo1`003=kK00<`7mkKg]/0=mkK000^g]/00`00g]_Nf`0Jg]/0
0`00ooooo`25ool7000=g]/00c0Og]_Nf`0fg]/002kNf`03003NfmkK01[Nf`03003ooooo08Goo`L0
00kNf`03<1oNfmkK03GNf`00;]kK0P006mkK00<00?ooool0QOoo1`003mkK0S0O=MkK000^g]/00`00
g]_Nf`0Jg]/00`00ooooo`25ool7000Ag]/00c0Og]_Nf`0bg]/0023Nf`@000;Nf`<000GNf`03003N
fmkK01[Nf`03003ooooo01;oo`800003ool0000000?oo`800003ool00?oo00;oo`800005ool00000
003oo`020002ool300001Ooo003oo`00ool00P000_oo0P0000?oo`00ool00_oo0P000_oo1@000_oo
0P001?oo0P0000?oo`00ool0<?oo1`004]kK00<`7mkKg]/0<MkK000Rg]/00`00g]_Nf`04g]/00`00
g]_Nf`02g]/00`00g]_Nf`0Jg]/00`00ooooo`0?<1l3ool01@00oooooooo00000_oo00@00?ooool0
00?oo`06003ooooo003oo`000_oo00@00?ooool000Coo`05003oo`00ool00002ool01000ooooo`00
0ooo00@00?ooool000?oo`05003oooooool00002ool01000ooooo`000_oo00<00?ooool0<?oo1`00
4mkK00<`7mkKg]/0<=kK000Rg]/00`00g]_Nf`04g]/00`00g]_Nf`02g]/2000Kg]/00`00ooooo`0B
ool01@00ool00?oo00000ooo0`000ooo00<00?ooool00_oo00@00?ooool000;oo`<000;oo`05003o
o`00ool00003ool30003ool00`00ooooo`04ool01@00oooooooo00001_oo0`00<_oo00<00=kKg]/0
6=kK00<`7mkKg]/0;mkK000Rg]/01000g]_NfmkK0`001MkK00<00=kKg]/06]kK00<00?ooool04_oo
00D00?oo003oo`0000Goo`05003oooooool00004ool01000ooooo`000_oo00X00?ooool00?oo003o
o`00ool000Goo`05003oooooool00006ool01@00oooooooo00000_oo00<00?ooool00ooo00<00?oo
ool0<?oo00<00=kKg]/06MkK00<`7mkKg]/0;]kK000Rg]/01@00g]_NfmkK00001mkK00<00=kKg]/0
6]kK00<00?ooool04_oo0P0000?oo`0000000ooo0P000ooo10000_oo0`001?oo0P000_oo0P0000?o
o`00ool00ooo0P000ooo10000ooo0P001?oo0P001?oo0P00<ooo00<00=kKg]/06]kK00<`7mkKg]/0
;MkK000Pg]/30003g]/00`00g]_Nf`05g]/00`00g]_Nf`0Jg]/00`00ooooo`0Bool01@00oooooooo
00002Ooo00<00?ooool00_oo00<00?ooool05_oo00<00?ooool0A?oo00<00=kKg]/06mkK00<`7mkK
g]/0;=kK000Rg]/01000g]_NfmkK10001=kK0P006mkK00<00?ooool08?oo00@00?ooooooo`8001So
o`03003ooooo00Coo`03003ooooo03goo`03003NfmkK01cNf`03<1oNfmkK02_Nf`00;]kK00<00=kK
g]/06]kKR@007]kK00<`7mkKg]/0:mkK000^g]/00`00g]_Nf`32g]/00c0Og]_Nf`0Zg]/002kNf`03
003NfmkK0<?Nf`03<1oNfmkK02WNf`00;]kK0P00aMkK00<`7mkKg]/0:=kK000^g]/00`00g]_Nf`35
g]/00c0Og]_Nf`0Wg]/002kNf`03003NfmkK0>oNf`00;]kK00<00=kKg]/0kmkK000^g]/00`00g]_N
f`3_g]/002kNf`03003NfmkK0>oNf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/001[Nf`<000CNf`<000?Nf`8000CNf`8000;Nf`<00003
g]/0000000;Nf`800003g]/00=kK00<00=oNf`006]kK00@00=kKg]/000;Nf`03003NfmkK00?Nf`04
003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0005g]/00`00g]_Nf`3L
g]/001gNf`03003NfmkK00<000?Nf`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`000]kK
00@00=kKg]/000?Nf`800=oNf`006mkK0P000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000
g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`3Og]/001[Nf`03003NfmkK
00CNf`8000CNf`8000CNf`8000;Nf`04003Nf`000004g]/30003g]/3003Ng]/001_Nf`<001gNf`03
003NfmkK0>;Nf`00>]kK0P00i=kK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.05261, -0.648943, \
0.00733523, 0.00733523}, {{7.125, 279.812}, {172.688, 4.1875}} -> {391.513, \
-1.89237, 4.48919, 0.117002}, {{75.3125, 211.625}, {61.1875, 27.0625}} -> \
{-5.27147, -12.6022, 0.0686662, 0.107988}, {{77.875, 92.4375}, {59.4375, \
50.1875}} -> {-5.64008, -28.4957, 0.0721037, 0.233332}, {{77.875, 92.4375}, \
{48.75, 39.4375}} -> {-5.64008, -30.9968, 0.0721037, 0.233332}, {{77.875, \
92.4375}, {38, 28.75}} -> {-5.64008, -33.4978, 0.0721037, 0.233332}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  "Again the blue line indicates the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " LUDecomposition, red the overhead for sending and receiving a matrix. The \
green line the LU decomposition done by the ATLAS DGETRF routine. Again note \
that moving to an external program only really pays for matrices larger than \
a certain size, on this machine larger than 900 x 900.\nBy all means, you \
should work on reducing the overhead. As you can see the largest part of \
computing the LU decomposition and sending it back is in the transfer of \
data.\nAnother point: Exporting also means double memory requirements! Only a \
copy of the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Kernel is send to the foreign program. This imposes a serious \
restriction. Since storing two copies of the matrix is very inefficient. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " should provide a mechanism to modify the kernel memory contends \
directly!"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
A complete decomposition and back substitution with focus on the accuracy of \
the result\
\>", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Install[atlasInterfacePath <> arch <> "\</atLUSolve\>"]\)], "Input"],

Cell[BoxData[
    \(LinkObject["/usr/local/Wolfram/Linux_P4SSE2/bin/atLUSolve", 6, 
      4]\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(inMatrix\  = \ TestMatrix[\ 400\ ];\)\), "\[IndentingNewLine]", 
    \(\(loadVector\  = \ TestVector[\ 400\ ];\)\), "\[IndentingNewLine]", 
    \(\(loadMatrix\  = \ TestMatrix[\ 400\ ];\)\)}], "Input"],

Cell[CellGroupData[{

Cell["Mathematica", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(resMatLU\  = \ 
          LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ 
            loadVector\ ];\) // Timing\)], "Input"],

Cell[BoxData[
    \({0.28999999999999093`\ Second, Null}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ATLAS", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(resATLU\  = \ atLUSolve[\ inMatrix, \ loadVector\ ];\)\  // 
      ExtendedTiming\)], "Input"],

Cell[BoxData[
    \({0.`, Null}\)], "Output"]
}, Open  ]],

Cell["\<\
Please note that we are below this machines critical problem size. Usually it \
would not pay to export the problem to an external application. Now, however, \
we do not send back the decomposed matrix, instead only the solution vector \
is send back. The interface design has changed in order to minimize the \
amount of transferred data.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Accuracy", "Subsubsection"],

Cell[TextData[{
  "According to ",
  ButtonBox["Weller",
    ButtonData:>"Weller",
    ButtonStyle->"Hyperlink"],
  " an estimate for the accuracy can be computed by the following formula:\n\t\
accuracy = ",
  StyleBox["t",
    FontSlant->"Italic"],
  " - \[Alpha] - 1\nwhere ",
  StyleBox["t",
    FontSlant->"Italic"],
  " is the floating-point digits (16 in our case), \[Alpha] computes from ",
  StyleBox["cond",
    FontSlant->"Italic"],
  "( ",
  StyleBox["m",
    FontSlant->"Italic"],
  " ) = ",
  Cell[BoxData[
      \(TraditionalForm\`10\^\[Alpha]\)]],
  ", where ",
  StyleBox["cond",
    FontSlant->"Italic"],
  "( ",
  StyleBox["m",
    FontSlant->"Italic"],
  " ) is the condition number of matrix ",
  StyleBox["m",
    FontSlant->"Italic"],
  " and is computed by ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(||\)\(m\)\( || \_\[Infinity]\)\(\(.\)\(\(||\)\(m\
\^\(-1\)\)\( || \_\[Infinity]\)\)\)\)\)]]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"myExpectedAccuracy", " ", "=", " ", 
      RowBox[{"16", " ", "-", " ", 
        RowBox[{"Floor", "[", "\[IndentingNewLine]", " ", 
          RowBox[{"Log", "[", " ", 
            RowBox[{"10", ",", "\[IndentingNewLine]", 
              
              RowBox[{\(MatrixNorm[\ 
                  Inverse[\ Transpose[\ inMatrix\ ]\ ]\ \ ]\), " ", 
                StyleBox["*",
                  "Text"], 
                StyleBox[" ",
                  
                  "Text"], \(MatrixNorm[\ \ Transpose[\ 
                    inMatrix\ ]\ \ ]\)}]}], "\[IndentingNewLine]", "]"}], 
          "\[IndentingNewLine]", "]"}], " ", "-", "1"}]}]], "Input"],

Cell[BoxData[
    \(11\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((\(SetAccuracy[\ #1, \ \ myExpectedAccuracy] &\)\  /@ \ \ resMatLU\ \ \
)\)\  === \ \ resATLU\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\<\
Also solving a linear system with a load matrix, i.e. multiple load vectors, \
is possible.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multiple Load Vectors with Mathematica", "Subsubsection"],

Cell["\<\
LUBackSubstitution expects as second argument a row vector (List). In order \
to load  the decomposed matrix with many load (column) vectors, we transpose \
each column into a row. (each RHS corresponds to a matrix ROW)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(tLM\  = \ Transpose[\ loadMatrix\ ];\)\), "\[IndentingNewLine]", 
    \(\(resMatLU\  = \ 
          LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ tLM];\)\  // 
      Timing\)}], "Input"],

Cell[BoxData[
    \({1.3900000000000137`\ Second, Null}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multiple Load Vectors with ATLAS", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(resATLU\  = \ atLUSolve[\ inMatrix, \ loadMatrix\ ];\)\  // 
      ExtendedTiming\)], "Input"],

Cell[BoxData[
    \({1.`, Null}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Accuracy", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((\(SetAccuracy[\ #1, \ myExpectedAccuracy\ ] &\)\  /@ \ 
          Transpose[\ resMatLU\ ]\ )\)\  === \ \ resATLU\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
A complete decomposition and back substitution with focus on the timing of \
the computation\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["Mathematica", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstMatLUSolve\  = \ timingMatLU[\ \ 500, 1500, \ 100\ ]\)], "Input"],

Cell[BoxData[
    \({{500, 0.5899999999999886`}, {600, 1.0800000000000183`}, {700, 
        1.7300000000000182`}, {800, 2.55`}, {900, 3.689999999999986`}, {1000, 
        4.999999999999984`}, {1100, 6.630000000000004`}, {1200, 
        8.649999999999979`}, {1300, 11.059999999999995`}, {1400, 
        13.720000000000013`}, {1500, 16.999999999999993`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitMatLUSolve\  = \ 
      Fit[\ lstMatLUSolve, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.005564414540583343`\)\ x + 
      0.000010951287828046034`\ x\^2\)], "Output"]
}, Open  ]],

Cell["Many load vectors", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstMatLUSolveMany\  = 
      timingMatLUMany[\ \ 500, 1500, \ 100\ ]\)], "Input"],

Cell[BoxData[
    \({{500, 2.7900000000000045`}, {600, 5.2099999999999635`}, {700, 
        7.75999999999995`}, {800, 12.839999999999977`}, {900, 
        16.429999999999986`}, {1000, 24.449999999999985`}, {1100, 
        30.330000000000037`}, {1200, 44.08000000000005`}, {1300, 
        50.50000000000003`}, {1400, 68.24000000000004`}, {1500, 
        78.77999999999994`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitMatLUSolveMany\  = \ 
      Fit[\ lstMatLUSolveMany, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.026233148024112637`\)\ x + 
      0.000051922943432990376`\ x\^2\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ATLAS", "Subsubsection"],

Cell["One load vector", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstATLUSolve\  = \ timingATLU[\ 500, \ 1500, \ 100\ ]\)], "Input"],

Cell[BoxData[
    \({{500, 0.4`}, {600, 0.6`}, {700, 0.8`}, {800, 0.7`}, {900, 1.`}, {1000, 
        1.4`}, {1100, 1.6`}, {1200, 2.`}, {1300, 2.4`}, {1400, 2.8`}, {1500, 
        3.3`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitATLUSolve\  = \ 
      Fit[\ lstATLUSolve, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.00013191459132517506`\)\ x + 
      1.519312346505917`*^-6\ x\^2\)], "Output"]
}, Open  ]],

Cell["Many load vectors", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstATLUSolveMany\  = \ 
      timingATLUMany[\ 500, \ 1500, \ 100\ ]\)], "Input"],

Cell[BoxData[
    \({{500, 0.9`}, {600, 1.3`}, {700, 2.2`}, {800, 3.`}, {900, 3.7`}, {1000, 
        5.`}, {1100, 6.1`}, {1200, 8.2`}, {1300, 9.3`}, {1400, 11.5`}, {1500, 
        14.1`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitATLUSolveMany\  = \ 
      Fit[\ lstATLUSolveMany, \ {x, \ \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.0027193143761797575`\)\ x + 
      7.852706570054195`*^-6\ x\^2\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Results", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(from\  = \ 500; \ to\  = \ 1500;\), "\[IndentingNewLine]", 
    \(Plot[\[IndentingNewLine]{\ fitMatLUSolve, \ fitATLUSolve\ }, {x, from, 
        to}, \ PlotStyle \[Rule] {Hue[0.7], Hue[0.9]}, 
      PlotLegend \[Rule] {"\<Mathematica\>", "\<ATLAS\>"}, 
      LegendLabel -> "\<One load vector\>", 
      LegendPosition \[Rule] {\(-0.6\), 0.2}, LegendSize \[Rule] {1, 0.25}, 
      LegendTextSpace \[Rule] 8, 
      AxesLabel \[Rule] {"\<N\>", "\<Seconds\>"}\[IndentingNewLine]]\)}], \
"Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0163141 0.0360263 [
[.30952 .00381 -9 -9 ]
[.30952 .00381 9 0 ]
[.5 .00381 -12 -9 ]
[.5 .00381 12 0 ]
[.69048 .00381 -12 -9 ]
[.69048 .00381 12 0 ]
[.88095 .00381 -12 -9 ]
[.88095 .00381 12 0 ]
[1.025 .01631 0 -4.90625 ]
[1.025 .01631 10 4.90625 ]
[.10655 .10638 -18 -4.5 ]
[.10655 .10638 0 4.5 ]
[.10655 .19645 -6 -4.5 ]
[.10655 .19645 0 4.5 ]
[.10655 .28651 -18 -4.5 ]
[.10655 .28651 0 4.5 ]
[.10655 .37658 -12 -4.5 ]
[.10655 .37658 0 4.5 ]
[.10655 .46664 -24 -4.5 ]
[.10655 .46664 0 4.5 ]
[.10655 .55671 -12 -4.5 ]
[.10655 .55671 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01631 m
.30952 .02256 L
s
[(800)] .30952 .00381 0 1 Mshowa
.5 .01631 m
.5 .02256 L
s
[(1000)] .5 .00381 0 1 Mshowa
.69048 .01631 m
.69048 .02256 L
s
[(1200)] .69048 .00381 0 1 Mshowa
.88095 .01631 m
.88095 .02256 L
s
[(1400)] .88095 .00381 0 1 Mshowa
.125 Mabswid
.16667 .01631 m
.16667 .02006 L
s
.21429 .01631 m
.21429 .02006 L
s
.2619 .01631 m
.2619 .02006 L
s
.35714 .01631 m
.35714 .02006 L
s
.40476 .01631 m
.40476 .02006 L
s
.45238 .01631 m
.45238 .02006 L
s
.54762 .01631 m
.54762 .02006 L
s
.59524 .01631 m
.59524 .02006 L
s
.64286 .01631 m
.64286 .02006 L
s
.7381 .01631 m
.7381 .02006 L
s
.78571 .01631 m
.78571 .02006 L
s
.83333 .01631 m
.83333 .02006 L
s
.07143 .01631 m
.07143 .02006 L
s
.02381 .01631 m
.02381 .02006 L
s
.92857 .01631 m
.92857 .02006 L
s
.97619 .01631 m
.97619 .02006 L
s
.25 Mabswid
0 .01631 m
1 .01631 L
s
gsave
1.025 .01631 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .10638 m
.1253 .10638 L
s
[(2.5)] .10655 .10638 1 0 Mshowa
.11905 .19645 m
.1253 .19645 L
s
[(5)] .10655 .19645 1 0 Mshowa
.11905 .28651 m
.1253 .28651 L
s
[(7.5)] .10655 .28651 1 0 Mshowa
.11905 .37658 m
.1253 .37658 L
s
[(10)] .10655 .37658 1 0 Mshowa
.11905 .46664 m
.1253 .46664 L
s
[(12.5)] .10655 .46664 1 0 Mshowa
.11905 .55671 m
.1253 .55671 L
s
[(15)] .10655 .55671 1 0 Mshowa
.125 Mabswid
.11905 .03433 m
.1228 .03433 L
s
.11905 .05234 m
.1228 .05234 L
s
.11905 .07035 m
.1228 .07035 L
s
.11905 .08837 m
.1228 .08837 L
s
.11905 .12439 m
.1228 .12439 L
s
.11905 .14241 m
.1228 .14241 L
s
.11905 .16042 m
.1228 .16042 L
s
.11905 .17843 m
.1228 .17843 L
s
.11905 .21446 m
.1228 .21446 L
s
.11905 .23247 m
.1228 .23247 L
s
.11905 .25049 m
.1228 .25049 L
s
.11905 .2685 m
.1228 .2685 L
s
.11905 .30452 m
.1228 .30452 L
s
.11905 .32254 m
.1228 .32254 L
s
.11905 .34055 m
.1228 .34055 L
s
.11905 .35856 m
.1228 .35856 L
s
.11905 .39459 m
.1228 .39459 L
s
.11905 .4126 m
.1228 .4126 L
s
.11905 .43062 m
.1228 .43062 L
s
.11905 .44863 m
.1228 .44863 L
s
.11905 .48466 m
.1228 .48466 L
s
.11905 .50267 m
.1228 .50267 L
s
.11905 .52068 m
.1228 .52068 L
s
.11905 .5387 m
.1228 .5387 L
s
.11905 .57472 m
.1228 .57472 L
s
.11905 .59274 m
.1228 .59274 L
s
.11905 .61075 m
.1228 .61075 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02324 L
.10458 .03401 L
.14415 .04554 L
.18221 .05791 L
.22272 .07246 L
.26171 .08781 L
.30316 .10558 L
.34309 .12411 L
.3815 .14325 L
.42237 .16502 L
.46172 .18736 L
.49955 .21011 L
.53984 .2357 L
.57861 .26166 L
.61984 .29069 L
.65954 .32006 L
.69774 .3496 L
.73838 .38243 L
.77751 .41539 L
.81909 .45188 L
.85916 .48847 L
.89771 .52498 L
.93871 .56524 L
.97619 .60332 L
s
1 0 .6 r
.02381 .02762 m
.06244 .02974 L
.10458 .03225 L
.14415 .03481 L
.18221 .03745 L
.22272 .04045 L
.26171 .04352 L
.30316 .04699 L
.34309 .05053 L
.3815 .05411 L
.42237 .05812 L
.46172 .06218 L
.49955 .06625 L
.53984 .07077 L
.57861 .07531 L
.61984 .08034 L
.65954 .08538 L
.69774 .0904 L
.73838 .09594 L
.77751 .10146 L
.81909 .10753 L
.85916 .11357 L
.89771 .11957 L
.93871 .12615 L
.97619 .13234 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.2381 .38045 m
.2381 .49949 L
.71429 .49949 L
.71429 .38045 L
F
1 g
.21429 .40426 m
.21429 .5233 L
.69048 .5233 L
.69048 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.21429 .40426 m
.69048 .40426 L
.69048 .5233 L
.21429 .5233 L
.21429 .40426 L
s
% Start of sub-graphic
p
0.214286 0.404255 0.690476 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00710227 0.0710227 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0127841 0.126068 0.0838068 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0483 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0951705 0.126068 0.166193 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .13068 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .20739 -108 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(One) show
87.000 11.250 moveto
(load) show
117.000 11.250 moveto
(vector) show
153.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 10}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00DmkK0P001=kK0P001=kK0P006mkK1000
0mkK0P001=kK0P001=kK0P006=kK10000]kK10000mkK0P001=kK0P005mkK10001=kK00<00=kKg]/0
0]kK0P001=kK0P00=]kK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Lg]/0
1@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`0Gg]/01@00g]_N
fmkK00001MkK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00g]_Nf`03g]/01@00g]_NfmkK0000
0]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/0
1000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kK
g]/05mkK00<00=kKg]/00]kK00<00=kKg]/00]kK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00
g]_Nf`050002g]/01000g]_Nf`000]kK00@00=kKg]/003GNf`00DmkK0P000mkK00@00=kKg]/000;N
f`04003NfmkK000Lg]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00
g]_Nf`0Gg]/00`00g]_Nf`03g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK01KN
f`04003NfmkK0002g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05mkK00<00=kKg]/01=kK00@00=kKg]/000;Nf`04
003NfmkK0002g]/00`00g]_Nf`0Fg]/01`00g]_NfmkK003Nf`0000?Nf`04003NfmkK0002g]/01000
g]_Nf`00=MkK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Jg]/30003g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Gg]/30003g]/01000g]_Nf`000]kK00@0
0=kKg]/000;Nf`04003NfmkK000Fg]/30004g]/20003g]/01000g]_Nf`000]kK00@00=kKg]/003GN
f`00;]kK00<00=kKg]/08]kK0P001=kK0P001=kK0P007MkK00<00=kKg]/00]kK0P001=kK0P001=kK
0P006]kK00<00=kKg]/00]kK0P001=kK0P001=kK0P006MkK00<00=kKg]/00mkK00<00=kKg]/00]kK
0P001=kK0P00=]kK000^g]/00`00g]_Nf`3_g]/002kNf`03003NfmkK0=?Nf`8000;Nf`03003NfmkK
01GNf`006=kK0c0O4mkK00<00=kKg]/0e=kK00@00=kKg]/001ONf`004]kK2@00130OgP002=kK00@0
0=kK000001ONf`006=kK00<00=kKg]/01=kK130O00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kK
g]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02MkK00<00=kKg]/02=kK00<00=kK
g]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kK
g]/02MkK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kK
g]/02=kK00<00=kKg]/02MkK00<00=kKg]/02mkK0P0000?Nf`00g]/05]kK000Hg]/5n1<6g]/3<1l8
g]/00`00g]_Nf`3Dg]/01000g]_Nf`005mkK000Mg]/Bn1?Eg]/200000mkK0000000Gg]/002WNf`<`
7`;Nf`03003h4oPC00Sh4nONf`00;=kK0c0O2]kK4_PCeMkK000^g]/00`00<1l`7`02<1lHg]/9n1?<
g]/002kNf`03003NfmkK00;Nf`@`7agNf`[h4l;Nf`00;]kK0P001mkK130O8mkK2OPC^MkK000^g]/0
0`00g]_Nf`0:g]/4<1lXg]/9n1>`g]/002kNf`03003NfmkK00kNf`8`7boNfa?h4igNf`00;]kK00<0
0=kKg]/04=kK0S0O@=kK2OPCU=kK000^g]/2000Cg]/2<1m7g]/7n1>=g]/002kNf`03003NfmkK01CN
f`<`7d_Nf`Ch4hWNf`00;]kK00<00=kKg]/05mkK0c0OC=kK1oPCP]kK000^g]/00`00g]_Nf`0Jg]/3
<1m@g]/:n1=hg]/002kNf`03003NfmkK01gNf`8`7eSNf`Wh4foNf`00;]kK0P008=kK0S0OGmkK2OPC
I]kK000^g]/00`00g]_Nf`0Qg]/2<1mVg]/8n1=Ng]/001[Nf`@000?Nf`03003NfmkK00;Nf`<000GN
f`03003NfmkK02?Nf`8`7fcNf`Ch4e[Nf`006]kK00<00=kKg]/03=kK00<00=kKg]/00]kK00<00=kK
g]/09MkK0S0OK]kK1oPCDmkK000Kg]/00`00g]_Nf`0;g]/00`00g]_Nf`02g]/2000Xg]/3<1mbg]/8
n1=;g]/001cNf`03003NfmkK00ONf`<000GNf`03003NfmkK02[Nf`8`7gSNf`Ch4dONf`007MkK00<0
0=kKg]/01]kK00<00=kKg]/01MkK00<00=kKg]/0;=kK0S0ON]kK1oPC@=kK000Jg]/01000g]_Nf`00
2=kK00<00=kKg]/01MkK00<00=kKg]/0;]kK0S0OOmkK2OPC=mkK000Kg]/20009g]/40004g]/2000a
g]/3<1n5g]/8n1<_g]/002kNf`03003NfmkK03?Nf`8`7h_Nf`Ch4b_Nf`00;]kK00<00=kKg]/0=MkK
0S0OSMkK0oPC:=kK000^g]/00`00g]_Nf`0gg]/2<1nfg]/002kNf`8003[Nf`8`7kCNf`00;]kK00<0
0=kKg]/0>mkK0S0O/]kK000^g]/00`00g]_Nf`0mg]/2<1n`g]/002kNf`03003NfmkK03oNf`03<1oN
fmkK0:gNf`00;]kK0P00@MkK0S0O[MkK000^g]/00`00g]_Nf`12g]/2<1n[g]/002kNf`03003NfmkK
04CNf`03<1oNfmkK0:SNf`00;]kK00<00=kKg]/0AMkK0S0OZ=kK000^g]/00`00g]_Nf`17g]/2<1nV
g]/002kNf`8004[Nf`8`7jCNf`00;]kK00<00=kKg]/0BmkK0S0OX]kK000Vg]/30005g]/00`00g]_N
f`1=g]/00c0Og]_Nf`2Og]/002WNf`03003NfmkK00;Nf`03003NfmkK04kNf`8`7ioNf`00:MkK00<0
0=kKg]/00]kK0P00DMkK0S0OWMkK000Vg]/30005g]/00`00g]_Nf`1Bg]/2<1nKg]/002KNf`03003N
fmkK00GNf`03003NfmkK05CNf`8`7iWNf`009]kK00<00=kKg]/01MkK00<00=kKg]/0E]kK00<`7mkK
g]/0U]kK000Vg]/40004g]/2001Hg]/2<1nFg]/002kNf`03003NfmkK05WNf`03<1oNfmkK09?Nf`00
;]kK00<00=kKg]/0F]kK0S0OTmkK000^g]/00`00g]_Nf`1Lg]/00c0Og]_Nf`2@g]/002kNf`8005kN
f`8`7i3Nf`00;]kK00<00=kKg]/0GmkK00<`7mkKg]/0SMkK000^g]/00`00g]_Nf`1Pg]/2<1n=g]/0
02kNf`03003NfmkK06;Nf`03<1oNfmkK08[Nf`00;]kK00<00=kKg]/0HmkK0S0OR]kK000^g]/2001V
g]/00c0Og]_Nf`27g]/002kNf`03003NfmkK06KNf`8`7hONf`00;]kK00<00=kKg]/0J=kK00<`7mkK
g]/0Q=kK000^g]/00`00g]_Nf`1Yg]/2<1n4g]/002kNf`8006cNf`03<1oNfmkK087Nf`00;]kK00<0
0=kKg]/0K=kK00<`7mkKg]/0P=kK000Kg]/00`00g]_Nf`03g]/00`00g]_Nf`02g]/30005g]/00`00
g]_Nf`1]g]/2<1n0g]/001_Nf`03003NfmkK00_Nf`03003NfmkK00;Nf`03003NfmkK06oNf`03<1oN
fmkK07gNf`007=kK00<00=kKg]/02]kK00<00=kKg]/00]kK0P00LMkK0S0OOMkK000Lg]/00`00g]_N
f`07g]/30005g]/00`00g]_Nf`1bg]/00c0Og]_Nf`1jg]/001gNf`03003NfmkK00KNf`03003NfmkK
00GNf`03003NfmkK07?Nf`03<1oNfmkK07WNf`006]kK00@00=kKg]/000SNf`03003NfmkK00GNf`03
003NfmkK07CNf`8`7gWNf`006]kK10002=kK10001=kK0P00MmkK00<`7mkKg]/0M]kK000^g]/00`00
g]_Nf`1gg]/00c0Og]_Nf`1eg]/002kNf`03003NfmkK07SNf`8`7gGNf`00;]kK00<00=kKg]/0N]kK
00<`7mkKg]/0L]kK000^g]/2001lg]/00c0Og]_Nf`1ag]/002kNf`03003NfmkK07cNf`03<1oNfmkK
073Nf`00;]kK00<00=kKg]/0OMkK0S0OL=kK000^g]/00`00g]_Nf`1og]/00c0Og]_Nf`1]g]/002kN
f`03003NfmkK083Nf`03<1oNfmkK06cNf`00;]kK0P00P]kK0S0OK=kK000^g]/00`00g]_Nf`23g]/0
0c0Og]_Nf`1Yg]/002kNf`03003NfmkK08CNf`03<1oNfmkK06SNf`00;]kK00<00=kKg]/0QMkK0S0O
J=kK000^g]/20028g]/00c0Og]_Nf`1Ug]/002kNf`03003NfmkK08SNf`03<1oNfmkK06CNf`008=kK
10000mkK0P001MkK00<00=kKg]/0RMkK0S0OI=kK000Rg]/01@00g]_NfmkK00000]kK00<00=kKg]/0
0]kK00<00=kKg]/0RmkK00<`7mkKg]/0HMkK000Rg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK
0P00SMkK0S0OHMkK000Rg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0S]kK00<`
7mkKg]/0G]kK000Rg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0SmkK00<`7mkK
g]/0GMkK000Pg]/30003g]/01000g]_Nf`001=kK00<00=kKg]/0T=kK00<`7mkKg]/0G=kK000Rg]/0
0`00g]_Nf`02g]/20005g]/2002Bg]/00c0Og]_Nf`1Kg]/002kNf`03003NfmkK09;Nf`8`7e_Nf`00
;]kK00<00=kKg]/0U=kK00<`7mkKg]/0F=kK000^g]/00`00g]_Nf`2Eg]/00c0Og]_Nf`1Gg]/002kN
f`03003NfmkK09KNf`03<1oNfmkK05KNf`00;]kK0P005=kKR000E=kK000^g]/00`00g]_Nf`0Cg]^8
001Dg]/002kNf`03003NfmkK01?NfhP005CNf`00;]kK00<00=kKg]/04mkKR000E=kK000^g]/2000D
g]^800000c0Og]_Nf`1Ag]/002kNf`03003NfmkK01?NfhP00003g]/`7c0O057Nf`00;]kK00<00=kK
g]/03=kKS`000mkK00<`7mkKg]/0C]kK000^g]/00`00g]_Nf`0<g]/00`00ooooo`26ool60004g]/0
0c0Og]_Nf`1=g]/002kNf`8000gNf`03003ooooo08Koo`H000GNf`03<1oNfmkK04cNf`00;]kK00<0
0=kKg]/03=kK00<00?ooool0Q_oo1P001]kK00<`7mkKg]/0BmkK000Dg]/40002g]/40003g]/00`00
g]_Nf`02g]/30005g]/00`00g]_Nf`0<g]/00`00ooooo`26ool60007g]/00c0Og]_Nf`1:g]/001KN
f`05003NfmkKg]/0000>g]/00`00g]_Nf`02g]/00`00g]_Nf`0<g]/00`00ooooo`26ool60008g]/0
0c0Og]_Nf`19g]/001KNf`03003NfmkK00;Nf`03003NfmkK00_Nf`03003NfmkK00;Nf`8000gNf`03
003ooooo01;oo`8000;oo`800004ool000000002ool500000ooo00000002ool200001?oo00000000
F?oo1P002MkK00<`7mkKg]/0B=kK000Fg]/00`00g]_Nf`03g]/00`00g]_Nf`07g]/30005g]/00`00
g]_Nf`0<g]/00`00ooooo`0?n1<4ool01000ooooo`000ooo00<00?ooool00_oo00@00?ooool000;o
o`04003ooooo0002ool01000ooooo`00Eooo1P002]kK0S0OB=kK000Fg]/00`00g]_Nf`04g]/00`00
g]_Nf`06g]/00`00g]_Nf`05g]/00`00g]_Nf`0<g]/00`00ooooo`0Cool40003ool00`00ooooo`02
ool00`00ooooo`03ool40005ool00`00ooooo`1Eool6000<g]/00c0Og]_Nf`15g]/001CNf`<000?N
f`04003NfmkK0008g]/00`00g]_Nf`05g]/00`00g]_Nf`0<g]/00`00ooooo`0Cool01000ooooo`00
0ooo00<00?ooool00_oo00<00?ooool00ooo00@00?ooool000?oo`8005Soo`H000gNf`03<1oNfmkK
04CNf`005]kK00<00=kKg]/00]kK0P002MkK10001=kK0P003MkK00<00?ooool05?oo00T00?oo003o
o`00ool00?oo00000_oo00<00?ooool01?oo00<00?oo00000_oo00<00?ooool0F?oo1P003]kK00<`
7mkKg]/0@mkK000^g]/00`00g]_Nf`0<g]/00`00ooooo`0Cool30002ool500001?oo000000001?oo
0`001?oo0`00Eooo1P003mkK00<`7mkKg]/0@]kK000^g]/00`00g]_Nf`0<g]/00`00ooooo`26ool6
000@g]/00c0Og]_Nf`11g]/002kNf`03003NfmkK00cNf`03003ooooo08Koo`H0017Nf`03<1oNfmkK
043Nf`00;]kK00<00=kKg]/03=kK00<00?ooool0Q_oo1P004]kK00<`7mkKg]/0?mkK000^g]/2000=
g]/00`00ooooo`26ool6000Cg]/00c0Og]_Nf`0ng]/002kNf`03003NfmkK00cNf`03003ooooo08Ko
o`H001CNf`03<1oNfmkK03gNf`00;]kK00<00=kKg]/03=kK00<00?ooool04_oo0P0000?oo`000000
0ooo0P0000?oo`00ool00_oo0P0000Goo`0000000?oo008000;oo`<00005ool00?oo003oo`020002
ool200000ooo003oo`02ool20002ool50002ool20004ool200000ooo003oo`0aool6000Eg]/00c0O
g]_Nf`0lg]/002kNf`03003NfmkK00cNf`03003ooooo00l`7`?oo`05003oooooool00002ool01000
ooooo`000ooo00H00?ooool00?oo0002ool01000ooooo`001?oo00D00?oo003oo`0000;oo`04003o
oooo0003ool01000ooooo`000ooo00D00?ooooooo`0000;oo`04003ooooo0002ool00`00ooooo`0a
ool6000Fg]/00c0Og]_Nf`0kg]/002kNf`8000gNf`03003ooooo01;oo`05003oo`00ool00003ool3
0003ool00`00ooooo`02ool01000ooooo`000_oo0`000_oo00D00?oo003oo`0000?oo`<000?oo`03
003ooooo00Coo`05003oooooool00006ool3000cool6000Gg]/00c0Og]_Nf`0jg]/002kNf`03003N
fmkK00cNf`03003ooooo01;oo`05003oo`00ool00005ool01@00oooooooo00001?oo00@00?ooool0
00;oo`0:003ooooo003oo`00ool00?oo0005ool01@00oooooooo00001_oo00D00?ooooooo`0000;o
o`03003ooooo00?oo`03003ooooo037oo`H001SNf`03<1oNfmkK03WNf`00;]kK00<00=kKg]/03=kK
00<00?ooool04_oo0P0000?oo`0000000ooo0P000ooo10000_oo0`001?oo0P000_oo0P0000?oo`00
ool00ooo0P000ooo10000ooo0P001?oo0P001?oo0P00=?oo1P006MkK00<`7mkKg]/0>=kK000^g]/0
0`00g]_Nf`0<g]/00`00ooooo`0Bool01@00oooooooo00002Ooo00<00?ooool00_oo00<00?ooool0
5_oo00<00?ooool0AOoo1P006]kK00<`7mkKg]/0=mkK000^g]/2000=g]/00`00ooooo`0Pool01000
oooooooo0P006?oo00<00?ooool01?oo00<00?ooool0?_oo1P006mkK00<`7mkKg]/0=]kK000^g]/0
0`00g]_Nf`0<g]/00`00ooooo`26ool6000Lg]/00c0Og]_Nf`0eg]/0023Nf`@000;Nf`<000GNf`03
003NfmkK00cNf`03003ooooo08Koo`H001gNf`8`7cGNf`008]kK00<00=kKg]/01=kK00<00=kKg]/0
0]kK00<00=kKg]/03=kK00<00?ooool0Q_oo1P007mkK00<`7mkKg]/0<]kK000Rg]/00`00g]_Nf`04
g]/00`00g]_Nf`02g]/2000=g]/00`00ooooo`0Fool20002ool300000ooo00000002ool30008ool5
0002ool20004ool200001?oo003ooooo0P0000?oo`00ool02?oo00<00?ooool00_oo0`000ooo0P00
1Ooo0P000ooo0P000ooo10006Ooo1P008=kK00<`7mkKg]/0<MkK000Rg]/01000g]_NfmkK0`001MkK
00<00=kKg]/03=kK00<00?ooool05Ooo00@00?ooool000;oo`04003ooooo0002ool00`00ooooo`0;
ool01@00oooooooo00000_oo00@00?ooool000;oo`04003ooooo0002ool00`00ooooo`07ool00`00
ool00002ool00`00ooooo`03ool01000ooooo`000ooo00H00?ooool00?oo0002ool01@00oooooooo
00006ooo1P008MkK00<`7mkKg]/0<=kK000Rg]/01@00g]_NfmkK00001mkK00<00=kKg]/03=kK00<0
0?ooool05Ooo00@00?ooool000;oo`04003ooooo0002ool3000;ool01@00oooooooo00000_oo00@0
0?ooooooo`<000;oo`04003ooooo0009ool00`00ool00002ool30003ool00`00ooooo`04ool00`00
ooooo`02ool01000ooooo`000ooo00<00?ooool06Ooo00<00=kKg]/09MkK00<`7mkKg]/0;mkK000P
g]/30003g]/00`00g]_Nf`05g]/00`00g]_Nf`0<g]/00`00ooooo`0Eool01000ooooo`000_oo00@0
0?ooool000;oo`04003ooooo000:ool01@00oooooooo00000_oo00<00?ooool00ooo00@00?ooool0
00;oo`03003ooooo00Koo`07003oooooool00?oo00000_oo00@00?ooool000;oo`05003oooooool0
0004ool01000ooooo`000ooo00<00?ooool06Ooo00<00=kKg]/09]kK00<`7mkKg]/0;]kK000Rg]/0
1000g]_NfmkK10001=kK00<00=kKg]/03=kK00<00?ooool05Ooo00L00?ooool00?oo003oo`020004
ool2000;ool00`00ooooo`02ool20004ool20004ool30007ool20002ool20002ool20004ool20003
ool40003ool20003ool00`00ool00002000Hool00`00g]_Nf`0Wg]/00c0Og]_Nf`0]g]/002kNf`80
00gNf`03003ooooo01Koo`8001Ooo`03003ooooo013oo`03003ooooo01Woo`03003ooooo02Goo`03
003NfmkK02SNf`03<1oNfmkK02cNf`00;]kK00<00=kKg]/03=kK00<00?ooool0;_oo0P004Ooo0P00
6ooo00<00?ooool09Ooo00<00=kKg]/0:MkK00<`7mkKg]/0:mkK000^g]/00`00g]_Nf`0<g]^:000/
g]/00c0Og]_Nf`0Zg]/002kNf`03003NfmkK0<?Nf`03<1oNfmkK02WNf`00;]kK0P00aMkK00<`7mkK
g]/0:=kK000^g]/00`00g]_Nf`35g]/00c0Og]_Nf`0Wg]/002kNf`03003NfmkK0<KNf`03<1oNfmkK
02KNf`00;]kK00<00=kKg]/0kmkK000^g]/2003`g]/002kNf`03003NfmkK0>oNf`00;]kK00<00=kK
g]/0kmkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Q
g]/00?oNfb7Nf`006]kK0`001=kK0`000mkK0P001=kK0P000]kK0`0000?Nf`0000000]kK0P0000?N
f`00g]/00`00gmkK000Jg]/01000g]_Nf`000]kK00<00=kKg]/00mkK00@00=kKg]/000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000GNf`03003NfmkK0=cNf`007MkK00<00=kKg]/0
0`000mkK00<00=kKg]/00mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000mkK0P00
gmkK000Kg]/20003g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_N
f`000]kK00@00=kKg]/000;Nf`03003NfmkK0=oNf`006]kK00<00=kKg]/01=kK0P001=kK0P001=kK
0P000]kK00@00=kK000000CNf`<000?Nf`<00=kNf`006mkK0`007MkK00<00=kKg]/0h]kK000jg]/2
003Tg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.05261, -0.648943, \
0.00733523, 0.00733523}, {{7.125, 279.812}, {172.688, 4.1875}} -> {392.241, \
-1.91777, 4.48393, 0.118536}, {{61.6875, 198}, {61.1875, 27.0625}} -> \
{-4.33589, -12.0586, 0.0686662, 0.103293}, {{64.25, 78.8125}, {59.375, \
49.6875}} -> {-4.65767, -28.5614, 0.0721037, 0.233332}, {{64.25, 78.8125}, \
{48.1875, 38.5}} -> {-4.65767, -31.1718, 0.0721037, 0.233332}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(from\  = \ 500; \ to\  = \ 1500;\), "\[IndentingNewLine]", 
    \(Plot[\[IndentingNewLine]{\ fitMatLUSolveMany\ , \ 
        fitATLUSolveMany\ }, {x, from, to}, 
      PlotStyle \[Rule] {Hue[0.7], Hue[0.9]}, 
      PlotLegend \[Rule] {"\<Mathematica\>", "\<ATLAS\>"}, 
      LegendLabel -> "\<Many load vectors\>", 
      LegendPosition \[Rule] {\(-0.6\), 0.2}, LegendSize \[Rule] {1, 0.25}, 
      LegendTextSpace \[Rule] 8, 
      AxesLabel \[Rule] {"\<N\>", "\<Seconds\>"}]\)}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.452381 0.000952381 0.0157453 0.00758386 [
[.30952 .00325 -9 -9 ]
[.30952 .00325 9 0 ]
[.5 .00325 -12 -9 ]
[.5 .00325 12 0 ]
[.69048 .00325 -12 -9 ]
[.69048 .00325 12 0 ]
[.88095 .00325 -12 -9 ]
[.88095 .00325 12 0 ]
[1.025 .01575 0 -4.90625 ]
[1.025 .01575 10 4.90625 ]
[.10655 .16742 -12 -4.5 ]
[.10655 .16742 0 4.5 ]
[.10655 .3191 -12 -4.5 ]
[.10655 .3191 0 4.5 ]
[.10655 .47078 -12 -4.5 ]
[.10655 .47078 0 4.5 ]
[.11905 .64303 -23 0 ]
[.11905 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01575 m
.30952 .022 L
s
[(800)] .30952 .00325 0 1 Mshowa
.5 .01575 m
.5 .022 L
s
[(1000)] .5 .00325 0 1 Mshowa
.69048 .01575 m
.69048 .022 L
s
[(1200)] .69048 .00325 0 1 Mshowa
.88095 .01575 m
.88095 .022 L
s
[(1400)] .88095 .00325 0 1 Mshowa
.125 Mabswid
.16667 .01575 m
.16667 .0195 L
s
.21429 .01575 m
.21429 .0195 L
s
.2619 .01575 m
.2619 .0195 L
s
.35714 .01575 m
.35714 .0195 L
s
.40476 .01575 m
.40476 .0195 L
s
.45238 .01575 m
.45238 .0195 L
s
.54762 .01575 m
.54762 .0195 L
s
.59524 .01575 m
.59524 .0195 L
s
.64286 .01575 m
.64286 .0195 L
s
.7381 .01575 m
.7381 .0195 L
s
.78571 .01575 m
.78571 .0195 L
s
.83333 .01575 m
.83333 .0195 L
s
.07143 .01575 m
.07143 .0195 L
s
.02381 .01575 m
.02381 .0195 L
s
.92857 .01575 m
.92857 .0195 L
s
.97619 .01575 m
.97619 .0195 L
s
.25 Mabswid
0 .01575 m
1 .01575 L
s
gsave
1.025 .01575 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.11905 .16742 m
.1253 .16742 L
s
[(20)] .10655 .16742 1 0 Mshowa
.11905 .3191 m
.1253 .3191 L
s
[(40)] .10655 .3191 1 0 Mshowa
.11905 .47078 m
.1253 .47078 L
s
[(60)] .10655 .47078 1 0 Mshowa
.125 Mabswid
.11905 .05366 m
.1228 .05366 L
s
.11905 .09158 m
.1228 .09158 L
s
.11905 .1295 m
.1228 .1295 L
s
.11905 .20534 m
.1228 .20534 L
s
.11905 .24326 m
.1228 .24326 L
s
.11905 .28118 m
.1228 .28118 L
s
.11905 .35702 m
.1228 .35702 L
s
.11905 .39494 m
.1228 .39494 L
s
.11905 .43286 m
.1228 .43286 L
s
.11905 .5087 m
.1228 .5087 L
s
.11905 .54662 m
.1228 .54662 L
s
.11905 .58453 m
.1228 .58453 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
gsave
.11905 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .01472 m
.06244 .02327 L
.10458 .03407 L
.14415 .04562 L
.18221 .05801 L
.22272 .07258 L
.26171 .08795 L
.30316 .10574 L
.34309 .12428 L
.3815 .14343 L
.42237 .16521 L
.46172 .18755 L
.49955 .2103 L
.53984 .23588 L
.57861 .26184 L
.61984 .29087 L
.65954 .32023 L
.69774 .34976 L
.73838 .38257 L
.77751 .41552 L
.81909 .45199 L
.85916 .48855 L
.89771 .52504 L
.93871 .56527 L
.97619 .60332 L
s
1 0 .6 r
.02381 .02032 m
.06244 .022 L
.10458 .02405 L
.14415 .02619 L
.18221 .02844 L
.22272 .03105 L
.26171 .03376 L
.30316 .03686 L
.34309 .04007 L
.3815 .04334 L
.42237 .04704 L
.46172 .05081 L
.49955 .05463 L
.53984 .0589 L
.57861 .06321 L
.61984 .06801 L
.65954 .07285 L
.69774 .07769 L
.73838 .08306 L
.77751 .08843 L
.81909 .09436 L
.85916 .10029 L
.89771 .10619 L
.93871 .11268 L
.97619 .11881 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.2381 .38045 m
.2381 .49949 L
.71429 .49949 L
.71429 .38045 L
F
1 g
.21429 .40426 m
.21429 .5233 L
.69048 .5233 L
.69048 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.21429 .40426 m
.69048 .40426 L
.69048 .5233 L
.21429 .5233 L
.21429 .40426 L
s
% Start of sub-graphic
p
0.214286 0.404255 0.690476 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00710227 0.0710227 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0127841 0.126068 0.0838068 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0483 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0951705 0.126068 0.166193 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .13068 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .20739 -114 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Many) show
93.000 11.250 moveto
(load) show
123.000 11.250 moveto
(vectors) show
165.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 10}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00DmkK0P001=kK0P001=kK0P006mkK1000
0mkK0P001=kK0P001=kK0P006=kK10000]kK10000mkK0P001=kK0P005mkK10001=kK00<00=kKg]/0
0]kK0P001=kK0P00=]kK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Lg]/0
1@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`0Gg]/01@00g]_N
fmkK00001MkK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00g]_Nf`03g]/01@00g]_NfmkK0000
0]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/0
1000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kK
g]/05mkK00<00=kKg]/00]kK00<00=kKg]/00]kK00@00=kKg]/000;Nf`04003NfmkK000Hg]/00`00
g]_Nf`050002g]/01000g]_Nf`000]kK00@00=kKg]/003GNf`00DmkK0P000mkK00@00=kKg]/000;N
f`04003NfmkK000Lg]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00
g]_Nf`0Gg]/00`00g]_Nf`03g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK01KN
f`04003NfmkK0002g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK03?Nf`00D]kK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`007=kK00D00=kKg]_Nf`0000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05mkK00<00=kKg]/01=kK00@00=kKg]/000;Nf`04
003NfmkK0002g]/00`00g]_Nf`0Fg]/01`00g]_NfmkK003Nf`0000?Nf`04003NfmkK0002g]/01000
g]_Nf`00=MkK001Bg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Jg]/30003g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Gg]/30003g]/01000g]_Nf`000]kK00@0
0=kKg]/000;Nf`04003NfmkK000Fg]/30004g]/20003g]/01000g]_Nf`000]kK00@00=kKg]/003GN
f`00;]kK00<00=kKg]/08]kK0P001=kK0P001=kK0P007MkK00<00=kKg]/00]kK0P001=kK0P001=kK
0P006]kK00<00=kKg]/00]kK0P001=kK0P001=kK0P006MkK00<00=kKg]/00mkK00<00=kKg]/00]kK
0P001=kK0P00=]kK000^g]/00`00g]_Nf`3_g]/002kNf`03003NfmkK0=?Nf`8000;Nf`03003NfmkK
01GNf`006=kK0c0O4mkK00<00=kKg]/0e=kK00@00=kKg]/001ONf`004]kK2@00130OgP002=kK00@0
0=kK000001ONf`006=kK3_PC2=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<0
0=kKg]/02=kK00<00=kKg]/02MkK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<0
0=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02MkK00<00=kKg]/02=kK00<0
0=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<00=kKg]/02=kK00<0
0=kKg]/03=kK0P0000?Nf`00g]/05]kK000Sg]/3<1lCn1?<g]/01000g]_Nf`005mkK000Vg]/4<1l4
g]/00`00g]_Nf`08g]/Bn1>ig]/200000mkK0000000Gg]/002[Nf`<`7`03g]/00=kK01_Nf`Wh4lcN
f`00;MkK0c0O9=kK4oPC^MkK000^g]/00`00g]/`7`02<1ldg]/9n1>`g]/002kNf`03003NfmkK00;N
f`<`7c[Nf`[h4jKNf`00;]kK00<00=kKg]/01MkK0c0O@MkK2OPCWMkK000^g]/20009g]/3<1m7g]/9
n1>Dg]/002kNf`03003NfmkK00_Nf`<`7dgNf`Wh4h_Nf`00;]kK00<00=kKg]/03]kK0c0ODmkK2OPC
P]kK000^g]/00`00g]_Nf`0Ag]/3<1mIg]/:n1=hg]/002kNf`03003NfmkK01CNf`<`7f3Nf`Wh4foN
f`00;]kK00<00=kKg]/05mkK0S0OImkK2OPCI]kK000^g]/00`00g]_Nf`0Ig]/2<1m^g]/8n1=Ng]/0
02kNf`03003NfmkK01_Nf`8`7gCNf`Ch4e[Nf`00;]kK0P007]kK0c0OMMkK1oPCDmkK000^g]/00`00
g]_Nf`0Pg]/2<1mjg]/8n1=;g]/002kNf`03003NfmkK02;Nf`<`7goNf`Ch4dONf`00;]kK00<00=kK
g]/09MkK0S0OPMkK1oPC@=kK000^g]/00`00g]_Nf`0Wg]/3<1n5g]/9n1<gg]/002kNf`03003NfmkK
02[Nf`8`7hcNf`Oh4c3Nf`00;]kK00<00=kKg]/0;=kK0S0OTMkK1?PC;=kK000^g]/00`00g]_Nf`0^
g]/2<1nCg]/3n1<Yg]/002kNf`03003NfmkK033Nf`8`7kgNf`00;]kK0P00<mkK0S0O^mkK000^g]/0
0`00g]_Nf`0dg]/2<1nig]/002kNf`03003NfmkK03KNf`8`7kONf`00;]kK00<00=kKg]/0>=kK0S0O
]MkK000^g]/00`00g]_Nf`0jg]/00c0Og]_Nf`2bg]/002kNf`03003NfmkK03_Nf`8`7k;Nf`00;]kK
00<00=kKg]/0?MkK0S0O/=kK000Pg]/40003g]/20005g]/00`00g]_Nf`0og]/2<1n^g]/0023Nf`03
003NfmkK00?Nf`04003NfmkK0004g]/00`00g]_Nf`11g]/2<1n/g]/0027Nf`03003NfmkK00;Nf`04
003NfmkK0004g]/20014g]/2<1nZg]/002;Nf`05003NfmkKg]/00002g]/00`00g]_Nf`02g]/00`00
g]_Nf`15g]/2<1nXg]/002?Nf`04003NfmkK0002g]/00`00g]_Nf`02g]/00`00g]_Nf`17g]/2<1nV
g]/0023Nf`04003NfmkK0002g]/01000g]_Nf`001=kK00<00=kKg]/0BMkK0S0OY=kK000Qg]/20004
g]/20005g]/00`00g]_Nf`1;g]/2<1nRg]/002kNf`03003NfmkK04gNf`03<1oNfmkK09oNf`00;]kK
00<00=kKg]/0C]kK0S0OWmkK000^g]/00`00g]_Nf`1@g]/2<1nMg]/002kNf`03003NfmkK05;Nf`8`
7i_Nf`00;]kK0P00EMkK0S0OVMkK000^g]/00`00g]_Nf`1Fg]/00c0Og]_Nf`2Fg]/002kNf`03003N
fmkK05ONf`8`7iKNf`00;]kK00<00=kKg]/0FMkK00<`7mkKg]/0TmkK000^g]/00`00g]_Nf`1Jg]/2
<1nCg]/002kNf`03003NfmkK05cNf`03<1oNfmkK093Nf`00;]kK00<00=kKg]/0GMkK0S0OT=kK000^
g]/00`00g]_Nf`1Og]/00c0Og]_Nf`2=g]/002kNf`03003NfmkK063Nf`8`7hgNf`00;]kK0P00HmkK
00<`7mkKg]/0R]kK000^g]/00`00g]_Nf`1Sg]/2<1n:g]/002kNf`03003NfmkK06GNf`03<1oNfmkK
08ONf`00;]kK00<00=kKg]/0I]kK0S0OQmkK000^g]/00`00g]_Nf`1Xg]/00c0Og]_Nf`24g]/002kN
f`03003NfmkK06WNf`8`7hCNf`00;]kK00<00=kKg]/0JmkK00<`7mkKg]/0PMkK000^g]/00`00g]_N
f`1/g]/00c0Og]_Nf`20g]/002kNf`03003NfmkK06gNf`8`7h3Nf`00;]kK0P00L=kK00<`7mkKg]/0
OMkK000^g]/00`00g]_Nf`1`g]/2<1mmg]/002kNf`03003NfmkK07;Nf`03<1oNfmkK07[Nf`00;]kK
00<00=kKg]/0LmkK00<`7mkKg]/0NMkK000^g]/00`00g]_Nf`1dg]/2<1mig]/002kNf`03003NfmkK
07KNf`03<1oNfmkK07KNf`00;]kK00<00=kKg]/0MmkK00<`7mkKg]/0MMkK000Rg]/00`00g]_Nf`02
g]/20005g]/00`00g]_Nf`1hg]/2<1meg]/002;Nf`05003NfmkKg]/00002g]/00`00g]_Nf`02g]/0
0`00g]_Nf`1jg]/00c0Og]_Nf`1bg]/001oNf`D000;Nf`04003NfmkK0004g]/2001lg]/00c0Og]_N
f`1ag]/001oNf`04003NfmkK0003g]/01000g]_Nf`001=kK00<00=kKg]/0O=kK00<`7mkKg]/0L=kK
000Pg]/00`00g]/00003g]/01000g]_Nf`001=kK00<00=kKg]/0OMkK0S0OL=kK000Qg]/20003g]/0
1000g]_Nf`001=kK00<00=kKg]/0OmkK00<`7mkKg]/0KMkK000Rg]/00`00g]_Nf`02g]/20005g]/0
0`00g]_Nf`20g]/00c0Og]_Nf`1/g]/002kNf`03003NfmkK087Nf`8`7fcNf`00;]kK00<00=kKg]/0
PmkK00<`7mkKg]/0JMkK000^g]/00`00g]_Nf`24g]/00c0Og]_Nf`1Xg]/002kNf`03003NfmkK08GN
f`03<1oNfmkK06ONf`00;]kK0P00QmkK0S0OImkK000^g]/00`00g]_Nf`28g]/00c0Og]_Nf`1Tg]/0
02kNf`03003NfmkK08WNf`03<1oNfmkK06?Nf`00;]kK00<00=kKg]/0R]kK00<`7mkKg]/0H]kK000^
g]/00`00g]_Nf`2;g]/2<1mRg]/002kNf`03003NfmkK08gNf`03<1oNfmkK05oNf`00;]kK00<00=kK
g]/0S]kK00<`7mkKg]/0G]kK000^g]/00`00g]_Nf`2?g]/00c0Og]_Nf`1Mg]/002kNf`80097Nf`8`
7egNf`00;]kK00<00=kKg]/0T]kK00<`7mkKg]/0F]kK000^g]/00`00g]_Nf`2Cg]/00c0Og]_Nf`1I
g]/002kNf`03003NfmkK09CNf`8`7eWNf`00;]kK00<00=kKg]/0U]kK00<`7mkKg]/0E]kK000^g]/0
0`00g]_Nf`0Cg]^8001Dg]/002kNf`03003NfmkK01?NfhP005CNf`00;]kK00<00=kKg]/04mkKR000
E=kK000^g]/00`00g]_Nf`0Cg]^8001Dg]/002kNf`8001CNfhP00003<1oNfmkK057Nf`00;]kK00<0
0=kKg]/04mkKR00000?Nfc0O<1l0DMkK000^g]/00`00g]_Nf`0<g]^?0003g]/00c0Og]_Nf`1>g]/0
02kNf`03003NfmkK00cNf`03003ooooo08Koo`H000CNf`03<1oNfmkK04gNf`00;]kK00<00=kKg]/0
3=kK00<00?ooool0Q_oo1P001MkK00<`7mkKg]/0C=kK000^g]/00`00g]_Nf`0<g]/00`00ooooo`26
ool60006g]/00c0Og]_Nf`1;g]/002kNf`03003NfmkK00cNf`03003ooooo08Koo`H000ONf`03<1oN
fmkK04[Nf`008MkK0P001=kK0P001MkK00<00=kKg]/03=kK00<00?ooool0Q_oo1P002=kK00<`7mkK
g]/0BMkK000Pg]/01000g]_Nf`000]kK00@00=kKg]/000CNf`03003NfmkK00cNf`03003ooooo01;o
o`8000;oo`800004ool000000002ool500000ooo00000002ool200001?oo00000000F?oo1P002MkK
00<`7mkKg]/0B=kK000Pg]/01000g]_Nf`000]kK00@00=kKg]/000CNf`8000gNf`03003ooooo00oh
4`Coo`04003ooooo0003ool00`00ooooo`02ool01000ooooo`000_oo00@00?ooool000;oo`04003o
oooo001Gool6000:g]/2<1m8g]/0023Nf`<000?Nf`04003NfmkK0004g]/00`00g]_Nf`0<g]/00`00
ooooo`0Cool40003ool00`00ooooo`02ool00`00ooooo`03ool40005ool00`00ooooo`1Eool6000<
g]/00c0Og]_Nf`15g]/0023Nf`03003NfmkK00?Nf`04003NfmkK0004g]/00`00g]_Nf`0<g]/00`00
ooooo`0Cool01000ooooo`000ooo00<00?ooool00_oo00<00?ooool00ooo00@00?ooool000?oo`80
05Soo`H000gNf`03<1oNfmkK04CNf`008=kK00<00=kKg]/00mkK00@00=kKg]/000CNf`03003NfmkK
00cNf`03003ooooo01Coo`09003oo`00ool00?oo003oo`0000;oo`03003ooooo00Coo`03003oo`00
00;oo`03003ooooo05Soo`H000kNf`03<1oNfmkK04?Nf`008MkK0`000mkK0P001MkK00<00=kKg]/0
3=kK00<00?ooool04ooo0`000_oo1@0000Coo`00000000Coo`<000Coo`<005Ooo`H000oNf`03<1oN
fmkK04;Nf`00;]kK00<00=kKg]/03=kK00<00?ooool0Q_oo1P004=kK00<`7mkKg]/0@MkK000^g]/0
0`00g]_Nf`0<g]/00`00ooooo`26ool6000Ag]/00c0Og]_Nf`10g]/002kNf`03003NfmkK00cNf`03
003ooooo08Koo`H001;Nf`03<1oNfmkK03oNf`00;]kK00<00=kKg]/03=kK00<00?ooool0Q_oo1P00
4mkK00<`7mkKg]/0?]kK000^g]/2000=g]/00`00ooooo`26ool6000Dg]/00c0Og]_Nf`0mg]/002kN
f`03003NfmkK00cNf`03003ooooo01;oo`800003ool0000000?oo`800003ool00?oo00;oo`800005
ool00000003oo`020002ool300001Ooo003oo`00ool00P000_oo0P0000?oo`00ool00_oo0P000_oo
1@000_oo0P001?oo0P0000?oo`00ool0<Ooo1P005MkK00<`7mkKg]/0?=kK000^g]/00`00g]_Nf`0<
g]/00`00ooooo`0?<1l3ool01@00oooooooo00000_oo00@00?ooool000?oo`06003ooooo003oo`00
0_oo00@00?ooool000Coo`05003oo`00ool00002ool01000ooooo`000ooo00@00?ooool000?oo`05
003oooooool00002ool01000ooooo`000_oo00<00?ooool0<Ooo1P005]kK00<`7mkKg]/0>mkK000^
g]/00`00g]_Nf`0<g]/00`00ooooo`0Bool01@00ool00?oo00000ooo0`000ooo00<00?ooool00_oo
00@00?ooool000;oo`<000;oo`05003oo`00ool00003ool30003ool00`00ooooo`04ool01@00oooo
oooo00001_oo0`00<ooo1P005mkK00<`7mkKg]/0>]kK000^g]/00`00g]_Nf`0<g]/00`00ooooo`0B
ool01@00ool00?oo00001Ooo00D00?ooooooo`0000Coo`04003ooooo0002ool02P00ooooo`00ool0
0?oo003oo`001Ooo00D00?ooooooo`0000Koo`05003oooooool00002ool00`00ooooo`03ool00`00
ooooo`0aool6000Hg]/00c0Og]_Nf`0ig]/002kNf`03003NfmkK00cNf`03003ooooo01;oo`800003
ool0000000?oo`8000?oo`@000;oo`<000Coo`8000;oo`800003ool00?oo00?oo`8000?oo`@000?o
o`8000Coo`8000Coo`8003Coo`H001WNf`03<1oNfmkK03SNf`00;]kK00<00=kKg]/03=kK00<00?oo
ool04_oo00D00?ooooooo`0000Woo`03003ooooo00;oo`03003ooooo01Koo`03003ooooo04Goo`H0
01[Nf`03<1oNfmkK03ONf`00;]kK00<00=kKg]/03=kK00<00?ooool08?oo00@00?ooooooo`8001So
o`03003ooooo00Coo`03003ooooo03koo`H001_Nf`03<1oNfmkK03KNf`00;]kK00<00=kKg]/03=kK
00<00?ooool0Q_oo1P007=kK00<`7mkKg]/0=MkK000^g]/2000=g]/00`00ooooo`0Pool2001Tool6
000Mg]/2<1leg]/002kNf`03003NfmkK00cNf`03003ooooo02;oo`03003ooooo067oo`H001oNf`03
<1oNfmkK03;Nf`00;]kK00<00=kKg]/03=kK00<00?ooool03_oo0P0000?oo`0000000ooo0P0000?o
o`0000000P0000?oo`0000000_oo0P002Ooo1@000_oo0P001?oo0P0000Coo`00ooooo`800003ool0
0?oo00Soo`03003ooooo00;oo`<000?oo`8000Goo`8000?oo`8000?oo`@000;oo`<001Coo`H0023N
f`03<1oNfmkK037Nf`00;]kK00<00=kKg]/03=kK00<00?ooool03_oo00D00?ooooooo`0000;oo`04
003ooooo0002ool01000ooooo`000_oo00@00?ooool000[oo`05003oooooool00002ool01000oooo
o`000_oo00@00?ooool000;oo`03003ooooo00Ooo`03003oo`0000;oo`03003ooooo00?oo`04003o
oooo0003ool01P00ooooo`00ool000;oo`05003oooooool00007ool00`00ooooo`0Aool6000Qg]/0
0c0Og]_Nf`0`g]/002kNf`03003NfmkK00cNf`03003ooooo00koo`05003oo`00ool00003ool30002
ool01000ooooo`000_oo00@00?ooool000[oo`05003oooooool00002ool01000oooooooo0`000_oo
00@00?ooool000Woo`03003oo`0000;oo`<000?oo`03003ooooo00Coo`03003ooooo00;oo`04003o
oooo0003ool00`00ooooo`03ool2000Dool00`00g]_Nf`0Ug]/00c0Og]_Nf`0_g]/002kNf`03003N
fmkK00cNf`03003ooooo00koo`05003oo`00ool00005ool01000ooooo`000_oo00@00?ooool000;o
o`03003ooooo00Soo`05003oooooool00002ool00`00ooooo`03ool01000ooooo`000_oo00<00?oo
ool01_oo00L00?ooooooo`00ool00002ool01000ooooo`000_oo00D00?ooooooo`0000Coo`04003o
oooo0003ool00`00ooooo`02ool00`00ooooo`0Dool00`00g]_Nf`0Vg]/00c0Og]_Nf`0^g]/002kN
f`03003NfmkK00cNf`03003ooooo00koo`800003ool0000000?oo`8000;oo`04003oo`000002ool2
00000ooo0000000:ool00`00ooooo`02ool20004ool20004ool30007ool20002ool20002ool20004
ool20003ool40003ool20003ool00`00ool000020002ool3000Cool00`00g]_Nf`0Wg]/00c0Og]_N
f`0]g]/002kNf`03003NfmkK00cNf`03003ooooo00koo`05003oooooool0000Lool00`00ooooo`0@
ool00`00ooooo`0Iool00`00ooooo`0Uool00`00g]_Nf`0Xg]/00c0Og]_Nf`0/g]/002kNf`03003N
fmkK00cNf`03003ooooo02koo`80017oo`8001_oo`03003ooooo02Goo`03003NfmkK02WNf`03<1oN
fmkK02_Nf`00;]kK0P003MkKRP00:mkK00<`7mkKg]/0:mkK000^g]/00`00g]_Nf`32g]/00c0Og]_N
f`0Zg]/002kNf`03003NfmkK0<?Nf`03<1oNfmkK02WNf`00;]kK00<00=kKg]/0a=kK00<`7mkKg]/0
:=kK000^g]/00`00g]_Nf`35g]/00c0Og]_Nf`0Wg]/002kNf`03003NfmkK0>oNf`00;]kK00<00=kK
g]/0kmkK000^g]/00`00g]_Nf`3_g]/002kNf`03003NfmkK0>oNf`00omkK8MkK003og]/Qg]/00?oN
fb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/001[Nf`<000CNf`<000?N
f`8000CNf`8000;Nf`<00003g]/0000000;Nf`800003g]/00=kK00<00=oNf`006]kK00@00=kKg]/0
00;Nf`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003N
fmkK0005g]/00`00g]_Nf`3Lg]/001gNf`03003NfmkK00<000?Nf`03003NfmkK00?Nf`04003NfmkK
0002g]/01000g]_Nf`000]kK00@00=kKg]/000?Nf`800=oNf`006mkK0P000mkK00@00=kKg]/000;N
f`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_N
f`3Og]/001[Nf`03003NfmkK00CNf`8000CNf`8000CNf`8000;Nf`04003Nf`000004g]/30003g]/3
003Ng]/001_Nf`<001gNf`03003NfmkK0>;Nf`00>]kK0P00i=kK003og]/Qg]/00?oNfb7Nf`00omkK
8MkK003og]/Qg]/00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.05261, -0.648943, \
0.00733523, 0.00733523}, {{7.125, 279.812}, {172.688, 4.1875}} -> {391.697, \
-9.11554, 4.48785, 0.563585}, {{61.6875, 198}, {61.1875, 27.0625}} -> \
{-4.33589, -12.0586, 0.0686662, 0.103293}, {{64.25, 78.8125}, {59.375, \
49.6875}} -> {-4.65767, -28.5614, 0.0721037, 0.233332}, {{64.25, 78.8125}, \
{48.1875, 38.5}} -> {-4.65767, -31.1718, 0.0721037, 0.233332}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["The transparent user interface prototype", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Options[\ imsLUSolve\ ]\  := \ {\ 
          ATLAS\  \[Rule] \ False\ };\)\), "\[IndentingNewLine]", 
    \(\(\(imsLUSolve::"\<Error\>" = \ "\<in the wrapper\>";\)\(\
\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(\(imsLUSolve[\ inMatrix_, \ loadMatrix_, \ opts___\ ?OptionQ]\  := \ 
        Module[\ {\ 
            res\ }, \[IndentingNewLine]ATLASQ\  = \ \(ATLAS\  /. \ {\ 
                  opts\ }\)\  /. \ 
              Options[\ 
                imsLUSolve\ ]; \[IndentingNewLine]\[IndentingNewLine]If[\ 
            ATLASQ, \[IndentingNewLine]res\  := 
              atLUSolve[\ inMatrix, \ 
                loadMatrix\ ], \[IndentingNewLine]res\  := \ 
              Transpose[\ 
                LUBackSubstitution[\ LUDecomposition[\ inMatrix\ ], \ 
                  Transpose[
                    loadMatrix\ ]\ ]\ ], \[IndentingNewLine]\(\(Message[
                  imsLUSolve::"\<Error\>"\ ];\);\)\[IndentingNewLine]\ ]; \
\[IndentingNewLine]\[IndentingNewLine]Return[\ 
            res\ ];\[IndentingNewLine]]\ ;\)\)}], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(ATLASQ\)\" is similar \
to existing symbol \"\!\(ATLAS\)\"."\)], "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["A big problem", "Subsection"],

Cell["\<\
This was computed on a sun4u sparc SUNW,Ultra-80, with 4GB main memory and 4 \
CPUs using a non-threaded ATLAS generated BLAS.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(from\  = \ 600; \ to\  = \ 1000; \ step\  = \ 400;\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(step\)\" is similar to \
existing symbol \"\!\(stop\)\"."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mathematica", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstMatLUSolveBig\  = \ timingMatLU[\ \ from, to, \ step\ ]\)], "Input"],

Cell[BoxData[
    \({{600, 1.050000000000109`}, {1000, 5.000000000000073`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitMatLUSolveBig\  = \ 
      Fit[\ lstMatLUSolveBig, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.0031249999999996662`\)\ x + 
      8.124999999999755`*^-6\ x\^2\)], "Output"]
}, Open  ]],

Cell["Many load vectors", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstMatLUSolveManyBig\  = 
      timingMatLUMany[\ \ from, to, \ step\ ]\)], "Input"],

Cell[BoxData[
    \({{600, 5.1699999999999005`}, {1000, 24.479999999999965`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitMatLUSolveManyBig\  = \ 
      Fit[\ lstMatLUSolveManyBig, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.01517833333333375`\)\ x + 
      0.000039658333333333794`\ x\^2\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ATLAS", "Subsubsection"],

Cell["One load vector", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstATLUSolveBig\  = \ timingATLU[\ from, \ to, \ step\ ]\)], "Input"],

Cell[BoxData[
    \({{600, 0.7`}, {1000, 1.6`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitATLUSolveBig\  = \ 
      Fit[\ lstATLUSolveBig, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(0.0005166666666666671`\ x + 1.083333333333331`*^-6\ x\^2\)], "Output"]
}, Open  ]],

Cell["Many load vectors", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lstATLUSolveManyBig\  = \ 
      timingATLUMany[\ from, \ to, \ step\ ]\)], "Input"],

Cell[BoxData[
    \({{600, 1.3`}, {1000, 5.1`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitATLUSolveManyBig\  = \ 
      Fit[\ lstATLUSolveManyBig, \ {\ x, \ x^2\ }, \ x\ ]\)], "Input"],

Cell[BoxData[
    \(\(-0.0022333333333333415`\)\ x + 
      7.333333333333353`*^-6\ x\^2\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Results", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[\[IndentingNewLine]{\ fitMatLUSolveBig\ , \ 
        fitATLUSolveBig\ }, {x, from, to}, 
      PlotStyle \[Rule] {Hue[0.7], Hue[0.9]}, 
      PlotLegend \[Rule] {"\<Mathematica\>", "\<ATLAS\>"}, 
      LegendLabel -> "\<Big problem\>", 
      LegendPosition \[Rule] {\(-0.6\), 0.2}, LegendSize \[Rule] {1, 0.25}, 
      LegendTextSpace \[Rule] 8, 
      AxesLabel \[Rule] {"\<N\>", "\<Seconds\>"}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.40476 0.00238095 0.0147151 0.117721 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -12 -9 ]
[.97619 .00222 12 0 ]
[1.025 .01472 0 -4.90625 ]
[1.025 .01472 10 4.90625 ]
[.01131 .13244 -6 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -6 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -6 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -6 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[.02381 .64303 -23 0 ]
[.02381 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(700)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(800)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(900)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(1000)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13244 m
.03006 .13244 L
s
[(1)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(2)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(3)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(4)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(5)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .03826 m
.02756 .03826 L
s
.02381 .0618 m
.02756 .0618 L
s
.02381 .08535 m
.02756 .08535 L
s
.02381 .10889 m
.02756 .10889 L
s
.02381 .15598 m
.02756 .15598 L
s
.02381 .17952 m
.02756 .17952 L
s
.02381 .20307 m
.02756 .20307 L
s
.02381 .22661 m
.02756 .22661 L
s
.02381 .2737 m
.02756 .2737 L
s
.02381 .29724 m
.02756 .29724 L
s
.02381 .32079 m
.02756 .32079 L
s
.02381 .34433 m
.02756 .34433 L
s
.02381 .39142 m
.02756 .39142 L
s
.02381 .41497 m
.02756 .41497 L
s
.02381 .43851 m
.02756 .43851 L
s
.02381 .46205 m
.02756 .46205 L
s
.02381 .50914 m
.02756 .50914 L
s
.02381 .53269 m
.02756 .53269 L
s
.02381 .55623 m
.02756 .55623 L
s
.02381 .57977 m
.02756 .57977 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.02381 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .13832 m
.06244 .15123 L
.10458 .16588 L
.14415 .18018 L
.18221 .19444 L
.22272 .21015 L
.26171 .2258 L
.30316 .24299 L
.34309 .2601 L
.3815 .27707 L
.42237 .29567 L
.46172 .31412 L
.49955 .33234 L
.53984 .35228 L
.57861 .37199 L
.61984 .39349 L
.65954 .41475 L
.69774 .4357 L
.73838 .45854 L
.77751 .48105 L
.81909 .50554 L
.85916 .52968 L
.89771 .55343 L
.93871 .57924 L
.97619 .60332 L
s
1 0 .6 r
.02381 .09712 m
.06244 .10062 L
.10458 .10452 L
.14415 .10825 L
.18221 .11191 L
.22272 .11588 L
.26171 .11976 L
.30316 .12397 L
.34309 .12809 L
.3815 .13213 L
.42237 .13649 L
.46172 .14077 L
.49955 .14494 L
.53984 .14946 L
.57861 .15388 L
.61984 .15865 L
.65954 .16331 L
.69774 .16787 L
.73838 .17279 L
.77751 .1776 L
.81909 .18278 L
.85916 .18785 L
.89771 .19279 L
.93871 .19813 L
.97619 .20307 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.2381 .38045 m
.2381 .49949 L
.71429 .49949 L
.71429 .38045 L
F
1 g
.21429 .40426 m
.21429 .5233 L
.69048 .5233 L
.69048 .40426 L
F
0 g
.001 w
[ ] 0 setdash
.21429 .40426 m
.69048 .40426 L
.69048 .5233 L
.21429 .5233 L
.21429 .40426 L
s
% Start of sub-graphic
p
0.214286 0.404255 0.690476 0.523303 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00710227 0.0710227 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0127841 0.126068 0.0838068 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0483 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0951705 0.126068 0.166193 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .13068 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .20739 -96 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Big) show
87.000 11.562 moveto
(problem) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 10}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00DMkK00<00=kKg]/00mkK0P001=kK0P00
:]kK0P001=kK0P001=kK0P00:=kK0`001=kK0P001=kK0P009]kK10000mkK0P001=kK0P001=kK0P00
5mkK001Ag]/00`00g]_Nf`02g]/01000g]_Nf`000]kK00@00=kKg]/002SNf`04003NfmkK0002g]/0
1000g]_Nf`000]kK00@00=kKg]/002[Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/0
9MkK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05=kK001B
g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK02KNf`04003NfmkK0002g]/01000
g]_Nf`000]kK00@00=kKg]/002[Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/09MkK
00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05=kK001Bg]/0
1@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK02ONf`8000?Nf`04003NfmkK0002g]/0
1000g]_Nf`00:=kK0`000]kK00@00=kKg]/000;Nf`04003NfmkK000Wg]/01@00g]_NfmkK00000]kK
00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`0Dg]/005?Nf`04003NfmkK0002g]/01000
g]_Nf`000]kK00<00=kKg]/09]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`009mkK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`009mkK00D00=kKg]_Nf`0000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05=kK001@g]/01000g]_Nf`000]kK00@00=kKg]/0
00;Nf`04003NfmkK000Xg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Wg]/01000
g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Ug]/30003g]/01000g]_Nf`000]kK00@00=kK
g]/000;Nf`04003NfmkK000Fg]/0027Nf`03003NfmkK02cNf`@000?Nf`8000CNf`8002[Nf`8000CN
f`8000CNf`8002WNf`8000CNf`8000CNf`8002SNf`03003NfmkK00;Nf`8000CNf`8000CNf`8001ON
f`008MkK00<00=kKg]/0o=kK000Qg]/00`00g]_Nf`3Xg]/20002g]/00`00g]_Nf`0=g]/0027Nf`03
003NfmkK0>WNf`04003NfmkK000?g]/001_Nfn/000ONf`04003Nf`00000?g]/0027Nf`03003NfmkK
00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00SNf`03003NfmkK00SNf`03003NfmkK00WNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00WNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00_Nf`800003g]/00=kK00kNf`008MkK00<00=kKg]/0jMkK00@00=kKg]/000oNf`008MkK00<00=kK
g]/0j=kK0P0000?Nf`0000003mkK000Qg]/00`00g]_Nf`3lg]/0027Nf`03003NfmkK0?cNf`008MkK
00<00=kKg]/0o=kK000Qg]/00`00g]_Nf`3lg]/0027Nf`03003NfmkK0?cNf`008MkK00<00=kKg]/0
o=kK000Qg]/00`00g]_Nf`3lg]/0027Nf`03003NfmkK0?cNf`008MkK00<00=kKg]/0o=kK000Qg]/0
0`00g]_Nf`3lg]/0027Nf`03003NfmkK0?cNf`008MkK00<00=kKg]/0o=kK000Qg]/00`00g]_Nf`3l
g]/0027Nf`03003NfmkK0?cNf`008MkK00<00=kKg]/0o=kK000Qg]/5n1?jg]/0027Nf`03003NfmkK
00;Nf`Wh4o7Nf`008MkK00<00=kKg]/02mkK2OPCj=kK000Qg]/00`00g]_Nf`0Dg]/Cn1?Eg]/0027N
f`03003NfmkK02ONf`Wh4lcNf`008MkK00<00=kKg]/0<=kK2OPC`mkK000Ig]/40004g]/00`00g]_N
f`0ig]/:n1>ig]/001_Nf`03003NfmkK00?Nf`03003NfmkK04?Nf`Wh4k3Nf`006mkK00<00=kKg]/0
0mkK0P00CMkK2OPCYmkK000Kg]/00`00g]_Nf`03g]/00`00g]_Nf`1Eg]/:n1>Mg]/001_Nf`03003N
fmkK00?Nf`8`7f3Nf`Wh4iCNf`006MkK0`001MkK00<00=kK<1l00S0OI]kK2OPCRmkK000Kg]/00`00
g]_Nf`03g]/00`00g]_Nf`02g]/3<1m/g]/9n1>2g]/0027Nf`03003NfmkK00GNf`<`7g;Nf`Wh4gWN
f`008MkK00<00=kKg]/02=kK0c0ON=kK2_PCKmkK000Qg]/00`00g]_Nf`0;g]/3<1mog]/7n1=Xg]/0
027Nf`03003NfmkK00kNf`<`7h?Nf`Ch4fCNf`008MkK00<00=kKg]/04MkK0c0OQ=kK1oPCGMkK000Q
g]/00`00g]_Nf`0Dg]/4<1n7g]/9n1=Dg]/0027Nf`03003NfmkK01SNf`<`7hgNf`[h4d[Nf`008MkK
00<00=kKg]/06mkK0S0OUMkK2OPC@MkK000Qg]/00`00g]_Nf`0Mg]/2<1nLg]/:n1<gg]/0027Nf`03
003NfmkK01oNf`8`7jCNf`Oh4c3Nf`008MkK00<00=kKg]/08MkK0c0OZ=kK1?PC;=kK000Qg]/00`00
g]_Nf`0Tg]/3<1nYg]/7n1<Ug]/0027Nf`03003NfmkK02ONf`<`7jgNf`Gh4b3Nf`008MkK00<00=kK
g]/0:]kK0c0OcmkK000Qg]/00`00g]_Nf`0]g]/2<1o=g]/0027Nf`03003NfmkK02oNf`8`7l_Nf`00
8MkK00<00=kKg]/0<MkK0S0ObMkK000Qg]/00`00g]_Nf`0cg]/3<1o6g]/0027Nf`03003NfmkK03KN
f`8`7lCNf`008MkK00<00=kKg]/0>=kK0c0O`MkK000Qg]/00`00g]_Nf`0kg]/2<1nog]/001WNf`@0
00CNf`03003NfmkK03gNf`<`7kcNf`006MkK00<00=kKg]/01MkK00<00=kKg]/0@=kK0S0O^]kK000J
g]/00`00g]_Nf`04g]/20013g]/2<1nhg]/001_Nf`03003NfmkK00?Nf`03003NfmkK04CNf`8`7kKN
f`007=kK00<00=kKg]/00]kK00<00=kKg]/0A]kK0c0O/mkK000Ig]/01000g]_Nf`001=kK00<00=kK
g]/0BMkK0S0O/MkK000Jg]/20005g]/00`00g]_Nf`1;g]/2<1n_g]/0027Nf`03003NfmkK04gNf`8`
7jgNf`008MkK00<00=kKg]/0CmkK0c0OZ]kK000Qg]/00`00g]_Nf`1Bg]/2<1nXg]/0027Nf`03003N
fmkK05CNf`<`7jGNf`008MkK00<00=kKg]/0EmkK0S0OXmkK000Qg]/00`00g]_Nf`1Ig]/2<1nQg]/0
027Nf`03003NfmkK05_Nf`8`7ioNf`008MkK00<00=kKg]/0GMkK0S0OWMkK000Qg]/00`00g]_Nf`1O
g]/2<1nKg]/0027Nf`03003NfmkK067Nf`8`7iWNf`008MkK00<00=kKg]/0HmkK0S0OUmkK000Qg]/0
0`00g]_Nf`1Ug]/2<1nEg]/0027Nf`03003NfmkK06ONf`8`7i?Nf`008MkK00<00=kKg]/0JMkK0S0O
TMkK000Qg]/00`00g]_Nf`1[g]/2<1n?g]/0027Nf`03003NfmkK06gNf`8`7hgNf`008MkK00<00=kK
g]/0KmkK0S0ORmkK000Qg]/00`00g]_Nf`1ag]/2<1n9g]/0027Nf`03003NfmkK07?Nf`8`7hONf`00
8MkK00<00=kKg]/0MMkK0S0OQMkK000Jg]/20005g]/00`00g]_Nf`1gg]/2<1n3g]/001WNf`04003N
fmkK0004g]/00`00g]_Nf`1ig]/2<1n1g]/001cNf`03003NfmkK00;Nf`8007cNf`8`7goNf`006]kK
0P001MkK00<00=kKg]/0OMkK0S0OOMkK000Lg]/00`00g]_Nf`02g]/00`00g]_Nf`1og]/2<1mkg]/0
01WNf`04003NfmkK0004g]/00`00g]_Nf`21g]/2<1mig]/001[Nf`8000GNf`03003NfmkK08?Nf`8`
7gONf`008MkK00<00=kKg]/0QMkK0S0OMMkK000Qg]/00`00g]_Nf`27g]/2<1mcg]/0027Nf`03003N
fmkK08WNf`8`7g7Nf`008MkK00<00=kKg]/0RmkK0S0OKmkK000Qg]/00`00g]_Nf`2=g]/2<1m]g]/0
027Nf`03003NfmkK08oNf`8`7f_Nf`008MkK00<00=kKg]/08=kKR000E=kK000Qg]/00`00g]_Nf`0P
g]^8001Dg]/0027Nf`03003NfmkK023NfhP005CNf`008MkK00<00=kKg]/08=kKR000E=kK000Qg]/0
0`00g]_Nf`0Pg]^8001Dg]/0027Nf`03003NfmkK023NfhP005CNf`008MkK00<00=kKg]/06MkKS`00
E=kK000Qg]/00`00g]_Nf`0Ig]/00`00ooooo`26ool6001Dg]/0027Nf`03003NfmkK01WNf`03003o
oooo08Koo`H005CNf`008MkK00<00=kKg]/06MkK00<00?ooool0Q_oo1P00E=kK000Qg]/00`00g]_N
f`0Ig]/00`00ooooo`26ool6001Dg]/0027Nf`03003NfmkK01WNf`03003ooooo08Koo`H005CNf`00
8MkK00<00=kKg]/06MkK00<00?ooool04_oo0P000_oo0P0000Coo`00000000;oo`D00003ool00000
00;oo`800004ool00000001Hool6001Dg]/0027Nf`03003NfmkK01WNf`03003ooooo00oh4`Coo`04
003ooooo0003ool00`00ooooo`02ool01000ooooo`000_oo00@00?ooool000;oo`04003ooooo001G
ool600000c0Og]_Nf`1Ag]/0027Nf`03003NfmkK01WNf`03003ooooo01?oo`@000?oo`03003ooooo
00;oo`03003ooooo00?oo`@000Goo`03003ooooo05Goo`H00003g]/`7c0O057Nf`006mkK00<00=kK
g]/00mkK00<00=kKg]/06MkK00<00?ooool04ooo00@00?ooool000?oo`03003ooooo00;oo`03003o
oooo00?oo`04003ooooo0003ool2001Hool60003g]/2<1m?g]/001_Nf`03003NfmkK00?Nf`03003N
fmkK01WNf`03003ooooo01Coo`09003oo`00ool00?oo003oo`0000;oo`03003ooooo00Coo`03003o
o`0000;oo`03003ooooo05Soo`H000GNf`03<1oNfmkK04cNf`006=kK1@001=kK0P006]kK00<00?oo
ool04ooo0`000_oo1@0000Coo`00000000Coo`<000Coo`<005Ooo`H000KNf`8`7dcNf`006=kK00@0
0=kKg]/000GNf`03003NfmkK01WNf`03003ooooo08Koo`H000SNf`8`7d[Nf`006MkK00<00=kK0000
1MkK00<00=kKg]/06MkK00<00?ooool0Q_oo1P002]kK0S0OB=kK000Jg]/20005g]/00`00g]_Nf`0I
g]/00`00ooooo`26ool6000<g]/2<1m6g]/001_Nf`03003NfmkK00?Nf`03003NfmkK01WNf`03003o
oooo08Koo`H000kNf`03<1oNfmkK04?Nf`008MkK00<00=kKg]/06MkK00<00?ooool0Q_oo1P003mkK
0S0O@mkK000Qg]/00`00g]_Nf`0Ig]/00`00ooooo`0Bool200000ooo00000003ool200000ooo003o
o`02ool200001Ooo00000000ool00P000_oo0`0000Goo`00ool00?oo008000;oo`800003ool00?oo
00;oo`8000;oo`D000;oo`8000Coo`800003ool00?oo037oo`H0017Nf`8`7d7Nf`008MkK00<00=kK
g]/06MkK00<00?ooool03c0O0ooo00D00?ooooooo`0000;oo`04003ooooo0003ool01P00ooooo`00
ool000;oo`04003ooooo0004ool01@00ool00?oo00000_oo00@00?ooool000?oo`04003ooooo0003
ool01@00oooooooo00000_oo00@00?ooool000;oo`03003ooooo037oo`H001?Nf`03<1oNfmkK03kN
f`008MkK00<00=kKg]/06MkK00<00?ooool04_oo00D00?oo003oo`0000?oo`<000?oo`03003ooooo
00;oo`04003ooooo0002ool30002ool01@00ool00?oo00000ooo0`000ooo00<00?ooool01?oo00D0
0?ooooooo`0000Koo`<003?oo`H001CNf`8`7ckNf`008MkK00<00=kKg]/06MkK00<00?ooool04_oo
00D00?oo003oo`0000Goo`05003oooooool00004ool01000ooooo`000_oo00X00?ooool00?oo003o
o`00ool000Goo`05003oooooool00006ool01@00oooooooo00000_oo00<00?ooool00ooo00<00?oo
ool0<Ooo1P005]kK0S0O?=kK000Qg]/00`00g]_Nf`0Ig]/00`00ooooo`0Bool200000ooo00000003
ool20003ool40002ool30004ool20002ool200000ooo003oo`03ool20003ool40003ool20004ool2
0004ool2000dool6000Hg]/00c0Og]_Nf`0ig]/0027Nf`03003NfmkK01WNf`03003ooooo01;oo`05
003oooooool00009ool00`00ooooo`02ool00`00ooooo`0Fool00`00ooooo`15ool6000Ig]/2<1li
g]/0027Nf`03003NfmkK01WNf`03003ooooo023oo`04003oooooool2000Hool00`00ooooo`04ool0
0`00ooooo`0nool6000Kg]/00c0Og]_Nf`0fg]/0027Nf`03003NfmkK01WNf`03003ooooo08Koo`H0
01cNf`8`7cKNf`008MkK00<00=kKg]/06MkK00<00?ooool0;Ooo0`002?oo0`00Booo1P007]kK00<`
7mkKg]/0<mkK000Qg]/00`00g]_Nf`0Ig]/00`00ooooo`0`ool00`00ooooo`06ool00`00ooooo`1:
ool6000Og]/2<1lcg]/0027Nf`03003NfmkK01WNf`03003ooooo023oo`@000?oo`D000;oo`<000So
o`<000?oo`@000?oo`8000;oo`@000?oo`D000;oo`<00005ool00?oo003oo`02000Tool6000Qg]/0
0c0Og]_Nf`0`g]/0027Nf`03003NfmkK01WNf`03003ooooo027oo`04003ooooo0004ool01@00oooo
oooo00000_oo00<00?ooool01_oo00@00?ooool000?oo`03003ooooo00;oo`04003ooooo0002ool0
1000ooooo`001?oo00D00?ooooooo`0000Coo`05003oo`00ool0000Uool6000Rg]/2<1l`g]/0027N
f`03003NfmkK01WNf`03003ooooo027oo`04003ooooo0004ool01@00oooooooo00000_oo00<00?oo
ool01_oo00@00?ooool000?oo`03003ooooo00;oo`04003ooooo0002ool01000ooooo`001?oo00@0
0?ooooooo`<000;oo`05003oo`00ool0000Uool00`00g]_Nf`0Wg]/00c0Og]_Nf`0]g]/0027Nf`03
003NfmkK01WNf`03003ooooo027oo`<000Goo`05003oooooool00002ool00`00ooooo`06ool01000
ooooo`000ooo00<00?ooool00_oo00@00?ooool000;oo`04003ooooo0004ool01@00oooooooo0000
0_oo00L00?oo003oo`00ool0000Uool00`00g]_Nf`0Xg]/2<1l]g]/0027Nf`03003NfmkK01WNf`03
003ooooo027oo`04003ooooo0003ool20004ool200000ooo003oo`05ool01000ool000000ooo00<0
0?oo00000P000_oo0P000ooo0`001Ooo00<00?ooool00_oo0P000_oo0P0000?oo`00ool09Ooo00<0
0=kKg]/0:]kK00<`7mkKg]/0:]kK000Qg]/00`00g]_Nf`0Ig]/00`00ooooo`0Pool4000Wool00`00
ooooo`05ool00`00ooooo`0`ool00`00g]_Nf`0[g]/2<1lZg]/0027Nf`03003NfmkK01WNf`03003o
oooo02Woo`03003ooooo01koo`8000Koo`8003;oo`03003NfmkK02gNf`03<1oNfmkK02ONf`008MkK
00<00=kKg]/06MkKRP00<=kK0S0O9mkK000Qg]/00`00g]_Nf`3Eg]/2<1lUg]/001WNf`<000GNf`03
003NfmkK0=ONf`8`7b?Nf`007=kK00<00=kKg]/00]kK00<00=kKg]/0fMkK0S0O8MkK000Lg]/00`00
g]_Nf`02g]/2003Lg]/00c0Og]_Nf`0Ng]/001WNf`<000GNf`03003NfmkK0?cNf`006MkK00<00=kK
g]/01MkK00<00=kKg]/0o=kK000Ig]/00`00g]_Nf`05g]/00`00g]_Nf`3lg]/001WNf`@000CNf`03
003NfmkK0?cNf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00
omkK8MkK003og]/Qg]/000gNf`<000CNf`<000?Nf`8000CNf`8000;Nf`<00003g]/0000000;Nf`80
0003g]/00=kK00<00>cNf`003MkK00@00=kKg]/000;Nf`03003NfmkK00?Nf`04003NfmkK0002g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0005g]/00`00g]_Nf`3Yg]/0013Nf`03003N
fmkK00<000?Nf`03003NfmkK00?Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/000?N
f`800>cNf`003]kK0P000mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@0
0=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`3/g]/000gNf`03003NfmkK00CNf`8000CNf`80
00CNf`8000;Nf`04003Nf`000004g]/30003g]/3003[g]/000kNf`<001gNf`03003NfmkK0>oNf`00
;MkK0P00lMkK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.05261, -0.648943, \
0.00733523, 0.00733523}, {{7.125, 279.812}, {172.688, 4.1875}} -> {540.601, \
-0.588017, 1.79803, 0.0363659}, {{61.6875, 198}, {61.1875, 27.0625}} -> \
{-4.33589, -12.0586, 0.0686662, 0.103293}, {{64.25, 78.8125}, {59.375, \
49.6875}} -> {-4.65767, -28.5614, 0.0721037, 0.233332}, {{64.25, 78.8125}, \
{48.1875, 38.5}} -> {-4.65767, -31.1718, 0.0721037, 0.233332}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[\[IndentingNewLine]{\ fitMatLUSolveManyBig\ , \ 
        fitATLUSolveManyBig\ }, {x, from, to}, 
      PlotStyle \[Rule] {Hue[0.7], Hue[0.9]}, 
      PlotLegend \[Rule] {"\<Mathematica\>", "\<ATLAS\>"}, 
      LegendLabel -> "\<Big + many load vectors\>", 
      LegendPosition \[Rule] {\(-0.7\), 0.15}, 
      LegendSize \[Rule] {1.1, 0.25}, LegendTextSpace \[Rule] 8, 
      AxesLabel \[Rule] {"\<N\>", "\<Seconds\>"}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.47619 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.40476 0.00238095 0.0147151 0.0240443 [
[.2619 .00222 -9 -9 ]
[.2619 .00222 9 0 ]
[.5 .00222 -9 -9 ]
[.5 .00222 9 0 ]
[.7381 .00222 -9 -9 ]
[.7381 .00222 9 0 ]
[.97619 .00222 -12 -9 ]
[.97619 .00222 12 0 ]
[1.025 .01472 0 -4.90625 ]
[1.025 .01472 10 4.90625 ]
[.01131 .13494 -6 -4.5 ]
[.01131 .13494 0 4.5 ]
[.01131 .25516 -12 -4.5 ]
[.01131 .25516 0 4.5 ]
[.01131 .37538 -12 -4.5 ]
[.01131 .37538 0 4.5 ]
[.01131 .4956 -12 -4.5 ]
[.01131 .4956 0 4.5 ]
[.01131 .61582 -12 -4.5 ]
[.01131 .61582 0 4.5 ]
[.02381 .64303 -23 0 ]
[.02381 .64303 23 9.8125 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(700)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(800)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(900)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(1000)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
69.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13494 m
.03006 .13494 L
s
[(5)] .01131 .13494 1 0 Mshowa
.02381 .25516 m
.03006 .25516 L
s
[(10)] .01131 .25516 1 0 Mshowa
.02381 .37538 m
.03006 .37538 L
s
[(15)] .01131 .37538 1 0 Mshowa
.02381 .4956 m
.03006 .4956 L
s
[(20)] .01131 .4956 1 0 Mshowa
.02381 .61582 m
.03006 .61582 L
s
[(25)] .01131 .61582 1 0 Mshowa
.125 Mabswid
.02381 .03876 m
.02756 .03876 L
s
.02381 .0628 m
.02756 .0628 L
s
.02381 .08685 m
.02756 .08685 L
s
.02381 .11089 m
.02756 .11089 L
s
.02381 .15898 m
.02756 .15898 L
s
.02381 .18303 m
.02756 .18303 L
s
.02381 .20707 m
.02756 .20707 L
s
.02381 .23111 m
.02756 .23111 L
s
.02381 .2792 m
.02756 .2792 L
s
.02381 .30325 m
.02756 .30325 L
s
.02381 .32729 m
.02756 .32729 L
s
.02381 .35133 m
.02756 .35133 L
s
.02381 .39942 m
.02756 .39942 L
s
.02381 .42347 m
.02756 .42347 L
s
.02381 .44751 m
.02756 .44751 L
s
.02381 .47156 m
.02756 .47156 L
s
.02381 .51964 m
.02756 .51964 L
s
.02381 .54369 m
.02756 .54369 L
s
.02381 .56773 m
.02756 .56773 L
s
.02381 .59178 m
.02756 .59178 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
gsave
.02381 .64303 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Seconds) show
105.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
.02381 .13902 m
.06244 .15192 L
.10458 .16656 L
.14415 .18085 L
.18221 .19509 L
.22272 .21078 L
.26171 .22641 L
.30316 .24358 L
.34309 .26067 L
.3815 .27762 L
.42237 .2962 L
.46172 .31461 L
.49955 .33281 L
.53984 .35272 L
.57861 .37239 L
.61984 .39387 L
.65954 .41509 L
.69774 .436 L
.73838 .4588 L
.77751 .48127 L
.81909 .50572 L
.85916 .52982 L
.89771 .55352 L
.93871 .57928 L
.97619 .60332 L
s
1 0 .6 r
.02381 .04597 m
.06244 .04858 L
.10458 .05153 L
.14415 .0544 L
.18221 .05726 L
.22272 .06039 L
.26171 .06351 L
.30316 .06692 L
.34309 .07032 L
.3815 .07367 L
.42237 .07734 L
.46172 .08098 L
.49955 .08456 L
.53984 .08848 L
.57861 .09234 L
.61984 .09655 L
.65954 .1007 L
.69774 .10479 L
.73838 .10924 L
.77751 .11362 L
.81909 .11838 L
.85916 .12307 L
.89771 .12768 L
.93871 .13268 L
.97619 .13734 L
s
MathSubEnd
P
% End of sub-graphic
0 g
.19048 .35664 m
.19048 .47568 L
.71429 .47568 L
.71429 .35664 L
F
1 g
.16667 .38045 m
.16667 .49949 L
.69048 .49949 L
.69048 .38045 L
F
0 g
.001 w
[ ] 0 setdash
.16667 .38045 m
.69048 .38045 L
.69048 .49949 L
.16667 .49949 L
.16667 .38045 L
s
% Start of sub-graphic
p
0.166667 0.380446 0.690476 0.499493 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0106838 0.106838 0.00645661 0.0645661 [
[ 0 0 0 0 ]
[ 1 .22727 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .22727 L
0 .22727 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0192308 0.0116219 0.126068 0.076188 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 .6 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .0439 -61 -8.90625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 17.8125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ATLAS) show
93.000 11.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% Start of sub-graphic
p
0.0192308 0.0865186 0.126068 0.151085 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.2 0 1 r
.5 Mabswid
[ ] 0 setdash
.02381 .30902 m
.97619 .30902 L
s
MathSubEnd
P
% End of sub-graphic
0 g
gsave
.13996 .1188 -61 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mathematica) show
129.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .18853 -132 -9.0625 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 18.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Big) show
87.000 11.562 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
99.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(many) show
129.000 11.562 moveto
(load) show
159.000 11.562 moveto
(vectors) show
201.000 11.562 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{10, 10}, {10, 10}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00OomkK8MkK003og]/Q
g]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`00DMkK00<00=kKg]/00mkK0P001=kK0P00
:]kK0P001=kK0P001=kK0P00:=kK0`001=kK0P001=kK0P009]kK10000mkK0P001=kK0P001=kK0P00
5mkK001Ag]/00`00g]_Nf`02g]/01000g]_Nf`000]kK00@00=kKg]/002SNf`04003NfmkK0002g]/0
1000g]_Nf`000]kK00@00=kKg]/002[Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/0
9MkK00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05=kK001B
g]/01@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK02KNf`04003NfmkK0002g]/01000
g]_Nf`000]kK00@00=kKg]/002[Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/09MkK
00D00=kKg]_Nf`0000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05=kK001Bg]/0
1@00g]_NfmkK00000]kK00@00=kKg]/000;Nf`03003NfmkK02ONf`8000?Nf`04003NfmkK0002g]/0
1000g]_Nf`00:=kK0`000]kK00@00=kKg]/000;Nf`04003NfmkK000Wg]/01@00g]_NfmkK00000]kK
00@00=kKg]/000;Nf`04003NfmkK0002g]/00`00g]_Nf`0Dg]/005?Nf`04003NfmkK0002g]/01000
g]_Nf`000]kK00<00=kKg]/09]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`009mkK
00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`009mkK00D00=kKg]_Nf`0000;Nf`04003N
fmkK0002g]/01000g]_Nf`000]kK00<00=kKg]/05=kK001@g]/01000g]_Nf`000]kK00@00=kKg]/0
00;Nf`04003NfmkK000Xg]/01000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Wg]/01000
g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK000Ug]/30003g]/01000g]_Nf`000]kK00@00=kK
g]/000;Nf`04003NfmkK000Fg]/0027Nf`03003NfmkK02cNf`@000?Nf`8000CNf`8002[Nf`8000CN
f`8000CNf`8002WNf`8000CNf`8000CNf`8002SNf`03003NfmkK00;Nf`8000CNf`8000CNf`8001ON
f`008MkK00<00=kKg]/0o=kK000Qg]/00`00g]_Nf`3Xg]/20002g]/00`00g]_Nf`0=g]/0027Nf`03
003NfmkK0>WNf`04003NfmkK000?g]/001_Nfn/000ONf`04003Nf`00000?g]/0027Nf`03003NfmkK
00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00SNf`03003NfmkK00SNf`03003NfmkK00WNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00WNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK00SNf`03003NfmkK
00_Nf`800003g]/00=kK00kNf`008MkK00<00=kKg]/0jMkK00@00=kKg]/000oNf`008MkK00<00=kK
g]/0j=kK0P0000?Nf`0000003mkK000Qg]/00`00g]_Nf`3lg]/0027Nf`03003NfmkK0?cNf`008MkK
00<00=kKg]/0o=kK000Qg]/5n1?jg]/0027Nf`03003NfmkK00;Nfa;h4nSNf`008MkK00<00=kKg]/0
5=kK2_PCg]kK000Qg]/00`00g]_Nf`0Ng]/Bn1?<g]/0027Nf`03003NfmkK033Nf`Wh4l?Nf`008MkK
00<00=kKg]/0>MkK2_PC^MkK000Qg]/00`00g]_Nf`13g]/9n1>`g]/0027Nf`03003NfmkK04cNfa?h
4igNf`008MkK00<00=kKg]/0GmkK2OPCU=kK000Qg]/00`00g]_Nf`1Xg]/9n1>;g]/0027Nf`03003N
fmkK077Nf`Wh4h;Nf`008MkK00<00=kKg]/0N]kK2OPCNMkK000Qg]/00`00g]_Nf`23g]/:n1=_g]/0
027Nf`03003NfmkK08gNf`Wh4fKNf`008MkK00<00=kKg]/0U]kK2OPCGMkK000Qg]/00`00g]_Nf`2O
g]/9n1=Dg]/0027Nf`03003NfmkK0:SNf`[h4d[Nf`008MkK00<00=kKg]/0/]kK2OPC@MkK000Qg]/0
0`00g]_Nf`2kg]/:n1<gg]/001WNf`<000GNf`03003NfmkK0<GNf`Wh4bkNf`007=kK00<00=kKg]/0
0]kK00<00=kKg]/0c]kK2OPC9MkK000Lg]/00`00g]_Nf`02g]/2003Hg]/5n1<Pg]/001WNf`<000GN
f`8`7ogNf`006MkK00<00=kKg]/01MkK00<00=kK<1l00S0On]kK000Ig]/00`00g]_Nf`05g]/00`00
g]_Nf`02g]/3<1ogg]/001WNf`@000CNf`03003NfmkK00GNf`<`7oCNf`008MkK00<00=kKg]/02=kK
0c0OlMkK000Qg]/00`00g]_Nf`0;g]/3<1o^g]/0027Nf`03003NfmkK00kNf`<`7n_Nf`008MkK00<0
0=kKg]/04MkK0S0OjMkK000Qg]/00`00g]_Nf`0Cg]/3<1oVg]/0027Nf`03003NfmkK01KNf`8`7nCN
f`008MkK00<00=kKg]/06=kK0c0OhMkK000Qg]/00`00g]_Nf`0Kg]/3<1oNg]/0027Nf`03003NfmkK
01kNf`<`7m_Nf`008MkK00<00=kKg]/08MkK0c0Of=kK000Qg]/00`00g]_Nf`0Tg]/2<1oFg]/0027N
f`03003NfmkK02KNf`8`7mCNf`008MkK00<00=kKg]/0:=kK0S0Od]kK000Qg]/00`00g]_Nf`0Zg]/3
<1o?g]/0027Nf`03003NfmkK02gNf`<`7lcNf`008MkK00<00=kKg]/0<=kK0c0ObMkK000Qg]/00`00
g]_Nf`0cg]/3<1o6g]/0027Nf`03003NfmkK03KNf`8`7lCNf`008MkK00<00=kKg]/0>=kK0c0O`MkK
000Qg]/00`00g]_Nf`0kg]/2<1nog]/0027Nf`03003NfmkK03gNf`<`7kcNf`004mkK10000mkK0P00
1MkK00<00=kKg]/0@=kK0S0O^]kK000Eg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kK
g]/0@]kK0S0O^=kK000Eg]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK0P00AMkK0S0O]]kK000E
g]/01@00g]_NfmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0A]kK0c0O/mkK000Eg]/01@00g]_N
fmkK00000]kK00<00=kKg]/00]kK00<00=kKg]/0BMkK0S0O/MkK000Cg]/30003g]/01000g]_Nf`00
1=kK00<00=kKg]/0BmkK0S0O[mkK000Eg]/00`00g]_Nf`02g]/20005g]/00`00g]_Nf`1=g]/2<1n]
g]/0027Nf`03003NfmkK04oNf`<`7j[Nf`008MkK00<00=kKg]/0D]kK0S0OZ=kK000Qg]/00`00g]_N
f`1Dg]/3<1nUg]/0027Nf`03003NfmkK05ONf`8`7j?Nf`008MkK00<00=kKg]/0FMkK0S0OXMkK000Q
g]/00`00g]_Nf`1Kg]/2<1nOg]/0027Nf`03003NfmkK05gNf`8`7igNf`008MkK00<00=kKg]/0GmkK
0S0OVmkK000Qg]/00`00g]_Nf`1Qg]/2<1nIg]/0027Nf`03003NfmkK06?Nf`8`7iONf`008MkK00<0
0=kKg]/0IMkK0S0OUMkK000Qg]/00`00g]_Nf`1Wg]/2<1nCg]/0027Nf`03003NfmkK06WNf`8`7i7N
f`008MkK00<00=kKg]/0JmkK0S0OSmkK000Qg]/00`00g]_Nf`1]g]/2<1n=g]/0027Nf`03003NfmkK
06oNf`8`7h_Nf`008MkK00<00=kKg]/0LMkK0S0ORMkK000Qg]/00`00g]_Nf`1cg]/2<1n7g]/0027N
f`03003NfmkK07GNf`8`7hGNf`008MkK00<00=kKg]/0MmkK0S0OPmkK000Qg]/00`00g]_Nf`1ig]/2
<1n1g]/001?Nf`@000;Nf`<000GNf`03003NfmkK07_Nf`8`7goNf`005MkK00<00=kKg]/01=kK00<0
0=kKg]/00]kK00<00=kKg]/0OMkK0S0OOMkK000Eg]/00`00g]_Nf`04g]/00`00g]_Nf`02g]/20020
g]/2<1mkg]/001GNf`04003NfmkKg]/30005g]/00`00g]_Nf`21g]/2<1mig]/001GNf`05003NfmkK
g]/00007g]/00`00g]_Nf`23g]/2<1mgg]/001?Nf`<000?Nf`03003NfmkK00GNf`03003NfmkK01;N
fiH005CNf`005MkK00@00=kKg]_Nf`@000CNf`03003NfmkK01;NfiH005CNf`008MkK00<00=kKg]/0
4]kKUP00E=kK000Qg]/00`00g]_Nf`0Bg]^F001Dg]/0027Nf`03003NfmkK01;NfiH005CNf`008MkK
00<00=kKg]/03=kKW000E=kK000Qg]/00`00g]_Nf`0<g]/00`00ooooo`2Cool6001Dg]/0027Nf`03
003NfmkK00cNf`03003ooooo09?oo`H005CNf`008MkK00<00=kKg]/03=kK00<00?ooool0Tooo1P00
E=kK000Qg]/00`00g]_Nf`0<g]/00`00ooooo`2Cool6001Dg]/0027Nf`03003NfmkK00cNf`03003o
oooo09?oo`H005CNf`008MkK00<00=kKg]/03=kK00<00?ooool05?oo0P000_oo0P0000Coo`000000
00;oo`D00003ool0000000;oo`800004ool00000001Sool6001Dg]/0027Nf`03003NfmkK00cNf`03
003ooooo013h4`Goo`04003ooooo0003ool00`00ooooo`02ool01000ooooo`000_oo00@00?ooool0
00;oo`04003ooooo001Rool6001Dg]/0027Nf`03003NfmkK00cNf`03003ooooo01Goo`@000?oo`03
003ooooo00;oo`03003ooooo00?oo`@000Goo`03003ooooo063oo`H005CNf`008MkK00<00=kKg]/0
3=kK00<00?ooool05Ooo00@00?ooool000?oo`03003ooooo00;oo`03003ooooo00?oo`04003ooooo
0003ool2001Sool6001Dg]/0027Nf`03003NfmkK00cNf`03003ooooo01Koo`09003oo`00ool00?oo
003oo`0000;oo`03003ooooo00Coo`03003oo`0000;oo`03003ooooo06?oo`H005CNf`008MkK00<0
0=kKg]/03=kK00<00?ooool05Ooo0`000_oo1@0000Coo`00000000Coo`<000Coo`<006;oo`H005CN
f`008MkK00<00=kKg]/03=kK00<00?ooool0Tooo1P00E=kK000Qg]/00`00g]_Nf`0<g]/00`00oooo
o`2Cool6001Dg]/0027Nf`03003NfmkK00cNf`03003ooooo09?oo`H00003<1oNfmkK057Nf`008MkK
00<00=kKg]/03=kK00<00?ooool0Tooo1P0000?Nfc0O<1l0DMkK000Qg]/00`00g]_Nf`0<g]/00`00
ooooo`2Cool60003g]/2<1m?g]/0027Nf`03003NfmkK00cNf`03003ooooo01Coo`800003ool00000
00?oo`800003ool00?oo00;oo`800005ool00000003oo`020002ool300001Ooo003oo`00ool00P00
0_oo0P0000?oo`00ool00_oo0P000_oo1@000_oo0P001?oo0P0000?oo`00ool0??oo1P001MkK00<`
7mkKg]/0C=kK000Cg]/40003g]/20005g]/00`00g]_Nf`0<g]/00`00ooooo`0@<1l4ool01@00oooo
oooo00000_oo00@00?ooool000?oo`06003ooooo003oo`000_oo00@00?ooool000Coo`05003oo`00
ool00002ool01000ooooo`000ooo00@00?ooool000?oo`05003oooooool00002ool01000ooooo`00
0_oo00<00?ooool0??oo1P001]kK0S0OC=kK000Cg]/00`00g]_Nf`03g]/01000g]_Nf`001=kK00<0
0=kKg]/03=kK00<00?ooool05?oo00D00?oo003oo`0000?oo`<000?oo`03003ooooo00;oo`04003o
oooo0002ool30002ool01@00ool00?oo00000ooo0`000ooo00<00?ooool01?oo00D00?ooooooo`00
00Koo`<003koo`H000SNf`8`7d[Nf`005=kK00<00=kKg]/00]kK00@00=kKg]/000CNf`8000gNf`03
003ooooo01Coo`05003oo`00ool00005ool01@00oooooooo00001?oo00@00?ooool000;oo`0:003o
oooo003oo`00ool00?oo0005ool01@00oooooooo00001_oo00D00?ooooooo`0000;oo`03003ooooo
00?oo`03003ooooo03coo`H000[Nf`8`7dSNf`005MkK00D00=kKg]_Nf`0000;Nf`03003NfmkK00;N
f`03003NfmkK00cNf`03003ooooo01Coo`800003ool0000000?oo`8000?oo`@000;oo`<000Coo`80
00;oo`800003ool00?oo00?oo`8000?oo`@000?oo`8000Coo`8000Coo`8003ooo`H000cNf`8`7dKN
f`005]kK00@00=kKg]/000;Nf`03003NfmkK00;Nf`03003NfmkK00cNf`03003ooooo01Coo`05003o
ooooool00009ool00`00ooooo`02ool00`00ooooo`0Fool00`00ooooo`1@ool6000>g]/00c0Og]_N
f`13g]/001?Nf`04003NfmkK0002g]/01000g]_Nf`001=kK00<00=kKg]/03=kK00<00?ooool08_oo
00@00?ooooooo`8001Soo`03003ooooo00Coo`03003ooooo04Woo`H000oNf`8`7d?Nf`005=kK0P00
1=kK0P001MkK00<00=kKg]/03=kK00<00?ooool0Tooo1P004MkK0S0O@MkK000Qg]/00`00g]_Nf`0<
g]/00`00ooooo`0@ool3000Vool2001Hool6000Cg]/00c0Og]_Nf`0ng]/0027Nf`03003NfmkK00cN
f`03003ooooo01?oo`03003ooooo02Goo`03003ooooo05Goo`H001CNf`8`7ckNf`008MkK00<00=kK
g]/03=kK00<00?ooool00ooo10000ooo1@000_oo0`002_oo00<00?ooool01_oo00@00?oo003oo`80
00;oo`800003ool0000000800003ool0000000;oo`8000Woo`D000;oo`8000Coo`800004ool00?oo
ool200000ooo003oo`08ool00`00ooooo`02ool30003ool20005ool20003ool20003ool40002ool3
0008ool6000Fg]/2<1llg]/0027Nf`03003NfmkK00cNf`03003ooooo00Coo`04003ooooo0004ool0
1@00oooooooo00000_oo00<00?ooool02?oo00<00?ooool01_oo00D00?oo003oo`0000;oo`04003o
oooo0002ool01000ooooo`000_oo00@00?ooool000[oo`05003oooooool00002ool01000ooooo`00
0_oo00@00?ooool000;oo`03003ooooo00Ooo`03003oo`0000;oo`03003ooooo00?oo`04003ooooo
0003ool01P00ooooo`00ool000;oo`05003oooooool00007ool00`00ooooo`05ool6000Hg]/00c0O
g]_Nf`0ig]/0027Nf`03003NfmkK00cNf`03003ooooo00Coo`04003ooooo0004ool01@00oooooooo
00000_oo00<00?ooool01_oo1@001_oo00D00?oo003oo`0000?oo`<000;oo`04003ooooo0002ool0
1000ooooo`002_oo00D00?ooooooo`0000;oo`04003oooooool30002ool01000ooooo`002Ooo00<0
0?oo00000_oo0`000ooo00<00?ooool01?oo00<00?ooool00_oo00@00?ooool000?oo`03003ooooo
00?oo`8000Soo`03003NfmkK01cNf`8`7cWNf`008MkK00<00=kKg]/03=kK00<00?ooool01?oo0`00
1Ooo00D00?ooooooo`0000;oo`03003ooooo00Soo`03003ooooo00Koo`05003oo`00ool00005ool0
1000ooooo`000_oo00@00?ooool000;oo`03003ooooo00Soo`05003oooooool00002ool00`00oooo
o`03ool01000ooooo`000_oo00<00?ooool01_oo00L00?ooooooo`00ool00002ool01000ooooo`00
0_oo00D00?ooooooo`0000Coo`04003ooooo0003ool00`00ooooo`02ool00`00ooooo`08ool00`00
g]_Nf`0Ng]/00c0Og]_Nf`0fg]/0027Nf`03003NfmkK00cNf`03003ooooo00Coo`04003ooooo0003
ool20004ool200000ooo003oo`08ool00`00ooooo`06ool200000ooo003oo`03ool20002ool01000
ool000000_oo0P0000?oo`0000002_oo00<00?ooool00_oo0P001?oo0P001?oo0`001ooo0P000_oo
0P000_oo0P001?oo0P000ooo10000ooo0P000ooo00<00?oo00000P000_oo0`001ooo00<00=kKg]/0
7mkK0S0O=]kK000Qg]/00`00g]_Nf`0<g]/00`00ooooo`03ool40011ool00`00ooooo`0@ool00`00
ooooo`0Iool00`00ooooo`0Iool00`00g]_Nf`0Qg]/00c0Og]_Nf`0cg]/0027Nf`03003NfmkK00cN
f`03003ooooo00coo`03003ooooo03Soo`80017oo`8001_oo`03003ooooo01Woo`03003NfmkK02;N
f`8`7c?Nf`008MkK00<00=kKg]/03=kK00<00?ooool0Tooo00<00=kKg]/09=kK00<`7mkKg]/0<=kK
000Qg]/00`00g]_Nf`0<g]^G000Wg]/2<1l`g]/0027Nf`03003NfmkK0<cNf`03<1oNfmkK02gNf`00
8MkK00<00=kKg]/0cMkK0S0O;MkK000Qg]/00`00g]_Nf`3?g]/00c0Og]_Nf`0Zg]/0027Nf`03003N
fmkK0=3Nf`8`7b[Nf`008MkK00<00=kKg]/0d]kK00<`7mkKg]/09mkK000Qg]/00`00g]_Nf`3Cg]/2
<1lWg]/0027Nf`03003NfmkK0=GNf`8`7bGNf`008MkK00<00=kKg]/0emkK0S0O8mkK000Qg]/00`00
g]_Nf`3Ig]/2<1lQg]/0027Nf`03003NfmkK0=_Nf`03<1oNfmkK01kNf`004mkK10000]kK0`001MkK
00<00=kKg]/0o=kK000Cg]/00`00g]_Nf`06g]/00`00g]_Nf`02g]/00`00g]_Nf`3lg]/001CNf`03
003NfmkK00GNf`03003NfmkK00;Nf`800?gNf`005MkK00@00=kKg]_Nf`<000GNf`03003NfmkK0?cN
f`005]kK00@00=kKg]/00?oNf`ONf`004mkK00@00=kKg]/000;Nf`03003NfmkK0?oNf`GNf`005=kK
0P000mkK1000omkK1=kK003og]/Qg]/00?oNfb7Nf`00omkK8MkK003og]/Qg]/00?oNfb7Nf`003MkK
0`001=kK0`000mkK0P001=kK0P000]kK0`0000?Nf`0000000]kK0P0000?Nf`00g]/00`00k=kK000=
g]/01000g]_Nf`000]kK00<00=kKg]/00mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_N
f`000]kK00@00=kKg]/000GNf`03003NfmkK0>WNf`004=kK00<00=kKg]/00`000mkK00<00=kKg]/0
0mkK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000mkK0P00k=kK000>g]/20003g]/0
1000g]_Nf`000]kK00@00=kKg]/000;Nf`04003NfmkK0002g]/01000g]_Nf`000]kK00@00=kKg]/0
00;Nf`03003NfmkK0>cNf`003MkK00<00=kKg]/01=kK0P001=kK0P001=kK0P000]kK00@00=kK0000
00CNf`<000?Nf`<00>_Nf`003]kK0`007MkK00<00=kKg]/0kmkK000]g]/2003ag]/00?oNfb7Nf`00
omkK8MkK003og]/Qg]/00?oNfb7Nf`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.05261, -0.648943, \
0.00733523, 0.00733523}, {{7.125, 279.812}, {172.688, 4.1875}} -> {540.601, \
-2.87893, 1.79803, 0.178048}, {{48.0625, 198}, {68, 33.9375}} -> {-3.10345, \
-11.3574, 0.0624511, 0.103338}, {{50.9375, 66.9375}, {66.25, 56.5625}} -> \
{-3.44805, -25.0443, 0.0669871, 0.216775}, {{50.9375, 66.9375}, {55, \
45.3125}} -> {-3.44805, -27.483, 0.0669871, 0.216775}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Section 1",
  Background->RGBColor[0.670008, 0.790005, 0.380011]],

Cell[TextData[{
  "[1] Netlib: ",
  ButtonBox["http://www.netlib.org",
    ButtonData:>{
      URL[ "http://www.netlib.org"], None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"Netlib"],

Cell[TextData[{
  "[2] Lapack: ",
  ButtonBox["http://www.netlib.org/lapack/index.html",
    ButtonData:>{
      URL[ "http://www.netlib.org/lapack/index.html"], None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"Lapack"],

Cell[TextData[{
  "[3] Quadpack: ",
  ButtonBox["http://www.netlib.org/quadpack/index.html",
    ButtonData:>{
      URL[ "http://www.netlib.org/quadpack/index.html"], None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"Quadpack"],

Cell[TextData[{
  "[4] BLAS: ",
  ButtonBox["http://www.netlib.org/blas/index.html",
    ButtonData:>{
      URL[ "http://www.netlib.org/blas/index.html"], None},
    Active->True,
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"BLAS"],

Cell[TextData[{
  "[5] ATLAS: ",
  ButtonBox["http://math-atlas.sourceforge.net",
    ButtonData:>{
      URL[ "http://math-atlas.sourceforge.net/"], None},
    Active->True,
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"ATLAS"],

Cell[TextData[{
  "[6] Miyaji: ",
  ButtonBox["http://www.melt.kyutech.ac.jp/~miyaji/Time/index-e.shtml",
    ButtonData:>{
      URL[ "http://www.melt.kyutech.ac.jp/~miyaji/Time/index-e.shtml"], None},
    
    Active->True,
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"Miyaji"],

Cell[TextData[{
  "[7] InterCall Book: ",
  ButtonBox["http://www.physics.uwa.edu.au/ICB/",
    ButtonData:>{
      URL[ "http://www.physics.uwa.edu.au/ICB/"], None},
    Active->True,
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"InterCallBook"],

Cell["\<\
[8] Fridrich Weller, Numerische Mathematik f\[UDoubleDot]r Ingenieure und \
Naturwissenschaftler, Vieweg\
\>", "Text",
  CellTags->"Weller"]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
AutoGeneratedPackage->None,
ScreenStyleEnvironment->"Presentation",
WindowToolbars->{"RulerBar", "EditBar"},
WindowSize->{832, 668},
WindowMargins->{{Automatic, 58}, {Automatic, -12}},
ShowCellBracket->True,
ShowCellTags->True,
SpellingDictionaries->{"CorrectWords"->{
  "Imtek", "Netlib", "R\[UDoubleDot]benk\[ODoubleDot]nig", "Rudnyi", 
    "Korvink", "Microsystem", "Freiburg", "imtek", "prototyping", "Quadpack", 
    "utilise", "uni", "freiburg", "ims", "ftp", "chmod", "mv", 
    "nanosystems"}},
Background->RGBColor[0.937255, 0.917647, 0.780392],
Magnification->1,
StyleDefinitions -> "Report.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Level of abstraction versus. performance"->{
    Cell[45078, 697, 117, 1, 35, "Subsection",
      CellTags->"Level of abstraction versus. performance"]},
  "MathLibIdea"->{
    Cell[50419, 825, 884825, 12217, 315, "NumberedFigure",
      CellTags->"MathLibIdea"]},
  "Performance comparison between Mathematica and MathLib"->{
    Cell[936946, 13099, 209, 6, 35, "Subsection",
      CellTags->"Performance comparison between Mathematica and MathLib"]},
  "Mat_LU_vs_MaToMa"->{
    Cell[938591, 13151, 30999, 881, 362, 11766, 639, "GraphicsData", 
    "PostScript", "NumberedFigure",
      CellTags->"Mat_LU_vs_MaToMa"]},
  "LUDec_vs_DGETRF"->{
    Cell[971487, 14082, 33660, 987, 362, 13782, 737, "GraphicsData", 
    "PostScript", "NumberedFigure",
      CellTags->"LUDec_vs_DGETRF"]},
  "LU_vs_ATLAS_LU"->{
    Cell[1007242, 15131, 30040, 896, 341, 12914, 680, "GraphicsData", 
    "PostScript", "NumberedFigure",
      CellTags->"LU_vs_ATLAS_LU"]},
  "LU_Many_vs_ATLAS_LU_Many"->{
    Cell[1037763, 16042, 30085, 845, 351, 12050, 617, "GraphicsData", 
    "PostScript", "NumberedFigure",
      CellTags->"LU_Many_vs_ATLAS_LU_Many"]},
  "Accuracy of the result"->{
    Cell[1095520, 17704, 82, 1, 35, "Subsection",
      CellTags->"Accuracy of the result"]},
  "The transparent user interface"->{
    Cell[1096691, 17748, 108, 1, 35, "Subsection",
      CellTags->"The transparent user interface"]},
  "Portability"->{
    Cell[1097985, 17779, 60, 1, 35, "Subsection",
      CellTags->"Portability"]},
  "Conclusion"->{
    Cell[1099389, 17820, 58, 1, 35, "Subsection",
      CellTags->"Conclusion"]},
  "Netlib"->{
    Cell[1332540, 25335, 196, 7, 51, "Text",
      CellTags->"Netlib"]},
  "Lapack"->{
    Cell[1332739, 25344, 232, 7, 51, "Text",
      CellTags->"Lapack"]},
  "Quadpack"->{
    Cell[1332974, 25353, 240, 7, 51, "Text",
      CellTags->"Quadpack"]},
  "BLAS"->{
    Cell[1333217, 25362, 242, 8, 51, "Text",
      CellTags->"BLAS"]},
  "ATLAS"->{
    Cell[1333462, 25372, 237, 8, 51, "Text",
      CellTags->"ATLAS"]},
  "Miyaji"->{
    Cell[1333702, 25382, 289, 9, 51, "Text",
      CellTags->"Miyaji"]},
  "InterCallBook"->{
    Cell[1333994, 25393, 255, 8, 51, "Text",
      CellTags->"InterCallBook"]},
  "Weller"->{
    Cell[1334252, 25403, 150, 4, 47, "Text",
      CellTags->"Weller"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Level of abstraction versus. performance", 1335571, 25439},
  {"MathLibIdea", 1335699, 25442},
  {"Performance comparison between Mathematica and MathLib", 1335853, 25445},
  {"Mat_LU_vs_MaToMa", 1336003, 25448},
  {"LUDec_vs_DGETRF", 1336170, 25452},
  {"LU_vs_ATLAS_LU", 1336335, 25456},
  {"LU_Many_vs_ATLAS_LU_Many", 1336510, 25460},
  {"Accuracy of the result", 1336693, 25464},
  {"The transparent user interface", 1336825, 25467},
  {"Portability", 1336947, 25470},
  {"Conclusion", 1337048, 25473},
  {"Netlib", 1337144, 25476},
  {"Lapack", 1337231, 25479},
  {"Quadpack", 1337320, 25482},
  {"BLAS", 1337407, 25485},
  {"ATLAS", 1337491, 25488},
  {"Miyaji", 1337577, 25491},
  {"InterCallBook", 1337671, 25494},
  {"Weller", 1337765, 25497}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 17638, 224, 73, 17398, 216, "GraphicsData", "Bitmap", "Text",
  Evaluatable->False],
Cell[19395, 277, 19185, 241, 59, 19018, 236, "GraphicsData", "Bitmap", "Text",
  
  Evaluatable->False],

Cell[CellGroupData[{
Cell[38605, 522, 287, 9, 87, "Title"],
Cell[38895, 533, 232, 7, 51, "Subtitle"],
Cell[39130, 542, 503, 12, 156, "Author"],

Cell[CellGroupData[{
Cell[39658, 558, 83, 1, 72, "Section 1"],
Cell[39744, 561, 2250, 48, 314, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[42031, 614, 87, 1, 46, "Section 1"],
Cell[42121, 617, 956, 21, 142, "Text"],
Cell[43080, 640, 210, 5, 54, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[43327, 650, 91, 1, 46, "Section 1"],

Cell[CellGroupData[{
Cell[43443, 655, 29, 0, 37, "Subsection"],
Cell[43475, 657, 1566, 35, 221, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[45078, 697, 117, 1, 35, "Subsection",
  CellTags->"Level of abstraction versus. performance"],

Cell[CellGroupData[{
Cell[45220, 702, 43, 0, 28, "Subsubsection"],
Cell[45266, 704, 5150, 119, 705, "Text"],
Cell[50419, 825, 884825, 12217, 315, "NumberedFigure",
  CellTags->"MathLibIdea"]
}, Closed]],

Cell[CellGroupData[{
Cell[935281, 13047, 50, 0, 20, "Subsubsection"],
Cell[935334, 13049, 1563, 44, 205, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[936946, 13099, 209, 6, 35, "Subsection",
  CellTags->"Performance comparison between Mathematica and MathLib"],

Cell[CellGroupData[{
Cell[937180, 13109, 106, 4, 28, "Subsubsection"],
Cell[937289, 13115, 1299, 34, 159, "Text"],
Cell[938591, 13151, 30999, 881, 362, 11766, 639, "GraphicsData", \
"PostScript", "NumberedFigure",
  CellTags->"Mat_LU_vs_MaToMa"],
Cell[969593, 14034, 1319, 30, 180, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[970949, 14069, 55, 0, 20, "Subsubsection"],
Cell[971007, 14071, 477, 9, 96, "Text"],
Cell[971487, 14082, 33660, 987, 362, 13782, 737, "GraphicsData", \
"PostScript", "NumberedFigure",
  CellTags->"LUDec_vs_DGETRF"],
Cell[1005150, 15071, 1267, 31, 201, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1006454, 15107, 114, 3, 20, "Subsubsection"],
Cell[1006571, 15112, 668, 17, 96, "Text"],
Cell[1007242, 15131, 30040, 896, 341, 12914, 680, "GraphicsData", \
"PostScript", "NumberedFigure",
  CellTags->"LU_vs_ATLAS_LU"],
Cell[1037285, 16029, 475, 11, 75, "Text"],
Cell[1037763, 16042, 30085, 845, 351, 12050, 617, "GraphicsData", \
"PostScript", "NumberedFigure",
  CellTags->"LU_Many_vs_ATLAS_LU_Many"]
}, Closed]],

Cell[CellGroupData[{
Cell[1067885, 16892, 38, 0, 20, "Subsubsection"],
Cell[1067926, 16894, 27545, 804, 296, 10040, 584, "GraphicsData", \
"PostScript", "NumberedFigure"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1095520, 17704, 82, 1, 35, "Subsection",
  CellTags->"Accuracy of the result"],
Cell[1095605, 17707, 1049, 36, 121, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1096691, 17748, 108, 1, 35, "Subsection",
  CellTags->"The transparent user interface"],
Cell[1096802, 17751, 67, 0, 33, "Text"],
Cell[1096872, 17753, 1076, 21, 261, "InputOnly"]
}, Closed]],

Cell[CellGroupData[{
Cell[1097985, 17779, 60, 1, 35, "Subsection",
  CellTags->"Portability"],

Cell[CellGroupData[{
Cell[1098070, 17784, 34, 0, 28, "Subsubsection"],
Cell[1098107, 17786, 242, 4, 54, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1098386, 17795, 38, 0, 20, "Subsubsection"],
Cell[1098427, 17797, 913, 17, 180, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1099389, 17820, 58, 1, 35, "Subsection",
  CellTags->"Conclusion"],
Cell[1099450, 17823, 1309, 31, 201, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1100808, 17860, 93, 1, 46, "Section 1"],
Cell[1100904, 17863, 1620, 37, 205, "Text"],

Cell[CellGroupData[{
Cell[1102549, 17904, 37, 0, 37, "Subsection"],
Cell[1102589, 17906, 292, 7, 75, "Text"],
Cell[1102884, 17915, 65, 0, 33, "Text"],
Cell[1102952, 17917, 79, 1, 58, "Input"],
Cell[1103034, 17920, 2008, 48, 213, "Text"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1105091, 17974, 85, 1, 46, "Section 1"],
Cell[1105179, 17977, 1037, 20, 159, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1106253, 18002, 80, 1, 46, "Section 1"],
Cell[1106336, 18005, 174, 6, 33, "Text"],

Cell[CellGroupData[{
Cell[1106535, 18015, 47, 0, 37, "Subsection"],
Cell[1106585, 18017, 513, 11, 121, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1107135, 18033, 48, 0, 21, "Subsection"],
Cell[1107186, 18035, 126, 3, 33, "Text"],

Cell[CellGroupData[{
Cell[1107337, 18042, 46, 0, 28, "Subsubsection"],
Cell[1107386, 18044, 26, 0, 33, "Text"],
Cell[1107415, 18046, 136, 5, 70, "Program"],
Cell[1107554, 18053, 308, 9, 54, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1107899, 18067, 32, 0, 28, "Subsubsection"],
Cell[1107934, 18069, 425, 10, 75, "Text"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1108408, 18085, 49, 0, 21, "Subsection"],
Cell[1108460, 18087, 428, 9, 75, "Text"],

Cell[CellGroupData[{
Cell[1108913, 18100, 48, 0, 28, "Subsubsection"],
Cell[1108964, 18102, 435, 8, 117, "Text"],
Cell[1109402, 18112, 88, 4, 26, "Program"],
Cell[1109493, 18118, 861, 17, 138, "Text"],
Cell[1110357, 18137, 168, 4, 33, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1110562, 18146, 46, 0, 28, "Subsubsection"],
Cell[1110611, 18148, 47, 0, 33, "Text"],
Cell[1110661, 18150, 66, 1, 26, "Program"],
Cell[1110730, 18153, 28, 0, 33, "Text"],
Cell[1110761, 18155, 90, 4, 26, "Program"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1110900, 18165, 49, 0, 21, "Subsection"],
Cell[1110952, 18167, 220, 4, 74, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1111221, 18177, 101, 1, 46, "Section 1"],
Cell[1111325, 18180, 1055, 23, 146, "Text"],

Cell[CellGroupData[{
Cell[1112405, 18207, 53, 0, 37, "Subsection"],
Cell[1112461, 18209, 255, 7, 54, "Text"],
Cell[1112719, 18218, 120, 2, 42, "Input"],
Cell[1112842, 18222, 28, 0, 33, "Text"],
Cell[1112873, 18224, 83, 1, 42, "Input"],
Cell[1112959, 18227, 62, 0, 33, "Text"],
Cell[1113024, 18229, 68, 1, 42, "Input"],
Cell[1113095, 18232, 54, 0, 33, "Text"],
Cell[1113152, 18234, 82, 3, 40, "Program"]
}, Closed]],

Cell[CellGroupData[{
Cell[1113271, 18242, 60, 0, 21, "Subsection"],
Cell[1113334, 18244, 254, 4, 54, "Text"],
Cell[1113591, 18250, 323, 7, 58, "Input",
  InitializationCell->True],
Cell[1113917, 18259, 355, 7, 75, "Text"],
Cell[1114275, 18268, 468, 8, 90, "Input",
  InitializationCell->True],
Cell[1114746, 18278, 424, 7, 90, "Input",
  InitializationCell->True],
Cell[1115173, 18287, 272, 5, 54, "Text"],
Cell[1115448, 18294, 586, 9, 122, "Input",
  InitializationCell->True],
Cell[1116037, 18305, 603, 10, 122, "Input",
  InitializationCell->True],
Cell[1116643, 18317, 495, 8, 106, "Input",
  InitializationCell->True],
Cell[1117141, 18327, 499, 8, 106, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[1117677, 18340, 28, 0, 21, "Subsection"],
Cell[1117708, 18342, 1311, 39, 159, "Text"],

Cell[CellGroupData[{
Cell[1119044, 18385, 156, 2, 58, "Input"],
Cell[1119203, 18389, 55, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1119295, 18395, 87, 1, 42, "Input"],
Cell[1119385, 18398, 45, 1, 42, "Output"]
}, Open  ]],
Cell[1119445, 18402, 895, 27, 100, "Text"],

Cell[CellGroupData[{
Cell[1120365, 18433, 163, 2, 58, "Input"],
Cell[1120531, 18437, 38, 1, 42, "Output"]
}, Open  ]],
Cell[1120584, 18441, 110, 3, 33, "Text"],

Cell[CellGroupData[{
Cell[1120719, 18448, 217, 4, 58, "Input"],
Cell[1120939, 18454, 38, 1, 42, "Output"]
}, Open  ]],
Cell[1120992, 18458, 249, 7, 54, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1121278, 18470, 109, 4, 21, "Subsection"],
Cell[1121390, 18476, 292, 9, 33, "Text"],

Cell[CellGroupData[{
Cell[1121707, 18489, 114, 2, 42, "Input"],
Cell[1121824, 18493, 388, 6, 58, "Output"]
}, Open  ]],
Cell[1122227, 18502, 188, 4, 54, "Text"],

Cell[CellGroupData[{
Cell[1122440, 18510, 92, 1, 42, "Input"],
Cell[1122535, 18513, 103, 2, 44, "Output"]
}, Open  ]],
Cell[1122653, 18518, 26, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1122704, 18522, 482, 9, 154, "Input"],
Cell[1123189, 18533, 20430, 556, 317, 6646, 381, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1143622, 19091, 130, 3, 42, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1143801, 19100, 133, 4, 21, "Subsection"],
Cell[1143937, 19106, 741, 16, 117, "Text"],

Cell[CellGroupData[{
Cell[1144703, 19126, 85, 1, 42, "Input"],
Cell[1144791, 19129, 103, 2, 42, "Output"]
}, Open  ]],
Cell[1144909, 19134, 73, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1145007, 19138, 75, 1, 42, "Input"],
Cell[1145085, 19141, 61, 1, 42, "Output"]
}, Open  ]],
Cell[1145161, 19145, 416, 13, 54, "Text"],

Cell[CellGroupData[{
Cell[1145602, 19162, 104, 2, 42, "Input"],
Cell[1145709, 19166, 199, 3, 58, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1145945, 19174, 90, 1, 42, "Input"],
Cell[1146038, 19177, 103, 2, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1146178, 19184, 480, 9, 154, "Input"],
Cell[1146661, 19195, 14845, 477, 214, 6498, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1161509, 19674, 130, 3, 42, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1161688, 19683, 120, 3, 21, "Subsection"],

Cell[CellGroupData[{
Cell[1161833, 19690, 407, 6, 74, "Input"],
Cell[1162243, 19698, 24474, 800, 213, 11760, 639, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1186720, 20500, 130, 3, 42, "Output"]
}, Open  ]],
Cell[1186865, 20506, 1153, 24, 180, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1188055, 20535, 52, 0, 21, "Subsection"],
Cell[1188110, 20537, 346, 8, 75, "Text"],

Cell[CellGroupData[{
Cell[1188481, 20549, 85, 1, 42, "Input"],
Cell[1188569, 20552, 103, 2, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1188709, 20559, 81, 1, 42, "Input"],
Cell[1188793, 20562, 117, 2, 42, "Output"]
}, Open  ]],
Cell[1188925, 20567, 123, 3, 33, "Text"],
Cell[1189051, 20572, 111, 2, 42, "Input"],

Cell[CellGroupData[{
Cell[1189187, 20578, 90, 1, 42, "Input"],
Cell[1189280, 20581, 102, 2, 44, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1189419, 20588, 396, 6, 90, "Input"],
Cell[1189818, 20596, 27487, 910, 215, 13776, 737, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1217308, 21508, 130, 3, 42, "Output"]
}, Open  ]],
Cell[1217453, 21514, 1007, 20, 180, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1218497, 21539, 119, 3, 21, "Subsection"],

Cell[CellGroupData[{
Cell[1218641, 21546, 88, 1, 42, "Input"],
Cell[1218732, 21549, 106, 2, 42, "Output"]
}, Open  ]],
Cell[1218853, 21554, 224, 3, 74, "Input"],

Cell[CellGroupData[{
Cell[1219102, 21561, 36, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1219163, 21565, 154, 3, 42, "Input"],
Cell[1219320, 21570, 70, 1, 42, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1219439, 21577, 30, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1219494, 21581, 116, 2, 42, "Input"],
Cell[1219613, 21585, 45, 1, 42, "Output"]
}, Open  ]],
Cell[1219673, 21589, 363, 6, 75, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1220073, 21600, 33, 0, 28, "Subsubsection"],
Cell[1220109, 21602, 931, 34, 100, "Text"],

Cell[CellGroupData[{
Cell[1221065, 21640, 679, 15, 106, "Input"],
Cell[1221747, 21657, 36, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1221820, 21663, 128, 2, 42, "Input"],
Cell[1221951, 21667, 38, 1, 42, "Output"]
}, Open  ]],
Cell[1222004, 21671, 115, 3, 33, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1222156, 21679, 63, 0, 28, "Subsubsection"],
Cell[1222222, 21681, 243, 4, 54, "Text"],

Cell[CellGroupData[{
Cell[1222490, 21689, 217, 4, 58, "Input"],
Cell[1222710, 21695, 69, 1, 42, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1222828, 21702, 57, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1222910, 21706, 116, 2, 42, "Input"],
Cell[1223029, 21710, 45, 1, 42, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1223123, 21717, 33, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1223181, 21721, 148, 2, 42, "Input"],
Cell[1223332, 21725, 38, 1, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1223431, 21733, 122, 3, 21, "Subsection"],

Cell[CellGroupData[{
Cell[1223578, 21740, 36, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1223639, 21744, 88, 1, 42, "Input"],
Cell[1223730, 21747, 366, 5, 58, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1224133, 21757, 105, 2, 42, "Input"],
Cell[1224241, 21761, 103, 2, 44, "Output"]
}, Open  ]],
Cell[1224359, 21766, 33, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1224417, 21770, 101, 2, 42, "Input"],
Cell[1224521, 21774, 387, 6, 58, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1224945, 21785, 113, 2, 42, "Input"],
Cell[1225061, 21789, 103, 2, 44, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1225213, 21797, 30, 0, 28, "Subsubsection"],
Cell[1225246, 21799, 31, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1225302, 21803, 86, 1, 42, "Input"],
Cell[1225391, 21806, 199, 3, 58, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1225627, 21814, 103, 2, 42, "Input"],
Cell[1225733, 21818, 103, 2, 44, "Output"]
}, Open  ]],
Cell[1225851, 21823, 33, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1225909, 21827, 101, 2, 42, "Input"],
Cell[1226013, 21831, 201, 3, 58, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1226251, 21839, 111, 2, 42, "Input"],
Cell[1226365, 21843, 102, 2, 44, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1226516, 21851, 32, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1226573, 21855, 515, 9, 138, "Input"],
Cell[1227091, 21866, 25696, 842, 214, 12908, 680, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1252790, 22710, 130, 3, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1252957, 22718, 511, 9, 122, "Input"],
Cell[1253471, 22729, 24557, 776, 214, 12044, 617, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1278031, 23507, 130, 3, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1278222, 23517, 62, 0, 21, "Subsection"],

Cell[CellGroupData[{
Cell[1278309, 23521, 1082, 21, 250, "Input"],
Cell[1279394, 23544, 184, 3, 30, "Message"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1279627, 23553, 35, 0, 21, "Subsection"],
Cell[1279665, 23555, 150, 3, 54, "Text"],

Cell[CellGroupData[{
Cell[1279840, 23562, 83, 1, 42, "Input"],
Cell[1279926, 23565, 181, 3, 30, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1280144, 23573, 36, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1280205, 23577, 91, 1, 42, "Input"],
Cell[1280299, 23580, 89, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1280425, 23586, 111, 2, 42, "Input"],
Cell[1280539, 23590, 102, 2, 44, "Output"]
}, Open  ]],
Cell[1280656, 23595, 33, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1280714, 23599, 104, 2, 42, "Input"],
Cell[1280821, 23603, 91, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1280949, 23609, 119, 2, 42, "Input"],
Cell[1281071, 23613, 102, 2, 44, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1281222, 23621, 30, 0, 28, "Subsubsection"],
Cell[1281255, 23623, 31, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1281311, 23627, 89, 1, 42, "Input"],
Cell[1281403, 23630, 61, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1281501, 23636, 109, 2, 42, "Input"],
Cell[1281613, 23640, 90, 1, 44, "Output"]
}, Open  ]],
Cell[1281718, 23644, 33, 0, 33, "Text"],

Cell[CellGroupData[{
Cell[1281776, 23648, 104, 2, 42, "Input"],
Cell[1281883, 23652, 61, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1281981, 23658, 117, 2, 42, "Input"],
Cell[1282101, 23662, 102, 2, 44, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1282252, 23670, 32, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[1282309, 23674, 435, 8, 90, "Input"],
Cell[1282747, 23684, 23699, 793, 214, 12521, 651, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1306449, 24479, 130, 3, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1306616, 24487, 458, 8, 106, "Input"],
Cell[1307077, 24497, 25169, 822, 214, 12973, 667, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1332249, 25321, 130, 3, 42, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1332452, 25332, 85, 1, 46, "Section 1"],
Cell[1332540, 25335, 196, 7, 51, "Text",
  CellTags->"Netlib"],
Cell[1332739, 25344, 232, 7, 51, "Text",
  CellTags->"Lapack"],
Cell[1332974, 25353, 240, 7, 51, "Text",
  CellTags->"Quadpack"],
Cell[1333217, 25362, 242, 8, 51, "Text",
  CellTags->"BLAS"],
Cell[1333462, 25372, 237, 8, 51, "Text",
  CellTags->"ATLAS"],
Cell[1333702, 25382, 289, 9, 51, "Text",
  CellTags->"Miyaji"],
Cell[1333994, 25393, 255, 8, 51, "Text",
  CellTags->"InterCallBook"],
Cell[1334252, 25403, 150, 4, 47, "Text",
  CellTags->"Weller"]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

